package kal.base.com.util;

import java.io.File;
import java.io.FileOutputStream;

//PD4ML
import org.zefer.pd4ml.PD4ML;
import org.zefer.pd4ml.PD4PageMark;

public class Pd4mlUtil {

	/**
	 * HTML  PDF  ȯŲ.
	 * @param String htmlPath ȯų HTML ġ
	 * @param String pdfPath ȯŲ PDF ġ
	 * @return 
	 * @exception Exception
	 * @author Copyright (c) 2009/04/02 
	 */
	public static void notamHtmlToPdf(String tmpHtmlPath, String tmpPdfPath, String pdfTitle) throws Exception {
		
		try {
						
			File pFile = new File(tmpPdfPath);
			FileOutputStream pfos = new FileOutputStream(pFile);
			
			PD4ML pd4ml = new PD4ML();
			
			PD4PageMark footer = new PD4PageMark();//2009.04.20 ߰ :  ǥ
			footer.setAreaHeight(40);
			footer.setHtmlTemplate("<center><br><font face='Arial' size='2'>PAGE ${page} OF ${total}, "+pdfTitle+"</font></center>");
			
			pd4ml.setPageFooter(footer);
			
			//pd4ml.generateOutlines(false); //å  false : <a name="destination">Label</a>
			pd4ml.generateOutlines(true); //å  true : <H1>-<H6>
			
			pd4ml.useTTF("/opt/IBM/WebSphere/AppServer/java/jre/lib/fonts", true); //Embedding fonts to PDF 
			
			pd4ml.render("file:" + tmpHtmlPath, pfos);
			
			pfos.close();
			
		} catch (Exception e) {
			throw new Exception(e.getMessage());
		}
	}	

}
