package kal.base.ffs.query;

import kal.base.ffs.dbbean.CdmA010BG;
import kal.base.jdf.com.Logger;

public class CdmA010Query {
    private static CdmA010Query instance = new CdmA010Query();
    
    public static CdmA010Query getInstance(){
    	return instance;
    }
    
    public static String selCdmSendList(CdmA010BG params){
    	
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT MSG_KEY, MSG_HEADER, SENDER_ADDR, DTG, TIMESTAMP, CONTENTS ");
    	sql.append(" FROM KFOS.SCDM_MSG_T ");
    	sql.append(" WHERE TO_DATE(SUBSTR(TIMESTAMP,1,4),'MMDD') >= TO_DATE('"+params.getFr_date()+"','MMDD')");
    	sql.append(" AND TO_DATE(SUBSTR(TIMESTAMP,1,4),'MMDD') <= TO_DATE('"+params.getTo_date()+"','MMDD')");
    	
    	//System.out.println("[BASE:CdmA010Query:selCdmSendList] "+sql.toString());
    	Logger.debug.println("[BASE:CdmA010Query:selCdmSendList] "+sql.toString());
    	
    	return sql.toString();
    }
}
