package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * MEL ȸ ȭ SQL 
  * @author Copyright (c) 2007/07/03  
  */  
public class FfsQ220Query {
	private static FfsQ220Query instance = new FfsQ220Query();
	
	public static FfsQ220Query getInstance() {
		return instance;
	}
	
	/** 
	  * MEL ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/07/03  
	  */
	public String selMel(FfsQ220BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MEL_#, ISS_D, EXPD_D, TXT_E ");
		//sql.append(" FROM TFOS_MEL@KALMES ");
		sql.append(" FROM KFOS.ERP_MEL_T "); //2010.12.27  : TFOS_MEL@KALMES -> KFOS.ERP_MEL_T
		sql.append(" WHERE HL_# = '" + params.getRegno() + "' ");
		sql.append(" 	AND (CLS_D IS NULL OR CLS_D = ' ') "); //2007.08.22 ߰ : OR CLS_D = ' '
		sql.append(" ORDER BY MEL_# ");
		
		//Logger.debug.println("[BASE:FfsQ220Query:selMel] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ220Query:selMel] sql : "+sql.toString());
		return sql.toString();
	}
	
	//20160715, 2016.12.12 AND DEF_TYPE = 'MEL' ߰
	public String selMelRev(FfsQ220BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MEL_NO AS MEL_#, DEF_TYPE,REMARKS_CONTENTS, ");//@2017-08-02
		sql.append("   REPLACE(SUBSTR(ISS_D,0,10),'-','') ISS_D, ");
		sql.append("   REPLACE(SUBSTR(EXPD_D,0,10),'-','') EXPD_D, ");
		sql.append("   TXT_E ");
		sql.append(" FROM KFOS.ERP_MEL_II ");
		sql.append(" WHERE HL_NO = 'HL" + params.getRegno() + "' ");
		//sql.append("   AND DEF_TYPE = 'MEL' ");
		sql.append(" ORDER BY MEL_NO ");
		
		System.out.println("[BASE:FfsQ220Query:selMelRev] sql : "+sql.toString());
		return sql.toString();
	}
}
