package kal.base.ffs.query;

//import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
//import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Flight Plan ȸ ȭ SQL 
  * @author Copyright sunpark
  * 20140903
  * sunpark
  */   
public class FfsQ240Query {
	private static FfsQ240Query instance = new FfsQ240Query();
	
	public static FfsQ240Query getInstance() {
		return instance;
	}

	private void printSQL(StringBuffer sqlSB){//@2017-09-13
		String sql	=	sqlSB==null?null:sqlSB.toString();
		if(sql!=null && sql.length()!=0){
			StackTraceElement	stack	=	Thread.currentThread().getStackTrace()[3];
			StringBuffer sb	=	new StringBuffer();
			sb.append("=========================	BASE printSQL : "+stack.getClassName()+"."+stack.getMethodName()+"[line "+stack.getLineNumber()+"]");
			sb.append("\n"+sql.replaceAll("\n"," ").replace("\\t+"," ").replace("^\\s+",""));	
			sb.append("\n;");
			System.out.println(sb.toString());
			//Logger.debug.println(sb.toString());
		}
	}
	private void printSQL(String sql){//@2017-09-13
		if(sql!=null && sql.length()!=0){
			StackTraceElement	stack	=	Thread.currentThread().getStackTrace()[3];
			StringBuffer sb	=	new StringBuffer();
			sb.append("=========================	BASE printSQL : "+stack.getClassName()+"."+stack.getMethodName()+"[line "+stack.getLineNumber()+"]");
			sb.append("\n"+sql.replaceAll("\n"," ").replace("\\t+"," ").replace("^\\s+",""));
			sb.append("\n;");
			System.out.println(sb.toString());
			//Logger.debug.println(sb.toString());
		}
	}
	
	/**
	  * ȸ   
	  * 20140903
	  * sunpark
	  */
	public String selFltPlanWithDocInfo(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT A.FLT_NUM, ");
		sql.append("   A.STNFR, ");
		sql.append("   A.STNTO, ");
		sql.append("   A.ALT_PORT, ");
		sql.append("   A.REGNO, ");
		sql.append("   A.ACTYP, ");
		sql.append("   A.PLANID, ");
		sql.append("   A.REGION_CD, ");
		sql.append("   A.EXTR_FUEL+A.PAD_FUEL                                       AS DISC, ");
		sql.append("   TO_CHAR(B.EST_DEP_DT,'DDMONYY','NLS_DATE_LANGUAGE=AMERICAN') AS DT, ");
		sql.append("   TO_CHAR(B.SCH_DEP_DT,'HH24MI')                               AS STD, ");
		sql.append("   TO_CHAR(B.ACT_DEP_DT,'HH24MI')                               AS ATD, ");
		sql.append("   TO_CHAR(B.SCH_ARV_DT,'HH24MI')                               AS STA, ");
		sql.append("   TO_CHAR(B.EST_ARV_DT,'HH24MI')                               AS ETA, ");
		
		//2016.12.12
		sql.append("   TO_CHAR(B.EST_DEP_DT,'HH24MI') 								AS ETD, ");
		sql.append("   REPLACE(TO_CHAR(FLOOR(A.ABHR/60),'00') || TO_CHAR(MOD(A.ABHR,60),'00'),' ','') AS EFT, ");
		
		sql.append("   NVL(B.TKOF_T,'')                                             AS TKOF_T, ");
		//20160301 ߰
		sql.append("   A.ETOPS_PORTS, ");
		sql.append("   DECODE(A.REFILE_Y,'Y',REFILE_POINT ||'/' ||REFILE_PORT ||'/' ||REFILE_ALT_PORTS,'') AS REFILE, ");
		sql.append("   DECODE(NVL(C.CAT,'X'), 'X', 'X', 'OK') AS PACKAGE_CAT, ");
		sql.append("   NVL(C.CONT,'')                         AS PACKAGE_CONT, ");
		sql.append("   NVL(C.FILE_PATH,'')                    AS PACKAGE_FILE_PATH, ");
		sql.append("   NVL(C.FILE_NAME,'')                    AS PACKAGE_FILE_NAME, ");
		sql.append("   DECODE(NVL(D.CAT,'X'), 'X', 'X', 'OK') AS CFP_CAT, ");
		sql.append("   NVL(D.CONT,'')                         AS CFP_CONT, ");
		sql.append("   NVL(D.FILE_PATH,'')                    AS CFP_FILE_PATH, ");
		sql.append("   NVL(D.FILE_NAME,'')                    AS CFP_FILE_NAME, ");
		sql.append("   DECODE(NVL(E.CAT,'X'), 'X', 'X', 'OK') AS NOTAM_CAT, ");
		sql.append("   NVL(E.CONT,'')                         AS NOTAM_CONT, ");
		sql.append("   NVL(E.FILE_PATH,'')                    AS NOTAM_FILE_PATH, ");
		sql.append("   NVL(E.FILE_NAME,'')                    AS NOTAM_FILE_NAME, ");
		sql.append("   DECODE(NVL(F.CAT,'X'), 'X', 'X', 'OK') AS TAF_CAT, ");
		sql.append("   NVL(F.CONT,'')                         AS TAF_CONT, ");
		sql.append("   NVL(F.FILE_PATH,'')                    AS TAF_FILE_PATH, ");
		sql.append("   NVL(F.FILE_NAME,'')                    AS TAF_FILE_NAME, ");
		sql.append("   DECODE(NVL(G.CAT,'X'), 'X', 'X', 'OK') AS RLSMSG_CAT, ");
		sql.append("   NVL(G.CONT,'')                         AS RLSMSG_CONT, ");
		sql.append("   NVL(G.FILE_PATH,'')                    AS RLSMSG_FILE_PATH, ");
		sql.append("   NVL(G.FILE_NAME,'')                    AS RLSMSG_FILE_NAME, ");
		sql.append("   DECODE(NVL(H.CAT,'X'), 'X', 'X', 'OK') AS WINTEM_CAT, ");
		sql.append("   NVL(H.CONT,'')                         AS WINTEM_CONT, ");
		sql.append("   NVL(H.FILE_PATH,'')                    AS WINTEM_FILE_PATH, ");
		sql.append("   NVL(H.FILE_NAME,'')                    AS WINTEM_FILE_NAME, ");
		sql.append("   DECODE(NVL(I.CAT,'X'), 'X', 'X', 'OK') AS SIGTURB_CAT, ");
		sql.append("   NVL(I.CONT,'')                         AS SIGTURB_CONT, ");
		sql.append("   NVL(I.FILE_PATH,'')                    AS SIGTURB_FILE_PATH, ");
		sql.append("   NVL(I.FILE_NAME,'')                    AS SIGTURB_FILE_NAME, ");
		sql.append("   DECODE(NVL(J.CAT,'X'), 'X', 'X', 'OK') AS ATC_CAT, ");
		sql.append("   NVL(J.CONT,'')                         AS ATC_CONT, ");
		sql.append("   NVL(J.FILE_PATH,'')                    AS ATC_FILE_PATH, ");
		sql.append("   NVL(J.FILE_NAME,'')                    AS ATC_FILE_NAME, ");
		sql.append("   NVL(K.TEL,'')                    	  AS BS_SIINFO_TEL ");
		sql.append(" FROM FLIGHT_PLAN_T A, DAILY_SCH_T B, KFOS.FLIGHT_DOC_T C, KFOS.FLIGHT_DOC_T D, ");
		sql.append("      KFOS.FLIGHT_DOC_T E, KFOS.FLIGHT_DOC_T F, KFOS.FLIGHT_DOC_T G, KFOS.FLIGHT_DOC_T H, KFOS.FLIGHT_DOC_T I, ");
		sql.append("      KFOS.FLIGHT_DOC_T J, KFOS.BS_SIINFO_T K ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" AND A.STNFR = B.STNFR ");
		sql.append(" AND A.STNTO = B.STNTO ");
		sql.append(" AND A.SYSKEY = C.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = D.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = E.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = F.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = G.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = H.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = I.SYSKEY(+) ");
		sql.append(" AND A.SYSKEY = J.SYSKEY(+) ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" AND A.SYSKEY = '" + params.getDocNo() + "' ");
		sql.append(" AND NVL(B.ACTNID,'') <> 'CNL' ");
		sql.append(" AND C.CAT(+) = 'PACKAGE' AND C.ACTIVE(+) = 'Y' ");
		sql.append(" AND D.CAT(+) = 'PLAN' AND D. ACTIVE (+) = 'Y' ");
		sql.append(" AND E.CAT(+) = 'NOTAM' AND E.ACTIVE (+) = 'Y' ");
		sql.append(" AND F.CAT(+) = 'TAF' AND F.ACTIVE (+) = 'Y' ");
		sql.append(" AND G.CAT(+) = 'FUEL' AND G.ACTIVE (+) = 'Y' ");
		sql.append(" AND H.CAT(+) = 'WINTEM' AND H.ACTIVE (+) = 'Y' ");
		sql.append(" AND I.CAT(+) = 'SIGTURB' AND I.ACTIVE (+) = 'Y' ");
		sql.append(" AND J.CAT(+) = 'ATC' AND I.ACTIVE (+) = 'Y' ");
		sql.append(" AND A.STNFR = K.DEP_PORT(+) ");
		sql.append(" AND A.STNTO = K.ARV_PORT(+) ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * ADDRESS ȸ   
	  * 20140903
	  * sunpark
	  */
	public String selFltPlanAddress(FfsQ240BG params, String grpStr) {
		StringBuffer sql = new StringBuffer();
		
		//20141030 ߰
		String arlnCdStr = " AND ARLN_CD = 'KE' ";
		String stnfrStr = params.getStnfr();
		if("4".equals(params.getFltNum().substring(0, 1))){
			arlnCdStr = " AND ARLN_CD = 'LJ' ";
			//20150107  ׺ ϴ° 
			//stnfrStr = "JNA";
		}
		//arlnCdStr += "4".equals(params.getFltNum().substring(0, 1)) ? "'LJ'" : "'KE'";
		
		//2016.09.07 ȣȭ  ENC_ADDR_LIST
		sql.append(" SELECT 'Email' as GB, ADDR_LIST, ENC_ADDR_LIST, OPTN ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + stnfrStr + "'  ");
		sql.append(" AND NTK = 'Email'  ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + stnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + stnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" union all ");
		sql.append(" SELECT 'SITA' as GB, ADDR_LIST, ENC_ADDR_LIST, OPTN ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + stnfrStr + "'  ");
		sql.append(" AND NTK = 'SITA'  ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + stnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + stnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" union all ");
		sql.append(" SELECT 'AFTN' as GB, ADDR_LIST, ENC_ADDR_LIST, OPTN ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + stnfrStr + "'  ");
		sql.append(" AND NTK = 'AFTN'  ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + stnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + stnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" union all ");
		sql.append(" SELECT 'FAX' as GB, ADDR_LIST, ENC_ADDR_LIST, OPTN ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + stnfrStr + "'  ");
		sql.append(" AND NTK = 'FAX'  ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + stnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + stnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * FLIGHT_ALERT_T update
	  * 20140903
	  * sunpark
	  */
	public String updFlightAlertT(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE KFOS.FLIGHT_ALERT_T ");
		sql.append(" SET PRV_DOC_NO = '" + params.getDocNo() + "' ");
		sql.append(" 	 , RLS_Y = 'R' ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND STNTO = '" + params.getStnto() + "' ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * FFS_ALERT_T update
	  * 20160301 ߰
	  * sunpark
	  */
	public String updFfsAlertT(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE KFOS.FFS_ALERT_T ");
		sql.append(" SET RELEASE_SYSKEY = '" + params.getDocNo() + "' ");
		sql.append(" 	 , RELEASE_FUEL_YN = 'R' ");
		sql.append(" 	 , PAYLOAD_ALERT = '' ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND STNTO = '" + params.getStnto() + "' ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * FLIGHT_DOC_LOG_T insert
	  * 20140903
	  * sunpark
	  */
	public String insFlightDocLogT(FfsQ240BG params, String sendGbn, String optn, String address) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO KFOS.FLIGHT_DOC_LOG_T ");
		sql.append("   (FIRST_LEG_FLT_DT ");
		sql.append("   , FLT_NUM ");
		sql.append("   , STNFR ");
		sql.append("   , STNTO ");
		sql.append("   , PLANID ");
		sql.append("   , SYSKEY ");
		sql.append("   , SENT_NTWK ");
		sql.append("   , SENT_CAT ");
		sql.append("   , SENT_ADDR ");
		sql.append("   , SND_TYPE ");
		sql.append("   , USERID ");
		sql.append("   , TIMESTMP) ");
		sql.append(" VALUES ");
		sql.append("   (TO_DATE('" + params.getFirstLegFltDt() + "', 'yyyyMMdd') ");
		sql.append("   , '" + params.getFltNum() + "' ");
		sql.append("   , '" + params.getStnfr() + "' ");
		sql.append("   , '" + params.getStnto() + "' ");
		sql.append("   , '" + params.getPlanid() + "' ");
		sql.append("   , '" + params.getDocNo() + "' ");
		sql.append("   , '" + sendGbn + "' ");	//߼۹(Email, SITA, AFTN, FAX)
		sql.append("   , '" + optn + "' ");		// 2 CAT 
		sql.append("   , '" + address + "' ");	//߼ ּ Ʈ(6 Sending Info Query   ADDR_LIST)
		//Released  ˾ DOC_NO PRV_DOC_NO    'Send'  insert 
		if("released".equals(params.getPopupType()) && (!"".equals(params.getPrvDocNo()) && params.getDocNo().equals(params.getPrvDocNo()))){
			sql.append("   , 'Send' ");
		} else if("enroute".equals(params.getPopupType())){
			sql.append("   , 'Send' ");
		} else {
			//20141210 beforeRelease ǿ MOVE   ߰
			if("Y".equals(params.getIsMove())) {
				sql.append("   , 'Move' ");
			} else {
				sql.append("   , 'Release' ");
			}
		}
		sql.append("   , '" + params.getEmpNo() + "' ");
		sql.append("   , SYSDATE) ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * RELEASE LOG ȸ   
	  * 20140903
	  * sunpark
	  */
	public String selFltReleaseLog(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PLANID, SENT_NTWK, SENT_CAT ,SENT_ADDR, SND_TYPE, TO_CHAR(TIMESTMP,'YY-MM-DD HH24:MI') AS TIMESTMP ");
		sql.append(" FROM KFOS.FLIGHT_DOC_LOG_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND STNTO = '" + params.getStnto() + "' ");
		sql.append(" ORDER BY TIMESTMP ASC, SENT_NTWK ASC, SENT_CAT ASC ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * BS_FUELMSG_T insert ׸ ȸ   
	  * 20140903
	  * sunpark
	  */
	public String selInfoForBsFuelmsgT(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') AS FSTDT,  ");
		sql.append("   A.FLT_NUM,  ");
		sql.append("   A.STNFR,  ");
		sql.append("   A.STNTO,  ");
		sql.append("   A.PLANID,  ");
		sql.append("   '01' AS ISSUED_NBR,  ");
		sql.append("   A.REGNO,  ");
		sql.append("   A.PLN_RAMP_FUEL*100                                        AS RAMP_FUEL,  ");
		sql.append("   A.TAXI_FUEL    *100                                        AS TAXI_FUEL,  ");
		sql.append("   A.PLN_TKOF_FUEL*100                                        AS TOF,  ");
		sql.append("   A.PLN_TRIP_FUEL*100                                        AS TIF,  ");
		sql.append("   A.PLN_PAYLOAD  *100                                        AS PAYLOAD,  ");
		sql.append("   A.PLN_TOW      *100                                        AS TOW,  ");
		sql.append("   NVL(A.DISP_NAME,'NO NAME')                                 AS DISP_NAME,  ");
		sql.append("   TO_CHAR(B.EST_DEP_DT,'HH24MI')                             AS EST_TIME,  ");
		sql.append("   TO_CHAR(B.EST_DEP_DT,'DDMON','NLS_DATE_LANGUAGE=AMERICAN') AS EST_DATE,  ");
		sql.append("   NVL(C.CC_FUEL_95*100,'0')                                  AS CC95,  ");
		sql.append("   NVL(C.CC_FUEL_75*100,'0')                                  AS CC75,  ");
		sql.append("   NVL(C.CC_FUEL_50*100,'0')                                  AS CC50,  ");
		sql.append("   NVL(D.SIINFO,'')                                           AS SIINFO  ");
		sql.append(" FROM FLIGHT_PLAN_T A,  ");
		sql.append("   DAILY_SCH_T B,  ");
		sql.append("   CM_CITYPAIR_AC_T C,  ");
		sql.append("   KFOS.BS_SIINFO_T D  ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT  ");
		sql.append(" AND A.FLT_NUM            = B.FLT_NUM  ");
		sql.append(" AND A.STNFR              = B.STNFR  ");
		sql.append(" AND A.STNTO              = B.STNTO  ");
		sql.append(" AND A.STNFR              = C.DEP_PORT(+)  ");
		sql.append(" AND A.STNTO              = C.ARV_PORT(+)  ");
		sql.append(" AND A.STNFR              = D.DEP_PORT(+)  ");
		sql.append(" AND A.STNTO              = D.ARV_PORT(+)  ");
		sql.append(" AND A.SYSKEY             = '" + params.getDocNo() + "'  ");
		sql.append(" AND B.ACTNID            <> 'CNL'  ");
		sql.append(" AND A.FIRST_LEG_FLT_DT   = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')  ");
		sql.append(" AND A.FLT_NUM            = '" + params.getFltNum() + "'  ");
		sql.append(" AND A.STNFR              = '" + params.getStnfr() + "'  ");
		sql.append(" AND A.STNTO              = '" + params.getStnto() + "'  ");
		sql.append(" AND A.PLANID             = '" + params.getPlanid() + "'  ");
		sql.append(" AND C.SACTYP             = '" + params.getActyp() + "'  ");
		
		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * BS_FUELMSG_T insert
	  * 20140903
	  * sunpark
	  */
	public String insBsFuelmsgT(FfsQ245BG params, String empNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("INSERT INTO BS_FUELMSG_T  ( ");
		sql.append("     FIRST_LEG_FLT_DT, ");
		sql.append("     FLT_NUM, ");
		sql.append("     STNFR, ");
		sql.append("     STNTO, ");
		sql.append("     MSG_SEQ, ");
		sql.append("     PLAN_NO, ");
		sql.append("     REGNO, ");
		sql.append("     EST_DEP_T, ");
		sql.append("     EST_DEP_D, ");
		sql.append("     RAMP_FUEL_Q, ");
		sql.append("     TAXI_FUEL_Q, ");
		sql.append("     ADD_FUEL_Q, ");
		sql.append("     ADD_RSN_CD, ");
		sql.append("     TOF_Q, ");
		sql.append("     TIF_Q, ");
		sql.append("     PLD_Q, ");
		sql.append("     TOW_Q, ");
		sql.append("     DISP_NAME, ");
		sql.append("     CC_FUEL95_Q, ");
		sql.append("     CC_FUEL75_Q, ");
		sql.append("     CC_FUEL50_Q, ");
		sql.append("     SI_INFO, ");
		sql.append("     TIMESTMP, ");
		sql.append("     USERID ");
		sql.append("   ) ");
		sql.append("   VALUES  ( ");
		sql.append("     TO_DATE('" + params.getFstdt() + "','YYYYMMDD'), ");
		sql.append("     '" + params.getFltNum() + "', ");
		sql.append("     '" + params.getStnfr() + "', ");
		sql.append("     '" + params.getStnto() + "', ");
		sql.append("     '" + params.getIssuedNbr() + "', ");
		sql.append("     '" + params.getPlanid() + "', ");
		sql.append("     '" + params.getRegno() + "', ");
		sql.append("     '" + params.getEstTime() + "', ");
		sql.append("     '" + params.getEstDate() + "', ");
		sql.append("     '" + params.getRampFuel() + "', ");
		sql.append("     '" + params.getTaxiFuel() + "', ");
		sql.append("     '0', ");
		sql.append("     NULL, ");
		sql.append("     '" + params.getTof() + "', ");
		sql.append("     '" + params.getTif() + "', ");
		sql.append("     '" + params.getPayload() + "', ");
		sql.append("     '" + params.getTow() + "', ");
		sql.append("     '" + params.getDispName() + "', ");
		sql.append("     '" + params.getCc95() + "', ");
		sql.append("     '" + params.getCc75() + "', ");
		sql.append("     '" + params.getCc50() + "', ");
		sql.append("     '" + params.getSiinfo() + "', ");
		sql.append("     SYSDATE, ");
		sql.append("     '" + empNo + "' ");
		sql.append("   ) ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * SITA  BS_FUELMSG_T ׸ ȸ   
	  * 20140903
	  * sunpark
	  */
	public String selBsFuelmsgTForSita(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE,'DDHH24MI') SYSDT, ");
		sql.append("   'KE'||DECODE(SUBSTR(FM.FLT_NUM,1,1),0,SUBSTR(FM.FLT_NUM,2),FM.FLT_NUM) FLTNR, ");
		sql.append("   TO_CHAR(B.SCH_DEP_DT,'DDMONYY','NLS_DATE_LANGUAGE=AMERICAN') STD, ");
		sql.append("   FM.STNFR, ");
		sql.append("   TO_NUMBER(SUBSTR(FM.MSG_SEQ,1,2)) MSG_SEQ, ");
		sql.append("   FM.RAMP_FUEL_Q TOF, ");
		sql.append("   FM.TIF_Q TIF, ");
		sql.append("   FM.TOW_Q RTOW, ");
		sql.append("   FM.TAXI_FUEL_Q STF, ");
		sql.append("   FM.REGNO ");
		sql.append(" FROM BS_FUELMSG_T FM, ");
		sql.append("   DAILY_SCH_T B ");
		sql.append(" WHERE FM.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FM.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND FM.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND FM.STNTO = '" + params.getStnto() + "' ");
		sql.append(" AND FM.MSG_SEQ = '01' ");
		sql.append(" AND FM.PLAN_NO = '" + params.getPlanid() + "' ");
		sql.append(" AND FM.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND FM.FLT_NUM = B.FLT_NUM ");
		sql.append(" AND FM.STNFR = B.STNFR ");
		sql.append(" AND FM.STNTO = B.STNTO ");
		sql.append(" AND NVL(B.ACTNID,'') <> 'CNL' ");

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	  * ˾ ׸ ȸ   
	  * 20140903
	  * sunpark
	  */
	public String selFltPlanDocObjectInfo(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT ");
		sql.append("   DECODE(NVL(C.CAT,'X'), 'X', 'X', 'OK') AS CAT, ");
		sql.append("   NVL(C.CONT,'')                         AS CONT, ");
		sql.append("   NVL(C.FILE_PATH,'')                    AS FILE_PATH, ");
		sql.append("   NVL(C.FILE_NAME,'')                    AS FILE_NAME ");
		sql.append(" FROM FLIGHT_PLAN_T A, DAILY_SCH_T B, KFOS.FLIGHT_DOC_T C ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" AND A.STNFR = B.STNFR ");
		sql.append(" AND A.STNTO = B.STNTO ");
		sql.append(" AND A.SYSKEY = C.SYSKEY(+) ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" AND A.SYSKEY = '" + params.getDocNo() + "' ");
		sql.append(" AND NVL(B.ACTNID,'') <> 'CNL' ");
		if("C".equals(StringUtil.checkString(params.getFlag()))){
			sql.append(" AND C.CAT(+) = 'PLAN' AND C. ACTIVE (+) = 'Y' ");
		} else if("T".equals(StringUtil.checkString(params.getFlag()))){
			sql.append(" AND C.CAT(+) = 'TAF' AND C.ACTIVE (+) = 'Y' ");
		} else if("R".equals(StringUtil.checkString(params.getFlag()))){
			sql.append(" AND C.CAT(+) = 'FUEL' AND C.ACTIVE (+) = 'Y' ");
		}

		printSQL(sql);
		return sql.toString();
	}
	
	/**
	 * 20160301 ߰ 
	 */
	public String selAdditionalMelCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" SELECT ");
		sql.append("   B.MEL_NO ");
		sql.append(" FROM (SELECT ");
		sql.append("         REGNO, MSG_TMPST ");
		sql.append("       FROM FLIGHT_PLAN_T ");
		sql.append("       WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append("       AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append("       AND STNFR = '" + params.getStnfr() + "' ");
		sql.append("       AND STNTO = '" + params.getStnto() + "' ");
		sql.append("       AND ACTIVE = 'Y' ");
		sql.append("       AND DOC_Y = 'Y' ");
		sql.append("       ) A,  ");
		sql.append("       (SELECT ");
		sql.append("         HL_NO, MEL_NO, TO_DATE(REPLACE(ISS_D,'T',' '),'YYYY-MM-DD HH24:MI:SS') AS ISS_D ");
		sql.append("       FROM KFOS.ERP_MEL_II) B ");
		sql.append(" WHERE A.REGNO = B.HL_NO ");
		sql.append(" AND B.ISS_D >= A.MSG_TMPST ");
		*/
		sql.append(" SELECT ");
		sql.append("   B.MEL_NO ");
		sql.append(" FROM FLIGHT_PLAN_T A, KFOS.ERP_MEL_II B ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM            = '" + params.getFltNum() + "' ");
		sql.append(" AND STNFR              = '" + params.getStnfr() + "' ");
		sql.append(" AND STNTO              = '" + params.getStnto() + "' ");
		sql.append(" AND A.ACTIVE = 'Y' ");
		sql.append(" AND A.REGNO = B.HL_NO ");
		sql.append(" AND B.DEF_TYPE = 'MEL'  ");
		sql.append(" ORDER BY B.ISS_D ASC ");

		printSQL(sql);
		return sql.toString();
	}
	
	public String selAdditionalCdlCheck(FfsQ240BG params) {//@2017-08-17		
		StringBuffer sql = new StringBuffer();
		/*
		sql.append("SELECT");
		sql.append("		B.REMARKS_CONTENTS");
		sql.append("	FROM");
		sql.append("		(");
		sql.append("			SELECT");
		sql.append("				REGNO ,	MSG_TMPST");
		sql.append("			FROM");
		sql.append("				FLIGHT_PLAN_T");
		sql.append("			WHERE");
		sql.append("						FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "' ,	'YYYYMMDD')");
		sql.append("			AND	FLT_NUM = '" + params.getFltNum() + "'");
		sql.append("			AND	STNFR = '" + params.getStnfr() + "'");
		sql.append("			AND	STNTO = '" + params.getStnto() + "'");
		sql.append("			AND	ACTIVE = 'Y'");
		sql.append("			AND	DOC_Y = 'Y'");
		sql.append("		) A");
		sql.append("	,	(");
		sql.append("			SELECT");
		sql.append("				HL_NO");
		sql.append("			,	MEL_NO");
		sql.append("			,	DEF_TYPE");
		sql.append("			,	REMARKS_CONTENTS");
		sql.append("			,	TO_DATE(REPLACE(ISS_D ,	'T' ,	' '),	'YYYY-MM-DD HH24:MI:SS') AS ISS_D");
		sql.append("			FROM");
		sql.append("				KFOS.ERP_MEL_II");
		sql.append("		) B");
		sql.append("	WHERE");
		sql.append("				A.REGNO = B.HL_NO");
		sql.append("	AND	B.ISS_D >= A.MSG_TMPST");
		sql.append("	AND	B.DEF_TYPE = 'CDL'");
		*/
		//@2017-09-15
		sql.append(" SELECT ");
		sql.append("   B.REMARKS_CONTENTS");
		sql.append(" FROM FLIGHT_PLAN_T A, KFOS.ERP_MEL_II B ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM            = '" + params.getFltNum() + "' ");
		sql.append(" AND STNFR              = '" + params.getStnfr() + "' ");
		sql.append(" AND STNTO              = '" + params.getStnto() + "' ");
		sql.append(" AND A.ACTIVE = 'Y' ");
		sql.append(" AND A.REGNO = B.HL_NO ");
		sql.append(" AND B.DEF_TYPE = 'CDL'  ");
		sql.append(" ORDER BY B.ISS_D ASC ");

		printSQL(sql);
		return sql.toString();
	}
	
	public String selOpspecCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT 1 as ORD, 'DEPARR_YN' AS GBN, DEPARR_YN, '' AS ALTN_YN, '' AS EDTO_YN, '' AS REFILE_YN ");
		sql.append(" FROM KFOS.CM_OPSPEC_AC_T ");
		sql.append(" WHERE IATA_PORT in ('" +params.getStnfr()+ "','" +params.getStnto()+ "') ");
		sql.append(" AND SACTYP      = '" + params.getActyp() + "' ");
		sql.append(" UNION  ");
		sql.append(" SELECT 2 as ORD, 'ALTN_YN' AS GBN, '' AS DEPARR_YN, ALTN_YN, '' AS EDTO_YN, '' AS REFILE_YN ");
		sql.append(" FROM KFOS.CM_OPSPEC_AC_T ");
		sql.append(" WHERE IATA_PORT = '" +params.getAltPort()+ "' ");
		sql.append(" AND SACTYP      = '" + params.getActyp() + "' ");
		if(!"".equals(params.getEdtoPort())) {
			sql.append(" UNION  ");
			sql.append(" SELECT 3 as ORD, 'EDTO_YN' AS GBN, '' AS DEPARR_YN, '' AS ALTN_YN, EDTO_YN, '' AS REFILE_YN ");
			sql.append(" FROM KFOS.CM_OPSPEC_AC_T ");
			sql.append(" WHERE IATA_PORT in (" + params.getEdtoPort() + ") ");
			sql.append(" AND SACTYP      = '" + params.getActyp() + "' ");
		}
		if(!"".equals(params.getRefile())) {
			sql.append(" UNION  ");
			sql.append(" SELECT 4 as ORD, 'REFILE_YN' AS GBN, '' AS DEPARR_YN, '' AS ALTN_YN, '' AS EDTO_YN, REFILE_YN ");
			sql.append(" FROM KFOS.CM_OPSPEC_AC_T ");
			sql.append(" WHERE IATA_PORT in (" + params.getRefile() + ") ");
			sql.append(" AND SACTYP      = '" + params.getActyp() + "' ");
		}
		sql.append(" order by ord  ");

		printSQL(sql);
		return sql.toString();
	}
	public String selRestrictedFirCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append("   BB.FIR_CD ");
		sql.append(" FROM (SELECT ");
		sql.append("         B.FIR_CD ");
		sql.append("       FROM FLIGHT_PLAN_T A, FPL_FIR_T B ");
		sql.append("       WHERE A.SYSKEY = B.SYSKEY ");
		sql.append("       AND A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append("       AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append("       AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append("       AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append("       AND A.ACTIVE = 'Y' ");
		sql.append("       AND A.DOC_Y = 'Y' ");
		sql.append("       ) AA ");
		sql.append("       , KFOS.CM_RESTRICTED_FIR_T BB ");
		sql.append(" WHERE AA.FIR_CD = BB.FIR_CD ");
		
		printSQL(sql);
		return sql.toString();
	}
	
	public String selSowDiffCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();

		//2016.12.12
		sql.append(" SELECT																													 ");	
		sql.append("    CASE WHEN FPL_SOW = OPS_SOW THEN 'N'     ELSE 'Y'                                                                    ");
		sql.append("    END AS SOW_ALERT                                                                                                     ");
		sql.append("  FROM (                                                                                                                 ");
		sql.append("      SELECT                                                                                                             ");
		sql.append("          A.OPS_CD, A.REGNO, A.FPL_SOW                                                                                   ");
		sql.append("          , DECODE(NVL(C.EXCEPTION_SOW,'N'), 'JPN', B.SOW_JPN, 'SEA', B.SOW_SEA, 'INTL', B.SOW_INTL,                     ");
		sql.append("                       DECODE(OPS_CD, 'JPN', B.SOW_JPN, 'SEA', B.SOW_SEA, 'INTL', B.SOW_INTL)) AS OPS_SOW                ");
		sql.append("          , NVL(C.EXCEPTION_SOW,'N') EXCEPTION_SOW                                                                       ");
		sql.append("        FROM (SELECT                                                                                                     ");
		sql.append("                DECODE(REGION_CD,'JPN','JPN','CHN','SEA','SEA','SEA','OCN','INTL','AME','INTL','EUR','INTL') AS OPS_CD,  ");
		sql.append("                STNFR, STNTO, ACTYP, REGNO, SOW * 100 FPL_SOW                                                            ");
		sql.append("              FROM FLIGHT_PLAN_T                                                                                         ");
		sql.append("              WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')                           ");
		sql.append("              AND FLT_NUM = '" + params.getFltNum() + "'                                                                 ");
		sql.append("              AND STNFR = '" + params.getStnfr() + "'                                                                    ");
		sql.append("              AND STNTO = '" + params.getStnto() + "'                                                                    ");
		sql.append("              AND ACTIVE = 'Y'                                                                                           ");
		sql.append("              AND DOC_Y = 'Y'                                                                                            ");
		sql.append("              ) A                                                                                                        ");
		sql.append("              , KFOS.OC_AIRCRAFT_T B                                                                                     ");
		sql.append("              , CM_CITYPAIR_AC_T C                                                                                       ");
		sql.append("        WHERE A.REGNO = B.REGNO                                                                                          ");
		sql.append("        AND A.STNFR = C.DEP_PORT                                                                                         ");
		sql.append("        AND A.STNTO = C.ARV_PORT                                                                                         ");
		sql.append("        AND A.ACTYP = C.SACTYP                                                                                           ");
		sql.append("        )                                                                                                                ");

		printSQL(sql);
		return sql.toString();
	}
	
	//2016.12.12 
	public String selCCFTimeAlert(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" \n");
		sql.append(" SELECT																			  \n");
		sql.append("   CASE WHEN CONT_TIME < 5 THEN 'Y'                                               \n");
		sql.append("        ELSE 'N' END AS CONT_ALERT                                                \n");
		sql.append(" FROM FLIGHT_PLAN_T                                                               \n");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') \n");
		sql.append(" AND FLT_NUM = '" + params.getFltNum() + "'                                       \n");
		sql.append(" AND STNFR = '" + params.getStnfr() + "'                                          \n");
		sql.append(" AND STNTO = '" + params.getStnto() + "'                                          \n");
		sql.append(" AND ACTIVE = 'Y'                                                                 \n");
		sql.append(" AND DOC_Y = 'Y'                                                                  \n");
		
		printSQL(sql);
		return sql.toString();
	}
	
	//2016.12.12 FODIS  Payload  Plan  Payload 
	public String selPldDiffCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" \n");
		sql.append(" SELECT 																										 \n");
		sql.append("   A.PLN_PAYLOAD*100 - (NVL(B.REQ_PAX_PLD_WT,0) + NVL(B.REQ_CGO_PLD_WT,0) + NVL(B.REQ_OTH_PLD_WT,0)) AS PLD_DIFF \n");
		sql.append(" FROM FLIGHT_PLAN_T A, PDP_FLT_PAYLOAD_T B                                                                       \n");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')                              \n");
		sql.append(" AND A.FLT_NUM = '" + params.getFltNum() + "'                                                                    \n");
		sql.append(" AND A.STNFR = '" + params.getStnfr() + "'                                                                       \n");
		sql.append(" AND A.STNTO = '" + params.getStnto() + "'                                                                       \n");
		sql.append(" AND A.ACTIVE = 'Y'                                                                                              \n");
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT                                                                     \n");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM                                                                                       \n");
		sql.append(" AND A.STNFR = B.STNFR                                                                                           \n");
		sql.append(" AND A.sTNTO = B.STNTO                                                                                           \n");

		printSQL(sql);
		return sql.toString();
	}
	
	//2016.12.12 UKFOS  CCF Plan  CCF  
	public String selCCFDiffCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" \n");		
		sql.append(" SELECT																													 \n");
		sql.append("   PAD_FUEL - CCF_FUEL AS CCF_DIFF                                                                                       \n");
		sql.append(" FROM (SELECT                                                                                                            \n");
		sql.append("         A.PAD_FUEL,                                                                                                     \n");
		sql.append("         CASE WHEN A.REFILE_Y = 'Y' AND B.CCF_CALC_Y = 'Y' THEN B.CC_FUEL_95                                             \n");
		sql.append("              WHEN A.REFILE_Y = 'N' AND B.CCF_CALC_Y = 'Y' THEN B.CC_FUEL_50                                             \n");
		sql.append("              WHEN A.REFILE_Y = 'N' AND B.CCF_CALC_Y = 'N' THEN NVL(C.MISC_Q,100)/100                                    \n");
		sql.append("              ELSE (CASE WHEN A.ABHR/60 < 6 THEN NVL(D.MISC_Q,100)/100                                                   \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 6 AND 8 AND A.ACTYP IN ('744','74Y','74E','74N','74H') THEN 35           \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 6 AND 8 AND A.ACTYP IN ('773','772','77W','333','332','77X') THEN 25     \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 6 AND 8 AND A.ACTYP IN ('388') THEN 38                                   \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 6 AND 8 AND A.ACTYP IN ('738','739','73H','73J','73W') THEN 7            \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 6 AND 8 AND A.ACTYP IN ('AB6','ABF','ABY') THEN 17                       \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 6 AND 8 AND A.ACTYP IN ('789') THEN 20                                   \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 8 AND 10 AND A.ACTYP IN ('744','74Y','74E','74N','74H') THEN 40          \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 8 AND 10 AND A.ACTYP IN ('773','772','77W','333','332','77X') THEN 30    \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 8 AND 10 AND A.ACTYP IN ('388') THEN 44                                  \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 8 AND 10 AND A.ACTYP IN ('738','739','73H','73J','73W') THEN 8           \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 8 AND 10 AND A.ACTYP IN ('AB6','ABF','ABY') THEN 19                      \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 8 AND 10 AND A.ACTYP IN ('789') THEN 25                                  \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 10 AND 12 AND A.ACTYP IN ('744','74Y','74E','74N','74H') THEN 50         \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 10 AND 12 AND A.ACTYP IN ('773','772','77W','333','332','77X') THEN 35   \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 10 AND 12 AND A.ACTYP IN ('388') THEN 55                                 \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 10 AND 12 AND A.ACTYP IN ('738','739','73H','73J','73W') THEN 9          \n");
		sql.append("                         WHEN A.ABHR/60 > 10 AND A.ACTYP IN ('AB6','ABF','ABY') THEN 24                                  \n");
		sql.append("                         WHEN A.ABHR/60 BETWEEN 10 AND 12 AND A.ACTYP IN ('789') THEN 25                                 \n");
		sql.append("                         WHEN A.ABHR/60 > 12 AND A.ACTYP IN ('744','74Y','74E','74N','74H') THEN 55                      \n");
		sql.append("                         WHEN A.ABHR/60 > 12 AND A.ACTYP IN ('773','772','77W','333','332','77X') THEN 40                \n");
		sql.append("                         WHEN A.ABHR/60 > 12 AND A.ACTYP IN ('388') THEN 60                                              \n");
		sql.append("                         WHEN A.ABHR/60 > 12 AND A.ACTYP IN ('738','739','73H','73J','73W') THEN 11                      \n");
		sql.append("                         ELSE 35 END) END AS CCF_FUEL                                                                    \n");
		sql.append("       FROM FLIGHT_PLAN_T A, CM_CITYPAIR_AC_T B, FC_MISC_T@COPERA C, FC_MISC_T@COPERA D                                  \n");
		sql.append("       WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')                                \n");
		sql.append("       AND A.FLT_NUM = '" + params.getFltNum() + "'                                                                      \n");
		sql.append("       AND A.STNFR = '" + params.getStnfr() + "'                                                                         \n");
		sql.append("       AND A.STNTO = '" + params.getStnto() + "'                                                                         \n");
		sql.append("       AND A.ACTIVE = 'Y'                                                                                                \n");
		sql.append("       AND A.STNFR = B.DEP_PORT                                                                                          \n");
		sql.append("       AND A.STNTO = B.ARV_PORT                                                                                          \n");
		sql.append("       AND A.ACTYP = B.SACTYP                                                                                            \n");
		sql.append("       AND C.MISC_C1(+) = 'CCG'                                                                                          \n");
		sql.append("       AND A.ACTYP = C.MISC_C2(+)                                                                                        \n");
		sql.append("       AND C.MISC_ISS_DT(+) <= SYSDATE                                                                                   \n");
		sql.append("       AND C.MISC_EXP_DT(+) >= SYSDATE                                                                                   \n");
		sql.append("       AND D.MISC_C1(+) = 'CCR'                                                                                          \n");
		sql.append("       AND A.ACTYP = D.MISC_C2(+)                                                                                        \n");
		sql.append("       AND D.MISC_ISS_DT(+) <= SYSDATE                                                                                   \n");
		sql.append("       AND D.MISC_EXP_DT(+) >= SYSDATE                                                                                   \n");
		sql.append("       )                                                                                                                 \n");

		printSQL(sql);
		return sql.toString();
	}
	
	
	/**
	  * 20160301 ߰
	  */
	public String selEmailSendLog(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append("   BB.EMAIL, TO_CHAR(BB.MSG_TMPST,'YY/MM/DD HH24:MI') AS TMPST, ");
		sql.append("   CASE WHEN BB.TITLE LIKE '%Package' THEN 'PACKAGE' ");
		sql.append("        WHEN BB.TITLE LIKE '%SIGTURB' THEN 'SIGTURB' ");
		sql.append("        WHEN BB.TITLE LIKE '%CFP' THEN 'CFP' ");
		sql.append("        WHEN BB.TITLE LIKE '%WINTEM' THEN 'WINTEM' ");
		sql.append("        WHEN BB.TITLE LIKE '%NOTAM' THEN 'NOTAM' ");
		sql.append("        WHEN BB.TITLE LIKE '%TAF' THEN 'TAF' ");
		sql.append("        WHEN BB.TITLE LIKE '%Release Msg' THEN 'FUEL' ");
		sql.append("   ELSE '' END AS CAT, ");
		sql.append("   DECODE(NVL(CC.ERROR_CODE,''),'','No ACK',CC.ERROR_CODE_NAME) AS RCV_ACK ");
		sql.append(" FROM (SELECT DISTINCT ");
		sql.append("         FLT_NUM, TIMESTMP, ");
		sql.append("         REGEXP_SUBSTR(A.SENT_ADDR, '[^,]+', 1, LEVEL) AS ADDR ");
		sql.append("       FROM (SELECT ");
		sql.append("               FLT_NUM, TIMESTMP, SENT_ADDR ");
		sql.append("             FROM KFOS.FLIGHT_DOC_LOG_T ");
		sql.append("             WHERE SENT_NTWK = 'Email' ");
		sql.append("             AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') ");
		sql.append("             AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append("             AND PLANID = '" + params.getPlanid() + "' ");
		sql.append("             ) A ");
		sql.append("       CONNECT BY LEVEL <= LENGTH(REGEXP_SUBSTR(SENT_ADDR, '[^,]+', 1, LEVEL))+1 ");
		sql.append("       ) AA, KFOS.UMS_SND_T BB, KFOS.UMS_RCV_T CC ");
		sql.append(" WHERE 1=1 ");
		sql.append(" AND BB.EID = CC.EID(+) ");
		sql.append(" AND AA.ADDR = BB.EMAIL ");
		sql.append(" AND BB.TITLE LIKE '%'||AA.FLT_NUM||'%' ");
		sql.append(" AND BB.TITLE LIKE 'DOCUMENT FOR%' ");
		sql.append(" AND BB.MSG_TMPST BETWEEN AA.TIMESTMP-3/1440 AND AA.TIMESTMP+3/1440 ");
		sql.append(" AND BB.MSG_CAT = 'SKYWEB' ");
		sql.append(" AND CC.ERROR_CODE(+) <> 'SU' ");
		sql.append(" ORDER BY BB.EID ASC ");

		printSQL(sql);
		return sql.toString();
	}

	//------------------------------	@2017-09-01
	public String selEraCheck(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT");
		sql.append("   ERA_Y");
		sql.append(" FROM FLIGHT_PLAN_T");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')");
		sql.append(" AND FLT_NUM = '" + params.getFltNum() + "'");
		sql.append(" AND STNFR = '" + params.getStnfr() + "'");
		sql.append(" AND STNTO = '" + params.getStnto() + "'");
		sql.append(" AND ACTIVE = 'Y'");

		printSQL(sql);
		return sql.toString();
	}
	//------------------------------	@2018-01-14
	public String selEraCheckCs3(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT");
		sql.append("	CASE WHEN PLN_TOW > 1050 THEN 'Y' ELSE 'N' END AS TOW_YN");
		sql.append(" ,	NVL(ERA_Y,'N') AS ERA_YN");
		sql.append(" FROM FLIGHT_PLAN_T");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')");
		sql.append(" AND FLT_NUM = '" + params.getFltNum() + "'");
		sql.append(" AND STNFR = '" + params.getStnfr() + "'");
		sql.append(" AND STNTO = '" + params.getStnto() + "'");
		sql.append(" AND ACTIVE = 'Y'");
		sql.append(" AND DOC_Y = 'Y'");
		sql.append(" AND ACTYP = 'CS3'");

		printSQL(sql);
		return sql.toString();
	}
	//------------------------------	@2018-03-27
	public String selAltYn(FfsQ240BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT");
		sql.append(" 	CASE WHEN B.ALT_PORT LIKE '%'||A.ALT_PORT||'%' THEN 'N' ELSE 'Y' END AS ALT_YN");
		sql.append(" FROM");
		sql.append(" 	FLIGHT_PLAN_T A");
		sql.append(" ,	CM_PORT_AC_T B");
		sql.append(" WHERE");
		sql.append(" 	A.STNTO = B.IATA_PORT");
		sql.append(" AND	A.ACTYP = B.SACTYP");
		sql.append(" AND	A.ACTIVE = 'Y'");
		sql.append(" AND	A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "',	'YYYYMMDD')");
		sql.append(" AND	A.FLT_NUM = '" + params.getFltNum() + "'");
		sql.append(" AND	A.STNFR = '" + params.getStnfr() + "'");
		sql.append(" AND	A.STNTO = '" + params.getStnto() + "'");
		
		printSQL(sql);
		return sql.toString();
	}
}
