package kal.base.ffs.query;
/*
@2018-08-20 
DAILY_SCH_T, IIS_ACDM_DEP_T ̺
*/
import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.FfsQ250BG;

public class FfsQ250Query {
	private static FfsQ250Query instance = new FfsQ250Query();
	
	public static FfsQ250Query getInstance() {
		return instance;
	}
	/*************************************************************************
	public String selAcdm(FfsQ250BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT");
		sql.append("		TO_CHAR(A.SCH_DEP_DT_LOC ,	'HH24:MI') AS STD");
		sql.append("	,	B.STATUS_CD");
		sql.append("	,	SUBSTR(B.TIMESTAMP ,	9 ,	2)||':'||SUBSTR(B.TIMESTAMP ,	11 ,	2) AS TIMESTMP");
		sql.append("	,	TO_CHAR(A.EST_DEP_DT_LOC ,	'HH24:MI') AS ETD");
		sql.append("	,	DECODE(B.MLSTN_CD1_DT ,	'' ,	'' ,	SUBSTR(B.MLSTN_CD1_DT ,	9 ,	2)||':'||SUBSTR(B.MLSTN_CD1_DT ,	11 ,	2)) AS EOBT");
		sql.append("	,	DECODE(B.TOBT_DT ,	'' ,	'' ,	SUBSTR(B.TOBT_DT ,	9 ,	2)||':'||SUBSTR(B.TOBT_DT ,	11 ,	2)) AS TOBT");
		sql.append("	,	DECODE(B.CTOT_DT ,	'' ,	'' ,	SUBSTR(B.CTOT_DT ,	9 ,	2)||':'||SUBSTR(B.CTOT_DT ,	11 ,	2)) AS COBT");
		sql.append("	,	DECODE(A.DEP_STS ,	'ACT' ,	TO_CHAR(A.ACT_DEP_DT_LOC ,	'HH24:MI'),	'') AS ATD");
		sql.append("	,	DECODE(B.TSAT_DT ,	'' ,	'' ,	SUBSTR(B.TSAT_DT ,	9 ,	2)||':'||SUBSTR(B.TSAT_DT ,	11 ,	2)) AS TSAT");
		sql.append("	,	DECODE(B.TTOT_DT ,	'' ,	'' ,	SUBSTR(B.TTOT_DT ,	9 ,	2)||':'||SUBSTR(B.TTOT_DT ,	11 ,	2)) AS TTOT");
		sql.append("	,	A.STNTO");
		sql.append("	FROM");
		sql.append("		DAILY_SCH_T A");
		sql.append("	,	KPMS.IIS_ACDM_DEP_T B");
		sql.append("	WHERE");
		sql.append("		A.SCH_DEP_DT_LOC = TO_DATE(B.SCH_DEP_DT_LOC ,	'YYYYMMDDHH24MI')");
		sql.append("	AND	A.FLT_NUM = B.FLT_NUM");
		sql.append("	AND	A.ACTNID <> 'CNL'");
		sql.append("	AND	A.FIRST_LEG_FLT_DT = TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD')");
		sql.append("	AND	A.FLT_NUM = '"+params.getFltNum()+"'");
		sql.append("	AND	A.STNFR = NVL('"+params.getStnfr()+"',A.STNFR)");
		sql.append("	AND	A.STNTO = NVL('"+params.getStnto()+"',A.STNTO)");
		sql.append("	AND	B.AFS_ID BETWEEN ");
		sql.append("				TO_CHAR(TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD')-10,	'YYYYMMDD')||'00000000000000'");
		sql.append("				AND	TO_CHAR(TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD'),	'YYYYMMDD')||'99999999999999'");
		sql.append("	ORDER BY");
		sql.append("		B.AFS_ID");
		sql.append("	,	B.TIMESTAMP DESC");

		Logger.debug.println("[BASE:FfsQ250Query:selAcdm] sql : "+sql.toString());
		return sql.toString();
	}*/
	
	/**************************************************************************/
	public String selAcdmIcn(FfsQ250BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT");
		sql.append("		TO_CHAR(A.SCH_DEP_DT_LOC ,	'HH24:MI') AS STD");
		sql.append("	,	B.STATUS_CD");
		sql.append("	,	SUBSTR(B.TIMESTAMP ,	9 ,	2)||':'||SUBSTR(B.TIMESTAMP ,	11 ,	2) AS TIMESTMP");
		sql.append("	,	TO_CHAR(A.EST_DEP_DT_LOC ,	'HH24:MI') AS ETD");
		sql.append("	,	DECODE(B.MLSTN_CD1_DT ,	'' ,	'' ,	SUBSTR(B.MLSTN_CD1_DT ,	9 ,	2)||':'||SUBSTR(B.MLSTN_CD1_DT ,	11 ,	2)) AS EOBT");
		sql.append("	,	DECODE(B.TOBT_DT ,	'' ,	'' ,	SUBSTR(B.TOBT_DT ,	9 ,	2)||':'||SUBSTR(B.TOBT_DT ,	11 ,	2)) AS TOBT");
		sql.append("	,	DECODE(B.CTOT_DT ,	'' ,	'' ,	SUBSTR(B.CTOT_DT ,	9 ,	2)||':'||SUBSTR(B.CTOT_DT ,	11 ,	2)) AS COBT");
		sql.append("	,	DECODE(A.DEP_STS ,	'ACT' ,	TO_CHAR(A.ACT_DEP_DT_LOC ,	'HH24:MI'),	'') AS ATD");
		sql.append("	,	DECODE(B.TSAT_DT ,	'' ,	'' ,	SUBSTR(B.TSAT_DT ,	9 ,	2)||':'||SUBSTR(B.TSAT_DT ,	11 ,	2)) AS TSAT");
		sql.append("	,	DECODE(B.TTOT_DT ,	'' ,	'' ,	SUBSTR(B.TTOT_DT ,	9 ,	2)||':'||SUBSTR(B.TTOT_DT ,	11 ,	2)) AS TTOT");
		sql.append("	,	A.STNTO");
		sql.append("	FROM");
		sql.append("		DAILY_SCH_T A");
		sql.append("	,	KPMS.IIS_ACDM_DEP_T B");
		sql.append("	WHERE");
		sql.append("		A.SCH_DEP_DT_LOC = TO_DATE(B.SCH_DEP_DT_LOC ,	'YYYYMMDDHH24MI')");
		sql.append("	AND	A.FLT_NUM = B.FLT_NUM");
		sql.append("	AND	A.ACTNID <> 'CNL'");
		sql.append("	AND	A.FIRST_LEG_FLT_DT = TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD')");
		sql.append("	AND	A.FLT_NUM = '"+params.getFltNum()+"'");
		sql.append("	AND	A.STNFR = 'ICN'");
		sql.append("	AND	A.STNTO = NVL('"+params.getStnto()+"',A.STNTO)");
		sql.append("	AND	B.AFS_ID BETWEEN ");
		sql.append("				TO_CHAR(TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD')-10,	'YYYYMMDD')||'00000000000000'");
		sql.append("				AND	TO_CHAR(TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD'),	'YYYYMMDD')||'99999999999999'");
		sql.append("	ORDER BY");
		sql.append("		B.AFS_ID");
		sql.append("	,	B.TIMESTAMP DESC");

		Logger.debug.println("[BASE:FfsQ250Query:selAcdmIcn] sql : "+sql.toString());
		return sql.toString();
	}
	/**************************************************************************/
	public String selAcdmNotIcn(FfsQ250BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT");
		sql.append("		TO_CHAR(A.SCH_DEP_DT_LOC ,	'HH24:MI') AS STD");
		sql.append("	,	'' AS STATUS");
		sql.append("	,	SUBSTR(B.ATFMS_TMPST ,	9 ,	2)||':'||SUBSTR(B.ATFMS_TMPST ,	11 ,	2) AS TIMESTMP");
		sql.append("	,	TO_CHAR(A.EST_DEP_DT_LOC ,	'HH24:MI') AS ETD");
		sql.append("	,	'' AS TOBT");
		sql.append("	,	DECODE(B.CTOT ,	'' ,	'' ,	SUBSTR(B.CTOT ,	9 ,	2)||':'||SUBSTR(B.CTOT ,	11 ,	2)) AS COBT");
		sql.append("	,	DECODE(A.DEP_STS ,	'ACT' ,	TO_CHAR(A.ACT_DEP_DT_LOC ,	'HH24:MI'),	'') AS ATD");
		sql.append("	,	'' AS TSAT");
		sql.append("	,	'' AS TTOT");
		sql.append("	FROM");
		sql.append("		DAILY_SCH_T A");
		sql.append("	,	KFOS.ATFMS_CTOT_RCV B");
		sql.append("	,	CM_PORT_T C");
		sql.append("	,	CM_PORT_T D");
		sql.append("	WHERE");
		sql.append("		A.SCH_DEP_DT = TO_DATE(B.SCH ,	'YYYYMMDDHH24MI')");
		sql.append("	AND	A.FLT_NUM = DECODE(LENGTH(SUBSTR(B.CALLSIGN ,	4)),	'3',	'0'||SUBSTR(B.CALLSIGN ,	4),	SUBSTR(B.CALLSIGN ,	4))");
		sql.append("	AND	A.STNFR = C.IATA_PORT");
		sql.append("	AND	A.STNTO = D.IATA_PORT");
		sql.append("	AND	C.ICAO_PORT = B.STNFR");
		sql.append("	AND	D.ICAO_PORT = B.STNTO");
		sql.append("	AND	A.ACTNID <> 'CNL'");
		sql.append("	AND	A.STNFR <> 'ICN'");
		sql.append("	AND	A.FIRST_LEG_FLT_DT = TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD')");		
		sql.append("	AND	A.FLT_NUM = '"+params.getFltNum()+"'");
		sql.append("	AND	A.STNFR = '"+params.getStnfr()+"'");
		sql.append("	AND	A.STNTO = '"+params.getStnto()+"'");
		sql.append("	AND	B.ATFMS_TMPST BETWEEN ");
		sql.append("				TO_CHAR(TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD')-5,	'YYYYMMDD')||'000000'");
		sql.append("				AND	TO_CHAR(TO_DATE('20"+params.getFirstLegFltDt()+"',	'YYYYMMDD'),	'YYYYMMDD')||'999999'");	
		sql.append("	ORDER BY");
		sql.append("		B.ATFMS_TMPST DESC");

		Logger.debug.println("[BASE:FfsQ250Query:selAcdmNotIcn] sql : "+sql.toString());
		return sql.toString();
	}
}
