package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;

 /**
  *  Fuel & Weight ȸ ȭ SQL 
  * @author Copyright (c) 2009/06/04  
  */   
public class TarQ010Query {
	private static TarQ010Query instance = new TarQ010Query();
	
	public static TarQ010Query getInstance() {
		return instance;
	}
	
	/** 
	  * Tarmac Department ȸ
	  * @return String Query  
	  * @author Copyright (c) 2011/07/29  
	  */
	public static String selDep(TarQ010BG params) {
		
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FLT_NUM, TO_CHAR(ACT_DEP_DT,'MM-DD') ACT_DEP_DT, SUBSTR(REGNO,3) REGNO, A.KACTYP, STNFR, STNTO, \n");
		sql.append("     TO_CHAR(EST_DEP_DT,'HH24:MI') EST_DEP_DT, TO_CHAR(ACT_DEP_DT,'HH24:MI') RAMPOUT, ");
		sql.append("     CASE WHEN ARV_STS = 'ACT' OR NVL(TKOF_T,' ') <> ' ' THEN 'Take Off' ELSE 'Taxi Out' END DB_STATUS, \n");
		sql.append("     TO_CHAR(ACT_DEP_DT + 3/24 - 10/1440,'YYYYMMDD HH24:MI') DB_DOT, \n");
		sql.append("     CASE WHEN NVL(TKOF_T,' ') = ' ' THEN \n");
		sql.append("                         CASE WHEN ARV_STS = 'ACT' THEN TO_NUMBER((ACT_ARV_DT-ACT_DEP_DT+10/1440 )*24*60) \n");
		sql.append("                                   ELSE TO_NUMBER((To_Date(To_Char(Sysdate,'yyyymmdd hh24mi'),'yyyymmdd hh24mi') - ACT_DEP_DT +10/1440 - 9/24)*24*60) \n");
		sql.append("                         END \n");
		sql.append("              ELSE CASE WHEN TO_CHAR(ACT_DEP_DT,'HH24MI') > TKOF_T THEN \n");
		sql.append("                                           TO_NUMBER( (TO_DATE('20110902 '||TKOF_T, 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||TO_CHAR(ACT_DEP_DT,'HH24MI'),'YYYYMMDD HH24MI') +10/1440 ) *1440) \n");
		sql.append("                                 ELSE TO_NUMBER( (TO_DATE('20110901 '||TKOF_T, 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||TO_CHAR(ACT_DEP_DT,'HH24MI'),'YYYYMMDD HH24MI') +10/1440 ) *1440) \n");
		sql.append("                       END \n");
		sql.append("     END DB_DELAY_T \n");
		sql.append(" 	 , DECODE(SUBSTR(FLT_NUM, 1, 1),'4','JNA','KAL') GBN  ");//@2013-11-07
		sql.append(" FROM DAILY_SCH_T A, CM_ACTYP_T B \n");
		sql.append(" WHERE EST_DEP_DT >= TO_DATE('"+params.getPFrDate()+"','YYYYMMDD HH24MI') AND \n");
		sql.append("     EST_DEP_DT <= TO_DATE('"+params.getPToDate()+"','YYYYMMDD HH24MI') AND \n");		
		sql.append("     CASE WHEN NVL(TKOF_T,' ') = ' ' THEN \n");
		sql.append("                         CASE WHEN ARV_STS = 'ACT' THEN TO_NUMBER((ACT_ARV_DT-ACT_DEP_DT+10/1440)*24*60) \n");
		sql.append("                                   ELSE TO_NUMBER((To_Date(To_Char(Sysdate,'yyyymmdd hh24mi'),'yyyymmdd hh24mi') - ACT_DEP_DT +10/1440 - 9/24)*24*60) \n");
		sql.append("                         END \n");
		sql.append("              ELSE CASE WHEN TO_CHAR(ACT_DEP_DT,'HH24MI') > TKOF_T THEN \n");
		sql.append("                                           TO_NUMBER( (TO_DATE('20110902 '||TKOF_T, 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||TO_CHAR(ACT_DEP_DT,'HH24MI'),'YYYYMMDD HH24MI') +10/1440 ) *1440) \n");
		sql.append("                                 ELSE TO_NUMBER( (TO_DATE('20110901 '||TKOF_T, 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||TO_CHAR(ACT_DEP_DT,'HH24MI'),'YYYYMMDD HH24MI') +10/1440 ) *1440) \n");
		sql.append("                       END \n");
		sql.append("     END >="+params.getPDelay()+" AND \n");			
		if(params.getPStatus().equals("Progress")){
			sql.append(" NOT (NVL(TKOF_T,' ')<>' ' OR ARV_STS = 'ACT') AND \n");
		}else if(params.getPStatus().equals("Finished")){
			sql.append(" (NVL(TKOF_T,' ')<>' ' OR ARV_STS = 'ACT') AND \n");
		}
		if(params.getPStn().trim().length()==3){
			sql.append(" STNFR = '"+params.getPStn()+"' AND \n");
		}
		//sql.append(" ( REGION_LEG IN ("+params.getPSchRegions()+") OR ((A.STNFR='GUM' OR A.STNTO='GUM') AND REGION_LEG='"+params.getRegionAME()+"')  OR ((A.STNFR!='GUM' AND A.STNTO!='GUM') AND REGION_LEG='"+params.getRegionOCN()+"') ) AND \n");
		/*sql.append(" ( REGION_LEG IN ("+params.getPSchRegions()+") \n");
		if(params.getRegionAME().equals("Y")){
		    sql.append("  OR  REGION_LEG = CASE WHEN STNFR = 'GUM' OR STNTO = 'GUM' THEN  '5' ELSE '6' END \n");
		}
		if(params.getRegionOCN().equals("Y")){
			sql.append("  OR  REGION_LEG = CASE WHEN STNFR != 'GUM' AND STNTO != 'GUM' THEN '5' ELSE 'X' END \n");
		}
		sql.append(" ) AND \n");
		*/
		if(params.getRegionAME().equals("Y")){
			sql.append(" ( REGION_LEG IN ("+params.getPSchRegions()+") OR A.STNFR='GUM' OR A.STNTO='GUM') AND \n");
		}else{
			sql.append(" REGION_LEG IN ("+params.getPSchRegions()+")  AND \n");
		}
		
		sql.append(" ACTNID <> 'CNL' AND \n");
		sql.append(" DEP_STS = 'ACT' AND \n");
		//sql.append(" SUBSTR(FLT_NUM,1,1) <> 4 AND \n");//@2013-11-07

		sql.append(" A.KACTYP = B.KACTYP AND \n");
		sql.append(" B.PAX_Y = 'Y' \n");
		if(params.getPSort().equals("Delay Time")){
			//sql.append(" ORDER BY 11");
			sql.append(" ORDER BY GBN ASC, 11 "); //@2013-11-07		
		}else{
			//sql.append(" ORDER BY 10 ");
			sql.append(" ORDER BY GBN ASC, 10 "); //@2013-11-07		
		}		
		
		System.out.println("[BASE:TarQ010Query:selDep] sql : <br/>"+sql.toString());
		Logger.debug.println("[BASE:TarQ010Query:selDep] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Tarmac Arrival ȸ
	  * @return String Query  
	  * @author Copyright (c) 2011/07/29  
	  */
	public static String selArv(TarQ010BG params) {
		
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FLT_NUM, TO_CHAR(ACT_ARV_DT,'MM-DD') ACT_ARV_DT, SUBSTR(REGNO,3) REGNO, A.KACTYP, STNFR, STNTO, \n");
		sql.append("     TO_CHAR(EST_ARV_DT,'HH24:MI') EST_ARV_DT, SUBSTR(LAND_T,1,2)||':'||SUBSTR(LAND_T,3,2) LAND_T, ");
		sql.append("     DECODE(ARV_STS,'ACT','Ramp In','Taxi In') DB_STATUS, \n");
		sql.append("     TO_CHAR(TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI')+3/24,'YYYYMMDD HH24:MI') DB_DOT, \n");
		sql.append("     CASE WHEN ARV_STS<>'ACT' THEN \n");
		sql.append("                         CASE WHEN TO_CHAR(SYSDATE-9/24,'HH24MI')>LAND_T THEN \n");
		sql.append("                                             TO_NUMBER( (TO_DATE('20110901 '||TO_CHAR(SYSDATE-9/24,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");                                                                 
		sql.append("                                   ELSE TO_NUMBER((TO_DATE('20110902 '||TO_CHAR(SYSDATE-9/24,'HH24MI'),'YYYYMMDD HH24MI')-TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI'))*1440) \n");
		sql.append("                         END \n");
		sql.append("              ELSE CASE WHEN TO_CHAR(ACT_ARV_DT,'HH24MI') > LAND_T THEN \n");
		sql.append("                                           TO_NUMBER( (TO_DATE('20110901 '||TO_CHAR(ACT_ARV_DT,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");
		sql.append("                                 ELSE TO_NUMBER( (TO_DATE('20110902 '||TO_CHAR(ACT_ARV_DT,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");
		sql.append("                       END \n");
		sql.append("     END DB_DELAY_T \n");
		sql.append(" FROM DAILY_SCH_T A, CM_ACTYP_T B  \n");
		sql.append(" WHERE EST_DEP_DT >= TO_DATE('"+params.getPFrDate()+"','YYYYMMDD HH24MI ')-1 AND \n");
		sql.append("     EST_DEP_DT <= TO_DATE('"+params.getPToDate()+"','YYYYMMDD HH24MI') AND \n");
		sql.append("     EST_ARV_DT >= TO_DATE('"+params.getPFrDate()+"','YYYYMMDD HH24MI') AND \n");
		sql.append("     EST_ARV_DT <= TO_DATE('"+params.getPToDate()+"','YYYYMMDD HH24MI') AND \n");
		sql.append("     CASE WHEN ARV_STS <> 'ACT' THEN \n");
		sql.append("                         CASE WHEN TO_CHAR(SYSDATE-9/24,'HH24MI')>LAND_T THEN \n");
		sql.append("                                             TO_NUMBER( (TO_DATE('20110901 '||TO_CHAR(SYSDATE-9/24,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");
		sql.append("                                   ELSE TO_NUMBER( (TO_DATE('20110902 '||TO_CHAR(SYSDATE-9/24,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");
		sql.append("                         END \n");
		sql.append("              ELSE CASE WHEN TO_CHAR(ACT_ARV_DT,'HH24MI') > LAND_T THEN \n");
		sql.append("                                           TO_NUMBER( (TO_DATE('20110901 '||TO_CHAR(ACT_ARV_DT,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");
		sql.append("                                 ELSE TO_NUMBER( (TO_DATE('20110902 '||TO_CHAR(ACT_ARV_DT,'HH24MI'), 'YYYYMMDD HH24MI') - TO_DATE('20110901 '||LAND_T,'YYYYMMDD HH24MI') ) *1440) \n");
		sql.append("                       END \n");
		sql.append("     END >="+params.getPDelay()+" AND \n");
		if(params.getPStatus().equals("Progress")){
			sql.append(" ARV_STS<>'ACT' AND \n");
		}else if(params.getPStatus().equals("Finished")){
			sql.append(" ARV_STS = 'ACT' AND \n");
		}
		if(params.getPStn().trim().length()==3){
			sql.append(" STNTO = '"+params.getPStn()+"' AND \n");
		}
		//sql.append(" REGION_LEG IN ("+params.getPSchRegions()+") AND \n");
		//sql.append(" ( REGION_X IN ("+params.getPSchRegions()+") OR (A.STNTO='GUM' AND REGION_X='"+params.getRegionAME()+"') ) AND \n");
		/*sql.append(" ( REGION_LEG IN ("+params.getPSchRegions()+") \n");
		if(params.getRegionAME().equals("Y")){
		    sql.append("  OR  REGION_LEG = CASE WHEN STNFR = 'GUM' OR STNTO = 'GUM' THEN  '5' ELSE '6' END \n");
		}
		if(params.getRegionOCN().equals("Y")){
			sql.append("  OR  REGION_LEG = CASE WHEN STNFR != 'GUM' AND STNTO != 'GUM' THEN '5' ELSE 'X' END \n");
		}
		sql.append(" ) AND \n");
		*/
		if(params.getRegionAME().equals("Y")){
			sql.append(" ( REGION_LEG IN ("+params.getPSchRegions()+") OR A.STNFR='GUM' OR A.STNTO='GUM') AND \n");
		}else{
			sql.append(" REGION_LEG IN ("+params.getPSchRegions()+")  AND \n");
		}
		sql.append(" ACTNID <> 'CNL' AND \n");
		sql.append(" DEP_STS = 'ACT' AND \n");
		sql.append(" NVL(LAND_T,' ')<>' ' AND \n");
		sql.append(" LENGTH(NVL(LAND_T,' ')) = 4 AND \n");//2011.10.13 ߰
		sql.append(" SUBSTR(FLT_NUM,1,1) <> 4 AND \n");
		sql.append(" A.KACTYP = B.KACTYP AND \n");
		sql.append(" B.PAX_Y = 'Y' \n");
		if(params.getPSort().equals("Delay Time")){
			sql.append(" ORDER BY 11");
		}else{
			sql.append(" ORDER BY 10 ");
		}		
		
		System.out.println("[BASE:TarQ010Query:selArv] sql : <br/>"+sql.toString());
		Logger.debug.println("[BASE:TarQ010Query:selArv] sql : "+sql.toString());
		return sql.toString();
	}
}
