package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IROPS Queue SQL 
  * @author Copyright (c) 2005/04/26 HIST  
  */   
public class IroQ060Query {
	private static IroQ060Query instance = new IroQ060Query();
	
	public static IroQ060Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Queue ̿Ϸ ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String selMain(IroQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select To_Char(Timestamp-(9/24),'YYYY/MM/DD HH24:MI') Timestamp, Arln_Cd, Flt_Num,");
		sql.append("        	Stnfr, Stnto, Title_x, Title_e, Seq_Num, Option_Num, To_Char(First_Leg_Flt_Dt,'YYYYMMDD') First_Leg_Flt_Dt");
		sql.append(" From Irops_Sch_t");
		sql.append(" Where Complete_y = 'H' And");
		sql.append("       		Decision_c = 'XX' And");
		if (!params.getTimestamp().equals("")) {
			//sql.append("		Timestamp = To_Date('20"+params.getTimestamp()+"','YYYYMMDD') And");
			//sql.append("		To_Char(Timestamp,'YYYYMMDD') = '20"+params.getTimestamp()+"' And");
			sql.append("		Timestamp >= To_Date('20"+params.getTimestamp()+"0000','YYYYMMDDHH24MI')+(9/24) And");
			sql.append("		Timestamp <= To_Date('20"+params.getTimestamp()+"2359','YYYYMMDDHH24MI')+(9/24) And");
		}
		if (!params.getFlt_num().equals(""))
			sql.append("		Flt_Num = '"+params.getFlt_num()+"' And");
		sql.append("       		Hide_y = 'N'");
		sql.append(" Order By Timestamp");
		
		Logger.debug.println("[BASE:IroQ060Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}//end of class
