package kal.base.jdf.jtx;

/**
 * @(#)
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import kal.base.jdf.db.ConnectionContext;

public interface UserTransaction {

	public void commit() throws CommitException;
	/**
	 * 
	 * @return Vector of com.lgeds.jdf.db.ConnectionContext
	 */
	public java.util.Vector getConnectionContexts();
	/**
	 * 
	 * @param utx com.lgeds.jdf.txn.UserTransaction
	 */
	public void join(UserTransaction utx);

	public void rollback() throws RollbackException;

	/**
	 * @param autoCommit boolean
	 */
	public void setAutoCommit(boolean autoCommit);
}