package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.ocb.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Daily Operation Info1 ȭ鿡  Query
 * ۼ ¥: 2005-03-29
 * @author: 
 */
public class OcbQ020Query {
	private static OcbQ020Query instance = new OcbQ020Query();
	
	public static OcbQ020Query getInstance() {
		return instance;
	}
	
	/** 
	  * Restriction Airport ȸ SQLԼ
	  * @param entity OcbQ020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 
	  */
	public String selResAir(OcbQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Irops_d, Apt_c, Seq_no,  Prob_c,  Reason_e, Start_t, End_t, Remark_e ");
		sql.append(" From Irops_Apt_t ");
		sql.append(" Where Irops_d  = '20"+entity.getIrops_d()+"' ");
		sql.append(" Order By Apt_c, Seq_no ");
		
		Logger.debug.println("[BASE:OcbQ020Query:selResAir] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR FLT STATUS DOM ȸ SQLԼ
	  * @param entity OcbQ020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 
	  */
	public String selIrrFltDom(OcbQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Region_Flt, A.Stnfr, A.Stnto, A.Dep_Sts, A.Arv_Sts, ");
		sql.append(" 	To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Dt_Loc, ");
		sql.append(" 	To_Char(A.Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Dt_Loc, ");
		sql.append(" 	To_Char(A.Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Dt_Loc,  ");
		sql.append(" 	B.Title_e, B.Decision_e, A.Actnid  ");
		sql.append(" From Daily_Sch_t A, Irops_Sch_t B ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('20"+entity.getIrops_d()+" 1500' ,'yyyymmdd hh24mi')-1 And  ");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('20"+entity.getIrops_d()+" 1459' ,'yyyymmdd hh24mi') And  ");
		sql.append(" 	B.Arln_Cd  = 'KE'   And ");
		sql.append(" 	B.Hide_y    = 'N'     And ");
		sql.append(" 	B.Decision_c <> 'X'  And ");
		sql.append(" 	B.Complete_y = 'Y'    And ");
		sql.append(" 	A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And ");
		sql.append(" 	A.Flt_Num  = B.Flt_Num  And ");
		
		//2008.02.22 
		//sql.append(" 	(Substr(A.Flt_Num,1,1) = '1' Or ");
		//sql.append(" 	(Substr(A.Flt_Num,1,2) = '01' And ");
		//sql.append(" 	(Substr(A.Flt_Num,5,1) >= 'A' And Substr(A.Flt_Num,5,1) <= 'Z') And ");
		//sql.append(" 	Not A.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S'))) And ");
		sql.append(" 	SUBSTR(A.FLT_NUM,1,1) = '1' AND ");
		
		sql.append(" 	A.Stnfr   = B.Stnfr  And ");
		sql.append(" 	A.Stnto  = B.Stnto ");  
		sql.append(" 	Order By A.Sch_Dep_Dt ");
		
		Logger.debug.println("[BASE:OcbQ020Query:selIrrFltDom] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR FLT STATUS INT ȸ SQLԼ
	  * @param entity OcbQ020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 
	  */
	public String selIrrFltInt(OcbQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Region_Flt, A.Stnfr, A.Stnto, A.Dep_Sts, A.Arv_Sts, ");
		sql.append(" 	To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Dt_Loc, ");
		sql.append(" 	To_Char(A.Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Dt_Loc, ");
		sql.append(" 	To_Char(A.Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Dt_Loc,  ");
		sql.append(" 	B.Title_e, B.Decision_e, A.Actnid  ");
		sql.append(" From Daily_Sch_t A, Irops_Sch_t B ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('20"+entity.getIrops_d()+" 1500' ,'yyyymmdd hh24mi')-1 And  ");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('20"+entity.getIrops_d()+" 1459' ,'yyyymmdd hh24mi') And  ");
		sql.append(" 	B.Arln_Cd  = 'KE'   And ");
		sql.append(" 	B.Hide_y    = 'N'     And ");
		sql.append(" 	B.Decision_c <> 'X'  And ");
		sql.append(" 	B.Complete_y = 'Y'    And ");
		sql.append(" 	A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And ");
		sql.append(" 	A.Flt_Num  = B.Flt_Num  And ");
		
		//2008.02.22 
		//sql.append(" 	Not (Substr(A.Flt_Num,1,1) = '1'  Or ");
		//sql.append(" 	(Substr(A.Flt_Num,1,2) = '01' And (Substr(A.Flt_Num,5,1) >= 'A' And  ");
		//sql.append(" 	Substr(A.Flt_Num,5,1) <= 'Z')) Or   ");
		//sql.append(" 	A.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S')) And ");
		sql.append(" 	NOT (SUBSTR(A.FLT_NUM,1,1) = '1' OR ");
		sql.append(" 	A.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X')) AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N,77X
		
		sql.append(" 	A.Stnfr   = B.Stnfr  And ");
		sql.append(" 	A.Stnto  = B.Stnto ");  
		sql.append(" 	Order By A.Sch_Dep_Dt ");
		
		//System.out.println("[BASE:OcbQ020Query:selIrrFltInt] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ020Query:selIrrFltInt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR FLT STATUS CGO ȸ SQLԼ
	  * @param entity OcbQ020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 
	  */
	public String selIrrFltCgo(OcbQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Region_Flt, A.Stnfr, A.Stnto, A.Dep_Sts, A.Arv_Sts, ");
		sql.append(" 	To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Dt_Loc, ");
		sql.append(" 	To_Char(A.Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Dt_Loc,  ");
		sql.append(" 	To_Char(A.Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Dt_Loc, ");
		sql.append(" 	To_Char(A.Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Dt_Loc,  ");
		sql.append(" 	B.Title_e, B.Decision_e, A.Actnid  ");
		sql.append(" From Daily_Sch_t A, Irops_Sch_t B ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('20"+entity.getIrops_d()+" 1500' ,'yyyymmdd hh24mi')-1 And  ");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('20"+entity.getIrops_d()+" 1459' ,'yyyymmdd hh24mi') And  ");
		sql.append(" 	B.Arln_Cd  = 'KE'   And ");
		sql.append(" 	B.Hide_y    = 'N'     And ");
		sql.append(" 	B.Decision_c <> 'X'  And ");
		sql.append(" 	B.Complete_y = 'Y'    And ");
		sql.append(" 	A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And ");
		sql.append(" 	A.Flt_Num  = B.Flt_Num  And ");
		
		//2008.02.22 
		//sql.append(" 	Substr(A.Flt_Num,1,1) <> '1'   And ");
		//sql.append(" 	A.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S') And ");
		sql.append(" 	A.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X') AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2012.02.03 ߰ : 74N,77X
		
		sql.append(" 	A.Stnfr   = B.Stnfr  And ");
		sql.append(" 	A.Stnto  = B.Stnto ");  
		sql.append(" 	Order By A.Sch_Dep_Dt ");
		
		Logger.debug.println("[BASE:OcbQ020Query:selIrrFltCgo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Restriction Airport  SQLԼ
	  * @param String irops_d, String apt_c, String seq_no
	  * @return String Query  
	  * @author Copyright (c) 2005/03/30 
	  */
	public String delResAir(String irops_d, String apt_c, String seq_no) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Delete From Irops_Apt_T ");
		sql.append(" Where Irops_d = '"+irops_d+"' And Apt_c = '"+apt_c+"' And Seq_no = "+seq_no+" ");
		
		Logger.debug.println("[BASE:OcbQ020Query:delResAir] sql : "+sql.toString());
		return sql.toString();
	}
}
