package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.RepQ010BG;
import kal.base.com.query.*;

 /**
   * Executive Summary SQL 
   * @author Copyright (c) 2005/02/16 
   */  
public class RepQ010Query {
	private static RepQ010Query instance = new RepQ010Query();
	
	public static RepQ010Query getInstance() {
		return instance;
	}
	/** 
	  * (yyyymm) ȸ SQLԼ.
	  * @param entity RepQ010BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/21 
	  */
	public String selDate(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Code_c, SUBSTR(Desc_e,0,6) Desc_e  ");
		sql.append(" From Code_T  ");
		sql.append(" Where Step_x = '1'   And  ");
		sql.append(" 	Use_y  = 'N'   And  ");
		sql.append(" 	Code_x = 'REPORT MONTH'  And ");
		sql.append(" 	End_D  > SYSDATE ");
		sql.append(" Order By Prty_no  ");
		
		Logger.debug.println("[BASE:RepQ010Query:selDate] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * Executive Summary  ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selSkd(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append(" 	Report_x = 'A' ");
		sql.append(" Group By Report_d ");
		
		Logger.debug.println("[BASE:RepQ010Query:selSkd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary  ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selOntime(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append("         Report_x = 'B'  And ");
		sql.append("         Code_C2 = 'D' ");
		sql.append(" Group By Report_d ");
		
		Logger.debug.println("[BASE:RepQ010Query:selOntime] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary Divert/Return ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selDivert(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c1, Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2, Sum(Flt_q3) Sum3 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append("        Report_x = 'C' ");
		sql.append(" Group By Report_d, Code_c1 ");
		
		Logger.debug.println("[BASE:RepQ010Query:selDivert] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary   ֿ  Ȳ ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selGround(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2,  Sum(Flt_q1) Sum1");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d = '"+entity.getReport_d()+"' And ");
		sql.append(" 	  Report_x = 'D'  ");
		sql.append(" Group By Report_d, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ010Query:selGround] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary   ֿ  Ȳ  ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selTotalGround(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2,  Sum(Flt_q1) Sum1");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d >= '"+entity.getReport_d().substring(0,4)+"01"+"' And ");
		sql.append(" 	  Report_d <= '"+entity.getReport_d()+"' And ");
		sql.append(" 	  Report_x = 'D'  ");
		sql.append(" Group By Report_d, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ010Query:selTotalGround] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary 簡ð ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selUtilization(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2,  Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append(" 	  Report_x = 'E' ");
		sql.append(" Group By Report_d, Code_c2 ");
		
		Logger.debug.println("[BASE:RepQ010Query:selUtilization] sql : "+sql.toString());
		return sql.toString();
	}

	/** 
	  * Executive Summary SKD ȹ ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selPlan(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d , Sum(Flt_q1) Sum1");
		sql.append(" From Ops_Report_T  ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append(" 	  Report_x = 'A'  ");
		sql.append(" Group By Report_d ");
		
		Logger.debug.println("[BASE:RepQ010Query:selPlan] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary SKD  ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selChange(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Sum(Flt_q1) Sum1 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))  And ");
		sql.append(" 	  Report_x = 'F' And ");
		sql.append(" 	  Code_c1 = 'A'  "); 
		sql.append(" Group By Report_d ");
		
		Logger.debug.println("[BASE:RepQ010Query:selChange] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary ǽ¹  ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/28 
	  */
	public String selCabinCrew(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Report_d, Code_c1, Code_c2, Flt_q1, Flt_q2  ");
		sql.append(" From Ops_Report_T  ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm')) And  ");
		sql.append(" 	  Report_x = 'G' And  ");
		sql.append(" 	  Code_c1 In('A', 'C')  ");
		sql.append(" Order By Report_d, Code_c1, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ010Query:selCabinCrew] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary ׽¹  ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/28 
	  */
	public String selCockpitCrew(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select Report_d, Code_c1, Code_c2, Code_c3, Flt_q1, Flt_q2, Flt_q3  ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d In('"+entity.getReport_d()+"', To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm')) And ");
		sql.append(" 	  Report_x = 'H' And ");
		sql.append(" 	  Code_c1 In('G','H')  ");
		sql.append(" Order By Report_d, Code_c1, Code_c2, Code_c3 ");
		
		Logger.debug.println("[BASE:RepQ010Query:selCockpitCrew] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary Ҹ ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selFuel(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Report_d, Code_c2, Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d = '"+entity.getReport_d()+"' And ");
		sql.append(" 	  Report_x = 'I'  And ");
		sql.append(" 	  Code_c2 = 'A' ");
		sql.append(" Group By Report_d, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ010Query:selFuel] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Executive Summary Fuel Dumping ȸ SQLԼ.
	  * @param entity RepQ010BG Executive Summary
	  * @return String Query 
	  * @author Copyright (c) 2005/02/16 
	  */
	public String selDumping(RepQ010BG entity) {
		StringBuffer sql = new StringBuffer();
		
		int last_year = Integer.parseInt(entity.getReport_d().substring(0,4)) - 1;

		sql.append(" Select Report_d, Code_c2,  Sum(Flt_q1) Sum1, Sum(Flt_q2) Sum2 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where ((Report_d >= '"+entity.getReport_d().substring(0,4)+"01"+"' And Report_d <= '"+entity.getReport_d()+"') Or (Report_d >= '"+String.valueOf(last_year).toString()+"01"+"' And Report_d <= To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'))) And ");
		sql.append(" 	  Report_x = 'I'    And ");
		sql.append(" 	  Code_c2 = 'D' ");
		sql.append(" Group By Report_d, Code_c2  ");
		
		Logger.debug.println("[BASE:RepQ010Query:selDumping] sql : "+sql.toString());
		return sql.toString();
	}
}

