package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * IROPS Report 캯Ȳ ȭ鿡  Query
 * ۼ ¥: 2005-02-23
 * @author: HIST  
 */
public class RepQ040Query {
	private static RepQ040Query instance = new RepQ040Query();
	
	public static RepQ040Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Report 캯Ȳ  泻 ȸ SQLԼ.
	  * @param reportD String ȸ yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/23 HIST 
	  */
	public String selView(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Code_c2,'E','' ,'N','߰ȹ','C','','T','ð') Code_c2,");
		sql.append("        	Sum(Decode(Code_c3,'A',Flt_q1,'0')) Code_c3_d30,");
		sql.append("        	Sum(Decode(Code_c3,'B',Flt_q1,'0')) Code_c3_d7,");
		sql.append("        	Sum(Decode(Code_c3,'C',Flt_q1,'0')) Code_c3_d2");
		sql.append("   From Ops_Report_T");
		sql.append("  Where 	Report_d = '"+reportD+"' And");
		sql.append("        		Report_x = 'F'       And");
		sql.append("        		Code_c1 = 'A'");
		sql.append(" Group By Decode(Code_c2,'E','' ,'N','߰ȹ','C','','T','ð')");
		
		Logger.debug.println("[BASE:RepQ040Query:selView] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IROPS Report 캯Ȳ κм ȸ SQLԼ.
	  * @param reportD String ȸ yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/23 HIST 
	  */
	public String selPointing(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Code_c2,'A','D2 ','B','48ð ̳') Code_c2,");
		sql.append("        	Sum(Decode(Code_c3,'A',Flt_q1,'0')) Code_c3_a,");
		sql.append("        	Sum(Decode(Code_c3,'B',Flt_q1,'0')) Code_c3_b,");
		sql.append("        	Sum(Decode(Code_c3,'C',Flt_q1,'0')) Code_c3_c,");
		sql.append("        	Sum(Decode(Code_c3,'D',Flt_q1,'0')) Code_c3_d");
		sql.append("   From Ops_Report_T");
		sql.append("  Where 	Report_d = '"+reportD+"' And");
		sql.append("        		Report_x = 'F'       And");
		sql.append("        		Code_c1 = 'B'");
		sql.append(" Group By Decode(Code_c2,'A','D2 ','B','48ð ̳')");
		sql.append(" Order By Code_c2 Desc");
		
		Logger.debug.println("[BASE:RepQ040Query:selPointing] sql : "+sql.toString());
		return sql.toString();
	}		
}
