package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * IROPS Report ǽ¹  ȭ鿡  Query
 * ۼ ¥: 2005-02-28
 * @author: HIST  
 */
public class RepQ050Query {
	private static RepQ050Query instance = new RepQ050Query();
	
	public static RepQ050Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Report ǽ¹  ȸ SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selOperation(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Code_c2,'A',' ο()','B','δ պð','C',' ϻ꼺','D',' Loss(%)','E',' Reserve (/Day)','F',' Standby (/Day)') Code_c2,");
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Flt_q1,'0')) Data_q1,");
		sql.append("        	Sum(Decode(Report_d,'"+reportD+"',Flt_q2,'0')) Data_q2,");
		sql.append("        	Sum(Decode(Report_d,To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'),Flt_q2,'0')) Data_q3");
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'G' And");
		sql.append("       		Code_c1 = 'A'");
		sql.append(" Group By Code_c2");
		
		Logger.debug.println("[BASE:RepQ050Query:selOperation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Report ǽ¹  LOSS ȸ SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selLoss(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Report_d,'"+reportD+"','    ','⵿') Report_d,");
		sql.append("        	Sum(Decode(Code_c2,'A',Flt_q1,'0')) Data_q1,");
		sql.append("        	Sum(Decode(Code_c2,'B',Flt_q1,'0')) Data_q2,");
		sql.append("        	Sum(Decode(Code_c2,'C',Flt_q1,'0')) Data_q3,");
		sql.append("        	Sum(Decode(Code_c2,'D',Flt_q1,'0')) Data_q4");
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'G' And");
		sql.append("       		Code_c1 = 'B'");
		sql.append(" Group By Report_d");
		sql.append(" Order By Report_d");
		
		Logger.debug.println("[BASE:RepQ050Query:selLoss] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Report ǽ¹  ð м ȸ SQLԼ.
	  * @param reportD String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selFlightTime(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Report_d,");
		sql.append("        	Sum(Decode(Code_c2,'A',Flt_q1,'0')) Data_q1,");
		sql.append("        	Sum(Decode(Code_c2,'B',Flt_q1,'0')) Data_q2,");
		sql.append("        	Sum(Decode(Code_c2,'C',Flt_q1,'0')) Data_q3,");
		sql.append("        	Sum(Decode(Code_c2,'D',Flt_q1,'0')) Data_q4");
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d In ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'G' And");
		sql.append("       		Code_c1 = 'C'");
		sql.append(" Group By Report_d");
		sql.append(" Order By Report_d Desc");
		
		Logger.debug.println("[BASE:RepQ050Query:selFlightTime] sql : "+sql.toString());
		return sql.toString();
	}
			
}//end of class
