package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ230BG;

 /**
   * Flight Summary SQL 
   * ۼ ¥ : 2010-07-22
   */  
public class StaQ230Query {
	
	private static StaQ230Query instance = new StaQ230Query();
	
	public static StaQ230Query getInstance() {
		return instance;
	}
	
	/** 
	  * Flight Summary ȸ SQLԼ.
	  * @param params StaQ230BG
	  * @return String Query 
	  * ۼ ¥ : 2010-07-22
	  */
	public String selMain(StaQ230BG params){
		StringBuffer sql = new StringBuffer();
		/*
		if (params.getSts().equals("ALL") || params.getSts().equals("DEP")) {
		
			sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, A.FLT_NUM, A.STNFR, A.STNTO, A.ACTNID, A.DEP_STS, ");
			sql.append(" CASE WHEN A.SVC IN ('J','F','M') THEN 'Y' ELSE 'N' END REGULAR_Y, ");
			sql.append(" CASE WHEN A.KACTYP IN ('74F','74Y') THEN 'Y' ELSE 'N' END CGO_Y, ");  
			sql.append(" TRUNC((A.ACT_DEP_DT - A.SCH_DEP_DT) * 1440, 0) DEL_MM ");
			sql.append(" FROM DAILY_SCH_T A, ");
			sql.append(" 		(SELECT DISTINCT FIRST_LEG_FLT_DT, FLT_NUM ");
			sql.append(" 		FROM DAILY_SCH_T ");
			sql.append(" 		WHERE SCH_DEP_DT >= TO_DATE('20"+params.getDt()+"0000', 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND SCH_DEP_DT <= TO_DATE('20"+params.getDt()+"2359', 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND DEP_STS <> 'INI' ");
			sql.append(" 		AND LEG_NUM IN (1,10) ");
			sql.append(" 		AND KACTYP NOT IN ('79S','7GG','ABH') ");
			sql.append(" 		AND SUBSTR(FLT_NUM,1,1) <> '4' ");
			sql.append(" 		AND SUBSTR(FLT_NUM, -1, 1) NOT IN ('M','F','T','D') "); //2010.09.05 ߰ : Suffix M,F,T,D  FLT 
			sql.append(" 		AND SCH_DEP_DT <= TIMESTAMP + 39/24) B ");
			sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
			sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
			sql.append(" AND A.DEP_STS <> 'INI' ");
		}
		if (params.getSts().equals("DEP")) {
			
			sql.append(" ORDER BY 1, 2, 3 ");
		}
		if (params.getSts().equals("ALL")) {
			
			sql.append(" UNION ");
		}
		if (params.getSts().equals("ALL") || params.getSts().equals("ARR")) {
			
			sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, A.FLT_NUM, A.STNFR, A.STNTO, A.ACTNID, A.DEP_STS, "); 
			sql.append(" CASE WHEN A.SVC IN ('J','F','M') THEN 'Y' ELSE 'N' END REGULAR_Y, "); 
			sql.append(" CASE WHEN A.KACTYP IN ('74F','74Y') THEN 'Y' ELSE 'N' END CGO_Y, ");        
			sql.append(" TRUNC((A.ACT_DEP_DT - A.SCH_DEP_DT) * 1440, 0) DEL_MM ");
			sql.append(" FROM DAILY_SCH_T A, "); 
			sql.append(" 		(SELECT DISTINCT FIRST_LEG_FLT_DT, FLT_NUM ");
			sql.append(" 		FROM DAILY_SCH_T ");
			sql.append(" 		WHERE SCH_DEP_DT >= TO_DATE('20"+params.getDt()+"0000', 'YYYYMMDDHH24MI') - 29/24 ");
			sql.append(" 		AND SCH_DEP_DT <= TO_DATE('20"+params.getDt()+"2359', 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND SCH_ARV_DT >= TO_DATE('20"+params.getDt()+"0000', 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND SCH_ARV_DT <= TO_DATE('20"+params.getDt()+"2359', 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND ARV_STS <> 'INI' ");
			sql.append(" 		AND LEG_NUM IN (1,10) ");
			sql.append(" 		AND KACTYP NOT IN ('79S','7GG','ABH') ");
			sql.append(" 		AND SUBSTR(FLT_NUM,1,1) <> '4' ");
			sql.append(" 		AND SUBSTR(FLT_NUM, -1, 1) NOT IN ('M','F','T','D') "); //2010.09.05 ߰ : Suffix M,F,T,D  FLT 
			sql.append(" 		AND SCH_DEP_DT <= TIMESTAMP + 39/24) B ");
			sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
			sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
			sql.append(" AND A.DEP_STS <> 'INI' ");
			sql.append(" ORDER BY 1, 2, 3 ");
		}
		*/
		sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, A.FLT_NUM, A.STNFR, A.STNTO, A.ACTNID, A.DEP_STS, ");
		sql.append(" CASE WHEN A.SVC IN ('J','F','M') THEN 'Y' ELSE 'N' END REGULAR_Y, ");
		//20140814 CGO_Y 
		//sql.append(" CASE WHEN A.KACTYP IN ('74F','74Y','74N','77X') THEN 'Y' ELSE 'N' END CGO_Y, ");//2012.02.22 ߰ 74N, 77X
		sql.append(" DECODE(NVL(C.PAX_Y, 'N'), 'N', 'Y', 'N') CGO_Y, ");
		sql.append(" TRUNC((A.ACT_DEP_DT - A.SCH_DEP_DT) * 1440, 0) DEL_MM, ");
		//sql.append(" (A.ACT_DEP_DT - A.SCH_DEP_DT) * 1440 DEL_MM, ");//2012.01.12 TRANC 
		sql.append(" SVC ");//2012.01.12 ߰
		sql.append(" FROM DAILY_SCH_T A, ");
		sql.append(" 		(SELECT DISTINCT FIRST_LEG_FLT_DT, FLT_NUM ");
		sql.append(" 		FROM DAILY_SCH_T ");
		sql.append(" 		WHERE SCH_DEP_DT >= TO_DATE('20"+params.getDt()+"0000', 'YYYYMMDDHH24MI') - 9/24 ");
		sql.append(" 		AND SCH_DEP_DT <= TO_DATE('20"+params.getDt()+"2359', 'YYYYMMDDHH24MI') - 9/24 ");
		sql.append(" 		AND DEP_STS <> 'INI' ");
		sql.append(" 		AND LEG_NUM IN (1,10) ");
		sql.append(" 		AND KACTYP NOT IN ('79S','7GG','ABH') ");
		sql.append(" 		AND SUBSTR(FLT_NUM,1,1) <> '4' ");
		sql.append(" 		AND SUBSTR(FLT_NUM, -1, 1) NOT IN ('M','F','T') "); //2010.09.05 ߰ : Suffix M,F,T,D  FLT , 2010.09.13  : 'D' .
		sql.append(" 		AND SCH_DEP_DT <= TIMESTAMP + 39/24) B ");
		//20140814 ߰
		sql.append("	  , CM_ACTYP_T C");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" AND A.DEP_STS <> 'INI' ");
		//20140814 ߰
		sql.append(" AND A.KACTYP = C.KACTYP(+) ");
		sql.append(" ORDER BY 1, 2, 3 ");
		
		//Logger.debug.println("[BASE:StaQ230Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ230Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}

}
