package kal.base.sup.dbbean;

import kal.base.jdf.db.EntityData;

import java.util.*;

/**
 * Current Weather Request ȭ鿡  Entity.
 * ۼ ¥: 2005-07-13
 * @author: 
 */
public class SupQ210BG extends EntityData {	
	private String metar;
	private String taf_fc;
	private String taf_ft;
	private String text;
	private String mode;
	private String area_cd;
	private String flt_num;
	private String stnfr;
	private String stnto;
	private String rte_id;
	private String time_step;
	private String rte_stn;
	private String icao_port;
	private String iata_port;
	private String port_e;
	private String rwy_dir_1;
	private String rwy_dir_2;
	private String rwy_vis_limit;
	private String rwy_rvr_limit;
	private String rwy_cig_limit;
	private String system_date;
	private String gmt_offset;
	private String curfew;
	private String wx_title;
	private String now_date;
	private List type_list;
	
	// Send Parameter
	private String addr_txt;
	private String origin_txt;
	private String acars_txt;
	private String mail_fax;
	
	private String mail_sender; //2009.08.03 ߰
	
	//2010.02.04 ߰
	private String rwy_dir;
	private String rwy_info;
	
	//@2018-04-12
	private String first_leg_flt_dt;
	private String userid;
	
	/**
	 * @return mail_sender
	 */
	public String getMail_sender() {
		return mail_sender;
	}

	/**
	 * @param mail_sender Ϸ mail_sender
	 */
	public void setMail_sender(String mail_sender) {
		this.mail_sender = mail_sender;
	}

	/**
	 * Returns the area_cd.
	 * @return String
	 */
	public String getArea_cd() {
		return area_cd;
	}

	/**
	 * Returns the curfew.
	 * @return String
	 */
	public String getCurfew() {
		return curfew;
	}

	/**
	 * Returns the flt_num.
	 * @return String
	 */
	public String getFlt_num() {
		return flt_num;
	}

	/**
	 * Returns the gmt_offset.
	 * @return String
	 */
	public String getGmt_offset() {
		return gmt_offset;
	}

	/**
	 * Returns the iata_port.
	 * @return String
	 */
	public String getIata_port() {
		return iata_port;
	}

	/**
	 * Returns the icao_port.
	 * @return String
	 */
	public String getIcao_port() {
		return icao_port;
	}

	/**
	 * Returns the port_e.
	 * @return String
	 */
	public String getPort_e() {
		return port_e;
	}

	/**
	 * Returns the rte_id.
	 * @return String
	 */
	public String getRte_id() {
		return rte_id;
	}

	/**
	 * Returns the rte_stn.
	 * @return String
	 */
	public String getRte_stn() {
		return rte_stn;
	}

	/**
	 * Returns the rwy_cig_limit.
	 * @return String
	 */
	public String getRwy_cig_limit() {
		return rwy_cig_limit;
	}

	/**
	 * Returns the rwy_rvr_limit.
	 * @return String
	 */
	public String getRwy_rvr_limit() {
		return rwy_rvr_limit;
	}

	/**
	 * Returns the rwy_vis_limit.
	 * @return String
	 */
	public String getRwy_vis_limit() {
		return rwy_vis_limit;
	}

	/**
	 * Returns the stnfr.
	 * @return String
	 */
	public String getStnfr() {
		return stnfr;
	}

	/**
	 * Returns the stnto.
	 * @return String
	 */
	public String getStnto() {
		return stnto;
	}

	/**
	 * Returns the system_date.
	 * @return String
	 */
	public String getSystem_date() {
		return system_date;
	}

	/**
	 * Returns the time_step.
	 * @return String
	 */
	public String getTime_step() {
		return time_step;
	}

	/**
	 * Sets the area_cd.
	 * @param area_cd The area_cd to set
	 */
	public void setArea_cd(String area_cd) {
		this.area_cd = area_cd;
	}

	/**
	 * Sets the curfew.
	 * @param curfew The curfew to set
	 */
	public void setCurfew(String curfew) {
		this.curfew = curfew;
	}

	/**
	 * Sets the flt_num.
	 * @param flt_num The flt_num to set
	 */
	public void setFlt_num(String flt_num) {
		this.flt_num = flt_num;
	}

	/**
	 * Sets the gmt_offset.
	 * @param gmt_offset The gmt_offset to set
	 */
	public void setGmt_offset(String gmt_offset) {
		this.gmt_offset = gmt_offset;
	}

	/**
	 * Sets the iata_port.
	 * @param iata_port The iata_port to set
	 */
	public void setIata_port(String iata_port) {
		this.iata_port = iata_port;
	}

	/**
	 * Sets the icao_port.
	 * @param icao_port The icao_port to set
	 */
	public void setIcao_port(String icao_port) {
		this.icao_port = icao_port;
	}

	/**
	 * Sets the port_e.
	 * @param port_e The port_e to set
	 */
	public void setPort_e(String port_e) {
		this.port_e = port_e;
	}

	/**
	 * Sets the rte_id.
	 * @param rte_id The rte_id to set
	 */
	public void setRte_id(String rte_id) {
		this.rte_id = rte_id;
	}

	/**
	 * Sets the rte_stn.
	 * @param rte_stn The rte_stn to set
	 */
	public void setRte_stn(String rte_stn) {
		this.rte_stn = rte_stn;
	}

	/**
	 * Sets the rwy_cig_limit.
	 * @param rwy_cig_limit The rwy_cig_limit to set
	 */
	public void setRwy_cig_limit(String rwy_cig_limit) {
		this.rwy_cig_limit = rwy_cig_limit;
	}

	/**
	 * Sets the rwy_rvr_limit.
	 * @param rwy_rvr_limit The rwy_rvr_limit to set
	 */
	public void setRwy_rvr_limit(String rwy_rvr_limit) {
		this.rwy_rvr_limit = rwy_rvr_limit;
	}

	/**
	 * Sets the rwy_vis_limit.
	 * @param rwy_vis_limit The rwy_vis_limit to set
	 */
	public void setRwy_vis_limit(String rwy_vis_limit) {
		this.rwy_vis_limit = rwy_vis_limit;
	}

	/**
	 * Sets the stnfr.
	 * @param stnfr The stnfr to set
	 */
	public void setStnfr(String stnfr) {
		this.stnfr = stnfr;
	}

	/**
	 * Sets the stnto.
	 * @param stnto The stnto to set
	 */
	public void setStnto(String stnto) {
		this.stnto = stnto;
	}

	/**
	 * Sets the system_date.
	 * @param system_date The system_date to set
	 */
	public void setSystem_date(String system_date) {
		this.system_date = system_date;
	}

	/**
	 * Sets the time_step.
	 * @param time_step The time_step to set
	 */
	public void setTime_step(String time_step) {
		this.time_step = time_step;
	}

	/**
	 * Returns the mode.
	 * @return String
	 */
	public String getMode() {
		return mode;
	}

	/**
	 * Sets the mode.
	 * @param mode The mode to set
	 */
	public void setMode(String mode) {
		this.mode = mode;
	}

	/**
	 * Returns the wx_title.
	 * @return String
	 */
	public String getWx_title() {
		return wx_title;
	}

	/**
	 * Sets the wx_title.
	 * @param wx_title The wx_title to set
	 */
	public void setWx_title(String wx_title) {
		this.wx_title = wx_title;
	}

	/**
	 * Returns the metar.
	 * @return String
	 */
	public String getMetar() {
		return metar;
	}

	/**
	 * Returns the taf_fc.
	 * @return String
	 */
	public String getTaf_fc() {
		return taf_fc;
	}

	/**
	 * Returns the taf_ft.
	 * @return String
	 */
	public String getTaf_ft() {
		return taf_ft;
	}

	/**
	 * Returns the text.
	 * @return String
	 */
	public String getText() {
		return text;
	}

	/**
	 * Sets the metar.
	 * @param metar The metar to set
	 */
	public void setMetar(String metar) {
		this.metar = metar;
	}

	/**
	 * Sets the taf_fc.
	 * @param taf_fc The taf_fc to set
	 */
	public void setTaf_fc(String taf_fc) {
		this.taf_fc = taf_fc;
	}

	/**
	 * Sets the taf_ft.
	 * @param taf_ft The taf_ft to set
	 */
	public void setTaf_ft(String taf_ft) {
		this.taf_ft = taf_ft;
	}

	/**
	 * Sets the text.
	 * @param text The text to set
	 */
	public void setText(String text) {
		this.text = text;
	}


	/**
	 * Returns the type_list.
	 * @return List
	 */
	public List getType_list() {
		return type_list;
	}

	/**
	 * Sets the type_list.
	 * @param type_list The type_list to set
	 */
	public void setType_list(List type_list) {
		this.type_list = type_list;
	}

	/**
	 * Returns the now_date.
	 * @return String
	 */
	public String getNow_date() {
		return now_date;
	}

	/**
	 * Sets the now_date.
	 * @param now_date The now_date to set
	 */
	public void setNow_date(String now_date) {
		this.now_date = now_date;
	}

	/**
	 * Returns the rwy_dir_1.
	 * @return String
	 */
	public String getRwy_dir_1() {
		return rwy_dir_1;
	}

	/**
	 * Returns the rwy_dir_2.
	 * @return String
	 */
	public String getRwy_dir_2() {
		return rwy_dir_2;
	}

	/**
	 * Sets the rwy_dir_1.
	 * @param rwy_dir_1 The rwy_dir_1 to set
	 */
	public void setRwy_dir_1(String rwy_dir_1) {
		this.rwy_dir_1 = rwy_dir_1;
	}

	/**
	 * Sets the rwy_dir_2.
	 * @param rwy_dir_2 The rwy_dir_2 to set
	 */
	public void setRwy_dir_2(String rwy_dir_2) {
		this.rwy_dir_2 = rwy_dir_2;
	}

	/**
	 * Returns the acars_txt.
	 * @return String
	 */
	public String getAcars_txt() {
		return acars_txt;
	}

	/**
	 * Returns the addr_txt.
	 * @return String
	 */
	public String getAddr_txt() {
		return addr_txt;
	}

	/**
	 * Returns the mail_fax.
	 * @return String
	 */
	public String getMail_fax() {
		return mail_fax;
	}

	/**
	 * Returns the origin_txt.
	 * @return String
	 */
	public String getOrigin_txt() {
		return origin_txt;
	}

	/**
	 * Sets the acars_txt.
	 * @param acars_txt The acars_txt to set
	 */
	public void setAcars_txt(String acars_txt) {
		this.acars_txt = acars_txt;
	}

	/**
	 * Sets the addr_txt.
	 * @param addr_txt The addr_txt to set
	 */
	public void setAddr_txt(String addr_txt) {
		this.addr_txt = addr_txt;
	}

	/**
	 * Sets the mail_fax.
	 * @param mail_fax The mail_fax to set
	 */
	public void setMail_fax(String mail_fax) {
		this.mail_fax = mail_fax;
	}

	/**
	 * Sets the origin_txt.
	 * @param origin_txt The origin_txt to set
	 */
	public void setOrigin_txt(String origin_txt) {
		this.origin_txt = origin_txt;
	}

	/**
	 * @return rwy_dir
	 */
	public String getRwy_dir() {
		return rwy_dir;
	}

	/**
	 * @param rwy_dir Ϸ rwy_dir
	 */
	public void setRwy_dir(String rwy_dir) {
		this.rwy_dir = rwy_dir;
	}

	/**
	 * @return rwy_info
	 */
	public String getRwy_info() {
		return rwy_info;
	}

	/**
	 * @param rwy_info Ϸ rwy_info
	 */
	public void setRwy_info(String rwy_info) {
		this.rwy_info = rwy_info;
	}
	//@2018-04-12
	public String getFirst_leg_flt_dt() {
		return first_leg_flt_dt;
	}
	public void setFirst_leg_flt_dt(String first_leg_flt_dt) {
		this.first_leg_flt_dt = first_leg_flt_dt;
	}
	public String getUserid() {
		return userid;
	}
	public void setUserid(String userid) {
		this.userid = userid;
	}

}
