package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * NOTAM Request SQL 
   * @author Copyright (c) 2005/06/27 
   */
public class SupQ010Query {
	private static SupQ010Query instance = new SupQ010Query();
	
	public static SupQ010Query getInstance() {
		return instance;
	}
	
	/** 
	  * NOTAM Request   ȸ SQLԼ.
	  * @param params SupQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selSTNSection(SupQ010BG params){
		StringBuffer sql = new StringBuffer();
		
		/*sql.append(" SELECT DISTINCT LEG_NUM,STNFR,STNTO,EXP_GMT_DT");
		sql.append(" FROM WEEKLY_SCH_T");
		//FLT#  Է½ (DEPSTN/ARRSTN Է½) mode : 2
		if (params.getMode().equals("2")) {
			//sql.append(" WHERE FLT_NUM = '"+params.getFlt_num()+"' AND LEG_NUM = 1 AND EFF_LOC_DT <= SYSDATE AND EXP_LOC_DT >= SYSDATE");
			sql.append(" WHERE FLT_NUM = '"+params.getFlt_num()+"' AND LEG_NUM=1 AND EXP_GMT_DT >= SYSDATE-9/24");
		    sql.append(" ORDER BY EXP_GMT_DT");
		}
		//FLT#/DEPSTN Է½ ARRSTN Է½ mode : 3
		if (params.getMode().equals("3")) {
			//sql.append(" WHERE FLT_NUM = '"+params.getFlt_num()+"' AND STNFR = '"+params.getDep_stn()+"'");
			//sql.append(" ORDER BY LEG_NUM");
			sql.append(" WHERE FLT_NUM = '"+params.getFlt_num()+"' AND STNFR = '"+params.getDep_stn()+"' AND EXP_GMT_DT >= SYSDATE-9/24");
		    sql.append(" ORDER BY EXP_GMT_DT");
		}
		//FLT#/DEPSTN/ARRSTN Է½ mode : 4
		if (params.getMode().equals("4")) {
			sql.append(" WHERE FLT_NUM = '"+params.getFlt_num()+"' AND STNFR = '"+params.getDep_stn()+"' AND STNTO = '"+params.getArr_stn()+"'");
			sql.append(" ORDER BY LEG_NUM");
		}*/
		
		// WEEKLY_SCH_T DAILY_SCH_T  => 2005.11.15 
		sql.append(" SELECT STNFR, STNTO ");
		sql.append(" FROM DAILY_SCH_T");
		//FLT#  Է½ (DEPSTN/ARRSTN Է½) mode : 2
		if (params.getMode().equals("2")) {
			sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24,'YYYYMMDD'),'YYYYMMDD') ");
			sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE + 2 - 9/24,'YYYYMMDD'),'YYYYMMDD') ");
			sql.append(" 	AND FLT_NUM LIKE '"+params.getFlt_num()+"%' ");
		    sql.append(" ORDER BY FIRST_LEG_FLT_DT, LEG_NUM ");
		}
		//FLT#/DEPSTN Է½ ARRSTN Է½ mode : 3
		if (params.getMode().equals("3")) {
			sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24,'YYYYMMDD'),'YYYYMMDD') ");
			sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE + 2 - 9/24,'YYYYMMDD'),'YYYYMMDD') ");
			sql.append(" 	AND FLT_NUM LIKE '"+params.getFlt_num()+"%' ");
			sql.append(" 	AND STNFR = '"+params.getDep_stn()+"' ");
		    sql.append(" ORDER BY FIRST_LEG_FLT_DT, LEG_NUM ");
		}
		//FLT#/DEPSTN/ARRSTN Է½ mode : 4
		if (params.getMode().equals("4")) {
			sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24,'YYYYMMDD'),'YYYYMMDD') ");
			sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE + 2 - 9/24,'YYYYMMDD'),'YYYYMMDD') ");
			sql.append(" 	AND FLT_NUM LIKE '"+params.getFlt_num()+"%' ");
			sql.append(" 	AND STNFR = '"+params.getDep_stn()+"' ");
			sql.append(" 	AND STNTO = '"+params.getArr_stn()+"' ");
		    sql.append(" ORDER BY FIRST_LEG_FLT_DT, LEG_NUM ");
		}
				
		Logger.debug.println("[BASE:SupQ010Query:selSTNSection] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Request ATC Station ȸ SQLԼ.
	  * @param params SupQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	/*public String selATCStation(SupQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_STN,ATC_DTG");
		sql.append(" FROM BS_ATC_ROUTE_T"); 
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		sql.append(" AND ATC_DTG+(4/24) > SYSDATE-(9/24)");
		sql.append(" ORDER BY ATC_DTG DESC");
		
		Logger.debug.println("[BASE:SupQ010Query:selATCStation] sql : "+sql.toString());
		return sql.toString();
	}*/
	public String selATCStation(SupQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_STN,ATC_DTG");
		sql.append(" FROM BS_ATC_ROUTE_T"); 
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"'");
		sql.append(" AND ATC_DTG+(4/24) > SYSDATE-(9/24)");
		sql.append(" ORDER BY ATC_DTG DESC");
		
		Logger.debug.println("[BASE:SupQ010Query:selATCStation] sql : "+sql.toString());
		return sql.toString();
	}			
	
	/** 
	  * NOTAM Request Route Station ȸ SQLԼ.
	  * @param params SupQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selRTEStation(SupQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DEP_STN,ARR_STN,RTE_STN");
		sql.append(" FROM BS_COMP_ROUTE_T");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		sql.append(" AND RTE_CD = '"+params.getRte_id()+"'");
		//sql.append(" AND RTE_CD = 'DEFT'");
		
		Logger.debug.println("[BASE:SupQ010Query:selRTEStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input Station ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT,IATA_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:SupQ010Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM FIR ȸ SQLԼ.
	  * @param notFir Stringȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selFirCd(String notFir){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD,FIR_E FROM BS_FIR_T WHERE FIR_CD = '"+notFir+"'");

		//Logger.debug.println("[BASE:SupQ010Query:selFirCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Request NOTAM ȸ SQLԼ.
	  * @param mode String 1 : NOTAM NBR Է    2 : ̿ 
	  * @param stnList String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selNotamNbr(String mode,String stnList,String cond,String notPeriod){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT A.*, DECODE(ICAO_PORT,"+StringUtil.icaoDecode(stnList)+") SEQ");
		
		// 2006.12.07 ߰
		sql.append(" , DECODE(SUBSTR(A.NOT_NUM,1,5),'CO-AD','A','B') COMP,");
		//sql.append(" SUBSTR(A.NOT_NUM,LENGTH(A.NOT_NUM)-1,2) YY, "); // 2007.01.18 
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,7,2),DECODE(SUBSTR(NOT_NUM,5,1),'/',SUBSTR(NOT_NUM,6,2),'XX')) YY, ");
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,1,1),'0') TP, ");
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,2,4),SUBSTR(A.NOT_NUM,1,4)) NUM ");
		
		sql.append(" FROM BS_NOTAM_T A");
		sql.append(" WHERE ICAO_PORT IN ("+StringUtil.strDBformat(stnList)+")");
		// 2006.05.12 
		if (notPeriod.equals("CLSD")) {
			sql.append(" AND NOT_OPEN_Y = 'N'");
		} else {
			sql.append(" AND NOT_OPEN_Y = 'Y'");
		}
		sql.append(cond);

		//Logger.debug.println("[BASE:SupQ010Query:selNotamNbr] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Request ׸ б SQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2005/06/28 
	  */
	public String selPort(String icaoPort){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.ICAO_PORT, A.IATA_PORT, A.PORT_E, B.NATION_ENG_N, A.CURFEW,");
		sql.append(" A.OP_COMPANY1, A.OP_FREQ1, A.OP_CALLSIGN1, A.OP_TEL1, A.OP_FAX1, A.OP_1ST_SITA1, A.OP_2ND_SITA1,");
		sql.append(" A.HTL_CRW_LOV1, A.HTL_TEL1, A.HTL_FAX1 ");
		sql.append(" FROM CM_PORT_T A, NATION_T B");
		sql.append(" WHERE A.ICAO_PORT='"+icaoPort+"' AND A.CTRY_CD=B.NATION_C(+)");

		Logger.debug.println("[BASE:SupQ010Query:selPort] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Request Ȱַ б SQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2005/06/28 
	  */
	public String selRwyCd(String icaoPort){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT RWY_DIR,RWY_LENG||'FT X '||RWY_WIDTH||'FT' RWY_SIZE,");
		//sql.append(" RWY_VIS_LIMIT||'FT - '||RWY_CIG_LIMIT||'M' RWY_LIMIT");
		sql.append(" RWY_VIS_LIMIT, RWY_CIG_LIMIT, RWY_RVR_LIMIT ");
		sql.append(" FROM BS_PORT_RWY_T");
		sql.append(" WHERE ICAO_PORT='"+icaoPort+"' AND RWY_SEQ <=4");
		sql.append(" ORDER BY RWY_SEQ");

		Logger.debug.println("[BASE:SupQ010Query:selRwyCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Request SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String insMsTelexMsgORG(String seq, int msgMax, int msgPos, String msg, String dbTime, String orginAddr, String projectNo){
		StringBuffer sql = new StringBuffer();

		//==> 2005.12.09 
		//sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		//sql.append(" VALUES ('NOTAM',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+orginAddr+"','"+StringUtil.DBInsStr(msg)+"',1,'"+projectNo+"','N',' ')");
		
		sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,SYS_MQID,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		sql.append(" VALUES ('NOTAM',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+orginAddr+"','"+StringUtil.DBInsStr(msg)+"',1,"+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')),'"+projectNo+"','N',' ')");
		
		//Logger.debug.println("[BASE:SupQ010Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}	
	//20150428 MHS
	public String insMsTelexMsg(String seq, int msgMax, int msgPos, String msg, String dbTime, String orginAddr, String projectNo){
		
		msg = msg != null ? msg.replace("\"", "") : msg;
		
		StringBuffer sql = new StringBuffer();

		//sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T_TEST (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,SYS_MQID,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,SYS_MQID,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		sql.append(" VALUES ('NOTAM',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+orginAddr+"','"+StringUtil.DBInsStr(msg)+"',1,"+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')),'"+projectNo+"','N',' ')");
		
		Logger.debug.println("[BASE:SupQ010Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}	
	
	/** 
	  * RTE_CD ȸ SQLԼ.
	  * @param params SupQ010BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/10/07 
	  */
	public String selRteCd(SupQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_CD");
		sql.append(" FROM BS_COMP_ROUTE_T");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		
		Logger.debug.println("[BASE:SupQ010Query:selRteCd] sql : "+sql.toString());
		return sql.toString();
	}
}
