package kal.base.ffs.ejb;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;

import kal.base.ffs.dbbean.CdmA010BG;
import kal.base.ffs.dbbean.FfsA080BG;
import kal.base.ffs.dbbean.FfsA240BG;
import kal.base.ffs.dbbean.FfsA250BG;
import kal.base.ffs.dbbean.FfsA260BG;
import kal.base.ffs.dbbean.FfsQ050BG;
import kal.base.ffs.dbbean.FfsQ110BG;
import kal.base.ffs.dbbean.FfsQ210BG;
import kal.base.ffs.dbbean.FfsQ220BG;
import kal.base.ffs.dbbean.FfsQ230BG;
import kal.base.ffs.dbbean.FfsQ240BG;
import kal.base.ffs.dbbean.FfsQ250BG;//@2018-08-20
import kal.base.ffs.dbbean.FfsQ410BG;
import kal.base.ffs.dbbean.FfsQ420BG;
import kal.base.ffs.dbbean.TarQ010BG;
import kal.base.ffs.dbbean.TrkQ010BG;
import kal.base.jdf.db.BusinessException;

/*#########################################################################
Remote interface for Enterprise Bean: FfsAllSL
@2017-09-07 ҽ
###########################################################################*/

@SuppressWarnings({"rawtypes"})
public interface FfsAllSL extends javax.ejb.EJBObject{
	/*======================================================================	
	@2006/12/21 
	Flight Following Chart - Not Released ȸԼ	
	*/
	public HashMap allNotReleased() throws BusinessException, java.rmi.RemoteException;
	/*======================================================================	
	@2007/01/10 
	Flight Following Chart - Released ȸԼ.
	*/
	public HashMap allReleased() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/01/12 
	Flight Following Chart - Enroute ȸԼ.
	*/
	public HashMap allEnroute() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/01/18 
	Enroute  Flight   ȸԼ.
	*/
	public HashMap allLanded() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	HashMap ȸ 
	*/
	public HashMap allEnrouteDetail() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/01/19 
	Enroute  Flight   Remarks ȸԼ.
	*/
	public Hashtable selRemarks(FfsQ050BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/01/19 
	Enroute  Flight   Remarks Լ.
	*/
	public String updRemarks(FfsQ050BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/01/24 
	Not Released  Alert Rule ȸԼ.
	*/
	public HashMap selAlertRule(String sel) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/05/22 
	Enroute  ACARS SMI ȸԼ.
	*/
	public Hashtable selAcarsSmiEN(String smiStr, HashMap fList) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/05/29 
	Enroute  ACARS SMI RAW_MSG ȸԼ.
	*/
	public Hashtable  selAcarsRawMsgEN(String fltNum, String smiStr) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/06/04 
	Released  ACARS SMI ȸԼ.
	*/
	public Hashtable selAcarsSmiRE(String smiStr, HashMap fList) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/06/04 
	 Released  ACARS SMI RAW_MSG ȸԼ.
	*/
	public Hashtable selAcarsRawMsgRE(String fltNum, String smiStr) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/06/21 
	(Permission Information) ȸԼ.
	*/
	public Hashtable selPermissionInfo(FfsQ210BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/07/02 
	Flight Plan ȸԼ.
	*/
	public Hashtable selFltPlanInfo(FfsQ230BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/07/03 
	MEL ȸԼ.
	*/
	public Hashtable selMelInfo(FfsQ220BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/07/06 
	Landed Flight Watch Log ȸԼ.
	*/
	public Hashtable selLandedDetail(FfsQ050BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/07/12 
	Position Report Է(Waypoint Name̳ /浵   ) Լ.
	*/
	public int updWaypoint(FfsA240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2007/07/13 
	Position Report Է(Waypoint Name̳ /浵  ) Լ.
	MSG  CRS Ͽ  ߼Ѵ.
	*/
	public String msgCRS(FfsA240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2008/08/19  
	Planned PLD, Changed PLD ȸԼ.
	*/
	public Hashtable selAccReqPld(FfsA250BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2008/08/20  
	Planned PLD, Changed PLD Լ
	*/
	public String updAccReqPld(FfsA250BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	*/
	public Hashtable selRlsMsgMain(FfsA260BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2009/01/09  
	Release Message SEND Լ.
	*/
	public String sendRlsMsg(FfsA260BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2009/01/09  
	Release Message RE-SEND Լ.
	*/
	public String reSendRlsMsg(FfsA260BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2009/06/05 
	Fuel & Weight  ȸԼ.
	*/
	public Hashtable selFuelWeight(FfsQ410BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2009/06/09 
	Fuel & Weight  ȸ Լ.
	*/
	public Hashtable selFltFuelWeight(FfsQ420BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2009/06/11 
	Fuel & Weight  UPDATE Լ
	*/
	public String updFltFuelWeight(FfsQ420BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2011/07/29 
	Tarmac ȸ Լ.
	*/
	public Hashtable selTarDepArv(TarQ010BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2009/01/09  
	Release Message DSP_CD ȸ Լ.
	*/
	public String getRlsMsgDspCd(String regno) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================		
	*/
	public Hashtable selFfsQ710Main() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/07/04 
	DspCd List ˻ Լ.
	*/
	public List selDspCdList() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================		
	@2012/07/04 
	FPL  Լ.
	*/
	public boolean sendFplMsg(FfsQ230BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/07/26 
	Cdm List ȸԼ.
	*/
	public Hashtable selCdmSendList(CdmA010BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/07/27 
	SITA MSG ó Լ
	*/
	public boolean sendCdmMsg(CdmA010BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/08/02 
	Flight Track ȸԼ.
	*/
	public Hashtable selTrkQ010Main(TrkQ010BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/08/02 
	Flight Track Kml  ٿ ε Լ.	
	public Hashtable downloadTrkKml(TrkQ010BG params) throws BusinessException, java.rmi.RemoteException;
	*/

	/*======================================================================	
	@2012/08/02 
	Flight Track Kml  ٿ ε Լ.[multi]
	*/
	public Hashtable downloadFoqaKml(List list) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/08/02 
	Flight Track Kml (Plan) ٿ ε Լ.[multi]
	*/
	public Hashtable downloadPlanKml(List list) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/08/02 
	Flight Track Kml   Լ[ ˻].
	*/
	public Hashtable downloadTurbulenceKml(List list) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2012/09/07 
	   Waypoint (FOQA_COMP_WPT_MASTER_T, FOQA_FUEL_WPT_T  PLAN, FPQA )
	*/
	public Hashtable selWptInfoForExcel(TrkQ010BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	*/
	public List selFfsRouteTab(FfsA080BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	*/
	public Hashtable selEnabledRouteList(FfsA080BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	*/
	public boolean updErsMasterT(FfsA080BG params)throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	*/
	public boolean insErsMasterT(FfsA080BG params)throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2013/04/01
	*/
	public Hashtable downloadNoiseKml(List list) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public boolean insFrightPlanCheckLogT(HashMap<String,String> params)throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public boolean updIsCommented(HashMap<String,String> params)throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public boolean updPlanConfirm(HashMap<String,String> params)throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public String selFuelAcarsMsg(String syskey) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public String selWeatherAcarsMsg(String iataPort) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public String selFuncSendToAcars(String firstLegFltDt, String regno, String fltNum, String stnfr, String stnto, String empNo, String msg) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-05-12 ~ @2014-05-26
	*/
	public boolean updAltRefileAcars(String firstLegFltDt,String fltNum, String stnfr,String stnto,String altRefileAcars) throws BusinessException, java.rmi.RemoteException;	

	/*======================================================================	
	@2014-09-03
	Flight Plan ȸԼ
	*/
	public Hashtable selFltPlanWithDocInfo(FfsQ240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-09-03
	Rlease  ʿ׸ ȸԼ.
	*/
	public Hashtable selFltPlanDocInfoForRelease(FfsQ240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-09-03
	Release  
	*/
	public boolean releaseFltPlanDocInfo(FfsQ240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2014-09-03
	CFP  ȸԼ.
	*/
	public String selFltPlanDocObjectInfo(FfsQ240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-03-01
	*/
	public boolean setAcarsDefault(FfsQ110BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-03-01
	*/
	public Hashtable selUserSetting(FfsQ110BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-03-01
	*/
	public boolean setUserAlert(FfsQ110BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-03-01
	*/
	public Hashtable selUserAlert(FfsQ110BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-03-01
	*/
	public Hashtable selFlightPlanCheck(FfsQ240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-03-01
	*/
	public Hashtable selActMessageList(FfsQ110BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-04-15
	*/
	public HashMap allNotReleasedRev() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-04-15
	*/
	public boolean insFrightPlanCheckLogTRev(HashMap<String,String> params) throws BusinessException, java.rmi.RemoteException;	

	/*======================================================================	
	@2016-07-06
	*/
	public boolean updAltRefileAcarsRev(String firstLegFltDt,String fltNum, String stnfr,String stnto,String altRefileAcars) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2016-07-06
	*/
	public String sendRlsMsgRev(FfsA260BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public boolean updFrightPlanCheckLogTRev(HashMap<String,String> params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public boolean updIsCommentedRev(HashMap<String,String> params) throws BusinessException, java.rmi.RemoteException;
	
	/*======================================================================	
	@2017-05-11
	*/
	public boolean releaseFltPlanDocInfoRev(FfsQ240BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public HashMap allReleasedRev() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public Hashtable selAcarsSmiRERev(String smiStr, HashMap fList, String tabStr) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public Hashtable selAcarsRawMsgRERev(FfsQ110BG params) throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public HashMap allEnrouteRev() throws BusinessException, java.rmi.RemoteException;

	/*======================================================================	
	@2017-05-11
	*/
	public HashMap allLandedRev() throws BusinessException, java.rmi.RemoteException;	
	
	/*======================================================================	
	@2017-09-05
	*/
	public boolean updDocRdy(HashMap<String,String> params)throws BusinessException, java.rmi.RemoteException;
	/*======================================================================	
	@2018-08-20
	*/
	public Hashtable selAcdm(FfsQ250BG params) throws BusinessException, java.rmi.RemoteException;
	
	/*======================================================================	
	@2018-08-22
	*/
	public boolean updTsatManual(HashMap<String,String> params)throws BusinessException, java.rmi.RemoteException;
	
	/*======================================================================	
	@2018-08-23
	*/
	public boolean updEldtManual(HashMap<String,String> params)throws BusinessException, java.rmi.RemoteException;
	
	
	/*======================================================================	
	@2018-08-27
	*/
	public List selATSFromATFMS(String actAlert) throws BusinessException, java.rmi.RemoteException;
	
	/*======================================================================	
	@2018-10-16
	*/
	public boolean updPsnManualDt(String firstLegFltDt, String fltNum, String legNum, String stnfr, String stnto) throws BusinessException, java.rmi.RemoteException;
	
}
