package kal.base.sta.ejb;

//ڹ 
import java.io.*;
import java.sql.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

//Project 
import kal.base.jdf.com.*;
import kal.base.jdf.db.*;
import kal.base.pbf.db.*;
import kal.base.jdf.jtx.*;
import kal.base.com.util.*;
import kal.base.jdf.ejb.*;

//SKD
import kal.base.sta.query.*;
import kal.base.sta.dbbean.*;

/**
 * Bean implementation class for Enterprise Bean: StaAllSL
 */
public class StaAllSLBean extends BeanAdapter {
	
	/** 
	  * <b>Operation Status - Airport ȸԼ</b>. 
	  * @param params StaQ020BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/25 HIST 
	  */
	public Hashtable selStaQ020Main(StaQ020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsMeta = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//2010.09.06 ߰ :   ȸ
			stmt = conn.createStatement();
			sql = StaQ020Query.getInstance().getDomAirport();
			rs = stmt.executeQuery(sql);
			
			String domAirport = ""; //'GMP','ICN','USN','CJJ'...  .
			while (rs.next()) {
				if (domAirport.equals("")) domAirport = "'" + StringUtil.checkString(rs.getString("IATA_PORT")) + "'";
				else domAirport = domAirport + ",'" + StringUtil.checkString(rs.getString("IATA_PORT")) + "'";
			}
			
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			if (stmt != null) stmt.close();
			
			//Operation Status ȸ
			stmt = conn.createStatement();
			//stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
			sql = StaQ020Query.getInstance().selMain(params, domAirport);
			rs = stmt.executeQuery(sql);
			//rsMeta = rs.getMetaData();
			//int colCount = rsMeta.getColumnCount();
			
			DecimalFormat df1 = new DecimalFormat("#,###,##0");
			DecimalFormat df2 = new DecimalFormat("#,###,##0.0");
			String bef_stn = "";		// Station
			String now_stn = "";		// Station
			double[] data_cnt = new double[9];
			int rs_cnt = 1;
			
			//2010.09.06 ߰ : COUNT TOTAL ߰
			double[] total_cnt = new double[9];
			
			while (rs.next()) {
				//Station ȸ
				now_stn = StringUtil.checkString(rs.getString("Stn"));
				
				//Logger.debug.println("[BASE:StaAllSLBean:selStaQ020Main] bef_stn : "+bef_stn+", now_stn : "+now_stn);
				
				//OLD Station
				if (now_stn.equalsIgnoreCase(bef_stn) || rs_cnt == 1) {
					//Regular
					if ((rs.getString("Flt_Mode")).equals("A") && (rs.getString("Svc")).equals("AR")) {
						data_cnt[0] += rs.getDouble("Data_Cnt");		//Reg.SKD
						total_cnt[0] += rs.getDouble("Data_Cnt");
						if ((rs.getString("Actnid")).equals("CNL")) {
							data_cnt[1] += rs.getDouble("Data_Cnt");	//Reg.CNL
							total_cnt[1] += rs.getDouble("Data_Cnt");
						} else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[2] += rs.getDouble("Data_Cnt");	//Reg.OPN
							total_cnt[2] += rs.getDouble("Data_Cnt");
						}
					} else if ((rs.getString("Flt_Mode")).equals("B") && (rs.getString("Svc")).equals("AR") && (rs.getString("Actnid")).equals("NEW")) {
						data_cnt[3] += rs.getDouble("Data_Cnt");		//Reg.DLY
						total_cnt[3] += rs.getDouble("Data_Cnt");
					}
					//Non Regular
					else if ((rs.getString("Flt_Mode")).equals("A") && (rs.getString("Svc")).equals("NR")) {
						data_cnt[4] += rs.getDouble("Data_Cnt");		//NReg.SKD
						total_cnt[4] += rs.getDouble("Data_Cnt");
						if ((rs.getString("Actnid")).equals("CNL")) {
							data_cnt[5] += rs.getDouble("Data_Cnt");	//NReg.CNL
							total_cnt[5] += rs.getDouble("Data_Cnt");
						} else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[6] += rs.getDouble("Data_Cnt");	//NReg.OPN
							total_cnt[6] += rs.getDouble("Data_Cnt");
						}
					}
					//Non Rev
					else  if ((rs.getString("Flt_Mode")).equals("A") && (rs.getString("Svc")).equals("NV")) {
						data_cnt[7] += rs.getDouble("Data_Cnt");		//NRev.SKD
						total_cnt[7] += rs.getDouble("Data_Cnt");
						if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[8] += rs.getDouble("Data_Cnt");	//NRev.OPN
							total_cnt[8] += rs.getDouble("Data_Cnt");
						}
					}
				} 
				//NEW Station
				else {
					StaQ020BG entity = new StaQ020BG();
					entity.setStn(bef_stn);
					entity.setReg_skd(df1.format(data_cnt[0]));		//Reg.SKD
					entity.setReg_cnl(df1.format(data_cnt[1]));			//Reg.CNL
					entity.setReg_opn(df1.format(data_cnt[2]));		//Reg.OPN
					entity.setReg_dly(df1.format(data_cnt[3]));			//Reg.DLY
					if ((data_cnt[2] - data_cnt[3]) == 0 || data_cnt[2] == 0) 
						entity.setReg_ontm("0");
					else {
						double regOntm = ((data_cnt[2] - data_cnt[3]) / data_cnt[2]) * 100;
						if ((String.valueOf(regOntm).toString()).indexOf(".0") != -1)
							entity.setReg_ontm(df1.format(regOntm));			
						else entity.setReg_ontm(df2.format(regOntm));	
					}
					entity.setNreg_skd(df1.format(data_cnt[4]));		//NReg.SKD
					entity.setNreg_cnl(df1.format(data_cnt[5]));		//NReg.CNL
					entity.setNreg_opn(df1.format(data_cnt[6]));		//NReg.OPN
					entity.setNrev_skd(df1.format(data_cnt[7]));		//NRev.SKD
					entity.setNrev_opn(df1.format(data_cnt[8]));		//NRev.OPN
					listData.add(entity);
					
					// ʱȭ
					data_cnt = new double[9];
					//DATA Count Start
					//Regular
					if ((rs.getString("Flt_Mode")).equals("A") && (rs.getString("Svc")).equals("AR")) {
						data_cnt[0] = rs.getDouble("Data_Cnt");		//Reg.SKD
						total_cnt[0] += rs.getDouble("Data_Cnt");
						if ((rs.getString("Actnid")).equals("CNL")) {
							data_cnt[1] = rs.getDouble("Data_Cnt");	//Reg.CNL
							total_cnt[1] += rs.getDouble("Data_Cnt");
						} else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[2] = rs.getDouble("Data_Cnt");	//Reg.OPN
							total_cnt[2] += rs.getDouble("Data_Cnt");
						}
					} else if ((rs.getString("Flt_Mode")).equals("B") && (rs.getString("Svc")).equals("AR") && (rs.getString("Actnid")).equals("NEW")) {
						data_cnt[3] = rs.getDouble("Data_Cnt");		//Reg.DLY
						total_cnt[3] += rs.getDouble("Data_Cnt");
					}
					//Non Regular
					else if ((rs.getString("Flt_Mode")).equals("A") && (rs.getString("Svc")).equals("NR")) {
						data_cnt[4] = rs.getDouble("Data_Cnt");		//NReg.SKD
						total_cnt[4] += rs.getDouble("Data_Cnt");
						if ((rs.getString("Actnid")).equals("CNL")) {
							data_cnt[5] = rs.getDouble("Data_Cnt");	//NReg.CNL
							total_cnt[5] += rs.getDouble("Data_Cnt");
						} else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[6] = rs.getDouble("Data_Cnt");	//NReg.OPN
							total_cnt[6] += rs.getDouble("Data_Cnt");
						}
					}
					//Non Rev
					else  if ((rs.getString("Flt_Mode")).equals("A") && (rs.getString("Svc")).equals("NV")) {
						data_cnt[7] = rs.getDouble("Data_Cnt");		//NRev.SKD
						total_cnt[7] += rs.getDouble("Data_Cnt");
						if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[8] = rs.getDouble("Data_Cnt");	//NRev.OPN
							total_cnt[8] += rs.getDouble("Data_Cnt");
						}
					}
				}
				//Logger.debug.println(" colCount : "+colCount+", rs_cnt : "+rs_cnt);
				/*
				for(int i=0; i<data_cnt.length; i++) {
					Logger.debug.println("[selStaQ020Main:Equal] data_cnt["+i+"] : "+data_cnt[i]);
				}
				*/
				
				//Station ü
				bef_stn = now_stn;
				rs_cnt++;
			}
			
			//  ó
			StaQ020BG entity = new StaQ020BG();
			entity.setStn(now_stn);
			entity.setReg_skd(df1.format(data_cnt[0]));		//Reg.SKD
			entity.setReg_cnl(df1.format(data_cnt[1]));			//Reg.CNL
			entity.setReg_opn(df1.format(data_cnt[2]));		//Reg.OPN
			entity.setReg_dly(df1.format(data_cnt[3]));			//Reg.DLY
			if ((data_cnt[2] - data_cnt[3]) == 0 || data_cnt[2] == 0) 
				entity.setReg_ontm("0");
			else {
				double regOntm = ((data_cnt[2] - data_cnt[3]) / data_cnt[2]) * 100;
				if ((String.valueOf(regOntm).toString()).indexOf(".0") != -1)
					entity.setReg_ontm(df1.format(regOntm));			
				else entity.setReg_ontm(df2.format(regOntm));	
			}
			entity.setNreg_skd(df1.format(data_cnt[4]));		//NReg.SKD
			entity.setNreg_cnl(df1.format(data_cnt[5]));		//NReg.CNL
			entity.setNreg_opn(df1.format(data_cnt[6]));		//NReg.OPN
			entity.setNrev_skd(df1.format(data_cnt[7]));		//NRev.SKD
			entity.setNrev_opn(df1.format(data_cnt[8]));		//NRev.OPN
			listData.add(entity);
			
			//2010.09.06 ߰ : COUNT TOTAL ߰
			StaQ020BG totalData = new StaQ020BG();
			
			totalData.setTot_reg_skd(df1.format(total_cnt[0]));
			totalData.setTot_reg_cnl(df1.format(total_cnt[1]));
			totalData.setTot_reg_opn(df1.format(total_cnt[2]));
			totalData.setTot_reg_dly(df1.format(total_cnt[3]));
			totalData.setTot_nreg_skd(df1.format(total_cnt[4]));
			totalData.setTot_nreg_cnl(df1.format(total_cnt[5]));
			totalData.setTot_nreg_opn(df1.format(total_cnt[6]));
			totalData.setTot_nrev_skd(df1.format(total_cnt[7]));
			totalData.setTot_nrev_opn(df1.format(total_cnt[8]));
						
			hashData.put("HASHDATA",listData);
			hashData.put("TOTALDATA",totalData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * <b>Ontime Status-Airport ȸԼ</b>. 
	  * @param params StaQ030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public Hashtable selStaQ030Main(StaQ030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsMeta = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	StaQ030BG delaycode = new StaQ030BG();
	    	delaycode.setArr_ew("WO,WT,WR,WI,WS,WG");																//
	    	delaycode.setArr_ea("AT,AR,AA,AS,AG,AF,AD,AM");															//
	    	delaycode.setArr_is("PD,PL,PE,PO,PH,PS,PC,PB,PG,GD,CD,CP,CC,CI,CU,CE,CL,CA");	//
	    	delaycode.setArr_im("TD,TM,TN,TS,TA,TC,TL,TV,TR");													//
	    	delaycode.setArr_io("FP,FF,FT,FR,FS,FM,RC");																	//
	    	delaycode.setArr_ig("GL,GE,GS,GC,GF,GU,GT,GB");														//
	    	delaycode.setArr_ix("FA,FC,FL,RS,ED,EC,EF");																	///
	    	delaycode.setArr_ik("SG,PO,CO");																					//
	    	delaycode.setArr_iz("DF,DG,FB,MF,MI,MO,MS,MX,RO");													//Ÿ
	    	delaycode.setArr_es("RL");																								//°
	    	delaycode.setArr_ec("NM,NB,NW,NT,NA");																		//װ⿬
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			System.out.println("aaaaa");
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = StaQ030Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			DecimalFormat df1 = new DecimalFormat("#,##0");
			DecimalFormat df2 = new DecimalFormat("##0.0");
			String bef_stn = null;		// Station
			String now_stn = null;		// Station
			double[] basic_data = new double[4];	//⺻ Data
			double[] del_data = new double[12];		//Del_rc1  DEP  Data
			int rs_cnt = 1;
			
			/*********************************************/
			/*************** (DEP) DATA ***************/
			/*********************************************/
			if (params.getDep_arr_x().equals("DEP")) {
				while (rs.next()) {
					//Station ȸ
					now_stn = StringUtil.checkString(rs.getString("Stn"));
					
					//OLD Station
					if (now_stn.equalsIgnoreCase(bef_stn) || rs_cnt == 1) {
						if ((rs.getString("Flt_Mode")).equals("A")) {
							basic_data[0] += rs.getDouble("Data_Cnt");		//SKD
							if ((rs.getString("Actnid")).equals("CNL"))
								basic_data[1] += rs.getDouble("Data_Cnt");	//CNL
							else if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[2] += rs.getDouble("Data_Cnt");	//OPRN
						} else if  ((rs.getString("Flt_Mode")).equals("B")) {
							if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[3] += rs.getDouble("Data_Cnt");	//DLY
								
							//Del_rc1 ڵ
							String delRc1 = rs.getString("Del_Rc1");
							if (delaycode.getArr_ew().indexOf(delRc1) != -1) del_data[0] += rs.getDouble("Data_Cnt");			//
							else if (delaycode.getArr_ea().indexOf(delRc1) != -1) del_data[1] += rs.getDouble("Data_Cnt");	//
							else if (delaycode.getArr_is().indexOf(delRc1) != -1) del_data[2] += rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_im().indexOf(delRc1) != -1) del_data[3] += rs.getDouble("Data_Cnt");	//
							else if (delaycode.getArr_io().indexOf(delRc1) != -1) del_data[4] += rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_ig().indexOf(delRc1) != -1) del_data[5] += rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_ix().indexOf(delRc1) != -1) del_data[6] += rs.getDouble("Data_Cnt");		///
							else if (delaycode.getArr_ik().indexOf(delRc1) != -1) del_data[7] += rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_iz().indexOf(delRc1) != -1) del_data[8] += rs.getDouble("Data_Cnt");		//Ÿ
							else if (delaycode.getArr_es().indexOf(delRc1) != -1) del_data[9] += rs.getDouble("Data_Cnt");	//°
							else if (delaycode.getArr_ec().indexOf(delRc1) != -1) del_data[10] += rs.getDouble("Data_Cnt");	//װ⿬
							else del_data[11] += rs.getDouble("Data_Cnt");	//Ÿ
						}
					} 
					//NEW Station
					else {
						StaQ030BG entity = new StaQ030BG();
						//Basic Data Add
						entity.setStn(bef_stn);									//Station
						entity.setSkd(df1.format(basic_data[0]));		//SKD
						entity.setCnl(df1.format(basic_data[1]));		//Cancel
						entity.setOpn(df1.format(basic_data[2]));	//Operation
						entity.setDly(df1.format(basic_data[3]));		//Delay
						if ((basic_data[2] - basic_data[3]) == 0 || basic_data[2] == 0)
							entity.setOntm("0");
						else {
							double onTm = ((basic_data[2] - basic_data[3]) / basic_data[2]) * 100;
							if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
								entity.setOntm(df1.format(onTm));			
							else entity.setOntm(df2.format(onTm));	
						}
						//Delay Code Data Add
						entity.setEw(df1.format(del_data[0]));
						entity.setEa(df1.format(del_data[1]));
						entity.setIs(df1.format(del_data[2]));
						entity.setIm(df1.format(del_data[3]));
						entity.setIo(df1.format(del_data[4]));
						entity.setIg(df1.format(del_data[5]));
						entity.setIx(df1.format(del_data[6]));
						entity.setIk(df1.format(del_data[7]));
						entity.setIz(df1.format(del_data[8]));
						entity.setEs(df1.format(del_data[9]));
						entity.setEc(df1.format(del_data[10]));
						entity.setEx(df1.format(del_data[11]));
						listData.add(entity);
						
						// ʱȭ
						basic_data = new double[4];
						del_data = new double[12];
						//DATA Count Start
						
						
						if ((rs.getString("Flt_Mode")).equals("A")) {
							basic_data[0] = rs.getDouble("Data_Cnt");		//SKD
							if ((rs.getString("Actnid")).equals("CNL"))
								basic_data[1] = rs.getDouble("Data_Cnt");	//CNL
							else if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[2] = rs.getDouble("Data_Cnt");	//OPRN
						} else if  ((rs.getString("Flt_Mode")).equals("B")) {
							if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[3] = rs.getDouble("Data_Cnt");	//DLY
								
							//Del_rc1 ڵ
							String delRc1 = rs.getString("Del_Rc1");
							if (delaycode.getArr_ew().indexOf(delRc1) != -1) del_data[0] = rs.getDouble("Data_Cnt");				//
							else if (delaycode.getArr_ea().indexOf(delRc1) != -1) del_data[1] = rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_is().indexOf(delRc1) != -1) del_data[2] = rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_im().indexOf(delRc1) != -1) del_data[3] = rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_io().indexOf(delRc1) != -1) del_data[4] = rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_ig().indexOf(delRc1) != -1) del_data[5] = rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_ix().indexOf(delRc1) != -1) del_data[6] = rs.getDouble("Data_Cnt");		///
							else if (delaycode.getArr_ik().indexOf(delRc1) != -1) del_data[7] = rs.getDouble("Data_Cnt");		//
							else if (delaycode.getArr_iz().indexOf(delRc1) != -1) del_data[8] = rs.getDouble("Data_Cnt");		//Ÿ
							else if (delaycode.getArr_es().indexOf(delRc1) != -1) del_data[9] = rs.getDouble("Data_Cnt");		//°
							else if (delaycode.getArr_ec().indexOf(delRc1) != -1) del_data[10] = rs.getDouble("Data_Cnt");	//װ⿬
							else del_data[11] = rs.getDouble("Data_Cnt");	//Ÿ
						}
					}
					//Station ü
					bef_stn = now_stn;
					rs_cnt++;
				}
				
				//  ó
				StaQ030BG entity = new StaQ030BG();
				//Basic Data Add
				entity.setStn(now_stn);								//Station
				entity.setSkd(df1.format(basic_data[0]));		//SKD
				entity.setCnl(df1.format(basic_data[1]));		//Cancel
				entity.setOpn(df1.format(basic_data[2]));	//Operation
				entity.setDly(df1.format(basic_data[3]));		//Delay
				if ((basic_data[2] - basic_data[3]) == 0 || basic_data[2] == 0)
					entity.setOntm("0");
				else {
					double onTm = ((basic_data[2] - basic_data[3]) / basic_data[2]) * 100;
					if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
						entity.setOntm(df1.format(onTm));			
					else entity.setOntm(df2.format(onTm));	
				}
				//Delay Code Data Add
				entity.setEw(df1.format(del_data[0]));
				entity.setEa(df1.format(del_data[1]));
				entity.setIs(df1.format(del_data[2]));
				entity.setIm(df1.format(del_data[3]));
				entity.setIo(df1.format(del_data[4]));
				entity.setIg(df1.format(del_data[5]));
				entity.setIx(df1.format(del_data[6]));
				entity.setIk(df1.format(del_data[7]));
				entity.setIz(df1.format(del_data[8]));
				entity.setEs(df1.format(del_data[9]));
				entity.setEc(df1.format(del_data[10]));
				entity.setEx(df1.format(del_data[11]));
				listData.add(entity);
			} 
			/*********************************************/
			/*************** (ARR) DATA ***************/
			/*********************************************/
			else {
				while (rs.next()) {
					//Station ȸ
					now_stn = StringUtil.checkString(rs.getString("Stn"));
					
					//OLD Station
					if (now_stn.equalsIgnoreCase(bef_stn) || rs_cnt == 1) {
						if ((rs.getString("Flt_Mode")).equals("A")) {
							basic_data[0] += rs.getDouble("Data_Cnt");		//SKD
							if ((rs.getString("Actnid")).equals("CNL"))
								basic_data[1] += rs.getDouble("Data_Cnt");	//CNL
							else if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[2] += rs.getDouble("Data_Cnt");	//OPRN
						} else if  ((rs.getString("Flt_Mode")).equals("B")) {
							if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[3] += rs.getDouble("Data_Cnt");	//DLY
						}
					} 
					//NEW Station
					else {
						StaQ030BG entity = new StaQ030BG();
						//Basic Data Add
						entity.setStn(bef_stn);									//Station
						entity.setSkd(df1.format(basic_data[0]));		//SKD
						entity.setCnl(df1.format(basic_data[1]));		//Cancel
						entity.setOpn(df1.format(basic_data[2]));	//Operation
						entity.setDly(df1.format(basic_data[3]));		//Delay
						if ((basic_data[2] - basic_data[3]) == 0 || basic_data[2] == 0)
							entity.setOntm("0");
						else {
							double onTm = ((basic_data[2] - basic_data[3]) / basic_data[2]) * 100;
							if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
								entity.setOntm(df1.format(onTm));			
							else entity.setOntm(df2.format(onTm));	
						}
						listData.add(entity);
						
						// ʱȭ
						basic_data = new double[4];
						del_data = new double[12];
						//DATA Count Start
						
						
						if ((rs.getString("Flt_Mode")).equals("A")) {
							basic_data[0] = rs.getDouble("Data_Cnt");		//SKD
							if ((rs.getString("Actnid")).equals("CNL"))
								basic_data[1] = rs.getDouble("Data_Cnt");	//CNL
							else if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[2] = rs.getDouble("Data_Cnt");	//OPRN
						} else if  ((rs.getString("Flt_Mode")).equals("B")) {
							if ((rs.getString("Actnid")).equals("NEW"))
								basic_data[3] = rs.getDouble("Data_Cnt");	//DLY
						}
					}
					//Station ü
					bef_stn = now_stn;
					rs_cnt++;
				}
				
				//  ó
				StaQ030BG entity = new StaQ030BG();
				//Basic Data Add
				entity.setStn(now_stn);								//Station
				entity.setSkd(df1.format(basic_data[0]));		//SKD
				entity.setCnl(df1.format(basic_data[1]));		//Cancel
				entity.setOpn(df1.format(basic_data[2]));	//Operation
				entity.setDly(df1.format(basic_data[3]));		//Delay
				if ((basic_data[2] - basic_data[3]) == 0 || basic_data[2] == 0)
					entity.setOntm("0");
				else {
					double onTm = ((basic_data[2] - basic_data[3]) / basic_data[2]) * 100;
					if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
						entity.setOntm(df1.format(onTm));			
					else entity.setOntm(df2.format(onTm));	
				}
				listData.add(entity);
			}
			
			/********** OnTime %  Sort *********/
			List listSort = new LinkedList();
			String[] arrSort = new String[listData.size()];
			if (listData.size() > 0) {
				for (int i=0; i<listData.size(); i++) {
					arrSort[i] = StringUtil.insString(((StaQ030BG)listData.get(i)).getOntm())+((StaQ030BG)listData.get(i)).getStn();
				}
				//OnTime+Station Sort
				Arrays.sort(arrSort);

				int j = arrSort.length;
				while (j != 0) {
					for (int k=0; k<listData.size(); k++) {
						StaQ030BG sortEntity = (StaQ030BG)listData.get(k);
						if (arrSort[j-1].equals(StringUtil.insString(sortEntity.getOntm())+sortEntity.getStn())) {
							listSort.add(sortEntity);
						}
					}
					j--;
				}
			}
			hashData.put("HASHDATA",listSort);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ030Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ030Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	/** 
	  * <b>Operation Status - LEG ȸԼ</b>. 
	  * @param params StaQ110BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public Hashtable selStaQ110Main(StaQ110BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsMeta = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = StaQ110Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			DecimalFormat df1 = new DecimalFormat("#,##0");
			DecimalFormat df2 = new DecimalFormat("##0.0");
			String bef_stn = null;		// Station
			String now_stn = null;		// Station
			double[] data_cnt = new double[6];
			int rs_cnt = 1;
			
			while (rs.next()) {
				//Station ȸ
				now_stn = StringUtil.checkString(rs.getString("Stnfr"))+"-"+StringUtil.checkString(rs.getString("Stnto"));
				
				//OLD Station
				if (now_stn.equalsIgnoreCase(bef_stn) || rs_cnt == 1) {
					if ((rs.getString("Flt_Mode")).equals("A")) {
						data_cnt[0] += rs.getDouble("Data_Cnt");			//SKD
						if ((rs.getString("Actnid")).equals("CNL"))
							data_cnt[1] += rs.getDouble("Data_Cnt");		//CNL
						else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[2] += rs.getDouble("Data_Cnt");		//OPRN
							data_cnt[4] += rs.getDouble("Supply");			//Supply
							data_cnt[5] += rs.getDouble("Onboard");		//OnBoard
						}
					} else if ((rs.getString("Flt_Mode")).equals("B")) {
						if ((rs.getString("Actnid")).equals("NEW"))
							data_cnt[3] += rs.getDouble("Data_Cnt");		//Delay
					}
				} 
				//NEW Station
				else {
					StaQ110BG entity = new StaQ110BG();
					entity.setLeg(bef_stn);
					entity.setSkd(df1.format(data_cnt[0]));						//SKD
					entity.setCnl(df1.format(data_cnt[1]));						//CNL
					entity.setOpn(df1.format(data_cnt[2]));					//OPN
					entity.setDly(df1.format(data_cnt[3]));						//DLY
					//On Time 
					if ((data_cnt[2] - data_cnt[3]) == 0 || data_cnt[2] == 0) 
						entity.setOntm("0");												//OnTime
					else {
						double onTm = ((data_cnt[2] - data_cnt[3]) / data_cnt[2]) * 100;
						if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
							entity.setOntm(df1.format(onTm));			
						else entity.setOntm(df2.format(onTm));		
					}
					entity.setSupply(df1.format(data_cnt[4]));				//Supply
					entity.setOnboard(df1.format(data_cnt[5]));				//OnBoard
					//L_F 
					if (data_cnt[5] == 0 || data_cnt[4] == 0)
						entity.setL_f("0");
					else {
						double l_F = (data_cnt[5] / data_cnt[4]) *100;
						if ((String.valueOf(l_F).toString()).indexOf(".0") != -1)
							entity.setL_f(df1.format(l_F));			//L_F
						else entity.setL_f(df2.format(l_F));						//L_F
					}
					listData.add(entity);
					
					// ʱȭ
					data_cnt = new double[6];
					//DATA Count Start
					if ((rs.getString("Flt_Mode")).equals("A")) {
						data_cnt[0] = rs.getDouble("Data_Cnt");			//SKD
						if ((rs.getString("Actnid")).equals("CNL"))
							data_cnt[1] = rs.getDouble("Data_Cnt");		//CNL
						else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[2] = rs.getDouble("Data_Cnt");		//OPRN
							data_cnt[4] = rs.getDouble("Supply");			//Supply
							data_cnt[5] = rs.getDouble("Onboard");		//OnBoard
						}
					} else if ((rs.getString("Flt_Mode")).equals("B")) {
						if ((rs.getString("Actnid")).equals("NEW"))
							data_cnt[3] = rs.getDouble("Data_Cnt");		//Delay
					}
				}
				//Station ü
				bef_stn = now_stn;
				rs_cnt++;
			}
			
			//  ó
			StaQ110BG entity = new StaQ110BG();
			entity.setLeg(now_stn);
			entity.setSkd(df1.format(data_cnt[0]));						//SKD
			entity.setCnl(df1.format(data_cnt[1]));						//CNL
			entity.setOpn(df1.format(data_cnt[2]));					//OPN
			entity.setDly(df1.format(data_cnt[3]));						//DLY
			//On Time 
			if ((data_cnt[2] - data_cnt[3]) == 0 || data_cnt[2] == 0) 
				entity.setOntm("0");												//OnTime
			else {
				double onTm = ((data_cnt[2] - data_cnt[3]) / data_cnt[2]) * 100;
				if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
					entity.setOntm(df1.format(onTm));			
				else entity.setOntm(df2.format(onTm));		
			}
			entity.setSupply(df1.format(data_cnt[4]));				//Supply
			entity.setOnboard(df1.format(data_cnt[5]));				//OnBoard
			//L_F 
			if (data_cnt[5] == 0 || data_cnt[4] == 0)
				entity.setL_f("0");
			else {
				double l_F = (data_cnt[5] / data_cnt[4]) *100;
				if ((String.valueOf(l_F).toString()).indexOf(".0") != -1)
					entity.setL_f(df1.format(l_F));			//L_F
				else entity.setL_f(df2.format(l_F));						//L_F
			}
			listData.add(entity);
						
			hashData.put("HASHDATA",listData);
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ110Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ110Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * <b>Operation Status - Flight ȸԼ</b>. 
	  * @param params StaQ110BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public Hashtable selStaQ210Main(StaQ210BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsMeta = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = StaQ210Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			DecimalFormat df1 = new DecimalFormat("#,##0");
			DecimalFormat df2 = new DecimalFormat("##0.0");
			String bef_flt = null;			// Flight Number
			String now_flt = null;		// Flight Number
			String bef_stn = null;		// Station
			String now_stn = null;		// Station
			double[] data_cnt = new double[6];
			int rs_cnt = 1;
			
			while (rs.next()) {
				//Station_Flight ȸ
				now_flt = StringUtil.checkString(rs.getString("Flt_Num"));
				now_stn = StringUtil.checkString(rs.getString("Stnfr"))+"-"+StringUtil.checkString(rs.getString("Stnto"));
				
				//OLD Station
				if ((now_stn.equalsIgnoreCase(bef_stn) && now_flt.equalsIgnoreCase(bef_flt)) || rs_cnt == 1) {
					if ((rs.getString("Flt_Mode")).equals("A")) {
						data_cnt[0] += rs.getDouble("Data_Cnt");			//SKD
						if ((rs.getString("Actnid")).equals("CNL"))
							data_cnt[1] += rs.getDouble("Data_Cnt");		//CNL
						else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[2] += rs.getDouble("Data_Cnt");		//OPRN
							data_cnt[4] += rs.getDouble("Supply");			//Supply
							data_cnt[5] += rs.getDouble("Onboard");		//OnBoard
						}
					} else if ((rs.getString("Flt_Mode")).equals("B")) {
						if ((rs.getString("Actnid")).equals("NEW"))
							data_cnt[3] += rs.getDouble("Data_Cnt");		//Delay
					}
				} 
				//NEW Station
				else {
					StaQ210BG entity = new StaQ210BG();
					entity.setFlt_num(bef_flt);				
					entity.setLeg(bef_stn);
					entity.setSkd(df1.format(data_cnt[0]));						//SKD
					entity.setCnl(df1.format(data_cnt[1]));						//CNL
					entity.setOpn(df1.format(data_cnt[2]));					//OPN
					entity.setDly(df1.format(data_cnt[3]));						//DLY
					//On Time 
					if ((data_cnt[2] - data_cnt[3]) == 0 || data_cnt[2] == 0) 
						entity.setOntm("0");												//OnTime
					else {
						double onTm = ((data_cnt[2] - data_cnt[3]) / data_cnt[2]) * 100;
						if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
							entity.setOntm(df1.format(onTm));			
						else entity.setOntm(df2.format(onTm));		
					}
					entity.setSupply(df1.format(data_cnt[4]));				//Supply
					entity.setOnboard(df1.format(data_cnt[5]));				//OnBoard
					//L_F 
					if (data_cnt[5] == 0 || data_cnt[4] == 0)
						entity.setL_f("0");
					else {
						double l_F = (data_cnt[5] / data_cnt[4]) *100;
						if ((String.valueOf(l_F).toString()).indexOf(".0") != -1)
							entity.setL_f(df1.format(l_F));			//L_F
						else entity.setL_f(df2.format(l_F));						//L_F
					}
					listData.add(entity);
					
					// ʱȭ
					data_cnt = new double[6];
					//DATA Count Start
					if ((rs.getString("Flt_Mode")).equals("A")) {
						data_cnt[0] = rs.getDouble("Data_Cnt");			//SKD
						if ((rs.getString("Actnid")).equals("CNL"))
							data_cnt[1] = rs.getDouble("Data_Cnt");		//CNL
						else if ((rs.getString("Actnid")).equals("NEW")) {
							data_cnt[2] = rs.getDouble("Data_Cnt");		//OPRN
							data_cnt[4] = rs.getDouble("Supply");			//Supply
							data_cnt[5] = rs.getDouble("Onboard");		//OnBoard
						}
					} else if ((rs.getString("Flt_Mode")).equals("B")) {
						if ((rs.getString("Actnid")).equals("NEW"))
							data_cnt[3] = rs.getDouble("Data_Cnt");		//Delay
					}
				}
				//Station_Flight ü
				bef_flt = now_flt;
				bef_stn = now_stn;
				rs_cnt++;
			}
			
			//  ó
			StaQ210BG entity = new StaQ210BG();
			entity.setFlt_num(now_flt);
			entity.setLeg(now_stn);
			entity.setSkd(df1.format(data_cnt[0]));						//SKD
			entity.setCnl(df1.format(data_cnt[1]));						//CNL
			entity.setOpn(df1.format(data_cnt[2]));					//OPN
			entity.setDly(df1.format(data_cnt[3]));						//DLY
			//On Time 
			if ((data_cnt[2] - data_cnt[3]) == 0 || data_cnt[2] == 0) 
				entity.setOntm("0");												//OnTime
			else {
				double onTm = ((data_cnt[2] - data_cnt[3]) / data_cnt[2]) * 100;
				if ((String.valueOf(onTm).toString()).indexOf(".0") != -1)
					entity.setOntm(df1.format(onTm));			
				else entity.setOntm(df2.format(onTm));		
			}
			entity.setSupply(df1.format(data_cnt[4]));				//Supply
			entity.setOnboard(df1.format(data_cnt[5]));				//OnBoard
			//L_F 
			if (data_cnt[5] == 0 || data_cnt[4] == 0)
				entity.setL_f("0");
			else {
				double l_F = (data_cnt[5] / data_cnt[4]) *100;
				if ((String.valueOf(l_F).toString()).indexOf(".0") != -1)
					entity.setL_f(df1.format(l_F));			//L_F
				else entity.setL_f(df2.format(l_F));						//L_F
			}
			listData.add(entity);
						
			hashData.put("HASHDATA",listData);
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ210Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ210Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>Flying Time Status-A/C Type ȸԼ</b>. 
	  * @param params StaQ310BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public Hashtable selStaQ310Main(StaQ310BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsMeta = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = StaQ310Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			DecimalFormat df1 = new DecimalFormat("#,##0");
			DecimalFormat df2 = new DecimalFormat("##0.0");
			String bef_typ = null;		// Station
			String now_typ = null;		// Station
			double[] data_cnt = new double[7];
			int rs_cnt = 1;
			//Period Ⱓ ¥ 
			int period = StringUtil.daysBetween(params.getFrom_date(),params.getTo_date());
			
			while (rs.next()) {
				//Kactyp
				now_typ = StringUtil.checkString(rs.getString("Kactyp"));
				
				//OLD ACTYP
				if (now_typ.equalsIgnoreCase(bef_typ) || rs_cnt == 1) {
					data_cnt[0] += 1;															//REG Count
					data_cnt[1] += rs.getDouble("Data_Cnt");					//Landing
					data_cnt[2] += rs.getDouble("Dly_Tm");						//Total
					if ((rs.getString("Svc")).equals("AR"))
						data_cnt[3] += rs.getDouble("Dly_Tm");					//Rev
					else if ((rs.getString("Svc")).equals("AR"))
						data_cnt[4] += rs.getDouble("Dly_Tm");					//N_Rev
					if ((rs.getString("Region_Leg")).equals("DOM"))
						data_cnt[5] += rs.getDouble("Dly_Tm");					//DOM
					else if ((rs.getString("Region_Leg")).equals("INT"))
						data_cnt[6] += rs.getDouble("Dly_Tm");					//INT
				} 
				//NEW ACTYP
				else {
					StaQ310BG entity = new StaQ310BG();
					entity.setActyp(bef_typ);
					entity.setFleets(df1.format(data_cnt[0]));
					entity.setLanding(df1.format(data_cnt[1]));
					entity.setTotal(df1.format(data_cnt[2]));
					entity.setRev(df1.format(data_cnt[3]));
					entity.setN_rev(df1.format(data_cnt[4]));
					//PRD.UTIL
					if (data_cnt[2] == 0 || data_cnt[0] == 0)
						entity.setPrd_util("0");
					else {
						double prdUtil = data_cnt[2] / data_cnt[0];
						if ((String.valueOf(prdUtil).toString()).indexOf(".0") != -1)
							entity.setPrd_util(df1.format(prdUtil));			
						else entity.setPrd_util(df2.format(prdUtil));	
					}
					//DAY.UTIL
					if (entity.getPrd_util().equals("0") || period == 0)
						entity.setDay_util("0");
					else {
						double dayUtil = Double.valueOf(entity.getPrd_util()).doubleValue() / period;
						if ((String.valueOf(dayUtil).toString()).indexOf(".0") != -1)
							entity.setDay_util(df1.format(dayUtil));			
						else entity.setDay_util(df2.format(dayUtil));	
					}
					entity.setDom(df1.format(data_cnt[5]));
					entity.setIntl(df1.format(data_cnt[6]));
					listData.add(entity);
					
					// ʱȭ
					data_cnt = new double[7];
					//DATA Count Start
					data_cnt[0] = 1;														//REG Count
					data_cnt[1] = rs.getDouble("Data_Cnt");					//Landing
					data_cnt[2] = rs.getDouble("Dly_Tm");						//Total
					if ((rs.getString("Svc")).equals("AR"))
						data_cnt[3] = rs.getDouble("Dly_Tm");					//Rev
					else if ((rs.getString("Svc")).equals("AR"))
						data_cnt[4] = rs.getDouble("Dly_Tm");					//N_Rev
					if ((rs.getString("Region_Leg")).equals("DOM"))
						data_cnt[5] = rs.getDouble("Dly_Tm");					//DOM
					else if ((rs.getString("Region_Leg")).equals("INT"))
						data_cnt[6] = rs.getDouble("Dly_Tm");					//INT
				}
				//Station_Flight ü
				bef_typ = now_typ;
				rs_cnt++;
			}
			
			//  ó
			StaQ310BG entity = new StaQ310BG();
			entity.setActyp(now_typ);
			entity.setFleets(df1.format(data_cnt[0]));
			entity.setLanding(df1.format(data_cnt[1]));
			entity.setTotal(df1.format(data_cnt[2]));
			entity.setRev(df1.format(data_cnt[3]));
			entity.setN_rev(df1.format(data_cnt[4]));
			//PRD.UTIL
			if (data_cnt[2] == 0 || data_cnt[0] == 0)
				entity.setPrd_util("0");
			else {
				double prdUtil = data_cnt[2] / data_cnt[0];
				if ((String.valueOf(prdUtil).toString()).indexOf(".0") != -1)
					entity.setPrd_util(df1.format(prdUtil));			
				else entity.setPrd_util(df2.format(prdUtil));	
			}
			//DAY.UTIL
			if (entity.getPrd_util().equals("0") || period == 0)
				entity.setDay_util("0");
			else {
				double dayUtil = Double.valueOf(entity.getPrd_util()).doubleValue() / period;
				if ((String.valueOf(dayUtil).toString()).indexOf(".0") != -1)
					entity.setDay_util(df1.format(dayUtil));			
				else entity.setDay_util(df2.format(dayUtil));	
			}
			entity.setDom(df1.format(data_cnt[5]));
			entity.setIntl(df1.format(data_cnt[6]));
			listData.add(entity);
						
			hashData.put("HASHDATA",listData);
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ310Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ310Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	/** 
	  * <b>Flying Time Status-REG ȸԼ</b>. 
	  * @param params StaQ320BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public Hashtable selStaQ320Main(StaQ320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsMeta = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = StaQ320Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			DecimalFormat df1 = new DecimalFormat("#,##0");
			DecimalFormat df2 = new DecimalFormat("##0.0");
			String bef_typ = null;		// Station
			String now_typ = null;		// Station
			String bef_reg = null;		// Reg No
			String now_reg = null;		// Reg No
			double[] data_cnt = new double[12];
			int rs_cnt = 1;
			String rev_reg = "J,F,M";
			String rev_ext = "G,A";
			String rev_cha = "C,H";
			String n_rev_fre  = "P";
			String n_rev_tes = "T";
			
			while (rs.next()) {
				//Kactyp
				now_typ = StringUtil.checkString(rs.getString("Kactyp"));
				now_reg = StringUtil.checkString(rs.getString("Regno"));
				
				//OLD ACTYP & Reg No
				if ((now_typ.equalsIgnoreCase(bef_typ) && now_reg.equalsIgnoreCase(bef_reg)) || rs_cnt == 1) {
					data_cnt[0] += rs.getDouble("Data_Cnt");					//Landing
					data_cnt[1] += rs.getDouble("Dly_Tm");						//Total
					if (rev_reg.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[2] += rs.getDouble("Dly_Tm");					//Rev
						data_cnt[4] += rs.getDouble("Dly_Tm");					//Regular
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[2] += rs.getDouble("Dly_Tm");					//Rev
						data_cnt[5] += rs.getDouble("Dly_Tm");					//Extra
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[2] += rs.getDouble("Dly_Tm");					//Rev
						data_cnt[6] += rs.getDouble("Dly_Tm");					//Charter
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[3] += rs.getDouble("Dly_Tm");					//N_Rev
						data_cnt[7] += rs.getDouble("Dly_Tm");					//Freey
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[3] += rs.getDouble("Dly_Tm");					//N_Rev
						data_cnt[8] += rs.getDouble("Dly_Tm");					//Test
					} else {
						data_cnt[3] += rs.getDouble("Dly_Tm");					//N_Rev
						data_cnt[9] += rs.getDouble("Dly_Tm");					//Other
					}
					if ((rs.getString("Region_Leg")).equals("DOM"))
						data_cnt[10] += rs.getDouble("Dly_Tm");					//DOM
					else if ((rs.getString("Region_Leg")).equals("INT"))
						data_cnt[11] += rs.getDouble("Dly_Tm");					//INT
				} 
				//NEW ACTYP & Reg No
				else {
					StaQ320BG entity = new StaQ320BG();
					entity.setActyp(bef_typ);
					entity.setReg(bef_reg);
					entity.setLanding(df1.format(data_cnt[0]));
					entity.setTotal(df1.format(data_cnt[1]));
					entity.setRev(df1.format(data_cnt[2]));
					entity.setN_rev(df1.format(data_cnt[3]));
					entity.setRegular(df1.format(data_cnt[4]));
					entity.setExtra(df1.format(data_cnt[5]));
					entity.setChtr(df1.format(data_cnt[6]));
					entity.setFerry(df1.format(data_cnt[7]));
					entity.setTest(df1.format(data_cnt[8]));
					entity.setOther(df1.format(data_cnt[9]));
					entity.setDom(df1.format(data_cnt[10]));
					entity.setIntl(df1.format(data_cnt[11]));
					listData.add(entity);
					
					// ʱȭ
					data_cnt = new double[12];
					//DATA Count Start
					data_cnt[0] = rs.getDouble("Data_Cnt");					//Landing
					data_cnt[1] = rs.getDouble("Dly_Tm");						//Total
					if (rev_reg.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[2] = rs.getDouble("Dly_Tm");					//Rev
						data_cnt[4] = rs.getDouble("Dly_Tm");					//Regular
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[2] = rs.getDouble("Dly_Tm");					//Rev
						data_cnt[5] = rs.getDouble("Dly_Tm");					//Extra
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[2] = rs.getDouble("Dly_Tm");					//Rev
						data_cnt[6] = rs.getDouble("Dly_Tm");					//Charter
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[3] = rs.getDouble("Dly_Tm");					//N_Rev
						data_cnt[7] = rs.getDouble("Dly_Tm");					//Freey
					} else if (rev_ext.indexOf(rs.getString("Svc")) != -1) {
						data_cnt[3] = rs.getDouble("Dly_Tm");					//N_Rev
						data_cnt[8] = rs.getDouble("Dly_Tm");					//Test
					} else {
						data_cnt[3] = rs.getDouble("Dly_Tm");					//N_Rev
						data_cnt[9] = rs.getDouble("Dly_Tm");					//Other
					}
					if ((rs.getString("Region_Leg")).equals("DOM"))
						data_cnt[10] = rs.getDouble("Dly_Tm");					//DOM
					else if ((rs.getString("Region_Leg")).equals("INT"))
						data_cnt[11] = rs.getDouble("Dly_Tm");					//INT
				}
				//ACTyp & Reg No ü
				bef_typ = now_typ;
				bef_reg = now_reg;
				rs_cnt++;
			}
			
			//  ó
			StaQ320BG entity = new StaQ320BG();
			entity.setActyp(now_typ);
			entity.setReg(now_reg);
			entity.setLanding(df1.format(data_cnt[0]));
			entity.setTotal(df1.format(data_cnt[1]));
			entity.setRev(df1.format(data_cnt[2]));
			entity.setN_rev(df1.format(data_cnt[3]));
			entity.setRegular(df1.format(data_cnt[4]));
			entity.setExtra(df1.format(data_cnt[5]));
			entity.setChtr(df1.format(data_cnt[6]));
			entity.setFerry(df1.format(data_cnt[7]));
			entity.setTest(df1.format(data_cnt[8]));
			entity.setOther(df1.format(data_cnt[9]));
			entity.setDom(df1.format(data_cnt[10]));
			entity.setIntl(df1.format(data_cnt[11]));
			listData.add(entity);
						
			hashData.put("HASHDATA",listData);
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ320Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ320Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	

	/** 
	  *  Delay Status(Airport) main ȸԼ.
	  * @param entity StaQ010BG  Delay Status(Airport)
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/25 
	  */
	public Hashtable selStaQ010Main(StaQ010BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Delay Status(Airport) ȸ
			stmt = conn.createStatement();
			sql = StaQ010Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// STN
			String preStn = "";
			int cnt = 0;
			String depSkd = "0";
			String depCnl = "0";
			String depOprn = "0";
			String depDelay = "0";
			String arrSkd = "0";
			String arrCnl = "0";
			String arrOprn = "0";
			String arrDelay = "0";
			
			while (rs.next()) {
				StaQ010BG entity = new StaQ010BG();
				
				String stn = StringUtil.checkString(rs.getString("Stnfr"));
				String actnid = StringUtil.checkString(rs.getString("Actnid"));
				String abcd = StringUtil.checkString(rs.getString("Abcd"));
				String total = StringUtil.checkString(rs.getString("Total"));
						
				if(stn.equals(preStn) || cnt == 0){
					if(actnid.equals("CNL") && abcd.equals("A")){
						depCnl = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("A")){
						depOprn = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("B")){
						depDelay = total;
					}
					else if(actnid.equals("CNL") && abcd.equals("C")){
						arrCnl = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("C")){
						arrOprn = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("D")){
						arrDelay = total;
					}
				}
				else{
					depSkd = String.valueOf(Integer.parseInt(depCnl)+Integer.parseInt(depOprn));
					arrSkd = String.valueOf(Integer.parseInt(arrCnl)+Integer.parseInt(arrOprn));
					entity.setStnfr(preStn);
					entity.setDep_skd(StringUtil.NumberFormatS(1,depSkd));
					entity.setDep_cnl(StringUtil.NumberFormatS(1,depCnl));
					entity.setDep_oprn(StringUtil.NumberFormatS(1,depOprn));
					entity.setDep_delay(StringUtil.NumberFormatS(1,depDelay));
					entity.setArr_skd(StringUtil.NumberFormatS(1,arrSkd));
					entity.setArr_cnl(StringUtil.NumberFormatS(1,arrCnl));
					entity.setArr_oprn(StringUtil.NumberFormatS(1,arrOprn));
					entity.setArr_delay(StringUtil.NumberFormatS(1,arrDelay));
						
					listData.add(entity);
						
					depSkd = "0";
					depCnl = "0";
					depOprn = "0";
					depDelay = "0";
					arrSkd = "0";
					arrCnl = "0";
					arrOprn = "0";
					arrDelay = "0";
						
					if(actnid.equals("CNL") && abcd.equals("A")){
						depCnl = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("A")){
						depOprn = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("B")){
						depDelay = total;
					}
					else if(actnid.equals("CNL") && abcd.equals("C")){
						arrCnl = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("C")){
						arrOprn = total;
					}
					else if(actnid.equals("NEW") && abcd.equals("D")){
						arrDelay = total;
					}
				}
				preStn = stn;
				cnt++;
			}
			if(!preStn.equals(""))
			{
				StaQ010BG entity = new StaQ010BG();
				
				depSkd = String.valueOf(Integer.parseInt(depCnl)+Integer.parseInt(depOprn));
				arrSkd = String.valueOf(Integer.parseInt(arrCnl)+Integer.parseInt(arrOprn));
				entity.setStnfr(preStn);
				entity.setDep_skd(StringUtil.NumberFormatS(1,depSkd));
				entity.setDep_cnl(StringUtil.NumberFormatS(1,depCnl));
				entity.setDep_oprn(StringUtil.NumberFormatS(1,depOprn));
				entity.setDep_delay(StringUtil.NumberFormatS(1,depDelay));
				entity.setArr_skd(StringUtil.NumberFormatS(1,arrSkd));
				entity.setArr_cnl(StringUtil.NumberFormatS(1,arrCnl));
				entity.setArr_oprn(StringUtil.NumberFormatS(1,arrOprn));
				entity.setArr_delay(StringUtil.NumberFormatS(1,arrDelay));
			}
		
			hashData.put("DELAYINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * Cancel Status(Airport) main ȸԼ.
	  * @param entity StaQ040BG  Cancel Status(Airport)
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/26 
	  */
	public Hashtable selStaQ040Main(StaQ040BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Cancel Status(Airport) ȸ
			stmt = conn.createStatement();
			sql = StaQ040Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// STN
			String preStn = "";
			int cnt = 0;
			int oprn = 0;
			int cnl = 0;
			int tech = 0;
			int opco = 0;
			int comm = 0;
			int oper = 0;
			int arpt = 0;
			int weat = 0;
			int equi = 0;
			int auth = 0;
			int indu = 0;
			int etc = 0;
			
			String cd01 = "TECH"; 
			String cd02 = "OPCO"; 
			String cd03 = "COMM,NODE"; 
			String cd04 = "OPER"; 
			String cd05 = "RUNW,AIRS,ARPT"; 
			String cd06 = "WEAT"; 
			String cd07 = "EQUI"; 
			String cd08 = "AUTH"; 
			String cd09 = "INDU";
			String cd10 = "CREW,DAMA,FUEL,PERF,POLI"; 
			
			while (rs.next()) {
				StaQ040BG entity = new StaQ040BG();

				String stn = StringUtil.checkString(rs.getString("Stnfr"));
				String actnid = StringUtil.checkString(rs.getString("Actnid"));
				String chgreas = StringUtil.checkString(rs.getString("Chgreas"));
				int total = Integer.parseInt(StringUtil.checkString(rs.getString("Total")));
				if(stn.equals(preStn) || cnt == 0){
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				else{
					int skd = oprn + cnl;
					double ratio = ((double)cnl/(double)skd) * 100;
					DecimalFormat df = new DecimalFormat("#,###.#");
					entity.setStnfr(preStn);
					entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
					entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
					entity.setRatio(df.format(ratio));
					entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
					entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
					entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
					entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
					entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
					entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
					entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
					entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
					entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
					entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
						
					listData.add(entity);
						
					oprn = 0;
					cnl = 0;
					tech = 0;
					opco = 0;
					comm = 0;
					oper = 0;
					arpt = 0;
					weat = 0;
					equi = 0;
					auth = 0;
					indu = 0;
					etc = 0;
						
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				preStn = stn;
				cnt++;
			}
			if(!preStn.equals(""))
			{
				StaQ040BG entity = new StaQ040BG();
				
				int skd = oprn + cnl;
				double ratio = ((double)cnl/(double)skd) * 100;
				DecimalFormat df = new DecimalFormat("#,###.#");
				entity.setStnfr(preStn);
				entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
				entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
				entity.setRatio(df.format(ratio));
				entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
				entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
				entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
				entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
				entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
				entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
				entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
				entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
				entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
				entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
					
				listData.add(entity);
			}
			hashData.put("CANCELINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ040Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ040Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * Cancel Status(LEG) main ȸԼ.
	  * @param entity StaQ120BG  Cancel Status(LEG)
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/26 
	  */
	public Hashtable selStaQ120Main(StaQ120BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Cancel Status(LEG) ȸ
			stmt = conn.createStatement();
			sql = StaQ120Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// STN
			String preStn = "";
			int cnt = 0;
			int oprn = 0;
			int cnl = 0;
			int tech = 0;
			int opco = 0;
			int comm = 0;
			int oper = 0;
			int arpt = 0;
			int weat = 0;
			int equi = 0;
			int auth = 0;
			int indu = 0;
			int etc = 0;
			
			String cd01 = "TECH"; 
			String cd02 = "OPCO"; 
			String cd03 = "COMM,NODE"; 
			String cd04 = "OPER"; 
			String cd05 = "RUNW,AIRS,ARPT"; 
			String cd06 = "WEAT"; 
			String cd07 = "EQUI"; 
			String cd08 = "AUTH"; 
			String cd09 = "INDU";
			String cd10 = "CREW,DAMA,FUEL,PERF,POLI"; 
			
			while (rs.next()) {
				StaQ120BG entity = new StaQ120BG();

				String stn = StringUtil.checkString(rs.getString("Stnfr"))+" - "+StringUtil.checkString(rs.getString("Stnto"));
				String actnid = StringUtil.checkString(rs.getString("Actnid"));
				String chgreas = StringUtil.checkString(rs.getString("Chgreas"));
				int total = Integer.parseInt(StringUtil.checkString(rs.getString("Total")));
				if(stn.equals(preStn) || cnt == 0){
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				else{
					int skd = oprn + cnl;
					double ratio = ((double)cnl/(double)skd) * 100;
					DecimalFormat df = new DecimalFormat("#,###.#");
					entity.setStnfr(preStn);
					entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
					entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
					entity.setRatio(df.format(ratio));
					entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
					entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
					entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
					entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
					entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
					entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
					entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
					entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
					entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
					entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
						
					listData.add(entity);
						
					oprn = 0;
					cnl = 0;
					tech = 0;
					opco = 0;
					comm = 0;
					oper = 0;
					arpt = 0;
					weat = 0;
					equi = 0;
					auth = 0;
					indu = 0;
					etc = 0;
						
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				preStn = stn;
				cnt++;
			}
			if(!preStn.equals(""))
			{
				StaQ120BG entity = new StaQ120BG();
				
				int skd = oprn + cnl;
				double ratio = ((double)cnl/(double)skd) * 100;
				DecimalFormat df = new DecimalFormat("#,###.#");
				entity.setStnfr(preStn);
				entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
				entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
				entity.setRatio(df.format(ratio));
				entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
				entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
				entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
				entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
				entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
				entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
				entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
				entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
				entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
				entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
					
				listData.add(entity);
				
			}
			hashData.put("CNLLEGINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ120Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ120Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * Cancel Status(Flight) main ȸԼ.
	  * @param entity StaQ220BG  Cancel Status(Flight)
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/27 
	  */
	public Hashtable selStaQ220Main(StaQ220BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Cancel Status(Flight) ȸ
			stmt = conn.createStatement();
			sql = StaQ220Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// STN
			String preStn = "";
			String preFltNum = "";
			int cnt = 0;
			int oprn = 0;
			int cnl = 0;
			int tech = 0;
			int opco = 0;
			int comm = 0;
			int oper = 0;
			int arpt = 0;
			int weat = 0;
			int equi = 0;
			int auth = 0;
			int indu = 0;
			int etc = 0;
			
			String cd01 = "TECH"; 
			String cd02 = "OPCO"; 
			String cd03 = "COMM,NODE"; 
			String cd04 = "OPER"; 
			String cd05 = "RUNW,AIRS,ARPT"; 
			String cd06 = "WEAT"; 
			String cd07 = "EQUI"; 
			String cd08 = "AUTH"; 
			String cd09 = "INDU";
			String cd10 = "CREW,DAMA,FUEL,PERF,POLI"; 
			
			while (rs.next()) {
				StaQ220BG entity = new StaQ220BG();
				
				String fltNum = StringUtil.checkString(rs.getString("Flt_Num"));
				String stn = StringUtil.checkString(rs.getString("Stnfr"))+" - "+StringUtil.checkString(rs.getString("Stnto"));
				String actnid = StringUtil.checkString(rs.getString("Actnid"));
				String chgreas = StringUtil.checkString(rs.getString("Chgreas"));
				int total = Integer.parseInt(StringUtil.checkString(rs.getString("Total")));
				// ==> 2005.12.21 
				if((fltNum.equals(preFltNum) && stn.equals(preStn)) || cnt == 0){
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				else{
					int skd = oprn + cnl;
					double ratio = ((double)cnl/(double)skd) * 100;
					DecimalFormat df = new DecimalFormat("#,###.#");
					
					entity.setFlt_num(preFltNum);
					entity.setStnfr(preStn);
					entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
					entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
					entity.setRatio(df.format(ratio));
					entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
					entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
					entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
					entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
					entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
					entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
					entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
					entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
					entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
					entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
							
					listData.add(entity);
						
					oprn = 0;
					cnl = 0;
					tech = 0;
					opco = 0;
					comm = 0;
					oper = 0;
					arpt = 0;
					weat = 0;
					equi = 0;
					auth = 0;
					indu = 0;
					etc = 0;
						
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				preStn = stn;
				preFltNum = fltNum;
				cnt++;
			}
			if(!preStn.equals(""))
			{
				StaQ220BG entity = new StaQ220BG();
				
				int skd = oprn + cnl;
				double ratio = ((double)cnl/(double)skd) * 100;
				DecimalFormat df = new DecimalFormat("#,###.#");
				
				entity.setFlt_num(preFltNum);
				entity.setStnfr(preStn);
				entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
				entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
				entity.setRatio(df.format(ratio));
				entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
				entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
				entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
				entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
				entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
				entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
				entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
				entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
				entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
				entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
						
				listData.add(entity);
				
			}
			hashData.put("CNLFLTINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ220Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ220Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * Cancel Status(A/C TYPE) main ȸԼ.
	  * @param entity StaQ330BG  Cancel Status(A/C TYPE)
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/27 
	  */
	public Hashtable selStaQ330Main(StaQ330BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Cancel Status(A/C TYPE) ȸ
			stmt = conn.createStatement();
			sql = StaQ330Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// A/C TYPE
			String preKactyp = "";
			int cnt = 0;
			int oprn = 0;
			int cnl = 0;
			int tech = 0;
			int opco = 0;
			int comm = 0;
			int oper = 0;
			int arpt = 0;
			int weat = 0;
			int equi = 0;
			int auth = 0;
			int indu = 0;
			int etc = 0;
			
			String cd01 = "TECH"; 
			String cd02 = "OPCO"; 
			String cd03 = "COMM,NODE"; 
			String cd04 = "OPER"; 
			String cd05 = "RUNW,AIRS,ARPT"; 
			String cd06 = "WEAT"; 
			String cd07 = "EQUI"; 
			String cd08 = "AUTH"; 
			String cd09 = "INDU";
			String cd10 = "CREW,DAMA,FUEL,PERF,POLI"; 
			
			while (rs.next()) {
				StaQ330BG entity = new StaQ330BG();

				String kactyp = StringUtil.checkString(rs.getString("Kactyp"));
				String actnid = StringUtil.checkString(rs.getString("Actnid"));
				String chgreas = StringUtil.checkString(rs.getString("Chgreas"));
				int total = Integer.parseInt(StringUtil.checkString(rs.getString("Total")));
				if(kactyp.equals(preKactyp) || cnt == 0){
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				else{
					int skd = oprn + cnl;
					double ratio = ((double)cnl/(double)skd) * 100;
					DecimalFormat df = new DecimalFormat("#,###.#");
					entity.setKactyp(preKactyp);
					entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
					entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
					entity.setRatio(df.format(ratio));
					entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
					entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
					entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
					entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
					entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
					entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
					entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
					entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
					entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
					entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
						
					listData.add(entity);
						
					oprn = 0;
					cnl = 0;
					tech = 0;
					opco = 0;
					comm = 0;
					oper = 0;
					arpt = 0;
					weat = 0;
					equi = 0;
					auth = 0;
					indu = 0;
					etc = 0;
						
					if(actnid.equals("NEW")){
						oprn = oprn + total;
					}
					else if(actnid.equals("CNL")){
						cnl = cnl + total;
						if(cd01.indexOf(chgreas)!=-1) tech = total;
						else if(cd02.indexOf(chgreas)!=-1) opco = total;
						else if(cd03.indexOf(chgreas)!=-1) comm = comm + total;
						else if(cd04.indexOf(chgreas)!=-1) oper = total;
						else if(cd05.indexOf(chgreas)!=-1) arpt = arpt + total;
						else if(cd06.indexOf(chgreas)!=-1) weat = total;
						else if(cd07.indexOf(chgreas)!=-1) equi = total;
						else if(cd08.indexOf(chgreas)!=-1) auth = total;
						else if(cd09.indexOf(chgreas)!=-1) indu = total;
						else if(cd10.indexOf(chgreas)!=-1) etc = etc + total;
						else etc = etc + total;
					}
				}
				preKactyp = kactyp;
				cnt++;
			}
			if(!preKactyp.equals(""))
			{
				StaQ330BG entity = new StaQ330BG();
				
				int skd = oprn + cnl;
				double ratio = ((double)cnl/(double)skd) * 100;
				DecimalFormat df = new DecimalFormat("#,###.#");
				entity.setKactyp(preKactyp);
				entity.setSkd(StringUtil.NumberFormatS(1,String.valueOf(skd)));
				entity.setCnl(StringUtil.NumberFormatS(1,String.valueOf(cnl)));
				entity.setRatio(df.format(ratio));
				entity.setTech(StringUtil.NumberFormatS(1,String.valueOf(tech)));
				entity.setOpco(StringUtil.NumberFormatS(1,String.valueOf(opco)));
				entity.setComm(StringUtil.NumberFormatS(1,String.valueOf(comm)));
				entity.setOper(StringUtil.NumberFormatS(1,String.valueOf(oper)));
				entity.setArpt(StringUtil.NumberFormatS(1,String.valueOf(arpt)));
				entity.setWeat(StringUtil.NumberFormatS(1,String.valueOf(weat)));
				entity.setEqui(StringUtil.NumberFormatS(1,String.valueOf(equi)));
				entity.setAuth(StringUtil.NumberFormatS(1,String.valueOf(auth)));
				entity.setIndu(StringUtil.NumberFormatS(1,String.valueOf(indu)));
				entity.setEtc(StringUtil.NumberFormatS(1,String.valueOf(etc)));
					
				listData.add(entity);
			}
			hashData.put("CNLACTYPINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ330Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ330Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * ASM Summary main ȸԼ.
	  * @param entity StaQ410BG  ASM Summary
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/27 
	  */
	public Hashtable selStaQ410Main(StaQ410BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//ASM Summary ȸ
			stmt = conn.createStatement();
			sql = StaQ410Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// Chgreas
			String preChgreas = "";
			int cnt = 0;
			int cdNew = 0;
			int cdRpl = 0;
			int cdCnl = 0;
			int cdEqt = 0;
			int cdCon = 0;
			int cdRrt = 0;
			int cdTim = 0;
			int cdRin = 0;
			int cdAdm = 0;
			int cdFlt = 0;
			int cdOth = 0;
			
			//հ
			int ttl_flt = 0;
			int ttl_asm = 0;
			int ttlNew = 0;
			int ttlRpl = 0;
			int ttlCnl = 0;
			int ttlEqt = 0;
			int ttlCon = 0;
			int ttlRrt = 0;
			int ttlTim = 0;
			int ttlRin = 0;
			int ttlAdm = 0;
			int ttlFlt = 0;
			int ttlOth = 0;	
			
			String cd01 = "NEW"; 
			String cd02 = "RPL"; 
			String cd03 = "CNL"; 
			String cd04 = "EQT"; 
			String cd05 = "CON"; 
			String cd06 = "RRT"; 
			String cd07 = "TIM"; 
			String cd08 = "RIN"; 
			String cd09 = "ADM";
			String cd10 = "FLT"; 
			
			while (rs.next()) {
				StaQ410BG entity = new StaQ410BG();
				
				String adhoc = StringUtil.checkString(rs.getString("Adhoc"));
				String actnid = StringUtil.checkString(rs.getString("Actnid"));
				String chgreas = StringUtil.checkString(rs.getString("Chgreas"));
				int total = Integer.parseInt(StringUtil.checkString(rs.getString("Total")));
				ttl_flt = ttl_flt + total;
				
				if(adhoc.equals("Y")){
					ttl_asm = ttl_asm + total;
					if(chgreas.equals(preChgreas) || cnt == 0){
						if(cd01.indexOf(actnid)!=-1){ cdNew = cdNew + total;			ttlNew = ttlNew + total;	}
						else if(cd02.indexOf(actnid)!=-1){ cdRpl = cdRpl + total;		ttlRpl = ttlRpl + total;	}
						else if(cd03.indexOf(actnid)!=-1){ cdCnl = cdCnl + total;	ttlCnl = ttlCnl + total;	}
						else if(cd04.indexOf(actnid)!=-1){ cdEqt = cdEqt + total;		ttlEqt = ttlEqt + total;	}
						else if(cd05.indexOf(actnid)!=-1){ cdCon = cdCon + total;	ttlCon = ttlCon + total;	}
						else if(cd06.indexOf(actnid)!=-1){ cdRrt = cdRrt + total;		ttlRrt = ttlRrt + total; 		}  
						else if(cd07.indexOf(actnid)!=-1){ cdTim = cdTim + total;	ttlTim = ttlTim + total;	}
						else if(cd08.indexOf(actnid)!=-1){ cdRin = cdRin + total;		ttlRin = ttlRin + total;	}
						else if(cd09.indexOf(actnid)!=-1){ cdAdm = cdAdm + total;	ttlAdm = ttlAdm + total;	}
						else if(cd10.indexOf(actnid)!=-1){ cdFlt = cdFlt + total;	 	ttlFlt = ttlFlt + total;		}
						else{ cdOth = cdOth + total;											ttlOth = ttlOth + total;	}
						 cnt++;
					}
					else{
						entity.setTtl_flt(preChgreas);
						entity.setTtl_asm(preChgreas);
						entity.setCd_new(StringUtil.NumberFormatS(1,String.valueOf(cdNew)));
						entity.setCd_rpl(StringUtil.NumberFormatS(1,String.valueOf(cdRpl)));
						entity.setCd_cnl(StringUtil.NumberFormatS(1,String.valueOf(cdCnl)));
						entity.setCd_eqt(StringUtil.NumberFormatS(1,String.valueOf(cdEqt)));
						entity.setCd_con(StringUtil.NumberFormatS(1,String.valueOf(cdCon)));
						entity.setCd_rrt(StringUtil.NumberFormatS(1,String.valueOf(cdRrt)));
						entity.setCd_tim(StringUtil.NumberFormatS(1,String.valueOf(cdTim)));
						entity.setCd_rin(StringUtil.NumberFormatS(1,String.valueOf(cdRin)));
						entity.setCd_adm(StringUtil.NumberFormatS(1,String.valueOf(cdAdm)));
						entity.setCd_flt(StringUtil.NumberFormatS(1,String.valueOf(cdFlt)));
						entity.setCd_oth(StringUtil.NumberFormatS(1,String.valueOf(cdOth)));
								
						listData.add(entity);
								
						cdNew = 0;
						cdRpl = 0;
						cdCnl = 0;
						cdEqt = 0;
						cdCon = 0;
						cdRrt = 0;
						cdTim = 0;
						cdRin = 0;
						cdAdm = 0;
						cdFlt = 0;
						cdOth = 0;
					
						if(cd01.indexOf(actnid)!=-1){ cdNew = cdNew + total;			ttlNew = ttlNew + total;	}
						else if(cd02.indexOf(actnid)!=-1){ cdRpl = cdRpl + total;		ttlRpl = ttlRpl + total;	}
						else if(cd03.indexOf(actnid)!=-1){ cdCnl = cdCnl + total;	ttlCnl = ttlCnl + total;	}
						else if(cd04.indexOf(actnid)!=-1){ cdEqt = cdEqt + total;		ttlEqt = ttlEqt + total;	}
						else if(cd05.indexOf(actnid)!=-1){ cdCon = cdCon + total;	ttlCon = ttlCon + total;	}
						else if(cd06.indexOf(actnid)!=-1){ cdRrt = cdRrt + total;		ttlRrt = ttlRrt + total; 		}  
						else if(cd07.indexOf(actnid)!=-1){ cdTim = cdTim + total;	ttlTim = ttlTim + total;	}
						else if(cd08.indexOf(actnid)!=-1){ cdRin = cdRin + total;		ttlRin = ttlRin + total;	}
						else if(cd09.indexOf(actnid)!=-1){ cdAdm = cdAdm + total;	ttlAdm = ttlAdm + total;	}
						else if(cd10.indexOf(actnid)!=-1){ cdFlt = cdFlt + total;	 	ttlFlt = ttlFlt + total;		}
						else{ cdOth = cdOth + total;											ttlOth = ttlOth + total;	}
					}
					preChgreas = chgreas;
				}//Adhoc 'Y'϶
			}
			if(!preChgreas.equals(""))
			{
				StaQ410BG entity = new StaQ410BG();
					
				entity.setTtl_flt(preChgreas);
				entity.setTtl_asm(preChgreas);
				entity.setCd_new(StringUtil.NumberFormatS(1,String.valueOf(cdNew)));
				entity.setCd_rpl(StringUtil.NumberFormatS(1,String.valueOf(cdRpl)));
				entity.setCd_cnl(StringUtil.NumberFormatS(1,String.valueOf(cdCnl)));
				entity.setCd_eqt(StringUtil.NumberFormatS(1,String.valueOf(cdEqt)));
				entity.setCd_con(StringUtil.NumberFormatS(1,String.valueOf(cdCon)));
				entity.setCd_rrt(StringUtil.NumberFormatS(1,String.valueOf(cdRrt)));
				entity.setCd_tim(StringUtil.NumberFormatS(1,String.valueOf(cdTim)));
				entity.setCd_rin(StringUtil.NumberFormatS(1,String.valueOf(cdRin)));
				entity.setCd_adm(StringUtil.NumberFormatS(1,String.valueOf(cdAdm)));
				entity.setCd_flt(StringUtil.NumberFormatS(1,String.valueOf(cdFlt)));
				entity.setCd_oth(StringUtil.NumberFormatS(1,String.valueOf(cdOth)));
						
				listData.add(entity);
			}
			//ۼƮ
			if(ttl_asm != 0){
				StaQ410BG entity = new StaQ410BG();
				
				DecimalFormat df = new DecimalFormat("#,###.#");	
				entity.setTtl_flt("");
				entity.setTtl_asm(df.format(((double)ttl_asm/(double)ttl_flt) * 100));
				entity.setCd_new(df.format(((double)ttlNew/(double)ttl_asm) * 100));
				entity.setCd_rpl(df.format(((double)ttlRpl/(double)ttl_asm) * 100));
				entity.setCd_cnl(df.format(((double)ttlCnl/(double)ttl_asm) * 100));
				entity.setCd_eqt(df.format(((double)ttlEqt/(double)ttl_asm) * 100));
				entity.setCd_con(df.format(((double)ttlCon/(double)ttl_asm) * 100));
				entity.setCd_rrt(df.format(((double)ttlRrt/(double)ttl_asm) * 100));
				entity.setCd_tim(df.format(((double)ttlTim/(double)ttl_asm) * 100));
				entity.setCd_rin(df.format(((double)ttlRin/(double)ttl_asm) * 100));
				entity.setCd_adm(df.format(((double)ttlAdm/(double)ttl_asm) * 100));
				entity.setCd_flt(df.format(((double)ttlFlt/(double)ttl_asm) * 100));
				entity.setCd_oth(df.format(((double)ttlOth/(double)ttl_asm) * 100));
						
				listData.add(entity);
			}
			// հ
			if(ttl_asm != 0){
				StaQ410BG entity = new StaQ410BG();
					
				entity.setTtl_flt(StringUtil.NumberFormatS(1,String.valueOf(ttl_flt)));
				entity.setTtl_asm(StringUtil.NumberFormatS(1,String.valueOf(ttl_asm)));
				entity.setCd_new(StringUtil.NumberFormatS(1,String.valueOf(ttlNew)));
				entity.setCd_rpl(StringUtil.NumberFormatS(1,String.valueOf(ttlRpl)));
				entity.setCd_cnl(StringUtil.NumberFormatS(1,String.valueOf(ttlCnl)));
				entity.setCd_eqt(StringUtil.NumberFormatS(1,String.valueOf(ttlEqt)));
				entity.setCd_con(StringUtil.NumberFormatS(1,String.valueOf(ttlCon)));
				entity.setCd_rrt(StringUtil.NumberFormatS(1,String.valueOf(ttlRrt)));
				entity.setCd_tim(StringUtil.NumberFormatS(1,String.valueOf(ttlTim)));
				entity.setCd_rin(StringUtil.NumberFormatS(1,String.valueOf(ttlRin)));
				entity.setCd_adm(StringUtil.NumberFormatS(1,String.valueOf(ttlAdm)));
				entity.setCd_flt(StringUtil.NumberFormatS(1,String.valueOf(ttlFlt)));
				entity.setCd_oth(StringUtil.NumberFormatS(1,String.valueOf(ttlOth)));
						
				listData.add(entity);
			}
			hashData.put("ASMINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ410Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaQ410Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	/** 
	  * OLAP  Ʈ Ʈ ȸ Լ.
	  * @param entity StaA510BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2007/12/18 
	  */
	public Hashtable selStaA510Main(StaA510BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
	   
		try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//FC_REPORT_T ȸ
			stmt = conn.createStatement();
			sql = StaA510Query.getInstance().selRptList(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				StaA510BG entity = new StaA510BG();
				
				entity.setRptNo(StringUtil.checkString(rs.getString("RPT_NO")));
				entity.setRptName(StringUtil.checkString(rs.getString("RPT_NAME")));
				entity.setRptLoc(StringUtil.checkString(rs.getString("RPT_LOC")));
						
				listData.add(entity);
			}
			
			hashData.put("OLAPRPTLIST",listData);
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaA510Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:selStaA510Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * OLAP  Ʈ Ʈ  Լ.
	  * @param entity StaA510BG 
	  * @return boolean returnFlg
	  * @author Copyright (c) 2007/12/20 
	  */
	public boolean updStaA510Main(StaA510BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		boolean returnFlg = false;
	   
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			if (params.getRptNo().equals("")) {
				
				//FC_REPORT_T ȸ
				stmt = conn.createStatement();
				sql = StaA510Query.getInstance().selRptNo(params);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					if (rs.getInt("RPTNO") < 200) { //100~199 ̿ RPT_NO  .
						params.setRptNo(StringUtil.checkString(rs.getString("RPTNO")));
					} else {
						throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
					}
				} else {
					throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
				} 
				
				//FC_REPORT_T Է
				stmt = conn.createStatement();			
				sql = StaA510Query.getInstance().insRptList(params);
				int insCnt = stmt.executeUpdate(sql);
				
				if (insCnt != 1) throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
				else returnFlg = true;				
			
			} else {
				//FC_REPORT_T 
				stmt = conn.createStatement();			
				sql = StaA510Query.getInstance().updRptList(params);
				int updCnt = stmt.executeUpdate(sql);
				
				if (updCnt != 1) throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
				else returnFlg = true;			
			}
			
			//Connection Commit
			conn.commit();
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:updStaA510Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			Logger.debug.println("[BASE:StaAllSLBean:updStaA510Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:updStaA510Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
		}
		return returnFlg;
	}//end of function
	
	/** 
	  * OLAP  Ʈ Ʈ  Լ.
	  * @param entity StaA510BG 
	  * @return boolean returnFlg
	  * @author Copyright (c) 2007/12/20 
	  */
	public boolean delStaA510Main(StaA510BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		boolean returnFlg = false;
	   
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//FC_REPORT_T 
			stmt = conn.createStatement();			
			sql = StaA510Query.getInstance().delRptList(params);
			int delCnt = stmt.executeUpdate(sql);
			
			if (delCnt != 1) throw new BusinessException(MessageCode.getInstance().DELETE_EXPT);
			else returnFlg = true;
			
			//Connection Commit
			conn.commit();
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:StaAllSLBean:delStaA510Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			Logger.debug.println("[BASE:StaAllSLBean:delStaA510Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:StaAllSLBean:delStaA510Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().DELETE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
		}
		return returnFlg;
	}//end of function
	
	/** 
	  * Legs Summary(LEG) ȸ Լ.
	  * @param entity StaQ130BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2010/01/18 
	  */
	public Hashtable selStaQ130Main(StaQ130BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
	   
		try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//LEG SUMMARY ȸ
			stmt = conn.createStatement();
			sql = StaQ130Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			String cgoKactyp = "ABF,M1F,7FQ,7FR,74Y,7FG,79S,7GG,ABH,74F,74N,77X"; //2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N, 77X
			
			String prevFirstLeg = "";
			String prevFltNum = "";
			String prevKactyp = "";
			String prevSvc = "";
			
			boolean selFlag = false;
			boolean cnlFlag = false;
			boolean oprnFlag = false;
			boolean dlaFlag = false;
			
			//0 : skd reg, 1 : cnl reg, 2 : oprn reg, 3 : dla reg, 4 : skd ext, 5 : cnl ext, 6 : oprn ext, 7 : dla ext
			int sel_dom_pax[] = {0,0,0,0,0,0,0,0};
			int sel_dom_cgo[] = {0,0,0,0,0,0,0,0};
			int sel_int_pax[] = {0,0,0,0,0,0,0,0};
			int sel_int_cgo[] = {0,0,0,0,0,0,0,0};
			int all_dom_pax[] = {0,0,0,0,0,0,0,0};
			int all_dom_cgo[] = {0,0,0,0,0,0,0,0};
			int all_int_pax[] = {0,0,0,0,0,0,0,0};
			int all_int_cgo[] = {0,0,0,0,0,0,0,0};
			
			while (rs.next()) {
				StaQ130BG entity = new StaQ130BG();
				
				String tmpFirstLeg = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
				String tmpFltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				String tmpStnfr = StringUtil.checkString(rs.getString("STNFR"));
				String tmpStnto = StringUtil.checkString(rs.getString("STNTO"));
				String tmpKactyp = StringUtil.checkString(rs.getString("KACTYP"));
				String tmpDepSts = StringUtil.checkString(rs.getString("DEP_STS"));
				String tmpSvc = StringUtil.checkString(rs.getString("SVC"));
				String tmpActnid = StringUtil.checkString(rs.getString("ACTNID"));
				int tmpDelMm = rs.getInt("DEL_MM");
				
				if (!prevFirstLeg.equals("") && !prevFltNum.equals("")) {
					if (!prevFirstLeg.equals(tmpFirstLeg) || !prevFltNum.equals(tmpFltNum)) {
						
						String dom_int = "";
						String pax_cgo = "";
						String reg_ext = "";
						if ((prevFltNum.substring(0,1)).equals("1")) dom_int = "dom";
						else dom_int = "int";
						if (cgoKactyp.indexOf(prevKactyp) == -1) pax_cgo = "pax";
						else pax_cgo = "cgo";
						if (prevSvc.equals("F") || prevSvc.equals("J")) reg_ext = "reg";
						else reg_ext = "ext";
						
						//شϴ 쿡 1 Ų.
						if (dom_int.equals("dom")) {
							if (pax_cgo.equals("pax")) {
								if (reg_ext.equals("reg")) {
									//dom_pax_reg
									if (selFlag) sel_dom_pax[0]++;
									all_dom_pax[0]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_pax[1]++;
										all_dom_pax[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_pax[2]++;
										all_dom_pax[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_pax[3]++;
										all_dom_pax[3]++;
									}
								} else {//ext
									//dom_pax_ext
									if (selFlag) sel_dom_pax[4]++;
									all_dom_pax[4]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_pax[5]++;
										all_dom_pax[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_pax[6]++;
										all_dom_pax[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_pax[7]++;
										all_dom_pax[7]++;
									}
								}
							} else {//cgo
								if (reg_ext.equals("reg")) {
									//dom_cgo_reg
									if (selFlag) sel_dom_cgo[0]++;
									all_dom_cgo[0]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_cgo[1]++;
										all_dom_cgo[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_cgo[2]++;
										all_dom_cgo[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_cgo[3]++;
										all_dom_cgo[3]++;
									}
								} else {//ext
									//dom_cgo_ext
									if (selFlag) sel_dom_cgo[4]++;
									all_dom_cgo[4]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_cgo[5]++;
										all_dom_cgo[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_cgo[6]++;
										all_dom_cgo[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_cgo[7]++;
										all_dom_cgo[7]++;
									}
								}
							}
						} else {//int
							if (pax_cgo.equals("pax")) {
								if (reg_ext.equals("reg")) {
									//int_pax_reg
									if (selFlag) sel_int_pax[0]++;
									all_int_pax[0]++;
									if (cnlFlag) {
										if (selFlag) sel_int_pax[1]++;
										all_int_pax[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_pax[2]++;
										all_int_pax[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_pax[3]++;
										all_int_pax[3]++;
									}
								} else {//ext
									//int_pax_ext
									if (selFlag) sel_int_pax[4]++;
									all_int_pax[4]++;
									if (cnlFlag) {
										if (selFlag) sel_int_pax[5]++;
										all_int_pax[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_pax[6]++;
										all_int_pax[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_pax[7]++;
										all_int_pax[7]++;
									}
								}
							} else {//cgo
								if (reg_ext.equals("reg")) {
									//int_cgo_reg
									if (selFlag) sel_int_cgo[0]++;
									all_int_cgo[0]++;
									if (cnlFlag) {
										if (selFlag) sel_int_cgo[1]++;
										all_int_cgo[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_cgo[2]++;
										all_int_cgo[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_cgo[3]++;
										all_int_cgo[3]++;
									}
								} else {//ext
									//int_cgo_ext
									if (selFlag) sel_int_cgo[4]++;
									all_int_cgo[4]++;
									if (cnlFlag) {
										if (selFlag) sel_int_cgo[5]++;
										all_int_cgo[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_cgo[6]++;
										all_int_cgo[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_cgo[7]++;
										all_int_cgo[7]++;
									}
								}
							}
						}
						
						//ʱȭ
						selFlag = false;
						cnlFlag = false;
						oprnFlag = false;
						dlaFlag = false;
					}
				}
				
				if (StringUtil.checkString(params.getSts()).equals("ALL") || StringUtil.checkString(params.getSts()).equals("DEP")) {
					//߰ ICN Ǵ GMP̸ SEL+1
					if (tmpStnfr.equals("ICN") || tmpStnfr.equals("GMP")) {
						selFlag = true;
					}
				}
				if (StringUtil.checkString(params.getSts()).equals("ALL") || StringUtil.checkString(params.getSts()).equals("ARR")) {
					// ICN Ǵ GMP̸ SEL+1
					if (tmpStnto.equals("ICN") || tmpStnto.equals("GMP")) {
						selFlag = true;
					}
				}
				if (tmpActnid.equals("CNL")) {
					cnlFlag = true;
				}
				if (tmpDepSts.equals("ACT")) {
					oprnFlag = true;
					if (tmpDelMm >= 3) { //delay  operation   üũ.
						dlaFlag = true;
					}
				}
				
				prevFirstLeg = tmpFirstLeg;
				prevFltNum = tmpFltNum;
				prevKactyp = tmpKactyp;
				prevSvc = tmpSvc;
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (!prevFirstLeg.equals("") && !prevFltNum.equals("")) {
				
				String dom_int = "";
				String pax_cgo = "";
				String reg_ext = "";
				if ((prevFltNum.substring(0,1)).equals("1")) dom_int = "dom";
				else dom_int = "int";
				if (cgoKactyp.indexOf(prevKactyp) == -1) pax_cgo = "pax";
				else pax_cgo = "cgo";
				if (prevSvc.equals("F") || prevSvc.equals("J")) reg_ext = "reg";
				else reg_ext = "ext";
				
				if (dom_int.equals("dom")) {
					if (pax_cgo.equals("pax")) {
						if (reg_ext.equals("reg")) {
							//dom_pax_reg
							if (selFlag) sel_dom_pax[0]++;
							all_dom_pax[0]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_pax[1]++;
								all_dom_pax[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_pax[2]++;
								all_dom_pax[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_pax[3]++;
								all_dom_pax[3]++;
							}
						} else {//ext
							//dom_pax_ext
							if (selFlag) sel_dom_pax[4]++;
							all_dom_pax[4]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_pax[5]++;
								all_dom_pax[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_pax[6]++;
								all_dom_pax[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_pax[7]++;
								all_dom_pax[7]++;
							}
						}
					} else {//cgo
						if (reg_ext.equals("reg")) {
							//dom_cgo_reg
							if (selFlag) sel_dom_cgo[0]++;
							all_dom_cgo[0]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_cgo[1]++;
								all_dom_cgo[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_cgo[2]++;
								all_dom_cgo[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_cgo[3]++;
								all_dom_cgo[3]++;
							}
						} else {//ext
							//dom_cgo_ext
							if (selFlag) sel_dom_cgo[4]++;
							all_dom_cgo[4]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_cgo[5]++;
								all_dom_cgo[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_cgo[6]++;
								all_dom_cgo[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_cgo[7]++;
								all_dom_cgo[7]++;
							}
						}
					}
				} else {//int
					if (pax_cgo.equals("pax")) {
						if (reg_ext.equals("reg")) {
							//int_pax_reg
							if (selFlag) sel_int_pax[0]++;
							all_int_pax[0]++;
							if (cnlFlag) {
								if (selFlag) sel_int_pax[1]++;
								all_int_pax[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_pax[2]++;
								all_int_pax[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_pax[3]++;
								all_int_pax[3]++;
							}
						} else {//ext
							//int_pax_ext
							if (selFlag) sel_int_pax[4]++;
							all_int_pax[4]++;
							if (cnlFlag) {
								if (selFlag) sel_int_pax[5]++;
								all_int_pax[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_pax[6]++;
								all_int_pax[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_pax[7]++;
								all_int_pax[7]++;
							}
						}
					} else {//cgo
						if (reg_ext.equals("reg")) {
							//int_cgo_reg
							if (selFlag) sel_int_cgo[0]++;
							all_int_cgo[0]++;
							if (cnlFlag) {
								if (selFlag) sel_int_cgo[1]++;
								all_int_cgo[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_cgo[2]++;
								all_int_cgo[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_cgo[3]++;
								all_int_cgo[3]++;
							}
						} else {//ext
							//int_cgo_ext
							if (selFlag) sel_int_cgo[4]++;
							all_int_cgo[4]++;
							if (cnlFlag) {
								if (selFlag) sel_int_cgo[5]++;
								all_int_cgo[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_cgo[6]++;
								all_int_cgo[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_cgo[7]++;
								all_int_cgo[7]++;
							}
						}
					}
				}
			}
			
			StaQ130BG entity = new StaQ130BG();
						
			int sel_total[] = {0,0,0,0,0,0,0,0};
			int all_total[] = {0,0,0,0,0,0,0,0};
			
			for (int i=0; i<8; i++) {
				sel_total[i] = sel_dom_pax[i] + sel_dom_cgo[i] + sel_int_pax[i] + sel_int_cgo[i];
				all_total[i] = all_dom_pax[i] + all_dom_cgo[i] + all_int_pax[i] + all_int_cgo[i];
			}
			
			//on-time(%)
			double[] ont = new double[20];
			if (sel_dom_pax[2] != 0) ont[0] = (((double)sel_dom_pax[2] - (double)sel_dom_pax[3]) / (double)sel_dom_pax[2]) * 100;
			if (sel_dom_pax[6] != 0) ont[1] = (((double)sel_dom_pax[6] - (double)sel_dom_pax[7]) / (double)sel_dom_pax[6]) * 100;
			if (sel_dom_cgo[2] != 0) ont[2] = (((double)sel_dom_cgo[2] - (double)sel_dom_cgo[3]) / (double)sel_dom_cgo[2]) * 100;
			if (sel_dom_cgo[6] != 0) ont[3] = (((double)sel_dom_cgo[6] - (double)sel_dom_cgo[7]) / (double)sel_dom_cgo[6]) * 100;
			if (sel_int_pax[2] != 0) ont[4] = (((double)sel_int_pax[2] - (double)sel_int_pax[3]) / (double)sel_int_pax[2]) * 100;
			if (sel_int_pax[6] != 0) ont[5] = (((double)sel_int_pax[6] - (double)sel_int_pax[7]) / (double)sel_int_pax[6]) * 100;
			if (sel_int_cgo[2] != 0) ont[6] = (((double)sel_int_cgo[2] - (double)sel_int_cgo[3]) / (double)sel_int_cgo[2]) * 100;
			if (sel_int_cgo[6] != 0) ont[7] = (((double)sel_int_cgo[6] - (double)sel_int_cgo[7]) / (double)sel_int_cgo[6]) * 100;
			if (sel_total[2] != 0) ont[8] = (((double)sel_total[2] - (double)sel_total[3]) / (double)sel_total[2]) * 100;
			if (sel_total[6] != 0) ont[9] = (((double)sel_total[6] - (double)sel_total[7]) / (double)sel_total[6]) * 100;
			if (all_dom_pax[2] != 0) ont[10] = (((double)all_dom_pax[2] - (double)all_dom_pax[3]) / (double)all_dom_pax[2]) * 100;
			if (all_dom_pax[6] != 0) ont[11] = (((double)all_dom_pax[6] - (double)all_dom_pax[7]) / (double)all_dom_pax[6]) * 100;
			if (all_dom_cgo[2] != 0) ont[12] = (((double)all_dom_cgo[2] - (double)all_dom_cgo[3]) / (double)all_dom_cgo[2]) * 100;
			if (all_dom_cgo[6] != 0) ont[13] = (((double)all_dom_cgo[6] - (double)all_dom_cgo[7]) / (double)all_dom_cgo[6]) * 100;
			if (all_int_pax[2] != 0) ont[14] = (((double)all_int_pax[2] - (double)all_int_pax[3]) / (double)all_int_pax[2]) * 100;
			if (all_int_pax[6] != 0) ont[15] = (((double)all_int_pax[6] - (double)all_int_pax[7]) / (double)all_int_pax[6]) * 100;
			if (all_int_cgo[2] != 0) ont[16] = (((double)all_int_cgo[2] - (double)all_int_cgo[3]) / (double)all_int_cgo[2]) * 100;
			if (all_int_cgo[6] != 0) ont[17] = (((double)all_int_cgo[6] - (double)all_int_cgo[7]) / (double)all_int_cgo[6]) * 100;
			if (all_total[2] != 0) ont[18] = (((double)all_total[2] - (double)all_total[3]) / (double)all_total[2]) * 100;
			if (all_total[6] != 0) ont[19] = (((double)all_total[6] - (double)all_total[7]) / (double)all_total[6]) * 100;
			
			String[] ont_arr = new String[20];
			DecimalFormat df = new DecimalFormat("###.#");
			for (int i=0; i<20; i++) {
				ont_arr[i] = df.format(ont[i]);
			}
			
			//--------------------------------------------------------------------------------------------
			entity.setSel_dom_pax(sel_dom_pax);
			entity.setSel_dom_cgo(sel_dom_cgo);
			entity.setSel_int_pax(sel_int_pax);
			entity.setSel_int_cgo(sel_int_cgo);
			entity.setAll_dom_pax(all_dom_pax);
			entity.setAll_dom_cgo(all_dom_cgo);
			entity.setAll_int_pax(all_int_pax);
			entity.setAll_int_cgo(all_int_cgo);
			
			entity.setSel_total(sel_total);
			entity.setAll_total(all_total);
			
			entity.setOnt(ont_arr);
			
			hashData.put("LEG_SUMMARY",entity);
			
		} catch(SQLException se) {
			System.out.println("[BASE:StaAllSLBean:selStaQ130Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			System.out.println("[BASE:StaAllSLBean:selStaQ130Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * Operation Status(A/C REG)  ȸ Լ.
	  * @param entity StaQ610BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2010/01/19 
	  */
	public Hashtable selStaQ610Main(StaQ610BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
	   
		try {
			String reg = "";
			if (!params.getReg_1().equals("")) reg = "'HL" + params.getReg_1() + "'";
			if (!params.getReg_2().equals("")) {
				if (reg.equals("")) reg = "'HL" + params.getReg_2() + "'";
				else reg = reg + ",'HL" + params.getReg_2() + "'";
			}
			if (!params.getReg_3().equals("")) {
				if (reg.equals("")) reg = "'HL" + params.getReg_3() + "'";
				else reg = reg + ",'HL" + params.getReg_3() + "'";
			}
			if (!params.getReg_4().equals("")) {
				if (reg.equals("")) reg = "'HL" + params.getReg_4() + "'";
				else reg = reg + ",'HL" + params.getReg_4() + "'";
			}
			
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Operation Status ȸ
			stmt = conn.createStatement();
			sql = StaQ610Query.getInstance().selMain(params, reg);
			rs = stmt.executeQuery(sql);
			
			int totalBlhr = 0;
			int totalAbhr = 0;
			int totalCycle = 0;
			
			String prevSchDate = "";
			String prevReg = "";
			
			while (rs.next()) {
				StaQ610BG entity = new StaQ610BG();
				
				if (StringUtil.checkString(rs.getString("SCH_DT")).equals(prevSchDate)) {
					entity.setSch_date("");
					if (StringUtil.checkString(rs.getString("REGNO")).equals(prevReg)) entity.setReg("");
					else entity.setReg(StringUtil.checkString(rs.getString("REGNO")));
				} else {
					entity.setSch_date(StringUtil.checkString(rs.getString("SCH_DT")));
					entity.setReg(StringUtil.checkString(rs.getString("REGNO")));
				}
								
				prevSchDate = StringUtil.checkString(rs.getString("SCH_DT"));
				prevReg = StringUtil.checkString(rs.getString("REGNO"));
				
				entity.setFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setLeg(StringUtil.checkString(rs.getString("LEG_NUM")));
				entity.setDep(StringUtil.checkString(rs.getString("STNFR")));
				entity.setArr(StringUtil.checkString(rs.getString("STNTO")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setSta(StringUtil.checkString(rs.getString("STA")));
				
				String atd = "";
				String toff = "";
				String tdwn = "";
				String ata = "";
				String blhr = "";
				String abhr = "";
				String taxi_out = "";
				String taxi_in = "";
				String dep_t = "";
				String arr_t = "";
				String dla_1 = "";
				String dla_2 = "";
				
				if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT")) {
					//ATD
					atd = StringUtil.checkString(rs.getString("ATD"));
					//DEP_T
					dep_t = StringUtil.checkString(rs.getString("DEP_T"));
					//DLA1
					if (!StringUtil.checkString(rs.getString("DEL_RC1")).equals("")) {
						dla_1 = StringUtil.checkString(rs.getString("DEL_RC1")) + "/" + StringUtil.checkString(rs.getString("DEL_DUR1"));
					}
					//DLA2
					if (!StringUtil.checkString(rs.getString("DEL_RC2")).equals("")) {
						dla_2 = StringUtil.checkString(rs.getString("DEL_RC2")) + "/" + StringUtil.checkString(rs.getString("DEL_DUR2"));
					}
					
					String tkofT = StringUtil.checkString(rs.getString("TKOF_T")).trim();
					String tmpTkofT = "";
					
					if (tkofT.length() == 4) {
						
						if (Integer.parseInt(StringUtil.checkString(rs.getString("ATD_DT")).substring(8,12)) < Integer.parseInt(tkofT)) {
							tmpTkofT = StringUtil.checkString(rs.getString("ATD_DT")).substring(0,8) + tkofT; // 
						} else {
							tmpTkofT = StringUtil.checkString(rs.getString("ATD_NEXT")) + tkofT; //Ϸ 
						}
						
						//TAXI-OUT
						taxi_out = String.valueOf(StringUtil.minsBetween(StringUtil.checkString(rs.getString("ATD_DT")), tmpTkofT)).toString();
						
						//TOFF
						if (params.getTm().equals("UTC")) {
							toff = tkofT.substring(0,2) + ":" + tkofT.substring(2,4);
						} else { //LOC
							toff = StringUtil.addMins(tkofT.substring(0,2) + ":" + tkofT.substring(2,4), rs.getInt("DEP_GMT_OFFSET"), "HH:mm");
						}
						
						//DEP_STS='ACT' ΰ ߿ ARV_STS='ACT' 
						if (StringUtil.checkString(rs.getString("ARV_STS")).equals("ACT")) {
							
							String landT = StringUtil.checkString(rs.getString("LAND_T")).trim();
							String tmpLandT = "";
							
							if (landT.length() == 4) {
								
								if (Integer.parseInt(StringUtil.checkString(rs.getString("ATA_DT")).substring(8,12)) > Integer.parseInt(landT)) {
									tmpLandT = StringUtil.checkString(rs.getString("ATA_DT")).substring(0,8) + landT; // 
								} else {
									tmpLandT = StringUtil.checkString(rs.getString("ATA_PREV")) + landT; //Ϸ 
								}
								
								//TAXI-IN
								taxi_in = String.valueOf(StringUtil.minsBetween(tmpLandT, StringUtil.checkString(rs.getString("ATA_DT")))).toString();
								
								//TDWN
								if (params.getTm().equals("UTC")) {
									tdwn = landT.substring(0,2) + ":" + landT.substring(2,4);
								} else { //LOC
									tdwn = StringUtil.addMins(landT.substring(0,2) + ":" + landT.substring(2,4), rs.getInt("ARV_GMT_OFFSET"), "HH:mm");
								}
								//ATA
								ata = StringUtil.checkString(rs.getString("ATA"));
								//BLHR
								blhr = StringUtil.minTohm(rs.getInt("BLHR"));
								totalBlhr = totalBlhr + rs.getInt("BLHR");
								//ARR_T
								arr_t = StringUtil.checkString(rs.getString("ARR_T"));
								//ABHR
								abhr = StringUtil.minTohm(StringUtil.minsBetween(tmpTkofT, tmpLandT));
								totalAbhr = totalAbhr + StringUtil.minsBetween(tmpTkofT, tmpLandT);
								totalCycle = totalCycle + 1;
							}
						}
					}
				}
				
				entity.setAtd(atd);
				entity.setToff(toff);
				entity.setTdwn(tdwn);
				entity.setAta(ata);
				entity.setBlhr(blhr);
				entity.setAbhr(abhr);
				entity.setTaxi_out(taxi_out);
				entity.setTaxi_in(taxi_in);
				entity.setDep_t(dep_t);
				entity.setArr_t(arr_t);
				entity.setDla_1(dla_1);
				entity.setDla_2(dla_2);
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("OPERATION_STATUS",listData);
			hashData.put("TOTAL_BLHR",StringUtil.minTohm(totalBlhr));
			hashData.put("TOTAL_ABHR",StringUtil.minTohm(totalAbhr));
			hashData.put("TOTAL_CYCLE",String.valueOf(totalCycle).toString());
			
		} catch(SQLException se) {
			System.out.println("[BASE:StaAllSLBean:selStaQ610Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			System.out.println("[BASE:StaAllSLBean:selStaQ610Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * ASM Status(IRR) AD-HOC MSG CODE ȸ Լ.
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2010/01/20 
	  */
	public Hashtable selStaQ420AdhocMsgCode() throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
	   
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//AD-HOC MSG CODE ȸ
			stmt = conn.createStatement();
			sql = StaQ420Query.getInstance().selCode();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				listData.add(StringUtil.checkString(rs.getString("CODE_C")));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("MSG_CODE",listData);
			
		} catch(SQLException se) {
			System.out.println("[BASE:StaAllSLBean:selStaQ420AdhocMsgCode:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			System.out.println("[BASE:StaAllSLBean:selStaQ420AdhocMsgCode:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * ASM Status(IRR) ȸ Լ.
	  * @param entity StaQ420BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2010/01/20 
	  */
	public Hashtable selStaQ420Main(StaQ420BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
		Statement stmt2 = null;
		ResultSet rs2 = null;
		String sql2 = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
	   
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//ASM Status ȸ
			stmt = conn.createStatement();
			sql = StaQ420Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				StaQ420BG entity = new StaQ420BG();
				
				String firstLegFltDt = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
				String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				String stnfr = StringUtil.checkString(rs.getString("STNFR"));
				String stnto = StringUtil.checkString(rs.getString("STNTO"));
				
				entity.setSch_date(StringUtil.checkString(rs.getString("SCH_DT")));
				entity.setActnid(StringUtil.checkString(rs.getString("ACTNID")));
				entity.setReason(StringUtil.checkString(rs.getString("REASON")));
				entity.setFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
				
				if (StringUtil.checkString(rs.getString("ACTNID")).equals("CNL")) {
					
					//main data => planned  ´. sub ȸ .
					entity.setChg_type("");
					entity.setChg_dep("");
					entity.setChg_std("");
					entity.setChg_arr("");
					entity.setChg_sta("");
					
					entity.setPln_type(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setPln_dep(StringUtil.checkString(rs.getString("STNFR")));
					entity.setPln_std(StringUtil.checkString(rs.getString("STD")));
					entity.setPln_arr(StringUtil.checkString(rs.getString("STNTO")));
					entity.setPln_sta(StringUtil.checkString(rs.getString("STA")));
					
				} else if (StringUtil.checkString(rs.getString("ACTNID")).equals("NEW")) {
					
					//main data => changed  ´. sub ȸ .
					entity.setChg_type(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setChg_dep(StringUtil.checkString(rs.getString("STNFR")));
					entity.setChg_std(StringUtil.checkString(rs.getString("STD")));
					entity.setChg_arr(StringUtil.checkString(rs.getString("STNTO")));
					entity.setChg_sta(StringUtil.checkString(rs.getString("STA")));
					
					entity.setPln_type("");
					entity.setPln_dep("");
					entity.setPln_std("");
					entity.setPln_arr("");
					entity.setPln_sta("");
					
				} else {
					//main data => changed, sub data => planned  ´.
					String plnType = "";
					String plnDep = "";
					String plnStd = "";
					String plnArr = "";
					String plnSta = "";
					
					//Sub ȸ
					stmt2 = conn.createStatement();
					sql2 = StaQ420Query.getInstance().selSub(firstLegFltDt, fltNum, stnfr, stnto);
					rs2 = stmt2.executeQuery(sql2);
					
					if (rs2.next()) { // ó row  ´.
						plnType = StringUtil.checkString(rs2.getString("KACTYP"));
						plnDep = StringUtil.checkString(rs2.getString("STNFR"));
						plnStd = StringUtil.checkString(rs2.getString("STD"));
						plnArr = StringUtil.checkString(rs2.getString("STNTO"));
						plnSta = StringUtil.checkString(rs2.getString("STA"));
					}
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
					
					entity.setChg_type(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setChg_dep(StringUtil.checkString(rs.getString("STNFR")));
					entity.setChg_std(StringUtil.checkString(rs.getString("STD")));
					entity.setChg_arr(StringUtil.checkString(rs.getString("STNTO")));
					entity.setChg_sta(StringUtil.checkString(rs.getString("STA")));
					
					entity.setPln_type(plnType);
					entity.setPln_dep(plnDep);
					entity.setPln_std(plnStd);
					entity.setPln_arr(plnArr);
					entity.setPln_sta(plnSta);
				}
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("ASM_STATUS",listData);
			
		} catch(SQLException se) {
			System.out.println("[BASE:StaAllSLBean:selStaQ420Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			System.out.println("[BASE:StaAllSLBean:selStaQ420Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * Delay Status(IRR)  ȸ Լ.
	  * @param entity StaQ430BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2010/01/21 
	  */
	public Hashtable selStaQ430Main(StaQ430BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
	   
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Delay Status ȸ
			stmt = conn.createStatement();
			sql = StaQ430Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				StaQ430BG entity = new StaQ430BG();
				
				entity.setSch_date(StringUtil.checkString(rs.getString("SCH_DT")));
				entity.setFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setTyp(StringUtil.checkString(rs.getString("KACTYP")));
				entity.setReg(StringUtil.checkString(rs.getString("REGNO")));
				entity.setDep(StringUtil.checkString(rs.getString("STNFR")));
				entity.setArr(StringUtil.checkString(rs.getString("STNTO")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setSta(StringUtil.checkString(rs.getString("STA")));
				
				String atd = "";
				String toff = "";
				String tdwn = "";
				String ata = "";
				String delay_1 = "";
				String delay_2 = "";
				String delay_3 = "";
				String delay_4 = "";
				String taxi_out = "";
				
				if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT")) {
					//ATD
					atd = StringUtil.checkString(rs.getString("ATD"));
					//DELAY_1
					if (!StringUtil.checkString(rs.getString("DEL_RC1")).equals("")) {
						delay_1 = StringUtil.checkString(rs.getString("DEL_RC1")) + "/" + StringUtil.checkString(rs.getString("DEL_DUR1"));
					}
					//DELAY_2
					if (!StringUtil.checkString(rs.getString("DEL_RC2")).equals("")) {
						delay_2 = StringUtil.checkString(rs.getString("DEL_RC2")) + "/" + StringUtil.checkString(rs.getString("DEL_DUR2"));
					}
					//DELAY_3
					if (!StringUtil.checkString(rs.getString("DEL_RC3")).equals("")) {
						delay_3 = StringUtil.checkString(rs.getString("DEL_RC3")) + "/" + StringUtil.checkString(rs.getString("DEL_DUR3"));
					}
					//DELAY_4
					if (!StringUtil.checkString(rs.getString("DEL_RC4")).equals("")) {
						delay_4 = StringUtil.checkString(rs.getString("DEL_RC4")) + "/" + StringUtil.checkString(rs.getString("DEL_DUR4"));
					}
					
					String tkofT = StringUtil.checkString(rs.getString("TKOF_T")).trim();
					String tmpTkofT = "";
					
					if (tkofT.length() == 4) {
						
						if (Integer.parseInt(StringUtil.checkString(rs.getString("ATD_DT")).substring(8,12)) < Integer.parseInt(tkofT)) {
							tmpTkofT = StringUtil.checkString(rs.getString("ATD_DT")).substring(0,8) + tkofT; // 
						} else {
							tmpTkofT = StringUtil.checkString(rs.getString("ATD_NEXT")) + tkofT; //Ϸ 
						}
						
						//TAXI-OUT
						taxi_out = String.valueOf(StringUtil.minsBetween(StringUtil.checkString(rs.getString("ATD_DT")), tmpTkofT)).toString();
						
						//TOFF
						if (params.getTm().equals("UTC")) {
							toff = tkofT.substring(0,2) + ":" + tkofT.substring(2,4);
						} else { //LOC
							toff = StringUtil.addMins(tkofT.substring(0,2) + ":" + tkofT.substring(2,4), rs.getInt("DEP_GMT_OFFSET"), "HH:mm");
						}
						
						//DEP_STS='ACT' ΰ ߿ ARV_STS='ACT' 
						if (StringUtil.checkString(rs.getString("ARV_STS")).equals("ACT")) {
							
							String landT = StringUtil.checkString(rs.getString("LAND_T")).trim();
							
							if (landT.length() == 4) {
								//TDWN
								if (params.getTm().equals("UTC")) {
									tdwn = landT.substring(0,2) + ":" + landT.substring(2,4);
								} else { //LOC
									tdwn = StringUtil.addMins(landT.substring(0,2) + ":" + landT.substring(2,4), rs.getInt("ARV_GMT_OFFSET"), "HH:mm");
								}
								//ATA
								ata = StringUtil.checkString(rs.getString("ATA"));
							}
						}
					}
				}
				
				entity.setAtd(atd);
				entity.setToff(toff);
				entity.setTdwn(tdwn);
				entity.setAta(ata);
				entity.setDelay_1(delay_1);
				entity.setDelay_2(delay_2);
				entity.setDelay_3(delay_3);
				entity.setDelay_4(delay_4);
				entity.setTaxi_out(taxi_out);
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("DELAY_STATUS",listData);
			
		} catch(SQLException se) {
			System.out.println("[BASE:StaAllSLBean:selStaQ430Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			System.out.println("[BASE:StaAllSLBean:selStaQ430Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * Flight Summary ȸ Լ.
	  * @param params StaQ230BG 
	  * @return Hashtable ȸ 
	  * ۼ ¥ : 2010-07-22
	  */
	public Hashtable selStaQ230Main(StaQ230BG params) throws BusinessException{
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
	   
		try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Flight Summary ȸ
			stmt = conn.createStatement();
			sql = StaQ230Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			String prevFirstLeg = "";
			String prevFltNum = "";
			String prevCgoY = "";
			String prevRegularY = "";
			
			boolean selFlag = false;
			boolean cnlFlag = true;
			boolean oprnFlag = false;
			boolean dlaFlag = false;
			
			//0 : skd reg, 1 : cnl reg, 2 : oprn reg, 3 : dla reg, 4 : skd ext, 5 : cnl ext, 6 : oprn ext, 7 : dla ext
			int sel_dom_pax[] = {0,0,0,0,0,0,0,0};
			int sel_dom_cgo[] = {0,0,0,0,0,0,0,0};
			int sel_int_pax[] = {0,0,0,0,0,0,0,0};
			int sel_int_cgo[] = {0,0,0,0,0,0,0,0};
			int all_dom_pax[] = {0,0,0,0,0,0,0,0};
			int all_dom_cgo[] = {0,0,0,0,0,0,0,0};
			int all_int_pax[] = {0,0,0,0,0,0,0,0};
			int all_int_cgo[] = {0,0,0,0,0,0,0,0};
			
			while (rs.next()) {
				StaQ230BG entity = new StaQ230BG();
				
				String tmpFirstLeg = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
				String tmpFltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				String tmpStnfr = StringUtil.checkString(rs.getString("STNFR"));
				String tmpStnto = StringUtil.checkString(rs.getString("STNTO"));
				String tmpActnid = StringUtil.checkString(rs.getString("ACTNID"));
				String tmpDepSts = StringUtil.checkString(rs.getString("DEP_STS"));
				String tmpRegularY = StringUtil.checkString(rs.getString("REGULAR_Y"));
				String tmpCgoY = StringUtil.checkString(rs.getString("CGO_Y"));
				int tmpDelMm = rs.getInt("DEL_MM");
				String svc = StringUtil.checkString(rs.getString("SVC"));
				
				if (!prevFirstLeg.equals("") && !prevFltNum.equals("")) { //ó ƴϸ
					if (!prevFirstLeg.equals(tmpFirstLeg) || !prevFltNum.equals(tmpFltNum)) {
						
						String dom_int = "";
						String pax_cgo = "";
						String reg_ext = "";
						/*
						if ((prevFltNum.substring(0,1)).equals("1") || (prevFltNum.substring(prevFltNum.length()-1)).equals("F")
						|| (prevFltNum.substring(prevFltNum.length()-1)).equals("M")|| (prevFltNum.substring(prevFltNum.length()-1)).equals("T")) dom_int = "dom"; // 1 ϰų Suffix F, M, T  
						else dom_int = "int";
						*/
						//2010.09.05  : DOM -  KE 1xxx FLT (Suffix M,F,T,D  FLT ), INT - DOM FLT  FLT (Suffix M,F,T,D  FLT )
						//Suffix M,F,T,D  FLT  
						if ((prevFltNum.substring(0,1)).equals("1")) dom_int = "dom";
						else dom_int = "int";
						if (prevCgoY.equals("Y")) pax_cgo = "cgo";
						else pax_cgo = "pax";
						if (prevRegularY.equals("Y")) reg_ext = "reg";
						else reg_ext = "ext";
						
						//شϴ 쿡 1 Ų.
						if (dom_int.equals("dom")) {
							if (pax_cgo.equals("pax")) {
								if (reg_ext.equals("reg")) {
									//dom_pax_reg
									if (selFlag) sel_dom_pax[0]++;
									all_dom_pax[0]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_pax[1]++;
										all_dom_pax[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_pax[2]++;
										all_dom_pax[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_pax[3]++;
										all_dom_pax[3]++;
									}
								} else {//ext
									//dom_pax_ext
									if (selFlag) sel_dom_pax[4]++;
									all_dom_pax[4]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_pax[5]++;
										all_dom_pax[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_pax[6]++;
										all_dom_pax[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_pax[7]++;
										all_dom_pax[7]++;
									}
								}
							} else {//cgo
								if (reg_ext.equals("reg")) {
									//dom_cgo_reg
									if (selFlag) sel_dom_cgo[0]++;
									all_dom_cgo[0]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_cgo[1]++;
										all_dom_cgo[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_cgo[2]++;
										all_dom_cgo[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_cgo[3]++;
										all_dom_cgo[3]++;
									}
								} else {//ext
									//dom_cgo_ext
									if (selFlag) sel_dom_cgo[4]++;
									all_dom_cgo[4]++;
									if (cnlFlag) {
										if (selFlag) sel_dom_cgo[5]++;
										all_dom_cgo[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_dom_cgo[6]++;
										all_dom_cgo[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_dom_cgo[7]++;
										all_dom_cgo[7]++;
									}
								}
							}
						} else if (dom_int.equals("int")) {//int
							if (pax_cgo.equals("pax")) {
								if (reg_ext.equals("reg")) {
									//int_pax_reg
									if (selFlag) sel_int_pax[0]++;
									all_int_pax[0]++;
									if (cnlFlag) {
										if (selFlag) sel_int_pax[1]++;
										all_int_pax[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_pax[2]++;
										all_int_pax[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_pax[3]++;
										all_int_pax[3]++;
									}
								} else {//ext
									//int_pax_ext
									if (selFlag) sel_int_pax[4]++;
									all_int_pax[4]++;
									if (cnlFlag) {
										if (selFlag) sel_int_pax[5]++;
										all_int_pax[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_pax[6]++;
										all_int_pax[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_pax[7]++;
										all_int_pax[7]++;
									}
								}
							} else {//cgo
								if (reg_ext.equals("reg")) {
									//int_cgo_reg
									if (selFlag) sel_int_cgo[0]++;
									all_int_cgo[0]++;
									if (cnlFlag) {
										if (selFlag) sel_int_cgo[1]++;
										all_int_cgo[1]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_cgo[2]++;
										all_int_cgo[2]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_cgo[3]++;
										all_int_cgo[3]++;
									}
								} else {//ext
									//int_cgo_ext
									if (selFlag) sel_int_cgo[4]++;
									all_int_cgo[4]++;
									if (cnlFlag) {
										if (selFlag) sel_int_cgo[5]++;
										all_int_cgo[5]++;
									}
									if (oprnFlag) {
										if (selFlag) sel_int_cgo[6]++;
										all_int_cgo[6]++;
									}
									if (dlaFlag) {
										if (selFlag) sel_int_cgo[7]++;
										all_int_cgo[7]++;
									}
								}
							}
						}
						
						//ʱȭ
						selFlag = false;
						cnlFlag = true;
						oprnFlag = false;
						dlaFlag = false;
					}
				}
				
				if (StringUtil.checkString(params.getSts()).equals("ALL") || StringUtil.checkString(params.getSts()).equals("DEP")) {
					//߰ ICN Ǵ GMP̸ SEL+1
					if (tmpStnfr.equals("ICN") || tmpStnfr.equals("GMP")) {
						selFlag = true;
					}
				}
				if (StringUtil.checkString(params.getSts()).equals("ALL") || StringUtil.checkString(params.getSts()).equals("ARR")) {
					// ICN Ǵ GMP̸ SEL+1
					if (tmpStnto.equals("ICN") || tmpStnto.equals("GMP")) {
						selFlag = true;
					}
				}
				if (!tmpActnid.equals("CNL")) {
					cnlFlag = false;
				}
				if (tmpDepSts.equals("ACT")) {
					oprnFlag = true;
					if ((tmpDelMm >= 6 && tmpCgoY.equals("N")) || (tmpDelMm >= 16 && tmpCgoY.equals("Y"))) { //delay  operation   üũ,  6 ̻ / ȭ 16 ̻ ϶ delay
						if(!svc.equals("P")){
						    dlaFlag = true;
						}
					}
				}
				
				prevFirstLeg = tmpFirstLeg;
				prevFltNum = tmpFltNum;
				prevCgoY = tmpCgoY;
				prevRegularY = tmpRegularY;
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (!prevFirstLeg.equals("") && !prevFltNum.equals("")) { //  ó
				
				String dom_int = "";
				String pax_cgo = "";
				String reg_ext = "";
				/*
				if ((prevFltNum.substring(0,1)).equals("1") || (prevFltNum.substring(prevFltNum.length()-1)).equals("F")
				|| (prevFltNum.substring(prevFltNum.length()-1)).equals("M")|| (prevFltNum.substring(prevFltNum.length()-1)).equals("T")) dom_int = "dom";
				else dom_int = "int";
				*/
				//2010.09.05  : DOM -  KE 1xxx FLT (Suffix M,F,T,D  FLT ), INT - DOM FLT  FLT (Suffix M,F,T,D  FLT )
				//Suffix M,F,T,D  FLT  
				if ((prevFltNum.substring(0,1)).equals("1")) dom_int = "dom";
				else dom_int = "int";
				if (prevCgoY.equals("Y")) pax_cgo = "cgo";
				else pax_cgo = "pax";
				if (prevRegularY.equals("Y")) reg_ext = "reg";
				else reg_ext = "ext";
				
				if (dom_int.equals("dom")) {
					if (pax_cgo.equals("pax")) {
						if (reg_ext.equals("reg")) {
							//dom_pax_reg
							if (selFlag) sel_dom_pax[0]++;
							all_dom_pax[0]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_pax[1]++;
								all_dom_pax[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_pax[2]++;
								all_dom_pax[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_pax[3]++;
								all_dom_pax[3]++;
							}
						} else {//ext
							//dom_pax_ext
							if (selFlag) sel_dom_pax[4]++;
							all_dom_pax[4]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_pax[5]++;
								all_dom_pax[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_pax[6]++;
								all_dom_pax[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_pax[7]++;
								all_dom_pax[7]++;
							}
						}
					} else {//cgo
						if (reg_ext.equals("reg")) {
							//dom_cgo_reg
							if (selFlag) sel_dom_cgo[0]++;
							all_dom_cgo[0]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_cgo[1]++;
								all_dom_cgo[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_cgo[2]++;
								all_dom_cgo[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_cgo[3]++;
								all_dom_cgo[3]++;
							}
						} else {//ext
							//dom_cgo_ext
							if (selFlag) sel_dom_cgo[4]++;
							all_dom_cgo[4]++;
							if (cnlFlag) {
								if (selFlag) sel_dom_cgo[5]++;
								all_dom_cgo[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_dom_cgo[6]++;
								all_dom_cgo[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_dom_cgo[7]++;
								all_dom_cgo[7]++;
							}
						}
					}
				} else if (dom_int.equals("int")) {//int
					if (pax_cgo.equals("pax")) {
						if (reg_ext.equals("reg")) {
							//int_pax_reg
							if (selFlag) sel_int_pax[0]++;
							all_int_pax[0]++;
							if (cnlFlag) {
								if (selFlag) sel_int_pax[1]++;
								all_int_pax[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_pax[2]++;
								all_int_pax[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_pax[3]++;
								all_int_pax[3]++;
							}
						} else {//ext
							//int_pax_ext
							if (selFlag) sel_int_pax[4]++;
							all_int_pax[4]++;
							if (cnlFlag) {
								if (selFlag) sel_int_pax[5]++;
								all_int_pax[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_pax[6]++;
								all_int_pax[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_pax[7]++;
								all_int_pax[7]++;
							}
						}
					} else {//cgo
						if (reg_ext.equals("reg")) {
							//int_cgo_reg
							if (selFlag) sel_int_cgo[0]++;
							all_int_cgo[0]++;
							if (cnlFlag) {
								if (selFlag) sel_int_cgo[1]++;
								all_int_cgo[1]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_cgo[2]++;
								all_int_cgo[2]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_cgo[3]++;
								all_int_cgo[3]++;
							}
						} else {//ext
							//int_cgo_ext
							if (selFlag) sel_int_cgo[4]++;
							all_int_cgo[4]++;
							if (cnlFlag) {
								if (selFlag) sel_int_cgo[5]++;
								all_int_cgo[5]++;
							}
							if (oprnFlag) {
								if (selFlag) sel_int_cgo[6]++;
								all_int_cgo[6]++;
							}
							if (dlaFlag) {
								if (selFlag) sel_int_cgo[7]++;
								all_int_cgo[7]++;
							}
						}
					}
				}
			}
			
			StaQ230BG entity = new StaQ230BG();
						
			int sel_total[] = {0,0,0,0,0,0,0,0};
			int all_total[] = {0,0,0,0,0,0,0,0};
			
			for (int i=0; i<8; i++) {
				sel_total[i] = sel_dom_pax[i] + sel_dom_cgo[i] + sel_int_pax[i] + sel_int_cgo[i];
				all_total[i] = all_dom_pax[i] + all_dom_cgo[i] + all_int_pax[i] + all_int_cgo[i];
			}
			
			//on-time(%)
			double[] ont = new double[20];
			if (sel_dom_pax[2] != 0) ont[0] = (((double)sel_dom_pax[2] - (double)sel_dom_pax[3]) / (double)sel_dom_pax[2]) * 100;
			if (sel_dom_pax[6] != 0) ont[1] = (((double)sel_dom_pax[6] - (double)sel_dom_pax[7]) / (double)sel_dom_pax[6]) * 100;
			if (sel_dom_cgo[2] != 0) ont[2] = (((double)sel_dom_cgo[2] - (double)sel_dom_cgo[3]) / (double)sel_dom_cgo[2]) * 100;
			if (sel_dom_cgo[6] != 0) ont[3] = (((double)sel_dom_cgo[6] - (double)sel_dom_cgo[7]) / (double)sel_dom_cgo[6]) * 100;
			if (sel_int_pax[2] != 0) ont[4] = (((double)sel_int_pax[2] - (double)sel_int_pax[3]) / (double)sel_int_pax[2]) * 100;
			if (sel_int_pax[6] != 0) ont[5] = (((double)sel_int_pax[6] - (double)sel_int_pax[7]) / (double)sel_int_pax[6]) * 100;
			if (sel_int_cgo[2] != 0) ont[6] = (((double)sel_int_cgo[2] - (double)sel_int_cgo[3]) / (double)sel_int_cgo[2]) * 100;
			if (sel_int_cgo[6] != 0) ont[7] = (((double)sel_int_cgo[6] - (double)sel_int_cgo[7]) / (double)sel_int_cgo[6]) * 100;
			if (sel_total[2] != 0) ont[8] = (((double)sel_total[2] - (double)sel_total[3]) / (double)sel_total[2]) * 100;
			if (sel_total[6] != 0) ont[9] = (((double)sel_total[6] - (double)sel_total[7]) / (double)sel_total[6]) * 100;
			if (all_dom_pax[2] != 0) ont[10] = (((double)all_dom_pax[2] - (double)all_dom_pax[3]) / (double)all_dom_pax[2]) * 100;
			if (all_dom_pax[6] != 0) ont[11] = (((double)all_dom_pax[6] - (double)all_dom_pax[7]) / (double)all_dom_pax[6]) * 100;
			if (all_dom_cgo[2] != 0) ont[12] = (((double)all_dom_cgo[2] - (double)all_dom_cgo[3]) / (double)all_dom_cgo[2]) * 100;
			if (all_dom_cgo[6] != 0) ont[13] = (((double)all_dom_cgo[6] - (double)all_dom_cgo[7]) / (double)all_dom_cgo[6]) * 100;
			if (all_int_pax[2] != 0) ont[14] = (((double)all_int_pax[2] - (double)all_int_pax[3]) / (double)all_int_pax[2]) * 100;
			if (all_int_pax[6] != 0) ont[15] = (((double)all_int_pax[6] - (double)all_int_pax[7]) / (double)all_int_pax[6]) * 100;
			if (all_int_cgo[2] != 0) ont[16] = (((double)all_int_cgo[2] - (double)all_int_cgo[3]) / (double)all_int_cgo[2]) * 100;
			if (all_int_cgo[6] != 0) ont[17] = (((double)all_int_cgo[6] - (double)all_int_cgo[7]) / (double)all_int_cgo[6]) * 100;
			if (all_total[2] != 0) ont[18] = (((double)all_total[2] - (double)all_total[3]) / (double)all_total[2]) * 100;
			if (all_total[6] != 0) ont[19] = (((double)all_total[6] - (double)all_total[7]) / (double)all_total[6]) * 100;
			
			String[] ont_arr = new String[20];
			DecimalFormat df = new DecimalFormat("###.#");
			for (int i=0; i<20; i++) {
				ont_arr[i] = df.format(ont[i]);
			}
			
			//--------------------------------------------------------------------------------------------
			entity.setSel_dom_pax(sel_dom_pax);
			entity.setSel_dom_cgo(sel_dom_cgo);
			entity.setSel_int_pax(sel_int_pax);
			entity.setSel_int_cgo(sel_int_cgo);
			entity.setAll_dom_pax(all_dom_pax);
			entity.setAll_dom_cgo(all_dom_cgo);
			entity.setAll_int_pax(all_int_pax);
			entity.setAll_int_cgo(all_int_cgo);
			
			entity.setSel_total(sel_total);
			entity.setAll_total(all_total);
			
			entity.setOnt(ont_arr);
			
			hashData.put("FLIGHT_SUMMARY",entity);
			
		} catch(SQLException se) {
			System.out.println("[BASE:StaAllSLBean:selStaQ230Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			System.out.println("[BASE:StaAllSLBean:selStaQ230Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
}//end of Class
