/******************************************************
 * Date ó  Java Script
 * Copyright (c) Hist ԰()
 ******************************************************/

/******************************************************
 *  Function : DUcheckDate(obj)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *							 - YYYY-MM-DD
 *  Parameter  : obj : ¥Է ü
 *  Return     : Boolean
 ******************************************************/
function DUcheckDate(obj) {
	var str = obj.value;
	var symbol = "";
	if (str.indexOf('-') >= 0) {
		symbol = '-';
	}

	if (str.indexOf('/') >= 0) {
		symbol = '/';
	}

	if( !DUverifyDate(obj, symbol)) {
		obj.focus();
		obj.select();
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUcheckMonth(obj)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *							  - YYYY-MM
 *  Parameter  : obj : ¥Է ü
 *  Return     : Boolean
 ******************************************************/
function DUcheckMonth(obj) {
	var str = obj.value;
	var symbol = "";
	if (str.indexOf('-') >= 0) {
		symbol = '-';
	}

	if (str.indexOf('/') >= 0) {
		symbol = '/';
	}

	if( !DUverifyMonth(obj, symbol)) {
		obj.focus();
		obj.select();
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUverifyDate(obj, symbol)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *  Parameter  : obj    : ¥Է ü
 *               symbol : ("/", "-", "", ...)
 *  Return     : Boolean
 ******************************************************/
function DUverifyDate(obj, symbol) {
	var tDate;
	if (obj == '[object]') tDate = obj.value;
	else tDate = obj;
	
	//var tDate = obj.value;
	var yyyymmdd;
	var yyyy;
	var mm;
	var dd;

	var i;

	// Է  ó
	if(tDate.length == 0)
		return true;

	if(symbol.length == 0) {
		if(tDate.length != 8) {
			//alert("¥  Ʋϴ.");
			//alert("Invalid Date Format");
			alert("Invalid Date Format");
			return false;
		}

		yyyy = tDate.substring(0, 4);
		mm = tDate.substring(4, 6);
		dd = tDate.substring(6, 8);
	} else {
		yyyymmdd = tDate.split(symbol);
		
		if(yyyymmdd.length != 3) {
			//alert("⵵" + symbol + "" + symbol + "  Էֽʽÿ !");
			alert("Year" + symbol + "Month" + symbol + ", Date Format Please !");
			return false;
		}

		yyyy = yyyymmdd[0];
		mm = yyyymmdd[1];
		dd = yyyymmdd[2];
	}
	
	// ¥  ˻
	if(!NUcheckDigit(yyyy)) {
		//alert("⵵ ߸Ǿϴ !");
		alert("Invalid Year");
		return false;
	}
	if(!NUcheckDigit(mm)) {
		//alert(" ߸Ǿϴ !");
		alert("Invalid Month");
		return false;
	}
	if(!NUcheckDigit(dd)) {
		//alert("ڰ ߸Ǿϴ !");
		alert("Invalid Day");
		return false;
	}

	// ˻
	if(parseInt(yyyy) < 1) {
		//alert("⵵ 1 ̻̾ մϴ.");
		alert("Must More Than 1 Year");
		return false;
	}

	// ޹ ˻
	if((mm < "01") || ("12" < mm)) {
		//alert("ȿ  ƴմϴ. 01 12   Է ֽʽÿ.");
		alert("Invalid Month, Please Insert From 01 To 12");
		return false;
	}

	// Ϲ ˻
	if((dd < "01") || ("31" < dd)) {
		//alert("ȿ ڰ ƴմϴ. 01 31   Է ֽʽÿ.");
		alert("Invalid Day, Please Insert From 01 To 31");
		return false;
	}
	var d = yyyy + mm + dd;
	if(!DUcheckDay(d)) {
		return false;
	}
	
	return true;
}

/******************************************************
 *  Function : DUverifyMonth(obj, symbol)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *  Parameter  : obj    : ¥Է ü
 *               symbol : ("/", "-", "", ...)
 *  Return     : Boolean
 ******************************************************/
function DUverifyMonth(obj, symbol) {
	var tDate = obj.value;
	var yyyymm;
	var yyyy;
	var mm;

	var i;

	// Է  ó
	if(tDate.length == 0)
		return true;

	if(symbol.length == 0) {
		if(tDate.length != 6) {
			alert("¥  Ʋϴ.");
			return false;
		}

		yyyy = tDate.substring(0, 4);
		mm = tDate.substring(4, 6);
	} else {
		yyyymm = tDate.split(symbol);
		if(yyyymm.length != 2) {
			alert("⵵" + symbol + "  Էֽʽÿ !");
			return false;
		}

		yyyy = yyyymm[0];
		mm = yyyymm[1];
	}

	// ¥  ˻
	if(!NUcheckDigit(yyyy)) {
		alert("⵵ ߸Ǿϴ !");
		return false;
	}
	if(!NUcheckDigit(mm)) {
		alert(" ߸Ǿϴ !");
		return false;
	}

	// ˻
	if(parseInt(yyyy) < 1) {
		alert("⵵ 1 ̻̾ մϴ.");
		return false;
	}

	// ޹ ˻
	if((mm < "01") || ("12" < mm)) {
		alert("ȿ  ƴմϴ. 01 12   Է ֽʽÿ.");
		return false;
	}

	return true;
}

/******************************************************
 *  Function : DUcheckDay(tDate)
 *         : Է¹ ü ¥ Ȯ üũѴ.
 *  Parameter  : tDate    : YYYYMMDD
 *  Return     : Boolean
 ******************************************************/
function DUcheckDay(tDate) {
	var tempYYYY = parseInt(tDate.substring(0, 4));
	var tempMM = parseInt(tDate.substring(4, 6));
	var tempDD = parseInt(tDate.substring(6, 8));

	var total_days = 31;


	if(tempMM == 1 || tempMM == 3 || tempMM == 5 || tempMM == 7 || tempMM == 8 || tempMM == 10 || tempMM == 12) {
		total_days = 31;
	} else if(tempMM == 2) {
		//  
		if(((tempYYYY % 4 == 0) && (tempYYYY % 100 != 0)) || (tempYYYY % 400 == 0)) {
			total_days = 29;
		} else {
			total_days = 28;
		}
	} else if(tempMM == 4 || tempMM == 6 || tempMM == 9 || tempMM == 11) {
		total_days = 30;
	}

	if(total_days < tempDD) {
		//alert(tempYYYY + " " + tempMM + " " + tempDD + "  ¥Դϴ.");
		//alert(tempYYYY + "-" + tempMM + "-" + tempDD + " is Invalid Date!");
		alert(tempYYYY + "-" + tempMM + "-" + tempDD + " is Invalid Date!");
		return false;
	}

	return true;
}

/******************************************************
 *  Function : DUcheckVal(tDate,val)
 *         : Է¹ ü ¥ Ȯ üũѴ.
 *  Parameter  : tDate    : YYYYMMDD
 *  Return     : Boolean
 ******************************************************/
function DUcheckMon(tDate,obj,val) {
	var tempYYYY = parseInt(tDate.substring(0, 4));
	var tempMM = parseInt(tDate.substring(4, 6));
	var tempDD = parseInt(tDate.substring(6, 8));

	var total_days = 31;


	if(tempMM == 1 || tempMM == 3 || tempMM == 5 || tempMM == 7 || tempMM == 8 || tempMM == 10 || tempMM == 12) {
		total_days = 31;
	} else if(tempMM == 2) {
		//  
		if(((tempYYYY % 4 == 0) && (tempYYYY % 100 != 0)) || (tempYYYY % 400 == 0)) {
			total_days = 29;
		} else {
			total_days = 28;
		}
	} else if(tempMM == 4 || tempMM == 6 || tempMM == 9 || tempMM == 11) {
		total_days = 30;
	}

	if(total_days < tempDD) {
		//alert(tempYYYY + " " + tempMM + " " + tempDD + "  ¥Դϴ.");
		//alert(tempYYYY + "-" + tempMM + "-" + tempDD + " is Invalid Date!");
		alert(val+" is Invalid Date!");
		obj.focus();
		obj.select();
		return false;
	}

	return true;
}

/******************************************************
 *  Function : DUcheckTime(obj)
 *         : Է¹ ü ð Ȯ üũѴ.
 *  Parameter  : obj    : ð Է¹ ü
 *  Return     : Boolean
 ******************************************************/
function DUcheckTime(obj) {
	var str;
	if (obj == '[object]') str = obj.value;
	else str = obj;
	
	//var str = obj.value;

	var symbol = "";
	if (str.indexOf(':') >= 0) {
		symbol = ':';
	}

	if(!DUverifyTime(str, symbol)) {
		obj.focus();
		obj.select();
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUverifyTime(tTime, symbol)
 *         : Է¹ ü ð Ȯ üũѴ.
 *  Parameter  : obj    : ð Է¹ ü
 *               symbol : ("/", "-", "", ...)
 *  Return     : Boolean
 ******************************************************/
function DUverifyTime(tTime, symbol) {
	var ttmm = '';
	var tt = '';
	var mm = '';
	
	if (tTime.length < 1)
		return true;

	if(symbol.length == 0) {
		if(tTime.length != 4) {
			//alert("ð  Ʋϴ.");
			alert("Invalid Time Format");
			return false;
		}

		tt = tTime.substring(0, 2);
		mm = tTime.substring(2, 4);

		ttmm = tt + mm;
	} else {
		if (tTime.length != 5) {
			//alert("ð  Ʋϴ.");
			alert("Invalid Time Format");
			return false;
		}

		var ttmm = tTime.split(symbol);

		if (ttmm.length != 2) {
			//alert("ð  Ʋϴ.");
			alert("Invalid Time Format");
			return false;
		}

		tt = ttmm[0];
		mm = ttmm[1];

		ttmm = ttmm.join('');
	}
	
	if (!NUcheckDigit(ttmm)) {
		//alert("ð ڸ Է մϴ.");
		alert("Time is Only insert Numeric");
		return false;
	}

	if ( tt < '00' || tt > '23' || mm < '00' || mm > '59') {
		//alert("ð 00:00  23:59  Է  մϴ.");
		alert("Time Insert is From 00:00 To 23:59");
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUformatDate(obj)
 *         : ¥ ȭ ϱ  OnKeyPress ̺Ʈ 
 *  Parameter  : obj    : ¥ Է¹ ü
 *  Return     : 2001-01-01
 *         : ex) 20010101 ==> 2001-01-01
 ******************************************************/
function DUformatDate(obj) {
	var symbol = "-";
	var str = obj.value;

	if(str.length == 4 || str.length == 7)
		obj.value = str + symbol;

	obj.focus();
}

/******************************************************
 *  Function : DUformatYM(obj)
 *         : ¥ ȭ ϱ  OnKeyPress ̺Ʈ 
 *  Parameter  : obj    : ¥ Է¹ ü
 *  Return     : 2001-01
 *         : ex) 200101 ==> 2001-01
 ******************************************************/
function DUformatYM(obj) {
	var symbol = "-";
	var str = obj.value;

	if(str.length == 4)
		obj.value = str + symbol;

	obj.focus();
}

/******************************************************
 *  Function : DUformatYMD(obj)
 *         : ¥ ȭ ϱ  OnKeyPress ̺Ʈ 
 *  Parameter  : obj    : ¥ Է¹ ü
 *  Return     : 01-01-30
 *         : ex) 010101 ==> 01-01-01
 ******************************************************/
function DUformatYMD(obj) {
	var symbol = "-";
	var str = obj.value;

	if(str.length == 2 || str.length == 5)
		obj.value = str + symbol;

	obj.focus();
}

/******************************************************
 *  Function : DUformatTime(obj)
 *         : ð ȭ ϱ  OnKeyPress ̺Ʈ 
 *  Parameter  : obj    : ð Է¹ ü
 *  Return     : 12:12
 *         : ex) 1212 ==> 12:12
 ******************************************************/
function DUformatTime(obj) {
	var symbol = ":";
	var str = obj.value;

	if(str.length == 2)
		obj.value = str + symbol;

	obj.focus();
}

/******************************************************
 *  Function : DUunFormatDate(obj)
 *         : ¥ ȭ
 *  Parameter  : obj    : ¥ Է¹ ü
 *  Return     : 20010101
 *         : ex) 2001-01-01  --> 20010101
 ******************************************************/
function DUunFormatDate(obj) {
	var str = obj.value;
	var arrStr = str.split('-');

	obj.value = arrStr.join('');

	obj.focus();
	return;
}

/******************************************************
 *  Function : DUunFormatDate(val)
 *         : ¥ ȭ
 *  Parameter  : val    : ¥ Է¹ 
 *  Return     : 20010101
 *         : ex) 2001-01-01  --> 20010101
 ******************************************************/
function DUunFormatDateVal(val) {
	var str;
	var arrStr = val.split('-');
	str = arrStr.join('');
	return str;
}

/******************************************************
 *  Function : DUunFormatTime(obj)
 *         : ð ȭ
 *  Parameter  : obj    : ð Է¹ ü
 *  Return     : 1212
 *         : ex) 12:12 ==> 1212
 ******************************************************/
function DUunFormatTime(obj) {
	var str = obj.value;
	var arrStr = str.split(':');

	obj.value = arrStr.join('');

	obj.focus();
	return;
}

/******************************************************
 *  Function : DUdateDiff(objF, objT)
 *         :  ¥ Ⱓ Է üũϴ Լ
 *  Parameter  : objF :  ü
 *               objT : Ϸ ü
 *  Return     : Boolean
 ******************************************************/
function DUdateDiff(objF, objT) {
	if (!DUcheckDate(objF) || !DUcheckDate(objT)) {
		return false;
	}

	var str_fr = objF.value;
	var str_to = objT.value;

	var arrDate_Fr = str_fr.split("-");
	var arrDate_To = str_to.split("-");

	str_fr = arrDate_Fr[0] + arrDate_Fr[1] + arrDate_Fr[2];
	str_to = arrDate_To[0] + arrDate_To[1] + arrDate_To[2];

	if (str_fr > str_to) {
		alert("Ȯ Ⱓ ԷϽʽÿ.");
		objF.focus();
		objF.select();
		return false;
	}

	return true;
}

/******************************************************
 *  Function : DUdateTimeDiff(objdF, objtF, objdT, objtT)
 *         :  ¥ ð Ⱓ Է üũϴ Լ
 *  Parameter  : objdF :  ü
 *               objtF : ۽ð ü
 *               objdT : Ϸ ü
 *               objtT : Ϸð ü
 *  Return     : Boolean
 ******************************************************/
function DUdateTimeDiff(objdF, objtF, objdT, objtT) {
	if (!DUcheckDate(objdF) || !DUcheckTime(objtF) || !DUcheckDate(objdT) || !DUcheckTime(objtT)) {
		return false;
	}

	var str_frd = objdF.value;
	var str_tod = objdT.value;
	var str_frt = objtF.value;
	var str_tot = objtT.value;


	var arrDate_Fr = str_frd.split("-");
	var arrDate_To = str_tod.split("-");
	var arrTime_Fr = str_frt.split(":");
	var arrTime_To = str_tot.split(":");

	var fdate = arrDate_Fr.join('') + arrTime_Fr.join('');
	var tdate = arrDate_To.join('') + arrTime_To.join('');

	if (fdate > tdate) {
		alert("Ȯ Ⱓ ԷϽʽÿ.");
		objdF.focus();
		objdF.select();
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUtodayBeforeCheck(obj)
 *         : Էڰ ú   üũϴ Լ
 *  Parameter  : obj : Է ü
 *  Return     : Boolean
 ******************************************************/
function DUtodayBeforeCheck(obj) {
	if(!DUcheckDate(obj))
		return false;

	var tempD = obj.value;

	var arrD = tempD.split('-');
	var inputday = arrD.join('');

	var tempTod = DUgetToday('yyyy-mm-dd');
	var arrTod = tempTod.split('-');
	var today = arrTod.join('');

	if (inputday < today) {
		alert("  ¥ Դϴ.");
		obj.focus();
		obj.select();
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUtimeBeforeCheck(objD, objT)
 *         : Է ð 纸   üũϴ Լ
 *  Parameter  : objD : Է ü
 *               objT : Է½ð ü
 *  Return     : Boolean
 ******************************************************/
function DUtimeBeforeCheck(objD, objT) {
	if(!DUcheckDate(objD) || !DUcheckTime(objT))
		return false;

	var tempD = objD.value;
	var tempT = objT.value;

	var arrD = tempD.split('-');
	var arrT = tempD.split(':');

	var inputday = arrD.join('') + arrT.join('');

	var tempTo = DUgetToday('yyyy-mm-dd/hh:mm');
	var arrTempTo = tempTo.split('/');
	var arrToD = arrTempTo[0].split('-');
	var arrToT = arrTempTo[1].split(':');

	var today = arrToD.join('') + arrToT.join('');
	if (inputday < today) {
		alert("  ð Դϴ.");
		objD.focus();
		objD.select();
		return false;
	}
	return true;
}

/******************************************************
 *  Function : DUgetToday(fi)
 *         : 糯¥,  ¥ ð ´.
 *  Parameter  : fi    :  Է¹ ü
 *  Return     : ¥, ¥ ð
 *         : ex) 'yyyy-mm-dd', 'yyyy-mm-dd/hh:mm'
 *         : ex) '2001-09-07', '2001-0907/21:12'
 ******************************************************/
function DUgetToday(fi) {
	var today = '';
	var toDate = new Date();
	var tyyyy = toDate.getYear();
	var tmonth = toDate.getMonth()+1;
	var tdd = toDate.getDate();
	var thh = toDate.getHours();
	var tmm = toDate.getMinutes();

	var yyyy = String(tyyyy);
	var month = '';
	var dd = '';
	var hh = '';
	var mm = '';

	if (tmonth < 10)
		month = '0' + tmonth;
	else
		month = String(tmonth);

	if (tdd < 10)
		dd = '0' + tdd;
	else
		dd = String(tdd);

	if (thh < 10)
		hh = '0' + thh;
	else
		hh = String(thh);

	if (tmm < 10)
		mm = '0' + tmm;
	else
		mm = String(tmm);

	if (fi == 'yyyy-mm-dd') {
		today = yyyy + "-" + month + "-" + dd;
	} else if (fi == 'yyyy-mm-dd/hh:mm') {
		today = yyyy + "-" + month + "-" + dd + "/" + hh + ":" + mm;
	}

	return today;
}

/******************************************************
 *  Function : DUgetMonth(fi)
 *         :  ´.
 *  Parameter  : fi    :  Է¹ ü
 *  Return     : [ ] ȯ
 *         : ex) 'yyyy-mm'
 *         : ex) '2001-09'
 ******************************************************/
function DUgetMonth(fi) {
	var today = '';
	var toDate = new Date();
	var tyyyy = toDate.getYear();
	var tmonth = toDate.getMonth()+1;

	var yyyy = String(tyyyy);
	var month = '';

	if (tmonth < 10)
		month = '0' + tmonth;
	else
		month = String(tmonth);

	if (fi == 'yyyy/mm') {
		today = yyyy + "/" + month;
	} else {
		today = yyyy + "-" + month;
	}

	return today;
}

/******************************************************
 *  Function : DUstringDate(str)
 *         : ¥ Ʈ ˿ ° ȯѴ.
 *  Parameter  : str :  Ʈ
 *  Return     : ˵ Ʈ
 *         : '20010907', '2001-09-07'
 ******************************************************/
function DUstringDate(str) {
	if(str.length == 8) {
		return str.substring(0,4) + "-" + str.substring(4,6) + "-" + str.substring(6);
	} else if (str.length == 6) {
		return str.substring(0,4) + "-" + str.substring(4,6);
	} else {
		return str;
	}
}

/******************************************************
 *  Function : DUdateString(str)
 *         : ¥ Ʈ ˿ ° ȯѴ.
 *  Parameter  : str :  Ʈ
 *  Return     : ˵ Ʈ
 *         : '2001-09-07', '20010907'
 ******************************************************/
function DUdateString(str) {
	var arrStr = str.split('-');
	return arrStr.join('');
}


/******************************************************
 *  Function : DUDateadd(obj, days)
 *         : ¥ Ѵ.
 *  Parameter  : obj  : ¥ Ʈ ü
 *               days :  ϼ
 *  Return     : ˵ Ʈ
 *         : '2001-09-07', '20010907'
 ******************************************************/
function DUDateadd(obj, days) {
	var arrDate;
	var str = obj.value
	
	if (str.length == 8) {
		year = str.substring(0, 4)
		month = str.substring(4, 6)
		day = str.substring(6, 8)
	} else {
		arrDate = str.split("-");

		year = arrDate[0];
		month = arrDate[1];
		day = arrDate[2];
	}

	var specialday = new Date(year, month-1, day);
	var add_days   = days*24*60*60*1000
	var std_days   = specialday.getTime()
	var tmp_days   = add_days + std_days
	specialday.setTime(tmp_days)

	var rtn_year = specialday.getYear()
	var rtn_mon  = specialday.getMonth() + 1
	var rtn_day  = specialday.getDate()

	var str_mon, str_day, rtn_date
	if (rtn_mon < 10)
		str_mon = "0" + rtn_mon
	else
		str_mon = "" + rtn_mon

	if (rtn_day < 10)
		str_day = "0" + rtn_day
	else
		str_day = "" + rtn_day

	if(str.length == 8) {
		rtn_date = "" + rtn_year + str_mon + str_day
	} else {
		rtn_date = "" + rtn_year + "-" + str_mon + "-" + str_day
	}

	return rtn_date;
}


/******************************************************
 *  Function : DUDateBet(obj1, obj2)
 *         : ¥ Ѵ.
 *  Parameter  : obj1  : ¥ Ʈ ü
 *               obj2  : ¥ Ʈ ü
 *  Return     : ¥
 ******************************************************/
function DUDateBet(obj1, obj2) {
	if(DUdateDiff) {
		var str_fr = obj1.value;
		var str_to = obj2.value;

		var arrDate_Fr = str_fr.split("-");
		var arrDate_To = str_to.split("-");


		var fr_date = new Date(arrDate_Fr[0], arrDate_Fr[1] - 1, arrDate_Fr[2]);
		var to_date = new Date(arrDate_To[0], arrDate_To[1] - 1, arrDate_To[2]);
		var days = Math.ceil((to_date - fr_date)/24/60/60/1000);
		return days;
	}
}

/******************************************************
 *  Function : DUchkDate(obj, symbol)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *  Parameter  : obj    : ¥Է ü
 *               symbol : ("/", "-", "", ...)
 *  Return     : Boolean
 ******************************************************/
function DUchkDate(obj, symbol) {
	var tDate;
	if (obj == '[object]') tDate = obj.value;
	else tDate = obj;
	
	//var tDate = obj.value;
	var yyyymmdd;
	var yyyy;
	var mm;
	var dd;

	var i;

	// Է  ó
	if(tDate.length == 0)
		return true;

	if(symbol.length == 0) {
		if(tDate.length != 8) {
			//alert("¥  Ʋϴ.");
			alert("Invalid Date Format");
			return false;
		}

		yyyy = tDate.substring(0, 4);
		mm = tDate.substring(4, 6);
		dd = tDate.substring(6, 8);
	} else {
		yyyymmdd = tDate.split(symbol);
		
		if(yyyymmdd.length != 3) {
			//alert("⵵" + symbol + "" + symbol + "  Էֽʽÿ !");
			alert("Year" + symbol + "Month" + symbol + "Date Format Please !");
			return false;
		}

		yyyy = yyyymmdd[0];
		mm = yyyymmdd[1];
		dd = yyyymmdd[2];
	}

	// ˻
	if(parseInt(yyyy) < 1) {
		//alert("⵵ 1 ̻̾ մϴ.");
		alert("Year is Over 1 Year");
		return false;
	}

	// ޹ ˻
	if((mm < "01") || ("12" < mm)) {
		//alert("ȿ  ƴմϴ. 01 12   Է ֽʽÿ.");
		alert("Invalid Month. Insert From 01 To 12 Please!");
		return false;
	}

	// Ϲ ˻
	if((dd < "01") || ("31" < dd)) {
		//alert("ȿ ڰ ƴմϴ. 01 31   Է ֽʽÿ.");
		alert("Invalid Date. Insert From 01 To 31 Please!");
		return false;
	}
	var d = yyyy + mm + dd;
	if(!DUcheckDay(d)) {
		return false;
	}
	
	return true;
}

/******************************************************
 *  Function : DUchkDate(obj, symbol)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *  Parameter  : obj    : ¥Է ü
 *               		 symbol : ("/", "-", "", ...)
 *						 val : Focus Target ü
 *  Return     : Boolean
 ******************************************************/
function DUchkDateFocus(obj, symbol, val) {
	var tDate;
	if (obj == '[object]') tDate = obj.value;
	else tDate = obj;
	
	//var tDate = obj.value;
	var yyyymmdd;
	var yyyy;
	var mm;
	var dd;

	var i;

	// Է  ó
	if(tDate.length == 0)
		return true;

	if(symbol.length == 0) {
		if(tDate.length != 8) {
			//alert("¥  Ʋϴ.");
			alert("Invalid Date Format");
			val.focus();
			val.select();
			return false;
		}

		yyyy = tDate.substring(0, 4);
		mm = tDate.substring(4, 6);
		dd = tDate.substring(6, 8);
	} else {
		yyyymmdd = tDate.split(symbol);
		
		if(yyyymmdd.length != 3) {
			//alert("⵵" + symbol + "" + symbol + "  Էֽʽÿ !");
			//alert("Year" + symbol + "Month" + symbol + "Date Format Please !");
			alert("'yy" + symbol + "mm" + symbol + "dd' Format Please !");
			val.focus();
			val.select();
			return false;
		}

		yyyy = yyyymmdd[0];
		mm = yyyymmdd[1];
		dd = yyyymmdd[2];
	}

	// ˻
	if(parseInt(yyyy) < 1) {
		//alert("⵵ 1 ̻̾ մϴ.");
		alert("Year is Over 1 Year");
		val.focus();
		val.select();
		return false;
	}

	// ޹ ˻
	if((mm < "01") || ("12" < mm)) {
		//alert("ȿ  ƴմϴ. 01 12   Է ֽʽÿ.");
		alert("Invalid Month. Insert From 01 To 12 Please!");
		val.focus();
		val.select();
		return false;
	}

	// Ϲ ˻
	if((dd < "01") || ("31" < dd)) {
		//alert("ȿ ڰ ƴմϴ. 01 31   Է ֽʽÿ.");
		alert("Invalid Date. Insert From 01 To 31 Please!");
		val.focus();
		val.select();
		return false;
	}
	var d = yyyy + mm + dd;
	if(!DUcheckDay(d)) {
		return false;
	}
	
	return true;
}

/******************************************************
 *  Function : DUchkMonth(obj, val)
 *         : Է¹ ü ¥ Ȯ üũѴ
 *  Parameter  : obj    : ¥Է ü
 *						 val : Focus Target ü
 *  Return     : Boolean
 ******************************************************/
function DUchkMonth(obj,val) {
	var tDate;
	if (obj == '[object]') tDate = obj.value;
	else tDate = obj;
	
	var months = "JAN,FEB,MAR,APR,MAY,JUN,JUL,AUG,SEP,OCT,NOV,DEC"
	var yyyymmdd;
	var yyyy;
	var mmm;
	var mm;
	var dd;
	
	if (tDate.length == 0) return true;
	else if (tDate.length != 7) {
		alert("Invalid Date Format");
		val.focus();
		val.select();
		return false;
	} else {
		yyyy = "20"+tDate.substring(0,2);
		mmm = tDate.substring(2,5);
		dd = tDate.substring(5);
	}
	
	// ˻
	if(parseInt(yyyy) < 1) {
		alert("Year is Over 1 Year");
		val.focus();
		val.select();
		return false;
	} else if (!NUcheckDigit(yyyy)) {
		alert("Invalid Year<BR>Year is only Numeric");
		val.focus();
		val.select();
		return false;
	}
	//Ϲ ˻
	if (!NUcheckDigit(dd)) {
		alert("Invalid Day<BR>Day is only Numeric");
		val.focus();
		val.select();
		return false;
	} else if((dd < "01") || ("31" < dd)) {
		alert("Invalid Date<BR>Insert From 01 To 31");
		val.focus();
		val.select();
		return false;
	}
	//޹ ˻
	var i = months.indexOf(mmm);
	if (i == -1) {
		alert(mmm+" is Invalid Month");
		val.focus();
		val.select();
		return false;
	}
	
	mm = covMonth(mmm);
	
	var d = yyyy + mm + dd;
	if(!DUcheckMon(d,val,tDate)) {
		return false;
	}
	
	return true;
}

function covMonth(val) {
	if (val == null || val.length == 0) return "";
	
	if (val == "JAN") return "01";
	else if (val == "FEB") return "02";
	else if (val == "MAR") return "03";
	else if (val == "APR") return "04";
	else if (val == "MAY") return "05";
	else if (val == "JUN") return "06";
	else if (val == "JUL") return "07";
	else if (val == "AUG") return "08";
	else if (val == "SEP") return "09";
	else if (val == "OCT") return "10";
	else if (val == "NOV") return "11";
	else if (val == "DEC") return "12";
	else return "";
}

/******************************************************
 *  Function : DUvalidationDate(date1,date2,term)
 *             : Է¹ From~To Date Validation Check 
 *                      - Ȯ ¥ ˻
 *                      - From To  ū ˻
 *                      - Է¹ term Ⱓ Ѿ ˻
 *  Parameter : date1  From Date Object
 *						date2  To Date Object
 *						term    Ⱓ Value
 *  Return     : Boolean
 ******************************************************/
function DUvalidationDate(date1,date2,term) {
	var fromDate = date1.value;
	var toDate = date2.value;
	var period = parseInt(term);	
	
	//Ȯ ¥ ˻
	if (fromDate == null) {
		alert("Invalid From Date Format 'yymmdd'!");
		date1.focus();
		date1.select();
		return false;
	} else if (fromDate.length != 6) {
		alert("Invalid From Date Format 'yymmdd'!");
		date1.focus();
		date1.select();
		return false;
	} else if (!DUchkDateFocus("20"+fromDate,"",date1)) return false;
	if (toDate == null) {
		alert("Invalid To Date Format 'yymmdd'!");
		date2.focus();
		date2.select();
		return false;
	} else if (toDate.length != 6) {
		alert("Invalid To Date Format 'yymmdd'!");
		date2.focus();
		date2.select();
		return false;
	} else if (!DUchkDateFocus("20"+toDate,"",date2)) return false;
	
	//From To  ū ˻
	if (fromDate > toDate) {
		date2.focus();
		date2.select();
		alert("From Date Bigger Than To Date!");
		return false;
	} 

	//Է¹ term Ⱓ Ѿ ˻
	if (!calDay(fromDate,toDate,period)) {
		alert("Out of Display Range "+period+" Days!");
		date2.focus();
		date2.select();
		return false;
	}

	return true;
}

function calDay(fromDate,toDate,term) {
	var period = parseInt(term);
	fromDate = covDate(fromDate);
	toDate = covDate(toDate);
	
	var date1 = new Date(fromDate);
	var date2 = new Date(toDate);
	var dDay = Math.ceil((date2 - date1) / 1000 / 24 / 60 / 60);
	
	if (dDay > period) return false;

	return true;
}

function covDate(strDate) {
	if (strDate == null || strDate.length != 6) return "";
	
	var year = strDate.substring(0,2);
	var month = strDate.substring(2,4)
	var day = strDate.substring(4);
	
	return "20"+year+"/"+month+"/"+day;
}

//γ¥ (YYYYMMDDHHMI vs YYYYMMDDHHMI)
// ð Ѵ
function DUTimeBet(obj1, obj2) {
	var yyyy1 = obj1.substring(0,4);
	var mm1 = obj1.substring(4,6);
	var dd1 = obj1.substring(6,8);
	var hh1 = obj1.substring(8,10);
	var mi1 = obj1.substring(10);
	
	var yyyy2 = obj2.substring(0,4);
	var mm2 = obj2.substring(4,6);
	var dd2 = obj2.substring(6,8);
	var hh2 = obj2.substring(8,10);
	var mi2 = obj2.substring(10);
	
	var fr_date = new Date(yyyy1,mm1-1,dd1,hh1,mi1);
	var to_date = new Date(yyyy2,mm2-1,dd2,hh2,mi2);
	var times = Math.ceil((to_date-fr_date)/60/60/1000);
	
	return times;
}

/******************************************************
 *  Function : DUcheckDateTime(val)
 *         : Է¹ ü ¥&ð Ȯ üũѴ.
 *  Parameter  : tDate    : YYYYMMDDHHMI
 *  Return     : Boolean
 ******************************************************/
 function DUcheckDateTime(val) {
 
 	if (val == null || val.length != 12) {
 		alert("¥  Ʋϴ. [YYYYMMDDHHMI]");
 		return false;
 	}
 	
 	/*
 	var tempYYYY = parseInt(val.substring(0, 4));
	var tempMM = parseInt(val.substring(4, 6));
	var tempDD = parseInt(val.substring(6, 8));
	var tt = val.substring(8, 10);
	var mm = val.substring(10, 12);
	*/
	
	var tmpY = cutZero(val.substring(0, 4));
 	var tmpM = cutZero(val.substring(4,6));
 	var tmpD = cutZero(val.substring(6,8));
 	
 	var tempYYYY = parseInt(tmpY);
	var tempMM = parseInt(tmpM);
	var tempDD = parseInt(tmpD);
	var tt = val.substring(8, 10);
	var mm = val.substring(10, 12);

	var total_days = 31;
	
	if (tempMM < 1 || tempMM > 12) {
		alert(tempMM + "   Դϴ.");
		return false;
	}
	
	if (tempDD < 1 || tempDD > 31) {
		alert(tempDD + "   Դϴ.");
		return false;
	}
	
	if(tempMM == 1 || tempMM == 3 || tempMM == 5 || tempMM == 7 || tempMM == 8 || tempMM == 10 || tempMM == 12) {
		total_days = 31;
	} else if(tempMM == 2) {
		//  
		if(((tempYYYY % 4 == 0) && (tempYYYY % 100 != 0)) || (tempYYYY % 400 == 0)) {
			total_days = 29;
		} else {
			total_days = 28;
		}
	} else if(tempMM == 4 || tempMM == 6 || tempMM == 9 || tempMM == 11) {
		total_days = 30;
	}

	if(total_days < tempDD) {
		alert(tempYYYY + " " + tempMM + " " + tempDD + "  ¥Դϴ.");
		return false;
	}
	
	if (!NUcheckDigit(tt+mm)) {
		alert("ð ڸ Է մϴ.");
		return false;
	}

	if ( tt < '00' || tt > '23' || mm < '00' || mm > '59') {
		alert("ð 00:00  23:59  Է  մϴ.");
		return false;
	}
	return true;
 }
 
  function cutZero (val) {
 	var tmp = "";
 
 	if (val == null || val.length == 0) return "";
 	
 	if (val.substring(0,1) == "0") tmp = val.substring(1);
 	else tmp = val;
 	
 	return tmp;
 }

/******************************************************
 *  Function : DUgetLocTime()
 *         : PC ð . 15Feb07 10:37 (FFS )
 *  Parameter  : 
 *  Return     : 
 *  ۼ ¥ : 2007.02.15 
 ******************************************************/
function DUgetLocTime() {
	if (document.all) {
		var now = new Date();
		
		/*var utcYear = now.getUTCFullYear();
		var utcMonth = now.getUTCMonth() + 1;
		var utcDay = now.getUTCDate();
		var utcHour = now.getUTCHours();
		var utcMinute = now.getUTCMinutes();
		var utcSecond = now.getUTCSeconds();*/
		
		var nowYear = now.getFullYear();
		var nowMonth = now.getMonth() + 1;
		var nowDay = now.getDate();
		var nowHour = now.getHours();
		var nowMinute = now.getMinutes();
		var nowSecond = now.getSeconds();
		
		if (nowDay < 10) nowDay = "0" + nowDay;
		
		if (nowMonth == "1") nowMonth = "Jan";
		else if (nowMonth == "2") nowMonth = "Feb";
		else if (nowMonth == "3") nowMonth = "Mar";
		else if (nowMonth == "4") nowMonth = "Apr";
		else if (nowMonth == "5") nowMonth = "May";
		else if (nowMonth == "6") nowMonth = "Jun";
		else if (nowMonth == "7") nowMonth = "Jul";
		else if (nowMonth == "8") nowMonth = "Aug";
		else if (nowMonth == "9") nowMonth = "Sep";
		else if (nowMonth == "10") nowMonth = "Oct";
		else if (nowMonth == "11") nowMonth = "Nov";
		else if (nowMonth == "12") nowMonth = "Dec";
		
		nowYear = nowYear.toString();
		nowYear = nowYear.substring(2,4);
		
		if (nowHour < 10) nowHour = "0" + nowHour;
		
		if (nowMinute < 10) nowMinute = "0" + nowMinute;
		
		if (nowSecond < 10) nowSecond = "0" + nowSecond;
		
		var nowStr = nowDay + nowMonth + nowYear + " " + nowHour + ":" + nowMinute;
		document.form.locTime.value = nowStr;
		
		setTimeout("DUgetLocTime()",1000);
	}
}
 