<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%@ page language="java" contentType="text/html; charset=EUC-KR" pageEncoding="EUC-KR" %>
<%@ page import="java.io.*" %>
<%@ page import="kal.base.jdf.com.Logger" %>
<%@ page import="kal.base.com.util.StringUtil" %>

<%!
	String errorMessge = "";
    private final int DEFAULT_BUFFER_SIZE = 4096;
    private final String clientEncoding = "euc-kr"; 
    private final String jvmEncoding = System.getProperty("file.encoding");
%>

<%
    try{
    	String prefix = null;
    	String filename = null;
    	
        try{ 
            prefix = (String)request.getParameter("prefix");
	    	filename = (String)request.getParameter("filename");
        } catch (Exception e) {
        	out.println(e.getMessage());
        }
        
        /*
        if(filename == null) {
            response.setContentType("text/plain;charset="+clientEncoding);
            //out.println("filename is needed: download.jsp?fn=XXX.txt");
            errorMessge = "filename is needed: download.jsp?fn=XXX.txt";
            //return;
        }
        */
        
        if (prefix != null && filename != null) {
        
	        if( filename.indexOf("..") != -1){ 
	            response.setContentType("text/plain;charset="+clientEncoding);
	            //out.println("file[" + filename + "] could not contains \"..\" for security");
	            errorMessge = "file[" + filename + "] could not contains \"..\" for security";
	            //return;
	        }
	
	        File file = new File(prefix + filename);
	        if (! file.exists() ){
	            response.setContentType("text/plain;charset="+clientEncoding);
	            //out.println("file[" + filename + "] does not exist in the directory, "+ prefix);
	            errorMessge = "file[" + filename + "] does not exist in the directory, "+ prefix;
	            //return;
	        }
	        
	        String filename_8859_1 = new String(filename.getBytes("EUC-KR"),"ISO-8859-1");
	        String client = request.getHeader("User-Agent");
	        response.reset();
	        
	        if (client.indexOf("MSIE 5.5") != -1) {
	            response.setHeader("Content-Type", "doesn/matter;charset=8859_1");
	            response.setHeader("Content-Disposition", "filename="+filename_8859_1 +";");
	        } 
	        else {
	            response.setHeader("Content-Type", "application/octet-stream;charset=8859_1");
	            response.setHeader("Content-Disposition", "attachment; filename="+filename_8859_1+";");
	        }
	        
	        response.setHeader("Content-Transfer-Encoding", "binary;");
	        response.setHeader("Pragma", "no-cache;");
	        response.setHeader("Expires", "-1;");
	        response.setHeader("Content-Length", ""+file.length() );
	
	        InputStream in = null;
	        OutputStream os = null;
	        ServletOutputStream fout = response.getOutputStream();
	
	        try {
	            in = new FileInputStream(file);
	            os = response.getOutputStream();
	
	            byte[] buf = new byte[4096]; //buffer size 4K.
	            int count = 0;
	            
	            while ((count = in.read(buf)) != -1) {
	                os.write(buf,0,count);
	                os.flush();
	            }
	
	        }
	        catch(Exception e) {
	        	errorMessge = e.getMessage();
	        }
	        
	        finally {
	            if(in != null) try{in.close();}catch(Exception e){}
	            if(os != null) try{os.close();}catch(Exception e){}
	        }
	    }
    }
    catch(Exception e){
            // There is nothing you can do at this time 
            // because HEADER is alreay set as "application/octet-stream"
            // System.out.println(e.toString());
            errorMessge = e.getMessage();
    }
%>

<script language="JavaScript" type="text/JavaScript">
<!--
if ("<%= errorMessge %>" != "") {
	alert("<%= errorMessge %>");
}
//self.close();
//-->
</script>
