<?xml version="1.0" encoding="EUC-KR"?>
<!-- <!DOCTYPE	xsl:stylesheet	[
	<!ENTITY	nbsp		"&#160;">
	<!ENTITY	copy			"&#169;">
	<!ENTITY	reg			"&#174;">
	<!ENTITY	trade		"&#8482;">
	<!ENTITY	mdash		"&#8212;">
	<!ENTITY	ldquo		"&#8220;">
	<!ENTITY	rdquo		"&#8221;"> 
	<!ENTITY	pound		"&#163;">
	<!ENTITY	yen			"&#165;">
	<!ENTITY	euro			"&#8364;">
]> -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:template match="ROOT">
<!-- 
@ ȭ	:	IROPS STATUS QRS  ȭ
@ 	:	irops_status_qrs.jsp
@ ۼ	:	v.bgkim@kalmate.net 2014-04-04 
@ 	:	 HTML ̾ƿ  ü,   , ũƮ 
 -->
<HTML>
	<!--	================================================================	HEAD	-->
	<HEAD>		
		<META	charset="EUC-KR"/>
		<META	http-equiv="X-UA-Compatible" content="IE=Edge"/> 
		<TITLE>:: IROPS STATUS ::</TITLE>
		<STYLE		type="text/css"> 
			/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/
			BODY{margin:10px;padding:0px;font-family:" ","Arial";font-size:0.7em;}
			FORM{width:600px;}
			TABLE {border-collapse:collapse;width:100%;}
			/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/
			DIV.group{margin-bottom:10px;}
			DIV.title{float:left;margin-bottom:3px;font-size:1.2em;font-weight:bold;}
			DIV.button{cursor:pointer;float:right;padding:0px 5px;padding-top:2px;margin-bottom:3px;margin-left:5px;background-color:#eee;border:1px solid #ccc;}
			/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/
			TABLE.grid {border-left:1px solid #CCC;}
			TABLE.grid CAPTION{word-spacing:0.7em;background-color:#EBF5FA;border:1px solid #CCC;padding:5px;font-weight:bold;}
			TABLE.grid TH,TABLE.grid TD{border-right:1px solid #CCC;	border-bottom:1px solid #CCC;padding:3px;}
 
			.tr_even TD{background-color:#F8F8F8;}
			.tr_even TH{background-color:white;}
			.td_link,.span_link{cursor:pointer;color:blue;}
			.td_title{text-align:left;padding-left:10px;}
			/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/
			#myBlink{display:none;border:1px solid #CCC;background-color:#CCFF00;padding:10px;text-align:left;font-weight:bold;}
		</STYLE>
		<!--	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -		HEAD.JS	-->
		<SCRIPT	type="text/javascript" src="/BASERoot/js/PopupUtil.js"></SCRIPT>
		<SCRIPT	type="text/javascript" src="/BASERoot/js/StringUtil.js"></SCRIPT>
		<SCRIPT	type="text/javascript">
			var	wVal;	//Weather Watch Regional Object
			var	titleArr			=	<xsl:value-of select="HEADER/@titleArr"/>||[];
			var	current		=	'<xsl:value-of select="HEADER/@current"/>';
			var	timer;
			<![CDATA[
			/*- - - - - - - - - - - - - - - - -	pageLoad	*/
			function pageLoad() {
				if(titleArr && titleArr.length!=0){
					document.getElementById("myBlink").style.display="block";
					setTitle();
				}
			} 
			/*- - - - - - - - - - - - - - - - -	buttonLink	*/
			function buttonLink(kind) {
				switch(kind){
					case "all":					location.href = "/BASERoot/jsp/etc/irops_status_qrs.jsp?current=N";break;
					case "current":			location.href = "/BASERoot/jsp/etc/irops_status_qrs.jsp?current=Y";break;
					case "refresh":			location.href = "/BASERoot/jsp/etc/irops_status_qrs.jsp?current="+current;break;
					case "weather":	
						var loc = PUgetLocation(1000, 720);
						window.open("",'WEATHER', 'status=yes,resizable=yes,scrollbars=no, ' + loc);
						document.form.action = "/BASERoot/jsp/sup/SupQ510UI.jsp?startPage=Y";
						document.form.target = "WEATHER";
						document.form.submit();
					break;					
				}
			}
			/*- - - - - - - - - - - - - - - - -	popupFltInfo	*/
			function popupFltInfo(schDepDt, fltNum, stnfr, stnto) {//2010.04.12 ߰ : FLT NUM Ŭ -> FLT PROGRESS INFO â
				var loc = PUgetLocation(867, 630);
				var progress = window.open("/BASERoot/jsp/iro/IroQ470PO.jsp?startPage=Y&iropsY=Y&pSchDepDt="+schDepDt+"&pFltNum="+fltNum+"&pStnfr="+stnfr+"&pStnto="+stnto, "PROGRESS", 'resizable=yes,scrollbars=yes,' + loc);
				progress.focus();
			}
			/*- - - - - - - - - - - - - - - - -	volcanoInfo	*/
			function volcanoInfo(code) {//2011.03.18 ߰
				var loc = PUgetLocation(980, 800);
				var volcano = window.open("/BASERoot/jsp/frame/volcano1.jsp?code_c="+code, "VOLCANO", 'resizable=yes,scrollbars=yes,' + loc);
				volcano.focus();
			}
			/*- - - - - - - - - - - - - - - - -	timer	*/
			function setBlinkTime(time) {//2010.10.27 
				timer = setTimeout("doBlink()",time);
			}
			function setTitle(){
				if(titleArr!=null){
					if(titleArr.length==1){
						document.all.myBlink.innerText = (titleArr[0].desc_e).split("&#39").join("'");
						document.all["myBlink"].onclick = function(){volcanoInfo(titleArr[0].code_c);};  
						//document.all.myBlink.style.display = "none";//2012.03.05 : Ѱ ϶ Ÿ 
						//doBlink();//2012.03.05 : Ѱ ϶ Ÿ 
					}else if(titleArr.length>1){          
						timer = setTimeout("showTitle()",0);
					}
				}
			}
			function showTitle(){
				var title = titleArr.shift();
				document.all.myBlink.innerText = (title.desc_e).split("&#39").join("'");
				document.all["myBlink"].onclick = function(){volcanoInfo(title.code_c);};
				titleArr.push(title);
				timer = setTimeout("showTitle()",3000);
			}
			function doBlink() {
				if (document.all.myBlink.style.display == "") {
					document.all.myBlink.style.display = "none";
					setBlinkTime(3000); //Ⱥ̴ ð200
				} else {
					document.all.myBlink.style.display = "";
					setBlinkTime(3000); //̴ ð1500
				}
			}
			/*- - - - - - - - - - - - - - - - -	showAlertAPO	*/
			function showAlertAPO(eleName,win){//WX INFORMATION
				var loc = SUgetLocation(460, 250);
				var msg = window.open("/BASERoot/jsp/ffs/FfsQ810PO01.jsp?mode="+win+"&ele="+eleName, win, loc);
			}
			]]>
		</SCRIPT>
	</HEAD>
	<!--	================================================================	BODY	-->
	<BODY onload="pageLoad()">	  
		<CENTER>
			<FORM name="form" method="post"> 
				<xsl:choose>
					<xsl:when test="HEADER/@authFlg='true'">
						<!--	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -		hidden	-->
						<INPUT type="hidden" name="loginOk" value="OK" />
						<!--	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -		DIV	-->
						<DIV class="group">
							<DIV id="myBlink"  onMouseOver="this.style.cursor='hand';clearTimeout(timer)" onMouseOut="this.style.cursor='default';setTitle();">
								<!-- timeout  µǴ  -->
							</DIV>
						</DIV>
						<!--	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -		DIV	-->
						<DIV class="group">
							<DIV class="title"> KE Flight Status - IROPS</DIV>
							<DIV class="button" onclick="buttonLink('refresh')">REFRESH</DIV>
							<DIV class="button" onclick="buttonLink('weather')">WEATHER</DIV>
							<DIV class="button" onclick="buttonLink('current')">CURRENT</DIV>
							<DIV class="button" onclick="buttonLink('all')">ALL</DIV>
							<TABLE class="grid">
								<CAPTION align="top">IROPS STATUS <xsl:value-of select="HEADER/@opDate"/></CAPTION>
								<COLGROUP>
									<COL width="40"/>
									<COL width="55"/>
									<COL width="70"/>
									<COL width="60"/>
									<COL/>
									<COL width="40"/>
									<COL/>
								</COLGROUP>
								<TBODY>
									<xsl:choose>
										<xsl:when test="count(IROPS/DOM)+count(IROPS/INT)+count(IROPS/CGO)=0"><xsl:value-of select="@aHREF"/>
											<TR>
												<TD colspan="7">No Data</TD>
											</TR>
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select="IROPS/DOM/ROW">	
												<TR>
													<xsl:if test="(0+position()) mod 2=1"><xsl:attribute name="class">tr_even</xsl:attribute></xsl:if>
													<xsl:if test="position() =1"><TH><xsl:attribute name="rowspan"><xsl:value-of select="count(../ROW)"/></xsl:attribute>DOM</TH></xsl:if>
													<TD class="td_link" onclick="javascript:popupFltInfo('{@sch_dep_dt}','{@flt_num}','{@stnfr}','{@stnto}')">KE<xsl:value-of select="@flt_num"/></TD>
													<TD><xsl:value-of select="@ddmon"/></TD>
													<TD><xsl:value-of select="@stnfr"/>/<xsl:value-of select="@stnto"/></TD>
													<TD class="td_title"><xsl:value-of select="@comment_e"/></TD>
													<TD><xsl:value-of select="@comment_x"/></TD>
													<TD class="td_title"><xsl:value-of select="@title_e"/></TD>
												</TR>
											</xsl:for-each>
											<xsl:for-each select="IROPS/INT/ROW">	
												<TR>
													<xsl:if test="(count(../../DOM/ROW)+position()) mod 2=1"><xsl:attribute name="class">tr_even</xsl:attribute></xsl:if>
													<xsl:if test="position() =1"><TH><xsl:attribute name="rowspan"><xsl:value-of select="count(../ROW)"/></xsl:attribute>INT</TH></xsl:if>
													<TD class="td_link" onclick="javascript:popupFltInfo('{@sch_dep_dt}','{@flt_num}','{@stnfr}','{@stnto}')">KE<xsl:value-of select="@flt_num"/></TD>
													<TD><xsl:value-of select="@ddmon"/></TD>
													<TD><xsl:value-of select="@stnfr"/>/<xsl:value-of select="@stnto"/></TD>
													<TD class="td_title"><xsl:value-of select="@comment_e"/></TD>
													<TD><xsl:value-of select="@comment_x"/></TD>
													<TD class="td_title"><xsl:value-of select="@title_e"/></TD>
												</TR>
											</xsl:for-each>
											<xsl:for-each select="IROPS/CGO/ROW">	
												<TR>
													<xsl:if test="(count(../../DOM/ROW)+count(../../INT/ROW)+position()) mod 2=1"><xsl:attribute name="class">tr_even</xsl:attribute></xsl:if>
													<xsl:if test="position() =1"><TH><xsl:attribute name="rowspan"><xsl:value-of select="count(../ROW)"/></xsl:attribute>CGO</TH></xsl:if>
													<TD class="td_link" onclick="javascript:popupFltInfo('{@sch_dep_dt}','{@flt_num}','{@stnfr}','{@stnto}')">KE<xsl:value-of select="@flt_num"/></TD>
													<TD><xsl:value-of select="@ddmon"/></TD>
													<TD><xsl:value-of select="@stnfr"/>/<xsl:value-of select="@stnto"/></TD>
													<TD class="td_title"><xsl:value-of select="@comment_e"/></TD>
													<TD><xsl:value-of select="@comment_x"/></TD>
													<TD class="td_title"><xsl:value-of select="@title_e"/></TD>
												</TR>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
								</TBODY>
							</TABLE>
						</DIV>
						<!--	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -		DIV	-->
						<DIV class="group">
							<DIV class="title"> Weather Information</DIV>
							<TABLE class="grid">
								<CAPTION align="top">WEATHER INFORMATION <xsl:value-of select="HEADER/@opDate"/></CAPTION>
								<TBODY>
									<TR>
										<TD class="td_title">
											<xsl:choose>
												<xsl:when test="count(WEATHER/ROW)=0">
													<DIV style="text-align:center;">No Data</DIV>
												</xsl:when>
												<xsl:otherwise>
													<xsl:for-each select="WEATHER/ROW">	
														<DIV><a href="javascript:showAlertAPO('manWx{position()+1}','COMMNT')"><strong><xsl:value-of select="@iata_port"/></strong><input type="hidden" name="manWx{position()+1}" value="{.}" /></a> 	- <xsl:value-of select="@wx_typ"/> / <xsl:value-of select="@man_iss_dt"/> ~ <xsl:value-of select="@getman_exp_dt"/></DIV>
													</xsl:for-each>
												</xsl:otherwise>
											</xsl:choose>
										</TD>
									</TR>
								</TBODY>
							</TABLE>
						</DIV> 
					</xsl:when>
					<xsl:otherwise>
						<!--	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -		DIV	-->
						<DIV class="group">
							<DIV class="title"> PAGE MESSAGE</DIV>
							<TABLE class="grid">
								<CAPTION align="top">Security check</CAPTION>
								<TBODY>
									<TR>
										<TD>Invalid access or permission !</TD>
									</TR>
								</TBODY>
							</TABLE>
						</DIV>
					</xsl:otherwise>
				</xsl:choose>
			</FORM>
		</CENTER>
	</BODY>
</HTML>
</xsl:template>
</xsl:stylesheet>