package kal.base.ffs.daemon;

import java.rmi.RemoteException;
import java.util.Timer;
import java.util.TimerTask;
import java.util.HashMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Landed
 */
public class FfsQ040Task extends TimerTask {
	
	Timer timer;
	public static HashMap hMap = new HashMap();
	
	public FfsQ040Task() {}
	
	public FfsQ040Task(Timer _timer) {
		this.timer = _timer;
	}
	
	public void run() {
		try {
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");			
			hMap = sl.allLanded();
			
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ040Task] "+((RemoteException)e).getMessage());
			} else {
				Logger.debug.println("[BASE:FfsQ040Task] "+((Exception)e).getMessage());
			}
		}
	}
}
