package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ocb.dbbean.*;
import kal.base.ocb.ejb.OcbAllSL;
import kal.base.com.ejb.ComAllSL;

/**
 * Departure On Time Pcnt Detail I Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/28  
 */
public class OcbQ130Serv  extends PublicBaseServlet {
	/** 
	  * Departure On Time Pcnt Detail I Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/28  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		// ¥ ȸ
		String today = ComUtil.getInstance().selDbTime("YYYYMMDD","0");  			//UTC : 540/1440, KST : 0
		
		try {
			OcbQ130BG params = new OcbQ130BG();
			params.setToday(today);	
			
			//EJB LookUp
			OcbAllSL ocbSL = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = ocbSL.selOcbQ130Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Departure On Time Pcnt Detail I", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ130Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:OcbQ130Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
}
