package kal.base.rep.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.rep.dbbean.*;
import kal.base.rep.ejb.RepAllSL;


/**
 * IROPS Report 캯Ȳ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/23 HIST  
 */
public class RepQ040Serv extends PublicBaseServlet{
	/** 
	  *  IROPS Report 캯Ȳ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/23 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String reportD = StringUtil.checkString(box.getString("report_d"));				//ȸ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//ȸ Return
			
			//EJB LookUp
			RepAllSL sl = (RepAllSL)EJBFinder.lookup("ejb/RepAllSL");
			Hashtable hashData  = sl.selRepQ040Main(reportD);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("캯Ȳ", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:RepQ040Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:RepQ040Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
}//end of class
