package kal.base.sys.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.*;
import kal.base.sys.ejb.SysAllSL;

/**
 * BASE2 User Log On & Info ȸ / PSWD Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/04 HIST  
 */
public class SysA010Serv extends PublicBaseServlet{

	/** 
	  * BASE2 User Log On & Info ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/04 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String empNo = StringUtil.checkString(box.getString("emp_no"));					//User ID
		//String pswdNo = StringUtil.checkString(box.getString("pswd_no"));			//User Password
		String randomC = StringUtil.checkString(box.getString("random_c"));			//Random Code
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();

		try {
			// IP Check
			/*			
			String[] arrIP = StringUtil.convertIP(req.getRemoteAddr());
			boolean ipFlag = ComUtil.getInstance().selIpCheck(arrIP);
			if (!ipFlag) throw new Exception("[System Exception]  ܺλ Դϴ.");
			*/
			
			// session Ȯؼ  η ؼ ٷ main.jsp  ̰  ͵
			// ڱ session ִ  server ϱ  .
			// parameter  Ȯؼ  ʱ logiṉ  ش ƾ Ÿ main.jsp 
			//  login ؼ login.jsp .
			// ʱ login ƾ  randomC Ʋ ̰͵  ؼ Exception Ÿ login.jsp .
			
			// Session 翩
		    SysA010BG temp = (SysA010BG)session.getAttribute("USERINFO");
		    if (temp != null) {
		    	printJspPage(req, res, returnPage);
		    } else {
		    	if (randomC.equals("")) {
		    		Logger.debug.println("==================================================");
		    		Logger.debug.println("[BASE:SysA010Serv] Illegal ConnectionTry!!! - IP : "+req.getRemoteAddr());
		    		Logger.debug.println("==================================================");
		    		throw new Exception("Illegal ConnectionTry!!!");
		    	}
		    	
				//Parameter 
				SysA010BG params = new SysA010BG();
				params.setEmp_no(empNo);
				//params.setPswd_no(pswdNo);
				params.setRandom_c(randomC);
				params.setIp_n(req.getRemoteAddr()); //getRemoteAddr() Ŭ̾Ʈ ּҸ ˾Ƴ.
				params.setPc_n(req.getRemoteUser()); //getRemoteUser() ̿ ̵ ˾Ƴ.(⺻  )
				
				boolean newSession = session.isNew();
				
				//EJB LookUp
				SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			    SysA010BG entity = sl.selSysA010Main(params);
				
			    if (entity != null) {
			    	/*
			    	if (temp == null) {
			    		session.setAttribute("USERINFO",entity);
			    	} else {
			    		try{session.invalidate();}catch(Exception e){}
			    		//session.removeAttribute("USERINFO");
			    		
			    		session = req.getSession();
			    		session.setAttribute("USERINFO",entity);
			    	}
			    	*/
			    	session.setAttribute("USERINFO",entity);
			    } else {
			    	/*
			    	if (temp != null) {
						try{session.invalidate();}catch(Exception e){}
						//session.removeAttribute("USERINFO");
						//session = null;
			    	}
			    	*/
			    	throw new Exception("Invalid User ID or Password");
			    }
		    }
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA010Serv:selectTask] "+((RemoteException)e).getMessage());
				//printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().SIGN_URL,"select");
				printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().ERR_URL,"select");
			} else {
				Logger.debug.println("[BASE:SysA010Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				//printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().SIGN_URL,"select");
				printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().ERR_URL,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BASE2 User Log Out Main Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/06 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		String processFlag = StringUtil.checkString(box.getString("processFlag"));		//Return Page ȹ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			
			// Session 翩
		    SysA010BG params = (SysA010BG)session.getAttribute("USERINFO");
		    if (params != null) {
		    	//Logout 
		    	//EJB LookUp
				SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			    SysA010BG entity = sl.updSysA010Main(params);
			    req.setAttribute("empNo",entity.getEmp_no());
			    req.setAttribute("randomC",entity.getRandom_c());
			    req.setAttribute("processFlag",processFlag);
		    	//Session Invalidate
		    	try{session.invalidate();}catch(Exception e){}
		    } else {
		    	//Session Invalidate
		    	try{session.invalidate();}catch(Exception e){}
		    }
		    
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA010Serv:updateTask] "+((RemoteException)e).getMessage());
				//printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().SIGN_URL,"update");
				printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().ERR_URL,"select");
			} else {
				Logger.debug.println("[BASE:SysA010Serv:updateTask] "+((Exception)e).getMessage());
				//printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().SIGN_URL,"update");
				printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().ERR_URL,"select");
			}
		} 
	}//end of function	
	
	/** 
	  * BASE2 User Log Out Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/06 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Session Invalidate
	    	try{session.invalidate();}catch(Exception e){}
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA010Serv:checkTask] "+((RemoteException)e).getMessage());
				//printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().SIGN_URL,"check");
				printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().ERR_URL,"select");
			} else {
				Logger.debug.println("[BASE:SysA010Serv:checkTask] "+((Exception)e).getMessage());
				//printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().SIGN_URL,"check");
				printMessagePage2(req, res, e.getMessage(),MessageCode.getInstance().ERR_URL,"select");
			}
		} 
	}//end of function		
	
	/** 
	  * Random Code ԷServlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/12/21 
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String projectC = StringUtil.checkString(box.getString("projectC"));
		
		Random rd = new Random();
		String rndmCd = String.valueOf(rd.nextInt(999999999)).toString();
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			String returnValue = sl.updRndmCd(empNo, projectC, rndmCd);
			
			req.setAttribute("returnValue", returnValue);
			
			req.setAttribute("empNo", empNo);
			req.setAttribute("projectC", projectC);
			req.setAttribute("rndmCd", rndmCd);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA010Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SysA010Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask

}
