package kal.base.test.serv;

import java.io.IOException;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;
import java.util.Random;
import java.sql.*;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpSession;

import uk.ltd.getahead.dwr.ExecutionContext;
import uk.ltd.getahead.dwr.util.LocalUtil;

public class NoReleasedFltWatchDataMgr {
	
	public NoReleasedFltWatchDataMgr()throws Exception{
		create_flt();
		mapping_color();
	}
	
	private static final String SESSION_CLICKS = "sessionClicks";
	private static final String CONTEXT_CLICKS = "contextClicks";
	private static int nextId = 0;
	private final Map flts = new HashMap();
	private final Vector colorMapping = new Vector(); //Ϳ color  Ű  Ǵ ӽ  
	String[] randomColor = {"RED","AQUA","CYAN","DARKORANGE","DARKSALMON","CADETBLUE","FUCHSIA","GOLD","GOLDENROD","LIGHTPINK","LIGHTSALMON","KHAKI"}; 
	private String url = "jdbc:oracle:thin:@152.67.1.83:1521:opera";
	private String user="kfos";
	private String password="fosk2117";
	private Connection con;
	private Statement stmt;
	private ResultSet rs;
	private void create_flt() throws Exception{
		
		
		Class.forName("oracle.jdbc.driver.OracleDriver");
		con = DriverManager.getConnection(url,user,password);
		stmt = con.createStatement();
		
		rs = stmt.executeQuery("Select A.FLT_NUM,A.REG_NUM,A.SUB_AC_TYPE,A.STNFR,A.STNTO,TO_CHAR(A.EST_TM_DEPARTURE,'HH24:MI'), "+
			"TO_CHAR(A.EST_TM_ARRIVAL,'HH24:MI'),A.ALTER_STN,A.CONTIGENCY_NON_REFILE,A.CONTIGENCY_REFILE,A.CRUISE_MODE,A.ETOP_STNS, "+
			"A.REFILE_STN,A.TANKERING, B.TAG, B.COLOR  "+
			"FROM BK_FLTWATCH A,BK_FLTWATCH_ALERT B "+
			"WHERE A.FLT_NUM = B.FLT_NUM(+) AND A.REG_NUM = B.REG_NUM(+) order by flt_num");
		
		
		while(rs.next()){
			colorMapping.add(new NoReleasedFlt(rs.getString(1), rs.getString(2), rs.getString(3),rs.getString(4),rs.getString(5),
				rs.getString(6), rs.getString(7), rs.getString(8),rs.getInt(9),rs.getInt(10),rs.getInt(11),rs.getString(12),rs.getString(13),
				rs.getString(14),rs.getString(15),rs.getString(16)));		
		}   
		
		rs.close();			
	   stmt.close();
	   con.close();
		
		//colorMapping.add(new NoReleasedFlt("0001","HL7327","747","ICN","LAX","00:10","10:00","SFO", 350,700,950,"TAC,GKE,GOE,DIF","HWA","Y","RED","BLUE","YELLOW","RED","BLUE"));
		//colorMapping.add(new NoReleasedFlt("0002","HL7328","747","ICN","JFK","00:10","10:00","SFO",350,700,950,"TAC,GKE,GOE,DIF","HWA","Y","RED","BLUE","YELLOW","RED","BLUE"));
		//colorMapping.add(new NoReleasedFlt("0003","HL7329","747","ICN","LAS","00:10","10:00","SFO",350,700,950,"TAC,GKE,GOE,DIF","HWA","Y","RED","BLUE","YELLOW","RED","BLUE"));	
	}
	
	//create_flt()  vector ڷḦ ̾Ƴ color mapping Ŵ
	private void mapping_color(){
		NoReleasedFlt releasedFlt;
		String clr_flt_num= "WHITE";
		String clr_reg_num= "WHITE";
		String prv_flt_num ="0000"; //Ѱ flt   ٶ  ǥõǴ  ϱ ؼ 
		String clr_stnfr, clr_stnto, clr_est_tm_departure;
		String front_tag="<table><tr><td bgcolor=";
		String end_tag="</td></tr></table>";
		Random myRandom = new Random();
		
		//   
		for(int i=0; i<colorMapping.size();i++){
			releasedFlt = (NoReleasedFlt)colorMapping.elementAt(i); //Ϳ  ϳ 
			releasedFlt.setFlt_num(front_tag +/* releasedFlt.getColor_flt_num()*/randomColor[myRandom.nextInt(randomColor.length)]+">"+releasedFlt.getFlt_num()+end_tag);
			releasedFlt.setReg_num(front_tag+/*releasedFlt.getColor_reg_num()*/randomColor[myRandom.nextInt(randomColor.length)]+">"+releasedFlt.getReg_num() +end_tag);
			releasedFlt.setStnfr(front_tag+/*releasedFlt.getColor_stnfr()*/randomColor[myRandom.nextInt(randomColor.length)]+">"+releasedFlt.getStnfr()+end_tag);
			releasedFlt.setStnto(front_tag+/*releasedFlt.getColor_stnto()*/randomColor[myRandom.nextInt(randomColor.length)]+">"+releasedFlt.getStnto()+end_tag);
			releasedFlt.setEst_tm_departure(front_tag+/*releasedFlt.getColor_est_tm_departure()*/randomColor[myRandom.nextInt(randomColor.length)]+">"+releasedFlt.getEst_tm_departure()+end_tag);
			flts.put(new Integer(nextId),releasedFlt);
			nextId++;
			//System.out.println("vector read"+nextId);
		};
	}
	public Collection getAllFlts() throws Exception{
		flts.clear();
		colorMapping.clear();
		create_flt();
		mapping_color();
		return flts.values();
	}
	
	
}
