package kal.base.ffs.query;

import kal.base.ffs.dbbean.FfsQ110BG;


 /**
  * 20160301 ߰ 
  */   
public class FfsQ110Query {
	private static FfsQ110Query instance = new FfsQ110Query();
	
	public static FfsQ110Query getInstance() {
		return instance;
	}
	
	public String mgrAcarsDefault(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_SETTING_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' AND CAT = '" + params.getCat() + "') \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET SET_VALUE = '" + params.getSetValue() + "', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, CAT, SET_VALUE, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', '" + params.getCat() + "', '" + params.getSetValue() + "', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	
	public String mgrColumnDefault(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_SETTING_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' AND CAT = '" + params.getCat() + "') \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET SET_VALUE = '" + params.getSetValue() + "', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, CAT, SET_VALUE, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', '" + params.getCat() + "', '" + params.getSetValue() + "', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	
	public String selSetValue(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT CAT, SET_VALUE \n");
		sql.append("FROM KFOS.FFS_USER_SETTING_T \n");
		sql.append("WHERE STAFF_NUM = '" + params.getStaffNum() + "' \n");
		if("ACS".equals(params.getCat())) {
			sql.append("AND CAT = '" + params.getCat() + "' \n");
		} else {
			sql.append("AND CAT IN ('BRL','REL','ENR','LND') \n");
		}
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
}
