package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;

/**
 *  Fuel & Weight  ȸ/Է ȭ SQL 
 * @author Copyright (c) 2009/06/08  
 */   
public class FfsQ420Query {
	private static FfsQ420Query instance = new FfsQ420Query();
	
	public static FfsQ420Query getInstance() {
		return instance;
	}
	
	/** 
	  * Fuel & Weight  ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/06/08  
	  */
	public String selMain(FfsQ420BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, A.ARLN_CD, A.FLT_PLANNED, ");
		sql.append(" A.FLT_NUM, A.STNFR, A.STNTO, A.SACTYP, A.REGNO, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT,'HH24MI') STD, ");
		sql.append(" TO_CHAR(A.SCH_ARV_DT,'HH24MI') STA, ");
		//sql.append(" TO_CHAR(A.EST_DEP_DT,'HH24MI') ETD, "); 2009.06.16  : ETD, ETA, PFT
		sql.append(" NVL2(D.ABHR,TO_CHAR(A.EST_DEP_DT,'HH24MI'),'') ETD, ");
		//sql.append(" TO_CHAR(A.EST_ARV_DT,'HH24MI') ETA, ");
		//sql.append(" NVL2(D.ABHR,TO_CHAR(A.EST_DEP_DT+D.ABHR/1440,'HH24MI'),'') ETA, ");
		sql.append(" NVL2(D.ABHR,TO_CHAR(A.EST_ARV_DT, 'HH24MI'),'') ETA, ");//@2013-11-07		
		sql.append(" SUBSTR(TO_CHAR(FLOOR(((A.SCH_ARV_DT-A.SCH_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.SCH_ARV_DT-A.SCH_DEP_DT)*24*60,60),'00'),2,2) PBT, ");
		//sql.append(" SUBSTR(TO_CHAR(FLOOR(((A.EST_ARV_DT-A.EST_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.EST_ARV_DT-A.EST_DEP_DT)*24*60,60),'00'),2,2) PFT, ");
		sql.append(" NVL2(D.ABHR,TRIM(TO_CHAR(TRUNC(D.ABHR/60),'00'))||TRIM(TO_CHAR(MOD(D.ABHR,60),'00')),'') PFT, ");
		sql.append(" DECODE(A.DEP_STS,'ACT',TO_CHAR(A.ACT_DEP_DT,'HH24MI'),'') RO, A.TKOF_T, ");
		sql.append(" DECODE(A.ARV_STS,'ACT',TO_CHAR(A.ACT_ARV_DT,'HH24MI'),'') RI, A.LAND_T, ");
		sql.append(" DECODE(A.ARV_STS,'ACT',SUBSTR(TO_CHAR(FLOOR(((A.ACT_ARV_DT-A.ACT_DEP_DT)*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((A.ACT_ARV_DT-A.ACT_DEP_DT)*24*60,60),'00'),2,2),'') ABT, ");
		sql.append(" DECODE(A.LAND_T,NULL,'',CASE WHEN A.LAND_T < A.TKOF_T THEN SUBSTR(TO_CHAR(FLOOR(((TO_DATE(A.LAND_T,'hh24mi')+1-TO_DATE(A.TKOF_T,'HH24MI'))*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((TO_DATE(A.LAND_T,'HH24MI')+1-TO_DATE(A.TKOF_T,'HH24MI'))*24*60,60),'00'),2,2) ELSE SUBSTR(TO_CHAR(FLOOR(((TO_DATE(A.LAND_T,'hh24mi')-TO_DATE(A.TKOF_T,'HH24MI'))*24*60)/60),'00'),2,2)||SUBSTR(TO_CHAR(MOD((TO_DATE(A.LAND_T,'HH24MI')-TO_DATE(A.TKOF_T,'HH24MI'))*24*60,60),'00'),2,2) END) AFT, ");
		sql.append(" B.PLN_PLD, B.PLN_ZFW, B.PLN_TOW, B.PLN_RTOW, B.PLN_ACL, B.PLN_RAMP_FUEL, B.PLN_TKOF_FUEL, B.PLN_TRIP_FUEL, ");
		sql.append(" B.PLN_EXTR_FUEL1, B.PLN_EXTR_RSN1, B.PLN_EXTR_FUEL2, B.PLN_EXTR_RSN2, B.PLN_TANK_FUEL, B.PLN_FOD_FUEL, ");
		sql.append(" B.ACT_PLD, B.ACT_ZFW, B.ACT_TOW, B.ACT_RTOW, B.ACT_ACL, ");
		//sql.append(" C.OUT_FOB, C.OFF_FOB, C.ON_FOB, C.IN_FOB, "); 2009.08.11  : PE_ACARS_SKD_T .
		sql.append(" B.ACT_RAMP_FUEL, B.ACT_TKOF_FUEL, B.ACT_TRIP_FUEL, B.ACT_FOD_FUEL, ");
		sql.append(" B.SI_MSG ");
		//sql.append(" FROM DAILY_SCH_T A, FLT_FUEL_WT_T B, PE_ACARS_SKD_T C, FLIGHT_PLAN_T D "); 2009.08.11  : PE_ACARS_SKD_T .
		//sql.append(" FROM DAILY_SCH_T A, FLT_FUEL_WT_T B, FLIGHT_PLAN_T D "); 2009.10.19  : FLIGHT_PLAN_T DISTINCT 
		sql.append(" FROM DAILY_SCH_T A, FLT_FUEL_WT_T B, ");
		sql.append(" (SELECT DISTINCT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, ABHR ");
		sql.append(" FROM FLIGHT_PLAN_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPSchDepDt()+"','YYMMDD')-2 AND TO_DATE('"+params.getPSchDepDt()+"','YYMMDD') AND ");//2012.12.10 : -2αü
		sql.append(" ACTIVE = 'Y') D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPSchDepDt()+"','YYMMDD')-2 AND TO_DATE('"+params.getPSchDepDt()+"','YYMMDD') ");//2012.12.10 : -2αü
		sql.append(" AND TO_CHAR(A.SCH_DEP_DT,'YYMMDD')='"+params.getPSchDepDt()+"' ");
		sql.append(" AND A.FLT_NUM='"+params.getPFltNum()+"' "); 
		if (!params.getPStnfr().equals("")) {
			sql.append(" AND A.STNFR='"+params.getPStnfr()+"' "); 
		}
		if (!params.getPStnto().equals("")) {
			sql.append(" AND A.STNTO='"+params.getPStnto()+"' ");
		}
		sql.append(" AND NVL(A.DEP_STS,'') <> 'INI' "); //2009.07.24 ߰
		sql.append(" AND NVL(A.ACTNID,'') <> 'CNL' "); //2009.11.30 ߰
		sql.append(" AND NVL(A.REGNO,'') <> 'ZZZZZ' "); //2009.11.30 ߰
		sql.append(" AND A.FIRST_LEG_FLT_DT=B.FIRST_LEG_FLT_DT(+) AND A.FLT_NUM=B.FLT_NUM(+) AND A.STNFR=B.STNFR(+) AND A.STNTO=B.STNTO(+) ");
		//sql.append(" AND A.FIRST_LEG_FLT_DT=C.FIRST_LEG_FLT_DT(+) AND A.FLT_NUM=C.FLT_NUM(+) AND A.STNFR=C.STNFR(+) AND A.STNTO=C.STNTO(+) "); 2009.08.11  : PE_ACARS_SKD_T .
		sql.append(" AND A.FIRST_LEG_FLT_DT=D.FIRST_LEG_FLT_DT(+) AND A.FLT_NUM=D.FLT_NUM(+) AND A.STNFR=D.STNFR(+) AND A.STNTO=D.STNTO(+) ");
		//sql.append(" AND D.ACTIVE(+)='Y' "); 2009.10.19  :  ѹ ɷ.
		//sql.append(" AND C.GBN_X(+)='S' "); 2009.08.11  : PE_ACARS_SKD_T .
		
		//System.out.println("[BASE:FfsQ420Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ420Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Fuel & Weight  ȸ 2 : DAILY_SCH_T   ѹ  ȸ 
	  * @return String Query  
	  * @author Copyright (c) 2009/07/23  
	  */
	public String selMain2(FfsQ420BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" SELECT TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, B.ARLN_CD, '' FLT_PLANNED, ");
		sql.append(" B.FLT_NUM, B.STNFR, B.STNTO, A.SACTYP, A.REGNO, ");
		sql.append(" '' STD, '' STA, '' ETD, '' ETA, '' PBT, '' PFT, '' RO, '' TKOF_T, '' RI, '' LAND_T, '' ABT, '' AFT, ");
		sql.append(" B.PLN_PLD, B.PLN_ZFW, B.PLN_TOW, B.PLN_RTOW, B.PLN_ACL, B.PLN_RAMP_FUEL, B.PLN_TKOF_FUEL, B.PLN_TRIP_FUEL, ");
		sql.append(" B.PLN_EXTR_FUEL1, B.PLN_EXTR_RSN1, B.PLN_EXTR_FUEL2, B.PLN_EXTR_RSN2, B.PLN_TANK_FUEL, B.PLN_FOD_FUEL, ");
		sql.append(" B.ACT_PLD, B.ACT_ZFW, B.ACT_TOW, B.ACT_RTOW, B.ACT_ACL, ");
		//sql.append(" C.OUT_FOB, C.OFF_FOB, C.ON_FOB, C.IN_FOB, "); 2009.08.11  : PE_ACARS_SKD_T .
		sql.append(" B.ACT_RAMP_FUEL, B.ACT_TKOF_FUEL, B.ACT_TRIP_FUEL, B.ACT_FOD_FUEL, ");
		sql.append(" B.SI_MSG ");
		//sql.append(" FROM DAILY_SCH_T A, FLT_FUEL_WT_T B, PE_ACARS_SKD_T C "); 2009.08.11  : PE_ACARS_SKD_T .
		sql.append(" FROM DAILY_SCH_T A, FLT_FUEL_WT_T B ");
		sql.append(" WHERE B.FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPSchDepDt()+"','YYMMDD')-2 AND TO_DATE('"+params.getPSchDepDt()+"','YYMMDD') ");//2012.12.10 : -2 ü
		sql.append(" AND B.FIRST_LEG_FLT_DT=A.FIRST_LEG_FLT_DT(+) AND B.FLT_NUM=A.FLT_NUM(+) AND B.STNFR=A.STNFR(+) "); 
		sql.append(" AND TO_CHAR(A.SCH_DEP_DT,'YYMMDD')='"+params.getPSchDepDt()+"' ");
		sql.append(" AND NVL(A.DEP_STS(+),'') <> 'INI' "); //2009.07.24 ߰
		sql.append(" AND B.FLT_NUM='"+params.getPFltNum()+"' "); 
		if (!params.getPStnfr().equals("")) {
			sql.append(" AND B.STNFR='"+params.getPStnfr()+"' "); 
		}
		if (!params.getPStnto().equals("")) {
			sql.append(" AND B.STNTO='"+params.getPStnto()+"' ");
		}
		//2009.08.11  : PE_ACARS_SKD_T .
		//sql.append(" AND B.FIRST_LEG_FLT_DT=C.FIRST_LEG_FLT_DT(+) AND B.FLT_NUM=C.FLT_NUM(+) AND B.STNFR=C.STNFR(+) ");
		//sql.append(" AND C.GBN_X(+)='S' ");
		
		//System.out.println("[BASE:FfsQ420Query:selMain2] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ420Query:selMain2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_FUEL_WT_T ִ ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/06/11  
	  */
	public String selFuelWt(FfsQ420BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * ");
		sql.append(" FROM FLT_FUEL_WT_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND ARLN_CD = '"+params.getArlnCd()+"' ");
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getStnto()+"' ");
		
		//System.out.println("[BASE:FfsQ420Query:selFuelWt] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ420Query:selFuelWt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_FUEL_WT_T 
	  * @return String Query  
	  * @author Copyright (c) 2009/06/11  
	  */
	public String updFuelWt(FfsQ420BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLT_FUEL_WT_T "); 
		sql.append(" SET PLN_PLD = '"+params.getPlnPld()+"', ");
		sql.append(" PLN_ZFW = '"+params.getPlnZfw()+"', ");
		sql.append(" PLN_TOW = '"+params.getPlnTow()+"', ");
		sql.append(" PLN_RTOW = '"+params.getPlnRtow()+"', ");
		sql.append(" PLN_ACL = '"+params.getPlnAcl()+"', ");
		sql.append(" PLN_RAMP_FUEL = '"+params.getPlnRampFuel()+"', ");
		sql.append(" PLN_TKOF_FUEL = '"+params.getPlnTkofFuel()+"', ");
		sql.append(" PLN_TRIP_FUEL = '"+params.getPlnTripFuel()+"', ");
		sql.append(" PLN_EXTR_FUEL1 = '"+params.getPlnExtrFuel1()+"', ");
		sql.append(" PLN_EXTR_RSN1 = '"+params.getPlnExtrRsn1()+"', ");
		sql.append(" PLN_EXTR_FUEL2 = '"+params.getPlnExtrFuel2()+"', ");
		sql.append(" PLN_EXTR_RSN2 = '"+params.getPlnExtrRsn2()+"', ");
		sql.append(" PLN_TANK_FUEL = '"+params.getPlnTankFuel()+"', ");
		sql.append(" ACT_FOD_FUEL = '"+params.getActFodFuel()+"', "); //2009.08.11 ߰ : ACT_FOD_FUEL Է°
		sql.append(" SI_MSG = '"+params.getSiMsg()+"', ");
		sql.append(" TIMESTMP = SYSDATE, ");
		sql.append(" USERID = '"+params.getUserId()+"' ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND ARLN_CD = '"+params.getArlnCd()+"' ");
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getStnto()+"' ");
		
		//System.out.println("[BASE:FfsQ420Query:updFuelWt] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ420Query:updFuelWt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_FUEL_WT_T Է
	  * @return String Query  
	  * @author Copyright (c) 2009/06/11  
	  */
	public String insFuelWt(FfsQ420BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO FLT_FUEL_WT_T(FIRST_LEG_FLT_DT, ARLN_CD, FLT_NUM, STNFR, STNTO, ");
		sql.append(" PLN_PLD, PLN_ZFW, PLN_TOW, PLN_RTOW, PLN_ACL, ");
		sql.append(" PLN_RAMP_FUEL, PLN_TKOF_FUEL, PLN_TRIP_FUEL, "); 
		sql.append(" PLN_EXTR_FUEL1, PLN_EXTR_RSN1, PLN_EXTR_FUEL2, PLN_EXTR_RSN2, PLN_TANK_FUEL, ");
		sql.append(" ACT_FOD_FUEL, "); //2009.08.11 ߰ : ACT_FOD_FUEL Է°
		sql.append(" SI_MSG, TIMESTMP, USERID) ");
		sql.append(" VALUES ('"+params.getFirstLegFltDt()+"','"+params.getArlnCd()+"','"+params.getFltNum()+"','"+params.getStnfr()+"','"+params.getStnto()+"', ");
		sql.append(" '"+params.getPlnPld()+"','"+params.getPlnZfw()+"','"+params.getPlnTow()+"','"+params.getPlnRtow()+"','"+params.getPlnAcl()+"', ");
		sql.append(" '"+params.getPlnRampFuel()+"','"+params.getPlnTkofFuel()+"','"+params.getPlnTripFuel()+"', ");
		sql.append(" '"+params.getPlnExtrFuel1()+"','"+params.getPlnExtrRsn1()+"','"+params.getPlnExtrFuel2()+"','"+params.getPlnExtrRsn2()+"','"+params.getPlnTankFuel()+"', ");
		sql.append(" '"+params.getActFodFuel()+"', ");
		sql.append(" '"+params.getSiMsg()+"',SYSDATE,'"+params.getUserId()+"') ");
		
		//System.out.println("[BASE:FfsQ420Query:insFuelWt] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ420Query:insFuelWt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DAILY_SCH_T  ִ ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/07/23  
	  */
	public String selDailySchT(FfsQ420BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND ARLN_CD = '"+params.getArlnCd()+"' ");
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getStnto()+"' ");
		
		//System.out.println("[BASE:FfsQ420Query:selDailySchT] sql : "+sql.toString());
		Logger.debug.println("[BASE:FfsQ420Query:selDailySchT] sql : "+sql.toString());
		return sql.toString();
	}
}
