package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.com.query.*;
import kal.base.iro.dbbean.*;
import kal.base.iro.query.*;

  /**
   * Station Statistics SQL 
   * @author Copyright (c) 2005/12/20 
   */
public class IroQ220Query {
	private static IroQ220Query instance = new IroQ220Query();
	
	public static IroQ220Query getInstance() {
		return instance;
	}
	
	/** 
	  * Station Statistics main ȸ SQLԼ.
	  * @param entity IroQ220BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/12/20 
	  */
	public String selMain(IroQ220BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Stnfr, Count(*) Total,");
		sql.append(" Sum(Decode(Title_x,'DLA',1)) DLA, Sum(Decode(Title_x,'CHG',1)) CHG,");
		sql.append(" Sum(Decode(Title_x,'CNL',1)) CNL, Sum(Decode(Title_x,'RTR',1)) RTR,");
		sql.append(" Sum(Decode(Title_x,'DIV',1)) DIV, Sum(Decode(Title_x,'MLT',1)) MLT,");
		sql.append(" Sum(Decode(Title_x,'NEW',1)) NEW");
		sql.append(" From Irops_Sch_T");
		sql.append(" WHERE Timestamp >= TO_DATE('"+params.getFrdate()+" 000000', 'YYYYMMDD HH24MISS') ");
		sql.append(" And Timestamp <= TO_DATE('"+params.getTodate()+" 235959', 'YYYYMMDD HH24MISS') ");
		if (!params.getDiv().equals("")) {
			if (!params.getDiv().equals("1")) {
				sql.append(" And Region_Flt = '1'");
			}
			else {
				sql.append(" And Region_Flt <> '1'");
			}				
		}
		if (!params.getStn().equals("")) {
			sql.append(" And Stnfr = '"+params.getStn()+"'");
		}			
		sql.append(" And Complete_y = 'Y'");
		sql.append(" Group By  Stnfr");

		Logger.debug.println("[BASE:IroQ220Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
