package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.NotA110BG;

 /**
   * New NOTAM List SQL 
   * @author Copyright (c) 2007/08/21 
   */
public class NotA110Query {
	private static NotA110Query instance = new NotA110Query();
	
	public static NotA110Query getInstance() {
		return instance;
	}
	
	/** 
	  * NOTAM List ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selNOTAMList(NotA110BG params){
		StringBuffer sql = new StringBuffer();
		
		/*
		sql.append(" SELECT ");
		sql.append(" 	NOT_AMS_NUM, TO_CHAR(NOT_DTG,'YYYY/MM/DD HH24:MI') NOT_DTG, NOT_NUM, ICAO_PORT, ");
		sql.append(" 	NOT_TEXT, NOT_ISS_DT, NOT_EXP_DT, NOT_OPEN_Y, ");
		sql.append(" 	DECODE(NOT_OLD_CAT, 'C', NOT_OLD_CAT, NOT_INPUT) NOT_INPUT, USERID, NOT_TYP, "); //=> 2005.11.16  
		sql.append(" 	NOT_FIR, NOT_2ND_QCD||NOT_4TH_QCD NOT_QCD, NOT_TRAF, NOT_PURP, NOT_SCOP, ");
		sql.append(" 	NOT_LOW, NOT_UPP, NOT_LAT_LON, NOT_CAT, NOT_VALID, NOT_COMMNT, NOT_OLD_NUM, NOT_OLD_CAT, ");
		sql.append(" 	NOT_CLS, NOT_EXP_EST_Y, NOT_SIG_Y "); //2007.09.03 ߰ 
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ");
		sql.append(" 	NOT_DTG >= SYSDATE - (9 + "+params.getDtg_range()+")/24 "); //2007.03.27  : 2,4,6    ְ .
		//sql.append(" 	NOT_DTG >= SYSDATE-15/24 "); ==> 2006.02.08 
		//sql.append(" WHERE NOT_OPEN_Y IS NULL OR");
		//sql.append("     (NOT_OPEN_Y IS NOT NULL AND NOT_DTG >= SYSDATE-11/24)");
		//2005.08.22 -> 2ð ̳  6ð 
		//sql.append("     (NOT_OPEN_Y IS NOT NULL AND NOT_DTG >= SYSDATE-15/24)");
		//sql.append(" WHERE (NOT_OPEN_Y IS NULL OR NOT_OPEN_Y IS NOT NULL)");
		//sql.append(" AND NOT_CAT IN ('N','R','C','S')"); ==> 2005.08.22 
		sql.append(" ORDER BY NOT_DTG DESC, NOT_AMS_NUM DESC ");
		*/
		
		//2008.08.04  : NOT_REMARK ߰, BS_NOTAM_CARE_T ߰, ȸ  ߰(STN, DTG, STATUS)
		sql.append(" SELECT ");
		sql.append(" 	A.NOT_AMS_NUM, TO_CHAR(A.NOT_DTG,'YYYY/MM/DD HH24:MI') NOT_DTG, A.NOT_NUM, A.ICAO_PORT, ");
		sql.append(" 	A.NOT_TEXT, A.NOT_ISS_DT, A.NOT_EXP_DT, A.NOT_OPEN_Y, ");
		sql.append(" 	DECODE(A.NOT_OLD_CAT, 'C', A.NOT_OLD_CAT, A.NOT_INPUT) NOT_INPUT, A.USERID, A.NOT_TYP, "); //=> 2005.11.16  
		sql.append(" 	A.NOT_FIR, A.NOT_2ND_QCD||A.NOT_4TH_QCD NOT_QCD, A.NOT_TRAF, A.NOT_PURP, A.NOT_SCOP, ");
		sql.append(" 	A.NOT_LOW, A.NOT_UPP, A.NOT_LAT_LON, A.NOT_CAT, A.NOT_VALID, A.NOT_COMMNT, A.NOT_OLD_NUM, A.NOT_OLD_CAT, ");
		sql.append(" 	A.NOT_CLS, A.NOT_EXP_EST_Y, A.NOT_SIG_Y, "); //2007.09.03 ߰
		sql.append(" 	A.NOT_DAY_FR, A.NOT_DAY_TO, "); //2009.11.10 ߰
		sql.append("  A.NOT_REMARK, B.NOT_CARE_TYP, ");
		sql.append("  A.NOT_EMS_Y, ");//2011.08.17 ߰ 
		sql.append(" 	DECODE(B.NOT_CARE_TYP, '', DECODE(A.NOT_OLD_CAT, 'C', A.NOT_OLD_CAT, DECODE(A.NOT_OPEN_Y, 'Y', A.NOT_INPUT, 'D')), B.NOT_CARE_TYP) NOT_STATUS ");
		//20150319 ߰
		sql.append("    ,A.NOT_FOLLOW_Y ");
		sql.append(" FROM BS_NOTAM_T A, BS_NOTAM_CARE_T B ");
		sql.append(" WHERE ");
		sql.append("	A.ICAO_PORT = B.ICAO_PORT(+) ");
		sql.append("	AND A.NOT_NUM = B.NOT_NUM(+) ");
		
		if (params.getHid_rd_dtg().equals("R")) {
			sql.append(" 	AND A.NOT_DTG >= SYSDATE - (9 + "+params.getDtg_range()+")/24 "); //2007.03.27  : 2,4,6    ְ .
		} else if (params.getHid_rd_dtg().equals("S")) {
			sql.append(" AND A.NOT_DTG >= TO_DATE('"+params.getDtgFr()+"','YYMMDDHH24MI') ");
			sql.append(" AND A.NOT_DTG <= TO_DATE('"+params.getDtgTo()+"','YYMMDDHH24MI') ");
		} else if (params.getHid_rd_dtg().equals("F")) { //2008.08.11 ߰ : P-NOTAM, A-NOTAM ϶ ȸⰣ NOT_ISS_DT .
			sql.append(" AND A.NOT_ISS_DT BETWEEN '"+params.getDtgFr()+"' AND '"+params.getDtgTo()+"' ");
		}
		
		if (!params.getC_stn().equals("")) {
			sql.append(" 	AND A.ICAO_PORT = '"+params.getC_stn()+"' ");
		}
		
		if (params.getC_status().equals("C")) {
			sql.append(" 	AND B.NOT_CARE_TYP IS NULL ");
			sql.append(" 	AND A.NOT_OLD_CAT = 'C' ");
		} else if (params.getC_status().equals("M") || params.getC_status().equals("S") || params.getC_status().equals("F")) {
			sql.append(" 	AND B.NOT_CARE_TYP IS NULL ");
			sql.append(" 	AND A.NOT_OLD_CAT <> 'C' ");
			sql.append(" 	AND A.NOT_OPEN_Y = 'Y' ");
			sql.append(" 	AND A.NOT_INPUT = '"+params.getC_status()+"' ");
		//20150320 
		//} else if (params.getC_status().equals("A") || params.getC_status().equals("P")||params.getC_status().equals("E")) {
		} else if (params.getC_status().equals("A") || params.getC_status().equals("P")||params.getC_status().equals("T")||params.getC_status().equals("J")) {//@2017-07-03
			sql.append(" 	AND B.NOT_CARE_TYP = '"+params.getC_status()+"' ");
		} else if (params.getC_status().equals("D")) {
			sql.append(" 	AND B.NOT_CARE_TYP IS NULL ");
			//sql.append(" 	AND A.NOT_OLD_CAT <> 'C' ");
			sql.append(" 	AND A.NOT_OPEN_Y = 'N' ");
		}
		
		//20150318 ߰
		if (!"".equals(params.getS_text())) {
			//20150415 
			//sql.append(" 	AND A.NOT_TEXT LIKE '%"+params.getS_text()+"%' ");
			sql.append(" 	AND A.NOT_TEXT LIKE '%"+params.getS_text().toUpperCase()+"%' ");
		}
		
		//20150324 ߰
		if ("Y".equals(params.getIs_history())) {
			//20150415 
			//sql.append(" 	AND NVL(A.NOT_FOLLOW_Y, 'N') IN ('F', 'C') ");
			sql.append(" 	AND NVL(A.NOT_FOLLOW_Y, 'N') IN ('F', 'C', 'A') ");
		}
		//@2017-07-21
		if(params.getPageId()==null || !"NotA180UI".equals(params.getPageId())){//NotA180UI ƴѰ T-NOTAM شϴ Ʈ Ѵ
			sql.append("    AND A.NOT_INPUT <> 'T' ");
		}

		
		//20150318  !"Y".equals(params.getS_sort())
		//if (params.getHid_rd_dtg().equals("R") || params.getHid_rd_dtg().equals("S")) {
		if (!"Y".equals(params.getS_sort()) && (params.getHid_rd_dtg().equals("R") || params.getHid_rd_dtg().equals("S"))) {
			sql.append(" ORDER BY A.NOT_DTG DESC, A.NOT_AMS_NUM DESC ");
		} else {
			sql.append(" ORDER BY A.NOT_ISS_DT ASC "); //2008.08.11 ߰
		}
		
		Logger.debug.println("[BASE:NotA110Query:selNOTAMList] sql : "+sql.toString());
		System.out.println("[BASE:NotA110Query:selNOTAMList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Detail ȸ SQLԼ. -- 
	  * @param params NotA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selNOTAMDetail(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT 	NOT_FIR,NOT_2ND_QCD||NOT_4TH_QCD NOT_QCD,NOT_TRAF,NOT_PURP,");
		sql.append("        		NOT_SCOP,NOT_LOW,NOT_UPP,NOT_LAT_LON,");
		sql.append("        		NOT_NUM,NOT_CAT,NOT_OLD_NUM,ICAO_PORT,NOT_ISS_DT,");
		sql.append("        		NOT_EXP_DT,NOT_OPEN_Y,NOT_VALID,NOT_TEXT,NOT_COMMNT");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		Logger.debug.println("[BASE:NotA110Query:selNOTAMDetail] sql : "+sql.toString());
		return sql.toString();
	}	
		
	/** 
	  * NOTAM FIR ȸ SQLԼ.
	  * @param params NotA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selFirCd(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE FIR_CD = '"+params.getNot_fir()+"'");

		Logger.debug.println("[BASE:NotA110Query:selFirCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Q-Code ȸ SQLԼ.
	  * @param params NotA110BG ȸ
	  * @param qSeq int 1,2
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selQCd(NotA110BG params, int qSeq){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NOT_CLS, NOT_QCD FROM BS_NOTAM_QCD_T ");
		if (qSeq == 1)
			sql.append(" WHERE NOT_QSEQ = 2 AND NOT_QCD = '"+(params.getNot_qcd()).substring(0,2)+"'");
		else 
			sql.append(" WHERE NOT_QSEQ = 4 AND NOT_QCD = '"+(params.getNot_qcd()).substring(2)+"'");

		Logger.debug.println("[BASE:NotA110Query:selQCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM  SQLԼ.
	  * @param params NotA110BG 
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String updNOTAM(NotA110BG params){
		StringBuffer sql = new StringBuffer();
		/*if (!params.getNot_qcd().equals("")) {
			params.setNot_qcd1((params.getNot_qcd()).substring(0,2));
			params.setNot_qcd2((params.getNot_qcd()).substring(2));
		} else {
			params.setNot_qcd1("");
			params.setNot_qcd2("");
		}*/
		if ("".equals(params.getNot_qcd())) {//2018-03-06
			params.setNot_qcd1("");
			params.setNot_qcd2("");			
		} else {
			params.setNot_qcd1((params.getNot_qcd()).substring(0,2));
			params.setNot_qcd2((params.getNot_qcd()).substring(2));
		}
		
		//Logger.debug.println("[BASE:updNOTAM] not_cat : "+params.getNot_cat());

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_FIR = '"+params.getNot_fir()+"',");
		sql.append("     	NOT_CLS = '"+params.getNot_cls()+"',");
		sql.append("     	NOT_2ND_QCD = '"+params.getNot_qcd1()+"',");
		sql.append("     	NOT_4TH_QCD = '"+params.getNot_qcd2()+"',");
		sql.append("     	NOT_TRAF = '"+params.getNot_traf()+"',");
		sql.append("     	NOT_PURP = '"+params.getNot_purp()+"',");
		sql.append("     	NOT_SCOP = '"+params.getNot_scop()+"',");
		sql.append("     	NOT_LOW = '"+params.getNot_low()+"',");
		sql.append("     	NOT_UPP = '"+params.getNot_upp()+"',");
		sql.append("     	NOT_LAT_LON = '"+params.getNot_lat_lon()+"',");
		
		if ((params.getNot_iss_dt()).equals("WIE")) {
			sql.append("     NOT_ISS_DT = TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'),");
		} else {
			sql.append("     NOT_ISS_DT = '"+params.getNot_iss_dt()+"',");
		}
		
		// 2005.11.14 
		if ((params.getNot_typ()).equals("S") && (params.getNot_exp_dt()).equals("PERM")) {
			if ((params.getNot_iss_dt()).equals("WIE")) {
				sql.append("  NOT_EXP_DT = TO_CHAR(SYSDATE+15/24,'YYMMDDHH24MI'),");
			} else {
				sql.append("	NOT_EXP_DT = TO_CHAR(TO_DATE('"+params.getNot_iss_dt()+"','YYMMDDHH24MI')+24/24,'YYMMDDHH24MI'),");
			}
		} else {
			sql.append("		NOT_EXP_DT = '"+params.getNot_exp_dt()+"',");
		}
		
		sql.append("     	NOT_VALID = '"+StringUtil.DBInsStr(params.getNot_valid())+"',");
		sql.append("     	NOT_TEXT = '"+StringUtil.DBInsStr(params.getNot_text())+"',");
		sql.append("     	NOT_COMMNT = '"+StringUtil.DBInsStr(params.getNot_commnt())+"',");
		sql.append("     	NOT_EXP_EST_Y = '"+params.getNot_exp_est()+"',"); //2007.09.06 ߰
		sql.append("     	NOT_SIG_Y = '"+params.getNot_sig()+"',"); 				//2007.09.06 ߰
		sql.append("     	NOT_DAY_FR = '"+params.getNot_day_fr()+"',"); 			//2009.11.09 ߰
		sql.append("     	NOT_DAY_TO = '"+params.getNot_day_to()+"',"); 		//2009.11.09 ߰
		sql.append("     	NOT_OLD_NUM = '"+params.getNot_old_num()+"',");
		sql.append("		NOT_OLD_CAT = '"+params.getNot_cat()+"',"); //2005.08.05 NOT OLD CAT 
		sql.append("     	NOT_REMARK = '"+StringUtil.DBInsStr(params.getNot_remarks())+"',"); //2008.08.06 ߰
		sql.append("     	NOT_OPEN_Y = '"+StringUtil.checkString(params.getNot_open_y())+"',");
		sql.append("     	NOT_INPUT = '"+params.getNot_input()+"',"); //2008.08.06  : NOT_INPUT = 'M' -> Է
		sql.append("     	NOT_EMS_Y = '"+params.getNot_ems()+"',"); //2011.08.18 ߰ 
		//20150319 ߰
		sql.append("     	NOT_FOLLOW_Y = '"+params.getNot_follow()+"',");
		sql.append("     	TIMESTMP = SYSDATE,");
		if (!StringUtil.checkString(params.getNot_typ()).equals("")) {
			sql.append("		NOT_TYP = '"+params.getNot_typ()+"',");
		}
		sql.append("     	USERID = '"+params.getUserid()+"'");
		
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNOTAM] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM  SQLԼ.
	  * @param params NotA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String delNOTAMItem(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		Logger.debug.println("[BASE:NotA110Query:delNOTAMItem] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM List Old NOTAM ȸSQLԼ.
	  * @param icaoPort String ICAO STN
	  * @param notNum String Old NOTAM Number
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selOldNOTAM(String icaoPort, String notNum){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT,IATA_PORT,NOT_NUM,NOT_ISS_DT,NOT_EXP_DT,NOT_VALID,NOT_TEXT,NOT_CLS,NOT_PREV_EXP_DT,NOT_MARK_Y,NOT_CAT,NOT_MARK_NUM");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" AND NOT_NUM = '"+notNum+"'");

		Logger.debug.println("[BASE:NotA110Query:selOldNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Code Search Q-Code ȸSQLԼ.
	  * @param notQcd1 String Q-Code 1
	  * @param notQcd2 String Q-Code 2
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selQCode(String notQcd1, String notQcd2){
		StringBuffer sql = new StringBuffer();
		
		if (!"".equals(notQcd1)) {//2018-03-06 if (!notQcd1.equals("")) {
			sql.append(" SELECT 'Q23' NOT_QSEQ, NOT_CLS, NOT_QCD, NOT_SIGN, NOT_ABBR");
			sql.append(" FROM BS_NOTAM_QCD_T");
			sql.append(" WHERE NOT_QCD = '"+notQcd1+"'");
			sql.append(" 	AND NOT_QSEQ = 2");
		}
		if (!"".equals(notQcd1) && !"".equals(notQcd2)) {//2018-03-06if (!notQcd1.equals("") && !notQcd2.equals("")) {
			sql.append(" UNION");
		}
		if (!"".equals(notQcd2)) {//2018-03-06if (!notQcd2.equals("")) {
			sql.append(" SELECT 'Q45' NOT_QSEQ, NOT_CLS, NOT_QCD, NOT_SIGN, NOT_ABBR");
			sql.append(" FROM BS_NOTAM_QCD_T");
			sql.append(" WHERE NOT_QCD = '"+notQcd2+"'");
			sql.append(" 	AND NOT_QSEQ = 4");
		}
		
		Logger.debug.println("[BASE:NotA110Query:selQCode] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Code Search ABBR Code ȸSQLԼ.
	  * @param abbrCd String ABBR Code
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selABBRCd(String abbrCd){
		StringBuffer sql = new StringBuffer();
		
			sql.append(" SELECT ABBR_CD, ORGN_CD, SIGN");
			sql.append(" FROM BS_ABBR_T");
			sql.append(" WHERE ABBR_CD = '"+abbrCd+"'");
			sql.append(" ORDER BY ORGN_CD");
		
		Logger.debug.println("[BASE:NotA110Query:selABBRCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Old NOTAM PORT ȸSQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selPORT(String icaoPort){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.PORT_E, B.NATION_ENG_N");
		sql.append(" FROM CM_PORT_T A, NATION_T B");
		sql.append(" WHERE A.CTRY_CD = B.NATION_C");
		sql.append(" AND A.ICAO_PORT = '"+icaoPort+"'");
		
		Logger.debug.println("[BASE:NotA110Query:selPORT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM IATA PORT ȸSQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selIATAPort(String icaoPort){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT");
		sql.append(" FROM CM_PORT_T");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		
		Logger.debug.println("[BASE:NotA110Query:selIATAPort] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Old NOTAM FIR ȸSQLԼ.
	  * @param firCd String FIR Code
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selFIR(String firCd){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.FIR_CD,A.FIR_E,B.NATION_ENG_N");
		sql.append(" FROM BS_FIR_T A, NATION_T B");
		sql.append(" WHERE A.NAT_CD = B.NATION_C(+)");
		sql.append(" AND A.FIR_CD = '"+firCd+"'");
		
		Logger.debug.println("[BASE:NotA110Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM NOT ACTIVE 'Y' STN ȸSQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selNotActive(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T WHERE NOT_ACTIVE = 'Y'");
		sql.append(" UNION");
		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE NOT_ACTIVE = 'Y'");
		
		Logger.debug.println("[BASE:NotA110Query:selNotActive] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM LOG  SQLԼ.
	  * @param params NotA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String delNOTAMLog(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_NOTAM_LOG_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		Logger.debug.println("[BASE:NotA110Query:delNOTAMLog] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  *   Q-Code, Category ȸ
	  * @param params NotA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/12/11 
	  */
	public String selPrevQ2cdCls(NotA110BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NOT_2ND_QCD, NOT_CLS ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"' ");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_num()+"' ");
		
		Logger.debug.println("[BASE:NotA110Query:selPrevQ2cdCls] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * CODE_T  COAD NOT_NUM ȸϱ
	  * @return String Query 
	  * @author Copyright (c) 2008/01/25 
	  */
	public String selCoadNotNum(String icao_port) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	DECODE(DESC_E, TO_CHAR(SYSDATE, 'YY'), DESC_E, TO_CHAR(SYSDATE, 'YY')) YY, ");
		sql.append(" 	DECODE(DESC_E, TO_CHAR(SYSDATE, 'YY'), TO_CHAR(PRTY_NO+1, '00'), '01') SEQ ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '9' ");
		sql.append(" 	AND CODE_X = 'NOTAM COADZ' ");
		sql.append(" 	AND CODE_C = '"+icao_port+"' ");

		Logger.debug.println("[BASE:NotA110Query:selCoadNotNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * YY ȸ.
	  * @return String Query 
	  * @author Copyright (c) 2008/01/25 
	  */
	public String selYY() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE, 'YY') YY FROM DUAL ");

		Logger.debug.println("[BASE:NotA110Query:selYY] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CODE_T COAD NOT_NUM .
	  * @param mode String ȸ
	  * @param params NotA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/01/25 
	  */
	public String updCoadNotNum(String codeC, String descE, String prtyNo) {
		StringBuffer sql = new StringBuffer();
			
		sql.append(" UPDATE CODE_T SET ");
		sql.append(" 	DESC_E = '"+descE+"', ");
		sql.append(" 	PRTY_NO = "+prtyNo+" ");
		sql.append(" WHERE STEP_X = '9' ");
		sql.append(" 	AND CODE_X = 'NOTAM COADZ' ");
		sql.append(" 	AND CODE_C = '"+codeC+"' ");

		Logger.debug.println("[BASE:NotA110Query:updCoadNotNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CODE_T COAD  Է.
	  * @return String Query 
	  * @author Copyright (c) 2008/01/25 
	  */
	public String insCoadNotNum(String codeC, String descE, String prtyNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO CODE_T ");
		sql.append(" VALUES ('9', 'NOTAM COADZ', '"+codeC+"', '"+descE+"', "+prtyNo+", '', '', '', '') ");
		
		Logger.debug.println("[BASE:NotA110Query:insCoadNotNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CODE_T COAD  ִ ȸ.
	  * @return String Query 
	  * @author Copyright (c) 2008/01/25 
	  */
	public String selCoadIcaoPort(String icao_port) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT CODE_C, DESC_E, PRTY_NO ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '9' ");
		sql.append(" 	AND CODE_X = 'NOTAM COADZ' ");
		sql.append(" 	AND CODE_C = '"+icao_port+"' ");

		Logger.debug.println("[BASE:NotA110Query:selCoadIcaoPort] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_CARE_T  NOTAM Է.
	  * @return String Query 
	  * @author Copyright (c) 2008/08/06 
	  */
	public String insNotCareT(NotA110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_CARE_T ( ");
		sql.append(" ICAO_PORT, NOT_NUM, NOT_CARE_TYP, TIMESTMP, USERID) ");
		sql.append(" VALUES ('"+params.getIcao_port()+"', '"+params.getNot_num()+"', '"+params.getNot_input()+"', SYSDATE, '"+params.getUserid()+"') ");

		System.out.println("[BASE:NotA110Query:insNotCareT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_CARE_T  NOTAM .
	  * @return String Query 
	  * @author Copyright (c) 2008/08/06 
	  */
	public String updNotCareT(NotA110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_CARE_T ");
		sql.append(" SET NOT_CARE_TYP = '"+params.getNot_input()+"', ");
		sql.append("     	TIMESTMP = SYSDATE, ");
		sql.append("     	USERID = '"+params.getUserid()+"' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 		AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotCareT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_CARE_T  NOTAM .
	  * @return String Query 
	  * @author Copyright (c) 2008/08/06 
	  */
	/*public String delNotCareT(NotA110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM BS_NOTAM_CARE_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 		AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:delNotCareT] sql : "+sql.toString());
		return sql.toString();
	}*/
	public String delNotCareT(String icao_port, String not_num) { //2008.12.10 
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM BS_NOTAM_CARE_T ");
		sql.append(" WHERE ICAO_PORT = '"+icao_port+"' ");
		sql.append(" 		AND NOT_NUM = '"+not_num+"' ");

		System.out.println("[BASE:NotA110Query:delNotCareT] sql : "+sql.toString());
		return sql.toString();
	}
	public String delNotCareT(String icao_port, String not_num, String not_care_typ) {//@2017-07-11
		StringBuffer sql = new StringBuffer();
		
		sql.append("	DELETE FROM BS_NOTAM_CARE_T");
		sql.append("	WHERE");
		sql.append("		ICAO_PORT = '"+icao_port+"' ");
		sql.append("	AND	NOT_NUM	= '"+not_num+"' ");
		sql.append("	AND	NOT_CARE_TYP	= '"+not_care_typ+"' ");	

		System.out.println("[BASE:NotA110Query:delNotCareT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150320 ߰
	  * multi update
	  */
	public String updNOTAM_notam_input(NotA110BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET 	NOT_OPEN_Y = '"+params.getNot_open_y()+"',");
		sql.append("     	NOT_INPUT = '"+params.getNot_input()+"',"); //2008.08.06  : NOT_INPUT = 'M' -> Է
		sql.append("     	NOT_EMS_Y = '"+params.getNot_ems()+"',"); //2011.08.18 ߰ 
		sql.append("     	NOT_FOLLOW_Y  = '"+params.getNot_follow()+"',");//@2018-02-22
		sql.append("     	TIMESTMP = SYSDATE,");
		sql.append("     	USERID = '"+params.getUserid()+"'");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNOTAM_notam_input] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNOTAM_notam_input] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150324 ߰
	  * notam history
	  */
	public String selNotamHistoryList(NotA110BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	A.NOT_AMS_NUM, TO_CHAR(A.NOT_DTG,'YYYY/MM/DD HH24:MI') NOT_DTG, A.NOT_NUM, A.ICAO_PORT, ");
		sql.append(" 	A.NOT_TEXT, A.NOT_ISS_DT, A.NOT_EXP_DT, A.NOT_OPEN_Y, ");
		sql.append(" 	DECODE(A.NOT_OLD_CAT, 'C', A.NOT_OLD_CAT, A.NOT_INPUT) NOT_INPUT, A.USERID, A.NOT_TYP, "); 
		sql.append(" 	A.NOT_FIR, A.NOT_2ND_QCD||A.NOT_4TH_QCD NOT_QCD, A.NOT_TRAF, A.NOT_PURP, A.NOT_SCOP, ");
		sql.append(" 	A.NOT_LOW, A.NOT_UPP, A.NOT_LAT_LON, A.NOT_CAT, A.NOT_VALID, A.NOT_COMMNT, A.NOT_OLD_NUM, A.NOT_OLD_CAT, ");
		sql.append(" 	A.NOT_CLS, A.NOT_EXP_EST_Y, A.NOT_SIG_Y, ");
		sql.append(" 	A.NOT_DAY_FR, A.NOT_DAY_TO, ");
		sql.append("  A.NOT_REMARK, B.NOT_CARE_TYP, ");
		sql.append("  A.NOT_EMS_Y, ");
		sql.append(" 	DECODE(B.NOT_CARE_TYP, '', DECODE(A.NOT_OLD_CAT, 'C', A.NOT_OLD_CAT, DECODE(A.NOT_OPEN_Y, 'Y', A.NOT_INPUT, 'D')), B.NOT_CARE_TYP) NOT_STATUS ");
		sql.append("    ,A.NOT_FOLLOW_Y ");
		sql.append("    ,C.OLD_NOT_NUM SUB_NOT_OLD_NUM ");
		sql.append(" FROM BS_NOTAM_T A, BS_NOTAM_CARE_T B, ( ");
		sql.append(" 		SELECT NOT_NUM, OLD_NOT_NUM ");
		sql.append(" 		FROM BS_NOTAM_FUP_T ");
		sql.append(" 		WHERE ICAO_PORT = '" + params.getIcao_port() + "' ");
		sql.append(" 		AND OLD_NOT_NUM = '" + params.getNot_num() + "' ");
		sql.append(" 		AND DEL_Y <> 'Y' ");
		sql.append(" 	  ) C ");
		sql.append(" WHERE ");
		sql.append("	A.ICAO_PORT = '" + params.getIcao_port() + "' ");
		sql.append("	AND A.NOT_NUM = C.NOT_NUM ");
		sql.append("	AND A.ICAO_PORT = B.ICAO_PORT(+) ");
		sql.append("	AND A.NOT_NUM = B.NOT_NUM(+) ");
		
		sql.append(" ORDER BY A.NOT_ISS_DT ASC ");
		
		Logger.debug.println("[BASE:NotA110Query:selNotamHistoryList] sql : "+sql.toString());
		System.out.println("[BASE:NotA110Query:selNotamHistoryList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150324 ߰
	  * notam history
	  */
	public String updNotamConfirm(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_FOLLOW_Y = 'F' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamConfirm] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamConfirm] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150324 ߰
	  * notam history
	  */
	public String updNotamDelete(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T ");
		sql.append(" SET NOT_FOLLOW_Y = '' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamDelete] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamDelete] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * 20150324 ߰
	  * notam history
	  */
	public String updNotamSubDelete(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_FUP_T ");
		sql.append(" SET DEL_Y = 'Y' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");
		sql.append(" AND OLD_NOT_NUM = '"+params.getSub_not_old_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamSubDelete] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamSubDelete] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150415 ߰
	  * notam history
	  */
	public String updNotamConfirmC(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_FOLLOW_Y = 'A' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getParent_icao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getParent_not_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamConfirmC] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamConfirmC] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * 20150415 ߰
	  * notam history
	  */
	public String updNotamConfirmRN(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_FOLLOW_Y = '' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getParent_icao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getParent_not_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamConfirmRN] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamConfirmRN] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * 20150415 ߰
	  * notam history
	  */
	public String updNotamConfirmSubRN(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_FOLLOW_Y = 'F' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamConfirmSubRN] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamConfirmSubRN] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * 20150415 ߰
	  * notam history
	  */
	public String updNotamDeleteC(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T ");
		sql.append(" SET NOT_FOLLOW_Y = '' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getParent_icao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getParent_not_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamDeleteC] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamDeleteC] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * 20150415 ߰
	  * notam history
	  */
	public String updNotamDeleteSubC(NotA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_FUP_T ");
		sql.append(" SET DEL_Y = 'Y' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");
		sql.append(" AND OLD_NOT_NUM = '"+params.getSub_not_old_num()+"'");

		System.out.println("[BASE:NotA110Query:updNotamDeleteSubC] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNotamDeleteSubC] sql : "+sql.toString());
		return sql.toString();
	}
}
