package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.NotA150BG;

 /**
   * New NOTAM Tracing SQL 
   * @author Copyright (c) 2007/08/21 
   */
public class NotA150Query {
	private static NotA150Query instance = new NotA150Query();
	
	public static NotA150Query getInstance() {
		return instance;
	}
	
	public String selArea(){
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT AREA_CD,AREA_STN FROM BS_AREA_T WHERE AREA_CD LIKE '%NOTAM%' ");
		
		Logger.debug.println("[BASE:NotA150Query:selArea] sql : "+sql.toString());
		return sql.toString();
	
	}
	
	public String selNotamTracing(NotA150BG params){
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT ICAO_PORT, DECODE(NOT_TYP, 'N', 'NOTAM', 'COADZ') AS NOT_TYP, ");
		sql.append(" 	NOT_NUM, NOT_ISS_DT, NOT_EXP_DT, NOT_TEXT, NOT_EXP_EST_Y ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT IN ("+ params.getCat_Area_Value() +") ");
		sql.append(" 	AND NOT_CAT IN ('N', 'R') ");
		sql.append(" 	AND NOT_TYP IN ('N', 'C', 'I') ");

		//sql.append(" 	AND ((NOT_EXP_DT IN ('PERM', 'UFN') ");
		//sql.append(" 	AND NOT_ISS_DT <= '"+ params.getStart_date2() +"'||'2359') OR ");
		//sql.append(" 	(NOT_EXP_DT BETWEEN '"+ params.getStart_date() +"'||'0000' AND '"+ params.getEnd_date() +"'||'2359' AND NOT_EXP_EST_Y='Y')) ");
		//2007.12.28 
		sql.append(" 	AND NOT_ISS_DT <= '"+ params.getEnd_date() +"'||'2359' ");
		sql.append(" 	AND (NOT_EXP_DT IN ('PERM', 'UFN') OR NOT_EXP_DT >= '"+ params.getStart_date() +"'||'0000') ");
		sql.append(" 	AND NOT_OPEN_Y = 'Y' ");
		
		sql.append(" ORDER BY ICAO_PORT, NOT_DTG DESC ");
		
		Logger.debug.println("[BASE:NotA150Query:selNotamTracing] sql : "+sql.toString());
		return sql.toString();
		
	}
	
	public String selicao(String port){
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		sql.append(" WHERE ICAO_PORT = '"+port+"' OR IATA_PORT ='"+port+"'");
		
		Logger.debug.println("[BASE:NotA150Query:selicao] sql : "+sql.toString());
		return sql.toString();
				
	}
	
	public String selFirCD(String port){
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT FIR_CD FROM BS_FIR_T");
		sql.append(" WHERE FIR_CD ='"+ port +"'");
		
		Logger.debug.println("[BASE:NotA150Query:selFirCD] sql : "+sql.toString());
		return sql.toString();
				
	}
}

