package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.RepQ030BG;
import kal.base.com.query.*;

 /**
   * 簡ð SQL 
   * @author Copyright (c) 2005/02/25 
   */  
public class RepQ030Query {
	private static RepQ030Query instance = new RepQ030Query();
	
	public static RepQ030Query getInstance() {
		return instance;
	}
	/** 
	  * 簡ð ȸ SQLԼ.
	  * @param entity RepQ030BG ׽
	  * @return String Query 
	  * @author Copyright (c) 2005/02/25 
	  */
	public String selUtilTime(RepQ030BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Code_c1,'C', 'B','A') a_b, Code_c3 ACTYP, ");
		sql.append(" 	 Sum(Decode(Report_d,'"+entity.getReport_d()+"',Decode(Code_c2,'A', Flt_q1,'0'),'0')) a_plan,   ");
		sql.append(" 	 Sum(Decode(Report_d,'"+entity.getReport_d()+"',Decode(Code_c2,'A', Flt_q2,'0'),'0')) a_actual,");
		sql.append(" 	 Sum(Decode(Report_d, To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'),Decode(Code_c2,'A', Flt_q2,'0'),'0')) a_past, "); 		  
		sql.append(" 	 Sum(Decode(Report_d,'"+entity.getReport_d()+"',Decode(Code_c2,'B', Flt_q1,'0'),'0')) b_plan,   ");
		sql.append(" 	 Sum(Decode(Report_d,'"+entity.getReport_d()+"',Decode(Code_c2,'B', Flt_q2,'0'),'0')) b_actual, ");
		sql.append(" 	 Sum(Decode(Report_d, To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'),Decode(Code_c2,'B', Flt_q2,'0'),'0')) b_past, "); 	  
		sql.append(" 	 Sum(Decode(Report_d,'"+entity.getReport_d()+"',Decode(Code_c2,'C', Flt_q1,'0'),'0')) c_plan,   ");
		sql.append(" 	 Sum(Decode(Report_d,'"+entity.getReport_d()+"',Decode(Code_c2,'C', Flt_q2,'0'),'0')) c_actual, "); 
		sql.append(" 	 Sum(Decode(Report_d, To_Char(To_Date('"+entity.getReport_d()+"01"+"','yyyymmdd')-365,'yyyymm'),Decode(Code_c2,'C', Flt_q2,'0'),'0')) c_past  "); 
		sql.append("  From Ops_Report_T    ");
		sql.append("  Where  Report_x = 'E'    ");
		sql.append("  Group By  Code_c1, Code_c3   ");
		sql.append("  Order By  Code_c1 Desc, Code_c3  ");
		
		Logger.debug.println("[BASE:RepQ030Query:selUtilTime] sql : "+sql.toString());
		return sql.toString();
	}
}
