package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.*;

 /**
   * HUB Station Info Detail SQL 
   * @author Copyright (c) 2007/10/08  
   */    
public class SkdQ060Query {
	private static SkdQ060Query instance = new SkdQ060Query();
	
	public static SkdQ060Query getInstance() {
		return instance;
	}
	
	/** 
	  * FLT INFO - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/08  
	  */
	public String selFltInfoKE(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		/*
		sql.append(" SELECT KACTYP, ACVER, REGNO, ");
		sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', SCH_DEP_DT_LOC, SCH_ARV_DT_LOC), 'HH24:MI') SCH, ");
		sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', EST_DEP_DT_LOC, EST_ARV_DT_LOC), 'HH24:MI') EST, ");
		sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', ACT_DEP_DT_LOC, ACT_ARV_DT_LOC), 'HH24:MI') ACT, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', ");
		sql.append(" 		TO_CHAR(TO_DATE(TKOF_T, 'HH24MI')+DEP_GMT_OFFSET/1440, 'HH24:MI'), ");
		sql.append(" 		TO_CHAR(TO_DATE(LAND_T, 'HH24MI')+ARV_GMT_OFFSET/1440, 'HH24:MI')) ONOFF, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', SPOT_OUT, SPOT_IN) SPOT, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', GATE_OUT, GATE_IN) GATE, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', DEP_STS, ARV_STS) STS, ");
		sql.append(" 	TO_CHAR(FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		
		sql.append(" 	TO_CHAR(ACT_DEP_DT_LOC + (540/1440),'YYYYMMDD HH24MI') ACT_DEP_DT_LOC, "); //2007.10.15 ߰
		
		//2008.04.17 
		//sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', SCH_DEP_DT_LOC, SCH_ARV_DT_LOC), 'YYMMDDHH24MI') SCH_DT_2, "); //2008.04.16 ߰
		//sql.append(" 	FLT_NUM FLT_NUM_2, "); //2008.04.16 ߰
		
		sql.append(" 	STNFR, STNTO ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND (('"+params.getPDepArvX()+"' = 'D' ");
		sql.append(" 	AND SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') - 3/24 ");
		sql.append(" 	AND SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') + 3/24 ");
		sql.append(" 	AND STNFR = '"+params.getPStn()+"') ");
		sql.append(" 	OR ('"+params.getPDepArvX()+"' = 'A' ");
		sql.append(" 	AND SCH_ARV_DT_LOC >= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') - 3/24 ");
		sql.append(" 	AND SCH_ARV_DT_LOC <= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') + 3/24 ");
		sql.append(" 	AND STNTO = '"+params.getPStn()+"')) ");
		sql.append(" 	AND STNFR <> STNTO ");
		*/
		//2008.10.14  : PE_ACARS_SKD_T ߰
		sql.append(" SELECT A.KACTYP, A.ACVER, A.REGNO, ");
		sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', A.SCH_DEP_DT_LOC, A.SCH_ARV_DT_LOC), 'HH24:MI') SCH, ");
		sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', A.EST_DEP_DT_LOC, A.EST_ARV_DT_LOC), 'HH24:MI') EST, ");
		sql.append(" 	TO_CHAR(DECODE('"+params.getPDepArvX()+"', 'D', A.ACT_DEP_DT_LOC, A.ACT_ARV_DT_LOC), 'HH24:MI') ACT, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', ");
		sql.append(" 		TO_CHAR(TO_DATE(A.TKOF_T, 'HH24MI')+A.DEP_GMT_OFFSET/1440, 'HH24:MI'), ");
		sql.append(" 		TO_CHAR(TO_DATE(A.LAND_T, 'HH24MI')+A.ARV_GMT_OFFSET/1440, 'HH24:MI')) ONOFF, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', A.SPOT_OUT, A.SPOT_IN) SPOT, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', A.GATE_OUT, A.GATE_IN) GATE, ");
		sql.append(" 	DECODE('"+params.getPDepArvX()+"', 'D', A.DEP_STS, A.ARV_STS) STS, ");
		sql.append(" 	TO_CHAR(A.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" 	TO_CHAR(A.ACT_DEP_DT_LOC + (540/1440),'YYYYMMDD HH24MI') ACT_DEP_DT_LOC, "); //2007.10.15 ߰
		sql.append(" 	A.STNFR, A.STNTO, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OUT_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_IN_DT + 9/24, 'HH24:MI'), ''))  ACT_ACARS, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OFF_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_ON_DT + 9/24, 'HH24:MI'), ''))  OFFON_ACAR ");
		sql.append(" FROM DAILY_SCH_T A, PE_ACARS_SKD_T B ");
		sql.append(" WHERE A.ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND (('"+params.getPDepArvX()+"' = 'D' ");
		sql.append(" 	AND A.SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') - 3/24 ");
		sql.append(" 	AND A.SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') + 3/24 ");
		sql.append(" 	AND A.STNFR = '"+params.getPStn()+"') ");
		sql.append(" 	OR ('"+params.getPDepArvX()+"' = 'A' ");
		sql.append(" 	AND A.SCH_ARV_DT_LOC >= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') - 3/24 ");
		sql.append(" 	AND A.SCH_ARV_DT_LOC <= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') + 3/24 ");
		sql.append(" 	AND A.STNTO = '"+params.getPStn()+"')) ");
		sql.append(" 	AND A.STNFR <> A.STNTO ");
		
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM(+) ");
		sql.append(" AND A.STNFR = B.STNFR(+) ");
		sql.append(" AND A.STNTO = B.STNTO(+) ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selFltInfoKE] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selFltInfoKE] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * FLT INFO - KE  ƴ  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/08  
	  */
	public String selFltInfoOther(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SACTYP, REGNO, ");
		sql.append(" 	TO_CHAR(SCH_DT_LOC, 'HH24:MI') SCH, ");
		sql.append(" 	TO_CHAR(EST_DT_LOC, 'HH24:MI') EST, ");
		sql.append(" 	TO_CHAR(ACT_DT_LOC, 'HH24:MI') ACT, ");
		sql.append(" 	TO_CHAR(TKOFLAND_T, 'HH24:MI') ONOFF, ");
		sql.append(" 	SPOT, DECODE(DEPARV_X, 'D', GATE, CAROULATERAL) GATE, "); //2008.04.16  : DEP϶ Gate, ARR϶ CRSL
		sql.append(" 	DECODE(DEPARV_X, 'D', STN, NVL(THIRDARPTSTOP, NVL(SCDARPTSTOP, NVL(FIRSTARPTSTOP, CONXSTN)))) STNFR, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', NVL(THIRDARPTSTOP, NVL(SCDARPTSTOP, NVL(FIRSTARPTSTOP, CONXSTN))), STN) STNTO ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND DEPARV_X = '"+params.getPDepArvX()+"' ");
		sql.append(" 	AND SCH_DT_LOC >= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') - 3/24 ");
		sql.append(" 	AND SCH_DT_LOC <= TO_DATE('"+params.getPSchDtLoc()+"', 'YYYYMMDD HH24MI') + 3/24 ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selFltInfoOther] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selFltInfoOther] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CATEGORY INFO - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/12  
	  */
	public String selCategoryInfoKE(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		/* 2008.04.16 
		sql.append(" SELECT ");
		sql.append(" 	TO_CHAR(B.CAT3_EXPDT, 'YYYY-MM-DD') CAT3_DATE, ");
		sql.append(" 	TO_CHAR(B.CAT2_EXPDT, 'YYYY-MM-DD') CAT2_DATE, ");
		sql.append(" 	'KE'||A.FLT_NUM FLT_NUM, ");
		sql.append(" 	TO_CHAR(B.LATEST_AUTODT, 'YYYY-MM-DD') CAT_DATE, ");
		sql.append(" 	A.STNFR, A.STNTO ");
		sql.append(" FROM PE_ACARS_SKD_T A, PE_ACREG_INFO_T B, ");
		sql.append(" 	(SELECT MAX(ACT_ON_DT) ACT_ON_DT, REGNO ");
		sql.append(" 	FROM PE_ACARS_SKD_T ");
		sql.append(" 	WHERE CAT_X = 'Y' ");
		sql.append(" 	GROUP BY REGNO) C ");
		sql.append(" WHERE B.REGNO = A.REGNO "); 
		sql.append(" 	AND B.REGNO = C.REGNO ");
		sql.append(" 	AND A.REGNO = '"+params.getPRegno()+"' ");
		sql.append(" 	AND A.CAT_X = 'Y' ");
		sql.append(" 	AND A.ACT_ON_DT = C.ACT_ON_DT "); 
		sql.append(" 	AND ROWNUM = 1 ");
		sql.append(" ORDER BY A.ACT_ON_DT DESC ");
		*/
		sql.append(" SELECT ");
		sql.append(" 	TO_CHAR(B.CAT3_EXPDT, 'YYYY-MM-DD') CAT3_DATE, ");
		sql.append(" 	TO_CHAR(B.CAT2_EXPDT, 'YYYY-MM-DD') CAT2_DATE, ");
		sql.append(" 	'KE'||A.FLT_NUM FLT_NUM, ");
		sql.append(" 	TO_CHAR(B.LATEST_AUTODT, 'YYYY-MM-DD') CAT_DATE, ");
		sql.append(" 	A.STNFR, A.STNTO ");
		sql.append(" FROM PE_ACARS_SKD_T A, PE_ACREG_INFO_T B, ");
		sql.append(" (SELECT MAX(ACT_ON_DT) ACT_ON_DT, REGNO ");
		sql.append(" FROM PE_ACARS_SKD_T ");
		sql.append(" WHERE CAT_X = 'Y' ");
		sql.append(" AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" GROUP BY REGNO) C ");
		sql.append(" WHERE A.REGNO = '"+params.getPRegno()+"' ");
		sql.append(" AND A.REGNO = B.REGNO ");
		sql.append(" AND A.REGNO = C.REGNO ");
		sql.append(" AND A.CAT_X = 'Y' ");
		sql.append(" AND A.ACT_ON_DT = C.ACT_ON_DT ");
		sql.append(" AND ROWNUM = 1 ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selCategoryInfoKE] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selCategoryInfoKE] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * CREW INFO - KE   ȸ SQLԼ -- .
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/12  
	  */
	public String selCrewInfoKE(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT C.STAFF_NUM, SUBSTR(D.SURNAME, 1, 30) SURNAME, B.DUTY_CD, ");
		sql.append(" 	DECODE(B.COP_DUTY_CD, 'P1', DECODE(C.ACTING_RANK, 'CAP', 'PIC', C.ACTING_RANK), 'CM', DECODE(C.ACTING_RANK, 'CAP', 'PIC', C.ACTING_RANK), C.ACTING_RANK) ACTING_RANK, ");
		sql.append(" 	DECODE(C.ACTING_RANK, 'CAP', '1', 'RC', '2', 'F/O', '3', 'F/E', '4', '5') ORD_RANK1, ");
		sql.append("		DECODE(B.COP_DUTY_CD, 'P1', '1', 'CM', '1', 'P2', '2', '3') ORD_RANK2 ");
		sql.append(" FROM DUTY_PRD_SEG_V B, ROSTER_V C, CREW_V D ");
		sql.append(" WHERE B.DELETE_IND = 'N' ");
		sql.append(" 	AND C.DELETE_IND = 'N' ");
		sql.append(" 	AND C.STAFF_NUM  = D.STAFF_NUM ");
		sql.append(" 	AND B.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND B.FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND B.PORT_A = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND B.PORT_B = '"+params.getPStnto()+"' ");
		sql.append(" 	AND B.SERIES_NUM = C.SERIES_NUM ");
		sql.append(" ORDER BY B.DUTY_CD, ORD_RANK1, ORD_RANK2 ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selCrewInfoKE] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * CREW PREV,NEXT FLT INFO - KE   ȸ SQLԼ -- .
	  * @return String Query 
	  * @author Copyright (c) 2007/10/12  
	  */
	public String selCrewPrevNextKE() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT 'PREV' FLT_SEQ, ARLN_CD||FLT_NUM FLT_NUM, TO_CHAR(ACT_END_DT_TM_GMT, 'DDMONYY') FLT_DATE, ");
		sql.append(" 	PORT_A, PORT_B, DUTY_CD, ACTING_RANK, '' REGNO ");
		sql.append(" FROM (SELECT FLT_NUM, ACT_END_DT_TM_GMT, PORT_A, PORT_B, A.DUTY_CD, ACTING_RANK, ARLN_CD ");
		sql.append("			  FROM DUTY_PRD_SEG_V A, ROSTER_V B");
		sql.append(" 		  WHERE STAFF_NUM = ? ");
		sql.append(" 			  AND ACT_END_DT_TM_GMT < TO_DATE(?, 'YYYYMMDD HH24MI') ");
		sql.append(" 			  AND ACT_END_DT_TM_GMT > TO_DATE(?, 'YYYYMMDD HH24MI') - 30 ");
		sql.append(" 			  AND B.SERIES_NUM = A.SERIES_NUM ");
		sql.append(" 			  AND A.DUTY_CD IN ('FLY', 'TVL') ");
		sql.append(" 			  AND DUTY_PUBLISHED = 'Y' ");
		sql.append(" 			  AND A.DELETE_IND = 'N' ");
		sql.append(" 			  AND B.DELETE_IND = 'N' ");
		sql.append(" 		  ORDER BY ACT_END_DT_TM_GMT DESC) ");
		sql.append(" WHERE ROWNUM = 1 ");
		
		sql.append(" UNION ALL ");
		
		sql.append(" SELECT 'NEXT' FLT_SEQ, ARLN_CD||FLT_NUM FLT_NUM, TO_CHAR(ACT_STR_DT_TM_GMT, 'DDMONYY') FLT_DATE, ");
		sql.append(" 	PORT_A, PORT_B, A.DUTY_CD DUTY_CD, ACTING_RANK, '' REGNO ");
		sql.append(" FROM DUTY_PRD_SEG_V A, ROSTER_V B ");
		sql.append(" WHERE STAFF_NUM = ? ");
		sql.append(" 	AND ACT_STR_DT_TM_GMT > TO_DATE(?, 'YYYYMMDD HH24MI') ");
		sql.append(" 	AND ACT_STR_DT_TM_GMT < TO_DATE(?, 'YYYYMMDD HH24MI') + 30 ");
		sql.append(" 	AND A.SERIES_NUM = B.SERIES_NUM ");
		sql.append(" 	AND A.DUTY_CD IN ('FLY', 'TVL') ");
		sql.append(" 	AND DUTY_PUBLISHED = 'Y' ");
		sql.append(" 	AND A.DELETE_IND = 'N' ");
		sql.append(" 	AND B.DELETE_IND = 'N' ");
		sql.append(" 	AND ROWNUM = 1 ");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewPrevNextKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CREW INFO + CREW PREV,NEXT FLT INFO - KE   ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/10/18  
	  */
	public String selCrewInfo_PrevNextKE(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.STAFF_NUM, SUBSTR(B.ENG_NAME, 1, 30) ENG_NAME, ");
		sql.append(" 	DECODE(B.RANK_NR, '11', 'CAP', '12', 'F/O', 'F/E') RANK, ");
		sql.append(" 	DECODE(B.RANK_NR, '11', 'FLY', '12', 'FLY', '13', 'FLY', 'EXT') DUTY, ");
		sql.append(" 	PRV_ARLN_CD||PRV_FLT_NUM||'/'||TO_CHAR(PRV_DEP_LDT, 'DDMONYY')||' - '||PRV_STNFR||'/'||PRV_STNTO PRV_FLT, ");
		sql.append(" 	NXT_ARLN_CD||NXT_FLT_NUM||'/'||TO_CHAR(NXT_DEP_LDT, 'DDMONYY')||' - '||NXT_STNFR||'/'||NXT_STNTO NXT_FLT ");
		sql.append(" FROM GD_SKD_T A, GD_CREW_T B ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getPFltNum()+"' ");
		//sql.append(" 	AND A.STNFR = '"+params.getPStn()+"' "); 2007.10.19 
		sql.append(" 	AND (('"+params.getPDepArvX()+"' = 'D' AND A.STNFR = '"+params.getPStn()+"') OR ('"+params.getPDepArvX()+"' = 'A' AND A.STNTO = '"+params.getPStn()+"')) ");
		sql.append(" 	AND A.FLT_SEQ_NR = B.FLT_SEQ_NR ");
		sql.append(" 	AND B.RANK_NR LIKE '1%' ");
		sql.append(" 	AND B.DA_IND = 'A' ");
		sql.append(" 	AND (B.CREW_SEQ_NR, B.STAFF_NUM) IN ");
		sql.append(" 	(SELECT MAX(CREW_SEQ_NR), STAFF_NUM ");
		sql.append(" 	FROM GD_CREW_T "); 
		sql.append(" 	WHERE FLT_SEQ_NR = A.FLT_SEQ_NR ");
		sql.append(" 	GROUP BY STAFF_NUM) ");
		sql.append(" ORDER BY B.RANK_NR, B.STAFF_NUM ");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewInfo_PrevNextKE] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCrewInfo_PrevNextKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CREW LAST FLT INFO - KE   ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/10/12  
	  */
	public String selCrewLastKE() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT 'LAST' FLT_SEQ, ARLN_CD||FLT_NUM FLT_NUM, TO_CHAR(LAND_ON_DT, 'DDMONYY') FLT_DATE, ");
		sql.append("    		  STNFR PORT_A, STNTO PORT_B, '' DUTY_CD, '' ACTING_RANK, REGNO, LAND_ON_DT ");
		sql.append(" FROM FS_LOG_SKD_T ");
		sql.append(" WHERE LAND_ON_CREW = ? ");
		sql.append(" 	AND LANDING_TYPE = 'A' ");
		sql.append(" 	AND ROWNUM = 1 ");
		sql.append(" ORDER BY LAND_ON_DT DESC ");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewLastKE] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCrewLastKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Aircraft Connection INFO - KE   ȸ SQLԼ. -- . 2008/04/17
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/15  
	  */
	public String selAircraftInfoKE(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" SELECT 'KE'||FLT_NUM FLT_NUM, STNFR, STNTO, DEP_STS, ARV_STS, ");	
		sql.append("      TO_CHAR(SCH_DEP_DT_LOC,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append("      TO_CHAR(SCH_DEP_DT_LOC,'HH24:MI') SCH_DEP_TM, TO_CHAR(SCH_ARV_DT_LOC,'HH24:MI') SCH_ARV_TM, ");
		sql.append(" 	TO_CHAR(EST_DEP_DT_LOC,'HH24:MI') EST_DEP_TM, TO_CHAR(ACT_DEP_DT_LOC,'HH24:MI') ACT_DEP_TM, ");
		sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||NVL(TRIM(TKOF_T), '0000'), 'YYYYMMDDHH24MI') + (DEP_GMT_OFFSET/1440), 'HH24:MI') TKOF_T, ");
		sql.append("		TO_CHAR(EST_ARV_DT_LOC,'HH24:MI') EST_ARV_TM, TO_CHAR(ACT_ARV_DT_LOC,'HH24:MI') ACT_ARV_TM, ");
		sql.append(" 	TO_CHAR(TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||NVL(TRIM(LAND_T), '0000'), 'YYYYMMDDHH24MI') + (ARV_GMT_OFFSET/1440), 'HH24:MI') LAND_T, ");
		sql.append("      DEP_GMT_OFFSET, ARV_GMT_OFFSET, SPOT_OUT, SPOT_IN ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" 	AND SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 0000','YYYYMMDD HH24MI') ");
		sql.append("      AND SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 2359','YYYYMMDD HH24MI') ");
		sql.append("      AND DEP_STS <> 'INI' ");
		sql.append("      AND ACTNID <> 'CNL' ");
		sql.append("      AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" ORDER BY SCH_DEP_DT, FLT_NUM ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selAircraftInfoKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Aircraft Connection INFO - KE  DEP  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/04/17  
	  */
	public String selAircraftInfoKEDep(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(SCH_DEP_DT_LOC, 'YYMMDDHH24MI') SCH_DT_2, ");
		sql.append(" FLT_NUM FLT_NUM_2, ");
		sql.append(" 'KE'||FLT_NUM FLT_NUM, STNFR, STNTO, DEP_STS, ARV_STS, ");
		sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'HH24:MI') SCH, ");
		sql.append(" TO_CHAR(EST_DEP_DT_LOC,'HH24:MI') EST, ");
		sql.append(" TO_CHAR(ACT_DEP_DT_LOC,'HH24:MI') ACT, ");
		sql.append(" TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(TKOF_T),'0000'), 'YYYYMMDDHH24MI') + (DEP_GMT_OFFSET/1440), 'HH24:MI') ONOFF, ");
		sql.append(" SPOT_OUT SPOT, ");
		sql.append(" GATE_OUT GC ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND ACTNID <> 'CNL' ");
		sql.append(" AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" ORDER BY SCH_DEP_DT, FLT_NUM ");
		*/
		//2008.10.14  : PE_ACARS_SKD_T ߰
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT_LOC, 'YYMMDDHH24MI') SCH_DT_2, ");
		sql.append(" A.FLT_NUM FLT_NUM_2, ");
		sql.append(" 'KE'||A.FLT_NUM FLT_NUM, A.STNFR, A.STNTO, A.DEP_STS, A.ARV_STS, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT_LOC,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT_LOC,'HH24:MI') SCH, ");
		sql.append(" TO_CHAR(A.EST_DEP_DT_LOC,'HH24:MI') EST, ");
		sql.append(" TO_CHAR(A.ACT_DEP_DT_LOC,'HH24:MI') ACT, ");
		sql.append(" TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.TKOF_T),'0000'), 'YYYYMMDDHH24MI') + (A.DEP_GMT_OFFSET/1440), 'HH24:MI') ONOFF, ");
		sql.append(" A.SPOT_OUT SPOT, ");
		sql.append(" A.GATE_OUT GC, ");
		sql.append(" DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OUT_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_IN_DT + 9/24, 'HH24:MI'), ''))  ACT_ACARS, ");
		sql.append(" DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OFF_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_ON_DT + 9/24, 'HH24:MI'), ''))  OFFON_ACAR ");
		sql.append(" FROM DAILY_SCH_T A, PE_ACARS_SKD_T B ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND A.SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND A.SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND A.DEP_STS <> 'INI' ");
		sql.append(" AND A.ACTNID <> 'CNL' ");
		sql.append(" AND A.REGNO = '"+params.getPRegno()+"' ");
		sql.append(" AND A.REGNO <> 'ZZZZZ' "); //2009.01.21 ߰
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM(+) ");
		sql.append(" AND A.STNFR = B.STNFR(+) ");
		sql.append(" AND A.STNTO = B.STNTO(+) ");
		sql.append(" ORDER BY SCH_DEP_DT, FLT_NUM ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selAircraftInfoKEDep] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selAircraftInfoKEDep] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Aircraft Connection INFO - KE  ARR  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/04/17  
	  */
	public String selAircraftInfoKEArr(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(SCH_ARV_DT_LOC, 'YYMMDDHH24MI') SCH_DT_2, ");
		sql.append(" FLT_NUM FLT_NUM_2, ");
		sql.append(" 'KE'||FLT_NUM FLT_NUM, STNFR, STNTO, DEP_STS, ARV_STS, ");
		sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(SCH_ARV_DT_LOC,'HH24:MI') SCH, ");
		sql.append(" TO_CHAR(EST_ARV_DT_LOC,'HH24:MI') EST, ");
		sql.append(" TO_CHAR(ACT_ARV_DT_LOC,'HH24:MI') ACT, ");
		sql.append(" TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(LAND_T),'0000'), 'YYYYMMDDHH24MI') + (ARV_GMT_OFFSET/1440), 'HH24:MI') ONOFF, ");
		sql.append(" SPOT_IN SPOT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND ACTNID <> 'CNL' ");
		sql.append(" AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" ORDER BY SCH_DEP_DT, FLT_NUM ");
		*/
		//2008.10.14  : PE_ACARS_SKD_T ߰
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(A.SCH_ARV_DT_LOC, 'YYMMDDHH24MI') SCH_DT_2, ");
		sql.append(" A.FLT_NUM FLT_NUM_2, ");
		sql.append(" 'KE'||A.FLT_NUM FLT_NUM, A.STNFR, A.STNTO, A.DEP_STS, A.ARV_STS, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT_LOC,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(A.SCH_ARV_DT_LOC,'HH24:MI') SCH, ");
		sql.append(" TO_CHAR(A.EST_ARV_DT_LOC,'HH24:MI') EST, ");
		sql.append(" TO_CHAR(A.ACT_ARV_DT_LOC,'HH24:MI') ACT, ");
		sql.append(" TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.LAND_T),'0000'), 'YYYYMMDDHH24MI') + (A.ARV_GMT_OFFSET/1440), 'HH24:MI') ONOFF, ");
		sql.append(" A.SPOT_IN SPOT, ");
		sql.append(" DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OUT_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_IN_DT + 9/24, 'HH24:MI'), ''))  ACT_ACARS, ");
		sql.append(" DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OFF_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_ON_DT + 9/24, 'HH24:MI'), ''))  OFFON_ACAR ");
		sql.append(" FROM DAILY_SCH_T A, PE_ACARS_SKD_T B ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND A.SCH_DEP_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND A.SCH_DEP_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+" 2359','YYYYMMDD HH24MI') ");
		sql.append(" AND A.DEP_STS <> 'INI' ");
		sql.append(" AND A.ACTNID <> 'CNL' ");
		sql.append(" AND A.REGNO = '"+params.getPRegno()+"' ");
		sql.append(" AND A.REGNO <> 'ZZZZZ' "); //2009.01.21 ߰
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM(+) ");
		sql.append(" AND A.STNFR = B.STNFR(+) ");
		sql.append(" AND A.STNTO = B.STNTO(+) ");
		sql.append(" ORDER BY SCH_DEP_DT, FLT_NUM ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selAircraftInfoKEArr] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selAircraftInfoKEArr] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Aircraft Connection INFO - KE  ƴ  ȸ SQLԼ. -- . 2008/04/17
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/15  
	  */
	public String selAircraftInfoOther(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ARLN_CD||FLT_NUM FLT_NUM, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', STN, NVL(THIRDARPTSTOP, NVL(SCDARPTSTOP, NVL(FIRSTARPTSTOP, CONXSTN)))) STNFR, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', NVL(THIRDARPTSTOP, NVL(SCDARPTSTOP, NVL(FIRSTARPTSTOP, CONXSTN))), STN) STNTO, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', TO_CHAR(SCH_DT_LOC, 'HH24:MI'), '') STD, ");
		sql.append(" 	DECODE(DEPARV_X, 'A', TO_CHAR(SCH_DT_LOC, 'HH24:MI'), '') STA, ");
		sql.append(" 	DECODE(EST_DT_LOC,SCH_DT_LOC, '', DECODE(DEPARV_X, 'D', TO_CHAR(EST_DT_LOC, 'HH24:MI'), '')) ETD, ");
		sql.append(" 	DECODE(EST_DT_LOC,SCH_DT_LOC, '', DECODE(DEPARV_X, 'A', TO_CHAR(EST_DT_LOC, 'HH24:MI'), '')) ETA, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', TO_CHAR(ACT_DT_LOC, 'HH24:MI'), '') ATD, ");
		sql.append(" 	DECODE(DEPARV_X, 'A', TO_CHAR(ACT_DT_LOC, 'HH24:MI'), '') ATA, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', TO_CHAR(TKOFLAND_T, 'HH24:MI'), '') TOFF, ");
		sql.append(" 	DECODE(DEPARV_X, 'A', TO_CHAR(TKOFLAND_T, 'HH24:MI'), '') TDWN, ");
		sql.append(" 	DECODE(DEPARV_X, 'D', DEPARV_STS, '') DEP_STS, "); //2007.10.15 ߰
		sql.append(" 	DECODE(DEPARV_X, 'A', DEPARV_STS, '') ARV_STS, "); //2007.10.15 ߰
		sql.append(" 	DECODE(DEPARV_X, 'D', SPOT, '') DEP_SPOT, ");
		sql.append(" 	DECODE(DEPARV_X, 'A', SPOT, '') ARR_SPOT ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" 	AND SCH_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+"'||' 0000','YYYYMMDD HH24MI') - 2 ");
		sql.append(" 	AND SCH_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+"'||' 2359','YYYYMMDD HH24MI') + 2 ");
		sql.append(" ORDER BY SCH_DT_LOC "); 
	
		Logger.debug.println("[BASE:SkdQ060Query:selAircraftInfoOther] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Aircraft Connection INFO - KE  ƴ DEP  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/04/17  
	  */
	public String selAircraftInfoOtherDep(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(SCH_DT_LOC, 'YYMMDDHH24MI') SCH_DT_2, ");
		sql.append(" FLT_NUM FLT_NUM_2, ");
		sql.append(" DEPARV_STS DEP_STS, '' ARV_STS, ");
		sql.append(" ARLN_CD||FLT_NUM FLT_NUM, ");
		sql.append(" STN STNFR, ");
		sql.append(" NVL(THIRDARPTSTOP,NVL(SCDARPTSTOP,NVL(FIRSTARPTSTOP,CONXSTN))) STNTO, ");
		sql.append(" TO_CHAR(SCH_DT_LOC,'HH24:MI') SCH, ");
		sql.append(" DECODE(EST_DT_LOC,SCH_DT_LOC,'',TO_CHAR(EST_DT_LOC,'HH24:MI')) EST, ");
		sql.append(" TO_CHAR(ACT_DT_LOC,'HH24 :MI') ACT, ");
		sql.append(" TO_CHAR(TKOFLAND_T,'HH24:MI') ONOFF, ");
		sql.append(" SPOT, ");
		sql.append(" GATE GC ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" 	AND SCH_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+"'||' 0000','YYYYMMDD HH24MI') - 2 ");
		sql.append(" 	AND SCH_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+"'||' 2359','YYYYMMDD HH24MI') + 2 ");
		sql.append(" ORDER BY SCH_DT_LOC ");
	
		Logger.debug.println("[BASE:SkdQ060Query:selAircraftInfoOtherDep] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selAircraftInfoOtherDep] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Aircraft Connection INFO - KE  ƴ ARR  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/04/17  
	  */
	public String selAircraftInfoOtherArr(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(SCH_DT_LOC, 'YYMMDDHH24MI') SCH_DT_2, ");
		sql.append(" FLT_NUM FLT_NUM_2, ");
		sql.append(" '' DEP_STS, DEPARV_STS ARV_STS, ");
		sql.append(" ARLN_CD||FLT_NUM FLT_NUM, ");
		sql.append(" NVL(THIRDARPTSTOP,NVL(SCDARPTSTOP,NVL(FIRSTARPTSTOP,CONXSTN))) STNFR, ");
		sql.append(" STN STNTO, ");
		sql.append(" TO_CHAR(SCH_DT_LOC,'HH24:MI') SCH, ");
		sql.append(" DECODE(EST_DT_LOC,SCH_DT_LOC,'',TO_CHAR(EST_DT_LOC,'HH24:MI')) EST, ");
		sql.append(" TO_CHAR(ACT_DT_LOC,'HH24:MI') ACT, ");
		sql.append(" TO_CHAR(TKOFLAND_T,'HH24:MI') ONOFF, ");
		sql.append(" SPOT, ");
		sql.append(" CAROULATERAL GC ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND REGNO = '"+params.getPRegno()+"' ");
		sql.append(" 	AND SCH_DT_LOC >= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+"'||' 0000','YYYYMMDD HH24MI') - 2 ");
		sql.append(" 	AND SCH_DT_LOC <= TO_DATE('"+params.getPSchDtLoc().substring(0,8)+"'||' 2359','YYYYMMDD HH24MI') + 2 ");
		sql.append(" ORDER BY SCH_DT_LOC ");
	
		Logger.debug.println("[BASE:SkdQ060Query:selAircraftInfoOtherArr] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selAircraftInfoOtherArr] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BOARDING INFO 1 - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/15  
	  */
	public String selBoardingInfoKE_1(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	NVL(F_CFG_Q, 0)||' / '||NVL(C_CFG_Q, 0)||' / '||NVL(Y_CFG_Q, 0) CFG, ");
		sql.append(" 	NVL(F_BOOK_Q, 0)||' / '||NVL(C_BOOK_Q, 0)||' / '||NVL(Y_BOOK_Q, 0) RSVN, ");
		sql.append(" 	NVL(F_CHECK_Q, 0)||' / '||NVL(C_CHECK_Q, 0)||' / '||NVL(Y_CHECK_Q, 0) CHKIN, ");
		sql.append(" 	NVL(PAX_ADLT_Q, 0)||' / '||NVL(PAX_CHLD_Q, 0)||' / '||NVL(PAX_INFT_Q, 0) ADLT_CHLD_ENF, ");
		sql.append(" 	NVL(CAPT_CREW_Q, 0)||' / '||NVL(CBN_CREW_MAN_Q, 0)||' / '||NVL(CBN_CREW_WOMAN_Q, 0) CREW, ");
		sql.append(" 	NVL(ACT_PAYLOAD_Q, 0) ACT_PAYLOAD_Q, ");
		sql.append(" 	NVL(MAX_PAYLOAD_Q, 0) MAX_PAYLOAD_Q, ");
		sql.append(" 	NVL(ACT_BEW_Q, 0) ACT_BEW_Q, ");
		sql.append(" 	NVL(ACT_SOW_Q, 0) ACT_SOW_Q, ");
		sql.append(" 	NVL(ACT_ZFW_Q, 0) ACT_ZFW_Q, ");
		sql.append(" 	NVL(ACT_TOW_Q, 0) ACT_TOW_Q, ");
		sql.append(" 	NVL(EST_LDW_Q, 0) EST_LDW_Q, ");
		sql.append(" 	NVL(TOF_Q, 0) TOF_Q, ");
		sql.append(" 	NVL(TIF_Q, 0) TIF_Q, ");
		sql.append(" 	NVL(CGO_WT_Q, 0) CGO_WT_Q, ");
		sql.append(" 	NVL(MAIL_WT_Q, 0) MAIL_WT_Q, ");
		sql.append(" 	NVL(BAG_WT_Q, 0) BAG_WT_Q ");
		sql.append(" FROM BASE_DCS_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') "); 
		sql.append(" 	AND ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");

		Logger.debug.println("[BASE:SkdQ060Query:selBoardingInfoKE_1] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selBoardingInfoKE_1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BOARDING INFO 2 - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/15  
	  */
	public String selBoardingInfoKE_2(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT OBD_STN_C, ");
		sql.append(" 	NVL(REV_Q, 0) REV_Q, NVL(REB_Q, 0) REB_Q, NVL(TRANS_Q, 0) TRANS_Q, ");
		sql.append(" 	NVL(CGO_WT_Q, 0) CGO_WT_Q, NVL(MAIL_WT_Q, 0) MAIL_WT_Q, NVL(BAG_WT_Q, 0) BAG_WT_Q, NVL(BAG_CNT_Q, 0) BAG_CNT_Q, NVL(TRANS_WT_Q, 0) TRANS_WT_Q ");
		sql.append(" FROM BASE_DCS_OBD_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') "); 
		sql.append(" 	AND ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selBoardingInfoKE_2] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selBoardingInfoKE_2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX Connection INFO - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/16  
	  */
	public String selPaxInfoKE(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TRANS_ARLN_CD, TRANS_FLT_NUM, ");
		if (params.getPDepArvX().equals("D")) {
			sql.append("  TRANS_STN_C DEP, STNFR ARR, ");
		} else {
			sql.append("  STNTO DEP, TRANS_STN_C ARR, ");
		}
		sql.append(" 	TO_CHAR(TRANS_DT, 'DDMONYY') TRANS_DATE, TO_CHAR(TRANS_DT, 'HH24:MI') TRANS_TIME, ");
		sql.append(" 	NVL(F_BOOK_Q, 0)||' / '||NVL(C_BOOK_Q, 0)||' / '||NVL(Y_BOOK_Q, 0) BOOK, ");
		sql.append(" 	NVL(F_CHKIN_Q, 0)||' / '||NVL(C_CHKIN_Q, 0)||' / '||NVL(Y_CHKIN_Q, 0) CHKIN, ");
		sql.append(" 	BAG_Q ");
		sql.append(" FROM BASE_DCS_TRANS_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') ");
		sql.append(" 	AND ARLN_CD = '"+params.getPArlnCd()+"' ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		if (params.getPDepArvX().equals("D")) {
			sql.append("  AND STNFR IN ('GMP', 'ICN') ");
		} else {
			sql.append("  AND STNTO IN ('GMP', 'ICN') ");
		}
		sql.append(" 	AND DEP_ARV_X = '"+params.getPDepArvX()+"' "); 
		if (params.getPDepArvX().equals("D")) {
			sql.append(" ORDER BY TRANS_STN_C, TRANS_DT ");
		} else {
			sql.append(" ORDER BY TRANS_DT ");
		}
		
		Logger.debug.println("[BASE:SkdQ060Query:selPaxInfoKE] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selPaxInfoKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX Connection INFO ArlnCd='KE' - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/16  
	  */
	public String selPaxInfoKE_1(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getPDepArvX().equals("D")) {
			sql.append(" SELECT * ");
			sql.append(" FROM ( ");
			sql.append(" 	SELECT ACT_ARV_DT_LOC, "); 
			sql.append(" 		TO_CHAR(ACT_ARV_DT_LOC, 'DDMONYY') ACT_ARV_DATE_LOC, ");
			sql.append(" 		TO_CHAR(ACT_ARV_DT_LOC, 'HH24:MI') ACT_ARV_TIME_LOC, ");
			sql.append(" 		DECODE(ARV_STS, 'ACT', 'ARR', ARV_STS) STS ");
			sql.append(" 	FROM DAILY_SCH_T ");
			sql.append(" 	WHERE FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') - 2 AND TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') ");
			sql.append(" 		AND FLT_NUM = '"+params.getPTransFltNum()+"' ");
			sql.append(" 		AND STNTO IN ('GMP', 'ICN') ");
			sql.append(" 		AND ACT_ARV_DT_LOC <= TO_DATE('"+params.getPTransDate()+" "+params.getPTransTime()+"' , 'DDMONYY HH24:MI') ");
			sql.append(" 		AND ACTNID <> 'CNL' ");
			sql.append(" 	ORDER BY ACT_ARV_DT_LOC DESC) ");
			sql.append(" WHERE ROWNUM = 1 ");
		
		} else {
			sql.append(" SELECT ACT_DEP_DT_LOC, "); 
			sql.append(" 		TO_CHAR(ACT_DEP_DT_LOC, 'DDMONYY') ACT_DEP_DATE_LOC, ");
			sql.append(" 		TO_CHAR(ACT_DEP_DT_LOC, 'HH24:MI') ACT_DEP_TIME_LOC, ");
			sql.append(" 	DECODE(DEP_STS, 'ACT', 'ARR', DEP_STS) STS ");
			sql.append(" FROM DAILY_SCH_T ");
			sql.append(" WHERE FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') AND TO_DATE('"+params.getPFirstLegFltDt()+"', 'YYYYMMDD') + 2 ");
			sql.append(" 	AND FLT_NUM = '"+params.getPTransFltNum()+"' ");
			sql.append(" 	AND STNFR IN ('GMP', 'ICN') ");
			sql.append(" 	AND ACT_DEP_DT_LOC >= TO_DATE('"+params.getPTransDate()+" "+params.getPTransTime()+"' , 'DDMONYY HH24:MI') ");
			sql.append(" 	AND ACTNID <> 'CNL' ");
			sql.append(" 	AND ROWNUM = 1 ");
			sql.append(" ORDER BY ACT_DEP_DT_LOC ");
		}
		
		Logger.debug.println("[BASE:SkdQ060Query:selPaxInfoKE_1] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selPaxInfoKE_1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX Connection INFO ArlnCd<>'KE' - KE   ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/16  
	  */
	public String selPaxInfoKE_2(SkdQ060BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getPDepArvX().equals("D")) {
			sql.append(" SELECT * ");
			sql.append(" FROM ( ");
			sql.append(" 	SELECT DECODE(DEPARV_STS, 'ACT', 'DEP', DEPARV_STS) STS ");
			sql.append(" 	FROM FO_DAILY_RAMP_T ");
			sql.append(" 	WHERE SCH_DT_LOC BETWEEN SYSDATE - 1 AND SYSDATE ");
			sql.append(" 		AND ARLN_CD = '"+params.getPTransArlnCd()+"' ");
			sql.append(" 		AND FLT_NUM = '"+params.getPTransFltNum()+"' ");
			sql.append(" 	ORDER BY SCH_DT_LOC DESC) ");
			sql.append(" WHERE ROWNUM = 1 ");
		
		} else {
			sql.append(" SELECT DECODE(DEPARV_STS, 'ACT', 'DEP', DEPARV_STS) STS ");
			sql.append(" FROM FO_DAILY_RAMP_T ");
			sql.append(" WHERE SCH_DT_LOC BETWEEN SYSDATE AND SYSDATE + 1 ");
			sql.append(" 	AND ARLN_CD = '"+params.getPTransArlnCd()+"' ");
			sql.append(" 	AND FLT_NUM = '"+params.getPTransFltNum()+"' ");
			sql.append(" 	AND ROWNUM = 1 ");
			sql.append(" ORDER BY SCH_DT_LOC ");
		}
		
		Logger.debug.println("[BASE:SkdQ060Query:selPaxInfoKE_2] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selPaxInfoKE_2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ARR     G/C  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/04/16  
	  */
	public String selArrGc(String schDt, String fltNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT CAROULATERAL GC ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE SCH_DT_LOC = TO_DATE('"+schDt+"', 'YYMMDDHH24MI') ");
		sql.append(" AND ARLN_CD = 'KE' ");
		sql.append(" AND FLT_NUM = '"+fltNum+"' ");
		sql.append(" AND ROWNUM = 1 ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selArrGc] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selArrGc] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *   CSFLT  ȸ SQLԼ.
	  * @param params SkdQ060BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/04/17  
	  */
	public String selCsFlt(String arlnCd, String schDt, String fltNum) {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" SELECT * FROM( ");
		sql.append(" SELECT CDSFLT ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE SCH_DT_LOC = TO_DATE('"+schDt+"', 'YYMMDDHH24MI') ");
		sql.append(" AND ARLN_CD = '"+arlnCd+"' ");
		sql.append(" AND FLT_NUM = '"+fltNum+"' ");
		sql.append(" UNION ");
		sql.append(" SELECT DECODE(CDSSTAT,'SL',ARLN_CD||FLT_NUM||'*',ARLN_CD||FLT_NUM) ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE SCH_DT_LOC = TO_DATE('"+schDt+"', 'YYMMDDHH24MI') ");
		sql.append(" AND CDSFLT = '"+arlnCd+"'||'"+fltNum+"') ");
		sql.append(" ORDER BY 1 ");
		
		Logger.debug.println("[BASE:SkdQ060Query:selCsFlt] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ060Query:selCsFlt] sql : "+sql.toString());
		return sql.toString();
	}
}
