package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ010BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Delay Status(Airport) SQL 
   * @author Copyright (c) 2005/01/25 
   */    
public class StaQ010Query {
	private static StaQ010Query instance = new StaQ010Query();
	
	public static StaQ010Query getInstance() {
		return instance;
	}
	/** 
	  * Delay Status(Airport) main ȸ SQLԼ.
	  * @param entity StaQ010BG Delay Status(Airport)
	  * @return String Query 
	  * @author Copyright (c) 2005/01/25 
	  */
	public String selMain(StaQ010BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Stnfr, Decode(Actnid,'CNL','CNL','NEW') Actnid, Count(*) Total, 'A' Abcd ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append(" SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.28 ߰ :  FLT 
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And  ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And  ");
		sql.append(" 	Timestamp >= Sch_Dep_Dt - 39/24 And ");
		if(!entity.getStnfr().equals("")){
			sql.append("  (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"') And ");
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		if(entity.getRegular().equals("REGULAR")){
			sql.append("	Svc In('J','F','M') And ");
		}
		else if(entity.getRegular().equals("NON_REG")){
			sql.append("	Svc In('G','A','C','H') And ");
		}
		else if(entity.getRegular().equals("NON_REV")){
			sql.append("	Svc In('J','F','M','G','A','C','H') And ");
		}
		sql.append("      Stnfr <> Stnto And ");
		sql.append(" 	Dep_Sts <> 'INI'   ");
		sql.append(" 	Group By Stnfr, Decode(Actnid,'CNL','CNL','NEW') ");
		sql.append(" Union ");
		sql.append(" Select Stnfr, Decode(Actnid,'CNL','CNL','NEW'), Count(*), 'B' ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append(" SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.28 ߰ :  FLT 
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And  ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And  ");
		if(!entity.getStart_time().equals("")){
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt > "+entity.getStart_time()+"/1440 And ");
		}
		else{
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt > 3/1440 And ");
		}
		if(!entity.getEnd_time().equals("")){;
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt < "+entity.getEnd_time()+"/1440 And ");
		}
		else{
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt < 9999/1440 And ");
		}
		sql.append(" 	Actnid  <> 'CNL'  And ");
		if(!entity.getStnfr().equals("")){
			sql.append("  (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"') And ");
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		if(entity.getRegular().equals("REGULAR")){
			sql.append("	Svc In('J','F','M') And ");
		}
		else if(entity.getRegular().equals("NON_REG")){
			sql.append("	Svc In('G','A','C','H') And ");
		}
		else if(entity.getRegular().equals("NON_REV")){
			sql.append("	Svc In('J','F','M','G','A','C','H') And ");
		}
		sql.append("      Stnfr <> Stnto And ");
		sql.append(" 	Dep_Sts <> 'INI'  ");
		sql.append(" 	Group By Stnfr, Decode(Actnid,'CNL','CNL','NEW') ");
		sql.append(" Union ");
		sql.append(" Select Stnto, Decode(Actnid,'CNL','CNL','NEW'), Count(*) , 'C' ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append(" SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.28 ߰ :  FLT 
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And  ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And  ");
		sql.append(" 	Timestamp >= Sch_Dep_Dt - 39/24 And ");
		if(!entity.getStnfr().equals("")){
			sql.append("  (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"') And ");
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		if(entity.getRegular().equals("REGULAR")){
			sql.append("	Svc In('J','F','M') And ");
		}
		else if(entity.getRegular().equals("NON_REG")){
			sql.append("	Svc In('G','A','C','H') And ");
		}
		else if(entity.getRegular().equals("NON_REV")){
			sql.append("	Svc In('J','F','M','G','A','C','H') And ");
		}
		sql.append("      Stnfr <> Stnto And ");
		sql.append(" 	Dep_Sts <> 'INI'    ");
		sql.append("  	Group By Stnto, Decode(Actnid,'CNL','CNL','NEW') ");
		sql.append(" Union ");
		sql.append(" Select Stnfr, Decode(Actnid,'CNL','CNL','NEW'), Count(*),'D' ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append(" SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.28 ߰ :  FLT 
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And  ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And  ");
		if(!entity.getStart_time().equals("")){
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt > "+entity.getStart_time()+"/1440 And ");
		}
		else{
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt > 3/1440 And ");
		}
		if(!entity.getEnd_time().equals("")){;
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt < "+entity.getEnd_time()+"/1440 And ");
		}
		else{
			sql.append(" 	Act_Dep_dt - Sch_Dep_Dt < 9999/1440 And ");
		}
		sql.append(" 	Actnid  <> 'CNL'  And ");
		if(!entity.getStnfr().equals("")){
			sql.append("  (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"') And ");
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		if(entity.getRegular().equals("REGULAR")){
			sql.append("	Svc In('J','F','M') And ");
		}
		else if(entity.getRegular().equals("NON_REG")){
			sql.append("	Svc In('G','A','C','H') And ");
		}
		else if(entity.getRegular().equals("NON_REV")){
			sql.append("	Svc In('J','F','M','G','A','C','H') And ");
		}
		sql.append("      Stnfr <> Stnto And ");
		sql.append(" 	Dep_Sts <> 'INI'   ");
		sql.append("  	Group By Stnfr, Decode(Actnid,'CNL','CNL','NEW')  ");
		sql.append("  	Order By 1, 4, 2  ");	
		
		//Logger.debug.println("[BASE:StaQ010Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ010Query:selMain] sql : "+sql.toString());
		
		return sql.toString();
	}
}
