package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ220BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Cancel Status(Flight) SQL 
   * @author Copyright (c) 2005/01/27 
   */  
public class StaQ220Query {
	private static StaQ220Query instance = new StaQ220Query();
	
	public static StaQ220Query getInstance() {
		return instance;
	}
	/** 
	  * Cancel Status(Flight) main ȸ SQLԼ.
	  * @param entity StaQ220BG Cancel Status(Flight)
	  * @return String Query 
	  * @author Copyright (c) 2005/01/27 
	  */
	public String selMain(StaQ220BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Flt_Num, Stnfr, Stnto, Decode(Actnid,'CNL','CNL','NEW') Actnid, Chgreas, Count(*) Total  ");
		sql.append(" From Daily_Sch_t  ");
		sql.append(" Where Arln_cd = 'KE' And ");
		sql.append(" 	SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.31 ߰ :  FLT 
		sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And  ");
		sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And  ");
		sql.append(" 	Timestamp >= Sch_Dep_Dt - 39/24 And  ");
		sql.append(" 	Stnfr <> Stnto And ");
		if(!entity.getStnfr().equals("")){
			sql.append("  (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"') And ");
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		if(entity.getRegular().equals("REGULAR")){
			sql.append("	Svc In('J','F','M') And ");
		}
		else if(entity.getRegular().equals("NON_REG")){
			sql.append("	Svc In('G','A','C','H') And ");
		}
		else if(entity.getRegular().equals("NON_REV")){
			sql.append("	Svc In('J','F','M','G','A','C','H') And ");
		}
		sql.append(" 	Dep_Sts <> 'INI'   ");
		sql.append(" Group By Flt_Num, Stnfr, Stnto, Decode(Actnid,'CNL','CNL','NEW'), Chgreas ");
		sql.append(" Order By 1, 2, 3, 4  ");	
		
		//Logger.debug.println("[BASE:StaQ220Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ220Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}

}
