package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.*;
import kal.base.com.query.*;

 /**
   * OPS Statistics/Flying Time Status-A/C Type SQL 
   * @author Copyright (c) 2005/01/27 HIST  
   */  
public class StaQ310Query {
	
	private static StaQ310Query instance = new StaQ310Query();
	
	public static StaQ310Query getInstance() {
		return instance;
	}
	
	/** 
	  * OPS Statistics/Flying Time Status-A/C Type Main ȸ SQLԼ.
	  * @param params StaQ310BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public String selMain(StaQ310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Kactyp, Regno, Decode(SVC,'J','AR','F','AR','M','AR','G','AR','A','AR','C','AR','H','NR','NV') Svc,");
		sql.append("            Decode(Region_Leg,'1','DOM','INT') Region_Leg,Count(*) Data_Cnt, Sum((Act_Arv_dt - Act_Dep_Dt) * 24) Dly_Tm");
		sql.append(" From Daily_Sch_T");
		sql.append(" Where Arln_Cd = 'KE'        And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.31 ߰ :  FLT 
		sql.append("            Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
		sql.append("       		Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') And");
		sql.append("       		Actnid  <> 'CNL'  And");
		sql.append("       		Stnfr   <> Stnto");
		sql.append(" Group By Kactyp ,regno,Decode(SVC,'J','AR','F','AR','M','AR','G','AR','A','AR','C','AR','H','NR','NV'),");
		sql.append("          		 Decode(Region_Leg,'1','DOM','INT')");
		sql.append(" Order by Kactyp,Regno");
				
		//Logger.debug.println("[BASE:StaQ310Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ310Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
}
