package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.not.dbbean.NotA110BG;
import kal.base.sup.dbbean.SupA310BG;
import kal.base.sup.dbbean.SupA360BG;
import kal.base.com.util.*;

 /**
   * Alert APO List SQL 
   * @author Copyright (c) 2011/11/04 
   */
public class SupA360Query {
	private static SupA360Query instance = new SupA360Query();
	
	public static SupA360Query getInstance() {
		return instance;
	}
	
	/** 
	  * Alert APO List ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOList(SupA360BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	IATA_PORT, WX_TYP, DTG, MAN_ISS_DT, MAN_EXP_DT, COMMNT,  ");
		sql.append(" 	MAN_DISPLAY, USERID, TO_CHAR(TIMESTMP,'YYMMDD/HH24MISS') TIMESTMP, DISPLAY_Y ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE ");
		
		if (params.getHid_rd_dtg().equals("R")) {
			sql.append(" DTG >= TO_DATE(TO_CHAR(SYSDATE - 9/24 -"+params.getDtg_range()+"/24, 'YYYYMMDDHH'),'YYYYMMDDHH') "); //2007.03.27  : 2,4,6    ְ .
		} else if (params.getHid_rd_dtg().equals("S")) {
			sql.append(" DTG >= TO_DATE('"+params.getDtgFr()+"','YYMMDDHH24MI') ");
			sql.append(" AND DTG <= TO_DATE('"+params.getDtgTo()+"','YYMMDDHH24MI') ");
		}
		sql.append(" ORDER BY DTG DESC ");
		
		//Logger.debug.println("[BASE:SupA350Query:selAlertAPOList] sql : "+sql.toString());debug true ٲٸ ̰͵  ϴ Ʒ 
		System.out.println("[BASE:SupA360Query:selAlertAPOList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO  ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPODetail(SupA360BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT, WX_TYP, DTG, TO_CHAR(MAN_ISS_DT,'DDHH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT, 'DDHH24MI')||'Z' MAN_EXP_DT, COMMNT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		//sql.append(" WHERE IATA_PORT =  '"+entity.getIata_port()+"' AND WX_TYP = '"+entity.getWx_typ()+"' AND TO_CHAR(DTG,'YYMMDD/HH24MI') = '"+entity.getDtg()+"'");
		sql.append(" WHERE TO_CHAR(TIMESTMP,'YYMMDD/HH24MISS') = '"+entity.getTimestmp()+"'");
		
		//Logger.debug.println("[BASE:SupA360Query:selAlertAPOList] sql : "+sql.toString());debug true ٲٸ ̰͵  ϴ Ʒ 
		System.out.println("[BASE:SupA360Query:selAlertAPODetail] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Alert APO  SQLԼ.
	  * @param entity SupA360BG 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String updAlertAPO(SupA360BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_MANUAL_WEATHER_T ");
		sql.append(" SET IATA_PORT = '"+entity.getIata_port()+"',");
		sql.append("        WX_TYP = '"+entity.getWx_typ()+"',");
		sql.append("        DTG = TO_DATE('"+entity.getDtg()+"','yyMMdd/hh24mi'),");
		sql.append("        MAN_DISPLAY = '"+entity.getMan_display()+"',");
		sql.append("        MAN_ISS_DT = TO_DATE('"+entity.getMan_iss_dt()+"','yyMMdd/hh24mi'),");
		sql.append("        MAN_EXP_DT = TO_DATE('"+entity.getMan_exp_dt()+"','yyMMdd/hh24mi'),");
		sql.append("        COMMNT = '"+entity.getCommnt()+"',");
		//2012.01.09 Display ǥ   => display_yĮ 
		// display_y  Ʈ ̷
		//sql.append("        MAN_PREV_ISS_DT = TO_DATE('"+entity.getMan_prev_iss_dt()+"','yyMMdd/hh24mi'),");
		//sql.append("        MAN_PREV_EXP_DT = TO_DATE('"+entity.getMan_prev_exp_dt()+"','yyMMdd/hh24mi'),");
		sql.append("        TIMESTMP = SYSDATE ");
		sql.append(" WHERE ");
		sql.append("        TIMESTMP = TO_DATE('"+entity.getTimestmp()+"','YYMMDD/HH24MISS')");
		/*  : ü Ȯο TIMESTMP Ű Ȯ
		sql.append("        IATA_PORT = '"+entity.getPrev_iata_port()+"' AND");
		sql.append("        WX_TYP = '"+entity.getPrev_wx_typ()+"' AND");
		sql.append("        TO_CHAR(DTG,'yyMMdd/hh24mi') = '"+entity.getPrev_dtg()+"' AND");
		sql.append("        MAN_DISPLAY = '"+entity.getPrev_man_display()+"' AND");
		sql.append("        MAN_ISS_DT = TO_DATE('"+entity.getPrev_man_iss_dt()+"','yyMMdd/hh24mi') AND");
		sql.append("        MAN_EXP_DT = TO_DATE('"+entity.getPrev_man_exp_dt()+"','yyMMdd/hh24mi') AND");
		sql.append("        COMMNT = '"+entity.getPrev_commnt()+"' AND");
		sql.append("        MAN_PREV_ISS_DT = TO_DATE('"+entity.getPrev_man_prev_iss_dt()+"','yyMMdd/hh24mi') AND");
		sql.append("        MAN_PREV_EXP_DT = TO_DATE('"+entity.getPrev_man_prev_exp_dt()+"','yyMMdd/hh24mi')");
		*/
		
		Logger.debug.println("[BASE:SupA360Query:updAlertAPO] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:updAlertAPO] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Display_y  SQLԼ.
	  * @param entity SupA350BG 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String updDisplay_y(SupA360BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_MANUAL_WEATHER_T ");
		sql.append(" SET DISPLAY_Y = '"+entity.getDisplay_y()+"'");
		sql.append(" WHERE TIMESTMP = TO_DATE('"+entity.getTimestmp()+"','YYMMDD/HH24MISS') ");		
		
		Logger.debug.println("[BASE:SupA360Query:updDisplay_y] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:updDisplay_y] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Է SQLԼ.
	  * @param entity SupA360BG 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String insAlertAPO(SupA360BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_MANUAL_WEATHER_T ( IATA_PORT, WX_TYP, DTG, MAN_ISS_DT, MAN_EXP_DT, COMMNT, ");
		sql.append(" MAN_DISPLAY, TIMESTMP, USERID, DISPLAY_Y ) ");
		sql.append(" VALUES ( '"+entity.getIata_port()+"', '"+entity.getWx_typ()+"', TO_DATE('"+entity.getDtg()+"','YYMMDD/HH24MI'), TO_DATE('"+entity.getMan_iss_dt()+"','YYMMDD/HH24MI'), TO_DATE('"+entity.getMan_exp_dt()+"','YYMMDD/HH24MI'), '"+entity.getCommnt()+"', ");
		sql.append(" '" + entity.getMan_display()+"',sysdate,'"+entity.getUserid()+"','Y')");
		
		Logger.debug.println("[BASE:SupA360Query:insAlertAPO] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:insAlertAPO] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO  SQLԼ.
	  * @param params SupA360BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String delAlertAPO(SupA360BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_MANUAL_WEATHER_T");
		sql.append(" WHERE ");
		sql.append("        TIMESTMP = TO_DATE('"+params.getTimestmp()+"','YYMMDD/HH24MISS')");
		/*  : ü Ÿ Ȯο timestmp Ű  
		sql.append("        IATA_PORT = '"+params.getPrev_iata_port()+"' AND");
		sql.append("        WX_TYP = '"+params.getPrev_wx_typ()+"' AND");
		sql.append("        TO_CHAR(DTG,'yyMMdd/hh24mi') = '"+params.getPrev_dtg()+"' AND");
		sql.append("        MAN_DISPLAY = '"+params.getPrev_man_display()+"' AND");
		sql.append("        MAN_ISS_DT = TO_DATE('"+params.getPrev_man_iss_dt()+"','yyMMdd/hh24mi') AND");
		sql.append("        MAN_EXP_DT = TO_DATE('"+params.getPrev_man_exp_dt()+"','yyMMdd/hh24mi') AND");
		sql.append("        COMMNT = '"+params.getPrev_commnt()+"' AND");
		sql.append("        MAN_PREV_ISS_DT = TO_DATE('"+params.getPrev_man_prev_iss_dt()+"','yyMMdd/hh24mi') AND");
		sql.append("        MAN_PREV_EXP_DT = TO_DATE('"+params.getPrev_man_prev_exp_dt()+"','yyMMdd/hh24mi')");
		*/

		Logger.debug.println("[BASE:SupA360Query:delAlertAPO] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Ÿ  SQL.
	  * @param entity SupA350BG 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selExist(SupA360BG entity){
		StringBuffer sql = new StringBuffer();

		//sql.append(" SELECT * FROM BS_MANUAL_WEATHER_T ");
		//sql.append(" WHERE IATA_PORT = '"+entity.getIata_port()+"' AND WX_TYP = '"+entity.getWx_typ()+"' AND DTG = TO_DATE('"+entity.getDtg()+"','YYMMDD/HH24MI') ");
		sql.append(" SELECT * FROM BS_MANUAL_WEATHER_T ");
		// : ü Ÿ Ȯο timestmpȮ 
		//sql.append(" WHERE IATA_PORT = '"+entity.getIata_port()+"' AND WX_TYP = '"+entity.getWx_typ()+"' AND DTG = TO_DATE('"+entity.getDtg()+"','YYMMDD/HH24MI') ");
		//sql.append(" AND MAN_DISPLAY = '"+entity.getMan_display()+"' AND MAN_ISS_DT = TO_DATE('"+entity.getMan_iss_dt()+"','YYMMDD/HH24MI') AND MAN_EXP_DT = TO_DATE('"+entity.getMan_exp_dt()+"','YYMMDD/HH24MI') AND MAN_PREV_ISS_DT = TO_DATE('"+entity.getMan_prev_iss_dt()+"','YYMMDD/HH24MI') AND MAN_PREV_EXP_DT = TO_DATE('"+entity.getMan_prev_exp_dt()+"','YYMMDD/HH24MI') AND COMMNT = '"+entity.getCommnt()+"'");
		sql.append(" WHERE TIMESTMP = TO_DATE('"+entity.getTimestmp()+"','YYMMDD/HH24MISS') ");
		
		Logger.err.println("[BASE:SupA350Query:selExist] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selAirport(SupA360BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT, IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ");
		if(entity.getIata_port().length() == 3){
			sql.append(" IATA_PORT = '"+entity.getIata_port()+"' ");
		}else{
			sql.append(" ICAO_PORT = '"+entity.getIata_port()+"' ");
		}
		
		Logger.debug.println("[BASE:SupA350Query:selAirport] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO  seq  ȸ.
	  * @return String seqȣ 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selUniSeq(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(UNI_SEQ.NEXTVAL) UNI_SEQ FROM DUAL");
		//Logger.debug.println("[BASE:SupQ350Query:selUniSeq] sql : "+sql.toString());
		return sql.toString();	
	}
	
	/** 
	  * Alert APO    Է
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String insMsTelexMsgORG(String seq, String msg, String originText, String processed){
		StringBuffer sql = new StringBuffer();
		
		sql.append("INSERT INTO MS_TELEX_MSG_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append("VALUES ('ALERTAPO',SYSDATE-9/24,"+seq+",1,1,'"+originText+"','"+msg+"',1,TO_CHAR(SYSDATE,'yyyymmddhh24miss')||TRIM(TO_CHAR('"+seq+"','00000')),TO_CHAR(SYSDATE,'yyyymmddhh24miss')||TRIM(TO_CHAR('"+seq+"','00000')),'"+processed+"',' ')");
		
		Logger.err.println("[BASE:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();
	}
	//20150428 MHS
	public String insMsTelexMsg(String seq, String msg, String originText, String processed){
		
		msg = msg != null ? msg.replace("\"", "") : msg;
		
		StringBuffer sql = new StringBuffer();
		
		//sql.append("INSERT INTO KFOS.MS_TELEX_MHS_T_TEST (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append("INSERT INTO KFOS.MS_TELEX_MHS_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append("VALUES ('ALERTAPO',SYSDATE-9/24,"+seq+",1,1,'"+originText+"','"+msg+"',1,TO_CHAR(SYSDATE,'yyyymmddhh24miss')||TRIM(TO_CHAR('"+seq+"','00000')),TO_CHAR(SYSDATE,'yyyymmddhh24miss')||TRIM(TO_CHAR('"+seq+"','00000')),'"+processed+"',' ')");
		
		Logger.err.println("[BASE:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Ÿ  SQL.
	  * @param entity SupA360BG 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOInfo1(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT A.IATA_PORT, TO_CHAR(A.MAN_ISS_DT,'HH24') MAN_ISS_DT, TO_CHAR(A.MAN_EXP_DT,'HH24') MAN_EXP_DT, A.TIMESTMP \n");
		sql.append(" FROM \n");
		sql.append("      ( SELECT IATA_PORT, MAN_ISS_DT, MAN_EXP_DT, TO_CHAR(TIMESTMP,'YYMMDD/HH24MISS') TIMESTMP, DISPLAY_Y FROM BS_MANUAL_WEATHER_T \n");
		sql.append("        WHERE WX_TYP IN ('OTS1', 'OTS2') ) A,  \n");
		sql.append("      DAILY_SCH_T B \n");
		sql.append(" WHERE B.FIRST_LEG_FLT_DT >= SYSDATE - 9/24 - 2 \n");
		sql.append(" AND B.FIRST_LEG_FLT_DT <= SYSDATE - 9/24 + 1 \n");
		sql.append(" AND A.IATA_PORT IN(B.STNFR, B.STNTO) \n");
		sql.append(" AND A.MAN_EXP_DT >= B.SCH_DEP_DT \n");//2012.04.09 : B.EST_DEP_DT -> B.SCH_DEP_DT 
		sql.append(" AND A.MAN_ISS_DT <= B.SCH_ARV_DT \n");//2012.04.09 : B.EST_ARV_DT -> B.SCH_ARV_DT 
		sql.append(" AND A.DISPLAY_Y = 'Y' \n");
		
		Logger.debug.println("[BASE:SupA360Query:selAlertAPOInfo1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Ÿ  SQL.
	  * @param entity SupA360BG 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOInfo2(){
		StringBuffer sql = new StringBuffer();
		
		/* 2012.04.10  ü : WX ALERT STATUS  ش οʹ  ǥ
		sql.append(" SELECT DISTINCT A.IATA_PORT, A.WX_TYP, TO_CHAR(A.MAN_ISS_DT, 'DD/HH24MI') MAN_ISS_DT, TO_CHAR(A.MAN_EXP_DT,'DD/HH24MI') MAN_EXP_DT, TIMESTMP ");
		sql.append(" FROM (SELECT IATA_PORT, WX_TYP, MAN_ISS_DT, MAN_EXP_DT, TO_CHAR(TIMESTMP,'YYMMDD/HH24MISS') TIMESTMP, DISPLAY_Y FROM BS_MANUAL_WEATHER_T ");
		sql.append("             WHERE WX_TYP NOT IN ('OTS1', 'OTS2', 'TM', 'NTC')) A, DAILY_SCH_T B ");//2012.04.09 : NTC ߰
		sql.append(" WHERE B.FIRST_LEG_FLT_DT >= SYSDATE -9/24 - 2  ");
		sql.append(" AND B.FIRST_LEG_FLT_DT <= SYSDATE -9/24 + 1 ");
		sql.append(" AND A.IATA_PORT IN(B.STNFR, B.STNTO) ");
		sql.append(" AND A.MAN_EXP_DT >= B.SCH_DEP_DT ");//2012.04.09 : B.EST_DEP_DT -> B.SCH_DEP_DT 
		sql.append(" AND A.MAN_ISS_DT <= B.SCH_ARV_DT ");//2012.04.09 : B.EST_ARV_DT -> B.SCH_ARV_DT 
		sql.append(" AND A.DISPLAY_Y = 'Y' ");
		*/
		
		sql.append(" SELECT IATA_PORT, WX_TYP, TO_CHAR(MAN_ISS_DT, 'DD/HH24MI') MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'DD/HH24MI') MAN_EXP_DT, COMMNT, TO_CHAR(TIMESTMP,'YYMMDD/HH24MISS') TIMESTMP ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE WX_TYP NOT IN ('OTS1', 'OTS2', 'TM','NTC' ) ");
		sql.append(" AND MAN_DISPLAY IN ('ALL', 'DSP') ");
		sql.append(" AND MAN_ISS_DT >= SYSDATE -3 ");
		sql.append(" AND MAN_EXP_DT <= SYSDATE+3 ");
		sql.append(" AND DISPLAY_Y = 'Y' ");
		sql.append(" ORDER BY DTG ASC ");
		
		Logger.debug.println("[BASE:SupA360Query:selAlertAPOInfo2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO TYPE Port   List
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOByTypes(String code){
		StringBuffer sql = new StringBuffer();
		
		//߰
		sql.append(" SELECT A.IATA_PORT, A.WX_TYP, TO_CHAR(A.DTG,'YYMMDDHH24MI') DTG, TO_CHAR(A.MAN_ISS_DT,'YYYYMMDDHH24MI') MAN_ISS_DT, TO_CHAR(A.MAN_EXP_DT,'YYYYMMDDHH24MI') MAN_EXP_DT, A.COMMNT, TO_CHAR(A.TIMESTMP,'YYMMDD/HH24MISS') TIMESTMP, B.FLT_NUM, ");
		sql.append(" DECODE(A.IATA_PORT, B.STNFR, 'STD', B.STNTO, 'STA', '') ST, ");
		sql.append(" DECODE(A.IATA_PORT, B.STNFR, TO_CHAR(B.EST_DEP_DT,'DDHH24MI'), B.STNTO, TO_CHAR(B.EST_ARV_DT,'DDHH24MI'), '') EST_DT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T A, DAILY_SCH_T B ");
		sql.append(" WHERE A.IATA_PORT = B.STNFR(+) ");
		//PreparedStatement ϴ  ƴ ڿ  ̹Ƿ ǿ  бؼ ڵ ۼ
		//WARN : 溸
		//OTS1  : ǰ
		if(code.equals("WARN")){
		    sql.append(" AND A.WX_TYP NOT IN ('TM', 'OTS1', 'OTS2', 'NTC') ");//2012.02.29 NTC ߰
		}else if(code.equals("OTS1")){
			sql.append(" AND A.WX_TYP IN ( 'OTS1','NTC') ");//2012.02.29 NTC ߰
		}else if(code.equals("OTS2")){
			sql.append(" AND A.WX_TYP = 'OTS2' ");
		}else if(code.equals("TM")){
			sql.append(" AND A.WX_TYP = 'TM' ");
		}
		sql.append(" AND A.MAN_DISPLAY IN ('ALL', 'DSP') ");
		sql.append(" AND B.FIRST_LEG_FLT_DT(+) >= SYSDATE - 9/24 - 2 ");
		sql.append(" AND B.FIRST_LEG_FLT_DT(+) <= SYSDATE - 9/24 + 1 ");
		sql.append(" AND (B.SCH_DEP_DT(+) BETWEEN A.MAN_ISS_DT AND A.MAN_EXP_DT) ");//2012.04.09 : B.EST_DEP_DT -> B.SCH_DEP_DT 
		sql.append(" AND A.DISPLAY_Y = 'Y' ");
		sql.append(" AND B.ACTNID(+) <> 'CNL' ");
		sql.append(" UNION ");
		// 
		sql.append(" SELECT A.IATA_PORT, A.WX_TYP, TO_CHAR(A.DTG,'YYMMDDHH24MI') DTG, TO_CHAR(A.MAN_ISS_DT,'YYYYMMDDHH24MI') MAN_ISS_DT, TO_CHAR(A.MAN_EXP_DT,'YYYYMMDDHH24MI') MAN_EXP_DT, A.COMMNT, TO_CHAR(A.TIMESTMP,'YYMMDD/HH24MISS') TIMESTMP, B.FLT_NUM, ");
		sql.append(" DECODE(A.IATA_PORT, B.STNFR, 'STD', B.STNTO, 'STA', '') ST, ");
		sql.append(" DECODE(A.IATA_PORT, B.STNFR, TO_CHAR(B.EST_DEP_DT,'DDHH24MI') , B.STNTO, TO_CHAR(B.EST_ARV_DT,'DDHH24MI'), '') EST_DT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T A, DAILY_SCH_T B ");
		sql.append(" WHERE A.IATA_PORT = B.STNTO(+) ");
		if(code.equals("WARN")){
			sql.append(" AND A.WX_TYP NOT IN ('TM', 'OTS1', 'OTS2', 'NTC') ");//2012.02.29 NTC ߰
		}else if(code.equals("OTS1")){
			sql.append(" AND A.WX_TYP IN ('OTS1','NTC') ");//2012.02.29 NTC ߰
		}else if(code.equals("OTS2")){
			sql.append(" AND A.WX_TYP = 'OTS2' ");
		}else if(code.equals("TM")){
			sql.append(" AND A.WX_TYP = 'TM' ");
		}
		sql.append(" AND A.MAN_DISPLAY IN ('ALL', 'DSP') ");
		sql.append(" AND B.FIRST_LEG_FLT_DT(+) >= SYSDATE - 9/24 - 2 ");
		sql.append(" AND B.FIRST_LEG_FLT_DT(+) <= SYSDATE - 9/24 + 1 ");
		sql.append(" AND (B.SCH_ARV_DT(+) BETWEEN A.MAN_ISS_DT AND A.MAN_EXP_DT) ");//2012.04.09 : B.EST_ARV_DT -> B.SCH_DEP_DT 
		sql.append(" AND A.DISPLAY_Y = 'Y' ");
		sql.append(" AND B.ACTNID(+) <> 'CNL' ");
		//BS_MANUAL_WEATHER_T̺ Ÿ  TIMESTMP Ǻ
		//sql.append(" ORDER BY IATA_PORT ASC, WX_TYP ASC, DTG ASC ");
		sql.append(" ORDER BY TIMESTMP ASC ");
		
		
		//Logger.debug.println("[BASE:SupA360Query:selAlertAPOByTypes] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:selAlertAPOByTypes] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Warn Port(溸) List 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOFltList(SupA360BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.FLT_NUM, TO_CHAR(B.EST_ARV_DT, 'DDHH24MI') EST_ARV_DT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T A, DAILY_SCH_T B ");
		sql.append(" WHERE A.IATA_PORT='"+entity.getIata_port()+"'");	
		sql.append(" AND A.WX_TYP = '"+entity.getWx_typ()+"'");
		sql.append(" AND A.DTG = TO_DATE('"+entity.getDtg()+"','YYMMDDHH24MI')");
		sql.append(" AND B.EST_DEP_DT BETWEEN TO_DATE('"+entity.getMan_iss_dt()+"','YYYYMMDDHH24MI') AND TO_DATE('"+entity.getMan_exp_dt()+"','YYYYMMDDHH24MI') ");
		sql.append(" AND B.STNFR = '"+entity.getIata_port()+"'");
		sql.append(" UNION ");
		sql.append(" SELECT B.FLT_NUM, TO_CHAR(B.EST_ARV_DT, 'DDHH24MI') EST_ARV_DT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T A, DAILY_SCH_T B ");
		sql.append(" WHERE A.IATA_PORT='"+entity.getIata_port()+"'");
		sql.append(" AND A.WX_TYP = '"+entity.getWx_typ()+"'");
		sql.append(" AND A.DTG = TO_DATE('"+entity.getDtg()+"','YYMMDDHH24MI')");
		sql.append(" AND B.EST_ARV_DT BETWEEN TO_DATE('"+entity.getMan_iss_dt()+"','YYYYMMDDHH24MI') AND TO_DATE('"+entity.getMan_exp_dt()+"','YYYYMMDDHH24MI') ");
		sql.append(" AND B.STNTO = '"+entity.getIata_port()+"'");
		
		//Logger.debug.println("[BASE:SupA310Query:selAlertAPOFltList] sql : "+sql.toString());
		System.out.println("[BASE:SupA310Query:selAlertAPOFltList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Warn Port(溸) List 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOFfs(SupA360BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT A.IATA_PORT, A.WX_TYP, TO_CHAR(A.MAN_ISS_DT,'DDHH24MI')||'Z' MAN_ISS_DT, TO_CHAR(A.MAN_EXP_DT, 'DDHH24MI')||'Z' MAN_EXP_DT , A.COMMNT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T A, DAILY_SCH_T B");
		sql.append(" WHERE ");
		sql.append(" A.MAN_EXP_DT >= B.SCH_DEP_DT ");//2012.03.05 : B.EST_DEP_DT -> B.SCH_DEP_DT  
		sql.append(" AND A.MAN_ISS_DT <= B.SCH_ARV_DT ");//2012.03.05 : B.EST_ARV_DT -> B.SCH_ARV_DT  
		sql.append(" AND B.FLT_NUM = '"+entity.getFlt_num() +"'");
		sql.append(" AND B.STNFR = '"+entity.getStnfr() +"'");
		sql.append(" AND A.IATA_PORT IN (B.STNFR, B.STNTO) ");
		sql.append(" AND A.MAN_DISPLAY IN ('ALL', 'DSP') ");
		sql.append(" AND B.FIRST_LEG_FLT_DT >= SYSDATE - 9/24 -2 ");
		sql.append(" AND B.FIRST_LEG_FLT_DT <= SYSDATE - 9/24 +1 ");
		sql.append(" AND DISPLAY_Y = 'Y' ");
		sql.append(" AND WX_TYP <> 'NTC' ");
		sql.append(" ORDER BY A.IATA_PORT ");
		
		Logger.err.println("[BASE:SupA360Query:selAlertAPOFfs] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:selAlertAPOFfs] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request   ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selStationInfo(String stn){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT, IATA_PORT, PORT_E, CURFEW, ");
		sql.append(" NVL(GMT_OFFSET,0)/60 GMT_OFFSET, TO_CHAR(SYSDATE-(9/24),'DD/MM/YY HH24:MI') NOW_TIME, ");
		sql.append(" RWY_INFO ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT = '"+stn+"' ");
		
		Logger.debug.println("[BASE:SupA360Query:selStationInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request  RWY  ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2011/12/08 
	  */
	public String selRwyInfo2(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RWY_DIR ");
		sql.append(" FROM BS_PORT_RWY_T ");
		sql.append(" WHERE ICAO_PORT = '"+stn+"' ");
		sql.append(" ORDER BY RWY_SEQ ");
		
		Logger.debug.println("[BASE:SupQ360Query:selRwyInfo2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Warn Port(溸) List 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPOIrops(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT, WX_TYP, TO_CHAR(DTG,'YYMMDD/HH24MI') DTG, TO_CHAR(MAN_ISS_DT,'DDHH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'DDHH24MI')||'Z' MAN_EXP_DT, COMMNT ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		/* 2012.03.05 MAN_ISS_DT, MAN_EXP_DT  
		sql.append(" WHERE MAN_ISS_DT <= SYSDATE - 9/24 ");
		sql.append(" AND MAN_EXP_DT >= SYSDATE - 9/24 ");
		sql.append(" AND MAN_DISPLAY IN ('ALL', 'PAX') ");*/
		sql.append(" WHERE MAN_DISPLAY IN ('ALL', 'PAX') ");
		sql.append(" AND DISPLAY_Y = 'Y' ");
		sql.append(" ORDER BY DTG ASC ");
		
		//Logger.debug.println("[BASE:SupA360Query:selAlertAPOIrops] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:selAlertAPOIrops] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Alert APO Dss List 
	  * @return String Query 
	  * @author Copyright (c) 2011/11/04 
	  */
	public String selAlertAPODss(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT, TO_CHAR(MAN_ISS_DT,'YYMMDD/HH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'YYMMDD/HH24MI')||'Z' MAN_EXP_DT , DTG, 'OTS1' WX_TYP, '' COMMNT, 'A' ORD ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE DISPLAY_Y = 'Y' ");
		sql.append(" AND WX_TYP = 'OTS1' ");
		sql.append(" UNION ALL");
		sql.append(" SELECT IATA_PORT, TO_CHAR(MAN_ISS_DT,'YYMMDD/HH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'YYMMDD/HH24MI')||'Z' MAN_EXP_DT , DTG, 'OTS2' WX_TYP, '' COMMNT, 'B' ORD ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE DISPLAY_Y = 'Y' ");
		sql.append(" AND WX_TYP = 'OTS2' ");
		sql.append(" UNION ALL");
		sql.append(" SELECT IATA_PORT, TO_CHAR(MAN_ISS_DT,'YYMMDD/HH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'YYMMDD/HH24MI')||'Z' MAN_EXP_DT , DTG, 'TM' WX_TYP, '' COMMNT, 'C' ORD ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE DISPLAY_Y = 'Y' ");
		sql.append(" AND WX_TYP = 'TM' ");
		sql.append(" UNION ALL");
		sql.append(" SELECT IATA_PORT, TO_CHAR(MAN_ISS_DT,'YYMMDD/HH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'YYMMDD/HH24MI')||'Z' MAN_EXP_DT , DTG, 'NTC' WX_TYP, COMMNT, 'D' ORD ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE DISPLAY_Y = 'Y' ");
		sql.append(" AND WX_TYP = 'NTC' ");
		sql.append(" UNION ALL");
		sql.append(" SELECT IATA_PORT, TO_CHAR(MAN_ISS_DT,'YYMMDD/HH24MI')||'Z' MAN_ISS_DT, TO_CHAR(MAN_EXP_DT,'YYMMDD/HH24MI')||'Z' MAN_EXP_DT , DTG, 'WARN' WX_TYP, '' COMMNT, 'E' ORD ");
		sql.append(" FROM BS_MANUAL_WEATHER_T ");
		sql.append(" WHERE DISPLAY_Y = 'Y' ");
		sql.append(" AND WX_TYP NOT IN ('OTS1', 'OTS2', 'TM', 'NTC') ");
		sql.append(" ORDER BY ORD ASC, DTG DESC ");
		
		//Logger.debug.println("[BASE:SupA360Query:selAlertAPODss] sql : "+sql.toString());
		System.out.println("[BASE:SupA360Query:selAlertAPODss] sql : "+sql.toString());
		return sql.toString();
	}
}
