package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2  ABBR Information   Query
 * ۼ ¥: 2005-05-30
 * @author: HIST  
 */
public class SupA710Query {
	private static SupA710Query instance = new SupA710Query();
	
	public static SupA710Query getInstance() {
		return instance;
	}
	
	/** 
	  * BASE2 ABBR Information Main ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String selABBRInfo(SupA710BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * FROM BS_ABBR_T");
		sql.append(" WHERE ABBR_CD IS NOT NULL");
		if (!params.getAbbr_cd().equals(""))
			sql.append(" AND ABBR_CD = '"+params.getAbbr_cd()+"'");
		if (!params.getOrgn_cd().equals(""))
			sql.append(" AND ORGN_CD = '"+params.getOrgn_cd()+"'");
		if (!params.getSign().equals(""))
			sql.append(" AND UPPER(SIGN) LIKE '%"+params.getSign().toUpperCase()+"%'");
		sql.append(" ORDER BY ABBR_CD");
		
		Logger.debug.println("[BASE:SupA710Query:selABBRInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2 ABBR Information  ȸ SQLԼ.
	  * @param params SupA710BG ȸ 
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String selABBRCd(SupA710BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * FROM BS_ABBR_T");
		sql.append(" WHERE ABBR_CD = '"+params.getAbbr_cd()+"'");
		sql.append(" AND ORGN_CD = '"+params.getOrgn_cd()+"'");
		sql.append(" ORDER BY ABBR_CD");
		
		Logger.debug.println("[BASE:SupA710Query:selABBRCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 ABBR Information Է SQLԼ.
	  * @param params SupA710BG Է 
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String insABBRInfo(SupA710BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_ABBR_T");
		sql.append(" VALUES ('"+params.getAbbr_cd()+"','"+params.getOrgn_cd()+"','"+StringUtil.toKSC5601(params.getSign())+"',SYSDATE,'"+params.getUserid()+"')");
		
		Logger.debug.println("[BASE:SupA710Query:insABBRInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 ABBR Information  SQLԼ.
	  * @param params SupA710BG  
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String updABBRInfo(SupA710BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_ABBR_T");
		sql.append(" SET SIGN = '"+StringUtil.toKSC5601(params.getSign())+"',");
		sql.append("     	TIMESTMP = SYSDATE,");
		sql.append("     	USERID = '"+params.getUserid()+"'");
		sql.append(" WHERE ABBR_CD = '"+params.getAbbr_cd()+"'");
		sql.append(" AND ORGN_CD = '"+params.getOrgn_cd()+"'");
		
		Logger.debug.println("[BASE:SupA710Query:updABBRInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 ABBR Information  SQLԼ.
	  * @param params SupA710BG  
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String delABBRInfo(SupA710BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_ABBR_T");
		sql.append(" WHERE ABBR_CD = '"+params.getAbbr_cd()+"'");
		sql.append(" AND ORGN_CD = '"+params.getOrgn_cd()+"'");
		
		Logger.debug.println("[BASE:SupA710Query:delABBRInfo] sql : "+sql.toString());
		return sql.toString();
	}	
}
