package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2  Q-Code Information   Query
 * ۼ ¥: 2005-05-30
 * @author: HIST  
 */
public class SupA720Query {
	private static SupA720Query instance = new SupA720Query();
	
	public static SupA720Query getInstance() {
		return instance;
	}
	
	/** 
	  * BASE2 Q-Code Information Main ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String selQCodeInfo(String mode,String notQcd,String notCls,String notAbbr,String notSign) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DECODE(NOT_QSEQ,'2','Q23','Q45') NOT_QSEQ,NOT_QCD,NOT_CLS,NOT_ABBR,NOT_SIGN");
		sql.append(" FROM BS_NOTAM_QCD_T");
		sql.append(" WHERE  NOT_QSEQ = '"+mode+"'");
		if (!notQcd.equals(""))
			sql.append(" AND NOT_QCD = '"+notQcd+"'");
		if (!notCls.equals(""))
			sql.append(" AND NOT_CLS = '"+notCls+"'");
		if (!notAbbr.equals(""))
			sql.append(" AND UPPER(NOT_ABBR) LIKE '%"+notAbbr.toUpperCase()+"%'");
		if (!notSign.equals(""))
			sql.append(" AND UPPER(NOT_SIGN) LIKE '%"+notSign.toUpperCase()+"%'");
		sql.append(" ORDER BY NOT_QSEQ,NOT_QCD,NOT_CLS,NOT_ABBR");
		
		Logger.debug.println("[BASE:SupA720Query:selQCodeInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2 Q-Code Information  ȸ SQLԼ.
	  * @param params SupA720BG ȸ 
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String selQCodeCd(String mode,String notQcd,String notCls) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT *");
		sql.append(" FROM BS_NOTAM_QCD_T");
		sql.append(" WHERE NOT_CLS = '"+notCls+"'");
		sql.append(" AND NOT_QSEQ = '"+mode+"'");
		sql.append(" AND NOT_QCD = '"+notQcd+"'");
		
		Logger.debug.println("[BASE:SupA720Query:selQCodeCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Q-Code Information Է SQLԼ.
	  * @param params SupA720BG Է 
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String insQCodeInfo(String mode,String notQcd,String notCls,String notAbbr,String notSign,String userID) {
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_NOTAM_QCD_T");
		sql.append(" VALUES ('"+notCls+"',"+mode+",'"+notQcd+"','"+notAbbr+"','"+notSign+"',SYSDATE,'"+userID+"')");
		
		Logger.debug.println("[BASE:SupA720Query:insQCodeInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Q-Code Information  SQLԼ.
	  * @param params SupA720BG  
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String updQCodeInfo(String mode,String notQcd,String notCls,String notAbbr,String notSign,String userID) {
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_QCD_T");
		sql.append(" SET NOT_ABBR = '"+notAbbr+"',");
		sql.append("     	NOT_SIGN = '"+notSign+"'");
		sql.append(" 		USERID = '"+userID+"'");
		sql.append(" WHERE NOT_CLS = '"+notCls+"'");
		sql.append(" AND NOT_QSEQ = '"+mode+"'");
		sql.append(" AND NOT_QCD = '"+notQcd+"'");
		
		Logger.debug.println("[BASE:SupA720Query:updQCodeInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Q-Code Information  SQLԼ.
	  * @param params SupA720BG  
	  * @return String Query  
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public String delQCodeInfo(String mode,String notQcd,String notCls) {
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_NOTAM_QCD_T");
		sql.append(" WHERE NOT_CLS = '"+notCls+"'");
		sql.append(" AND NOT_QSEQ = '"+mode+"'");
		sql.append(" AND NOT_QCD = '"+notQcd+"'");
		
		Logger.debug.println("[BASE:SupA720Query:delQCodeInfo] sql : "+sql.toString());
		return sql.toString();
	}	

}
