package kal.base.com.ejb;

//ڹ 
import java.awt.Insets;
import java.io.*;
import java.sql.*;
import java.text.*;
import java.net.*;
import java.math.* ;
import java.util.*;

import kal.base.com.query.ComQ01Query; 
import kal.base.com.query.ComQ02Query;
import kal.base.iro.dbbean.*;
import kal.base.com.util.MessageCode;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.db.BusinessException;
import kal.base.jdf.db.ConnectionResource;
import kal.base.jdf.ejb.BeanAdapter;
import kal.base.pbf.db.ToolConnectionResource;



//ڹ ϰ
import java.rmi.*;

import javax.ejb.*;
import javax.naming.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

//PD4ML
import org.zefer.pd4ml.PD4ML;
import org.zefer.pd4ml.PD4PageMark;
import org.zefer.pd4ml.PD4Constants;
/**
 * Bean implementation class for Enterprise Bean: ComAllSL
 */
public class ComAllSLBean extends BeanAdapter {
	
	/** 
	  *  DB ð ȸ SQLԼ.
	  * @param format String Return Date Format  ex) YYYYMMDD
	  * @param setTime String  ð ex) GMT : 540/1440   KST : 0
	  * @return String ȸ DB Time
	  * @exception Exception
	  * @author Copyright (c) 2005/01/06 HIST 
	  */
	public String selDbTime(String format,String setTime) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String dbTime = null;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DB TABLE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selDbTime(format,setTime); 
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				dbTime = StringUtil.checkString(rs.getString("DB_TIME"));
			}
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selDbTime:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selDbTime:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return dbTime;
	}//end of function
	
	/** 
	  * DB Table ȸ Լ.
	  *  Table SELECT ,TABLE,ȸ,ORDERBY  ȸѴ
	  *  Լ  DB TABLE FLEXIBLE ȸ   ȸϴ
	  * @param arrParam String[] ȸ  [0]SELECT [1]TABLE [2]WHERE [3]ORDERBY [4]SELECT
	  * @return List ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/06 HIST 
	  */
	public List selDbTable(String[] arrParam) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    List listData = new LinkedList();
	    List listRow = null;
	   
	    try {
	    	// и
	    	String selName = arrParam[0];
	    	String tblName = arrParam[1];
	    	String paramName = arrParam[2];
	    	String orderName = arrParam[3];
	    	int selCnt = Integer.valueOf(arrParam[4]).intValue();
	    	
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DB TABLE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selDbTable(selName,tblName,paramName,orderName);
			rs = stmt.executeQuery(sql);
			
			//Listȿ List Cross ԽŲ
			while (rs.next()) {
				//ȸ SELECT ʵ ŭ ARRAY Ѵ
				listRow = new LinkedList();
				for (int i=0; i<listRow.size(); i++) {
					listRow.add(StringUtil.checkString(rs.getString(i+1)));
				}
				listData.add(listRow);
			} 
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selDbTable:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selDbTable:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return listData;
	}//end of function
	
	/** 
	  * ACTYP ȸ Լ.
	  * @return Vector ȸ ACTYP
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public Vector selActyp() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Vector vtData = new Vector();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DB TABLE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selActyp();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				vtData.add(StringUtil.checkString(rs.getString("Code_c")));
			}
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selActyp:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selActyp:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return vtData;
	}//end of function	
	
	/** 
	  * Desk Description ȸ Լ.
	  * @param String descE Desk_Code
	  * @return String ȸ Code_x
	  * @exception Exception
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String selDesk(String deskX) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String codeX = null;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DB TABLE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selDesk(deskX);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) codeX = StringUtil.checkString(rs.getString("Code_x"));
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selDesk:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selDesk:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return codeX;
	}//end of function	
	
	/** 
	  * FTS  ȸ SQLԼ.
	  * @param empNo String USER ID
	  * @return String ȸ FTS 
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String selFtsAuth(String empNo) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String authPmsn = null;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//FTS ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selFtsAuth(empNo);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) authPmsn = StringUtil.checkString(rs.getString("Auth_Pmsn"));
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selFtsAuth:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selFtsAuth:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return authPmsn;
	}//end of function	
	
	/** 
	  * FTS Menu ȸ SQLԼ.
	  * @return String ȸ FTS Menu
	  * @exception Exception
	  * @author Copyright (c) 2005/04/27 HIST 
	  */
	public Hashtable selFtsMenu() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			conn.setAutoCommit(false);

			
			//FTS ȸ
			//stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selFtsMenu();
			//sql = "Select * From fc_report_t@fuel Where rownum = 1";
			//sql = "Select * From fc_report_t";
			pstmt = conn.prepareStatement(sql);
			rs = pstmt.executeQuery();

			//rs = stmt.executeQuery(sql);
			//rs = stmt.executeQuery(" Select Rpt_No,Rpt_Loc From fc_report_t FOR UPDATE");
			
			while (rs.next()) {
				String menuKey = StringUtil.checkString(rs.getString(1));
				String rptLoc = StringUtil.checkString(rs.getString(2));
				hashData.put(menuKey,rptLoc);
				/*
				StringBuffer output = new StringBuffer();
				Reader input = rs.getCharacterStream("Rpt_Loc");
				char[] buffer = new char[1024];
				int byteRead=0;
				
				while((byteRead=input.read(buffer,0,1024))!=-1){
					output.append(buffer,0,byteRead);
				}
				input.close();
				
				//Clob clob  = rs.getClob(1); 
				//CLOB clob = ((oracle.sql.CLOB)rs).getClob("Rpt_Loc");
				CLOB clob = ((oracle.sql.CLOB)rs).getCLOB(2); 


				Writer writer = clob.getCharacterOutputStream();
				Reader src = new CharArrayReader(content.toCharArray());
				char[] buffer = new char[1024];
				int read = 0;
				while ( (read = src.read(buffer,0,1024)) != -1) {
					writer.write(buffer, 0, read);
				}
			   src.close(); 
			   writer.close();
				hashData.put(menuKey,output.toString());
				*/
			}
			
			conn.commit();
		    conn.setAutoCommit(true);


			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selFtsMenu:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selFtsMenu:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * Region Flight ȸ SQLԼ.
	  * @param fltNum String Flight Number
	  * @return String ȸ Region Flight Code
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String getRegionFlt(String fltNum) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String regionFlt = null;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//FTS ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().getRegionFlt(fltNum);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) regionFlt = StringUtil.checkString(rs.getString("Region_Flt"));
			else regionFlt = "9";
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:getRegionFlt:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:getRegionFlt:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return regionFlt;
	}//end of function		
	
	/** 
	  * Region X ȸ SQLԼ.
	  * @param stnFr String  Station From
	  * @param stnTo String  Station To
	  * @return String ȸ Region X Code
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String getRegionX(String stnFr, String stnTo) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String regionX = null;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//FTS ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().getRegionX(stnFr,stnTo);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) regionX = StringUtil.checkString(rs.getString("Region_x"));
			else regionX = "9";
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:getRegionX:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:getRegionX:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return regionX;
	}//end of function	
	
	/** 
	  *  IP Check Լ.
	  * @param arrIP String[]  IP Code
	  * @return boolean  
	  * @exception Exception
	  * @author Copyright (c) 2005/05/04 HIST 
	  */
	public boolean selIpCheck(String[] arrIP) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    boolean ipFlag = false;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IP Check
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selIpCheck(arrIP[0],arrIP[1],arrIP[2],arrIP[3]);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				if (rs.getInt("Cnt") > 0) ipFlag = true;
			}
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selIpCheck:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selIpCheck:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return ipFlag;
	}//end of function		
	
	/** 
	  * IROPS ߻  ȸ SQLԼ.
	  * @return Hashtable ȸ IROPSǼ
	  * @exception Exception
	  * @author Copyright (c) 2005/07/05 HIST 
	  */
	public Hashtable selIropsData() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    List listData = new LinkedList();
	    Hashtable hashData = new Hashtable();
	    
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROS ߻  ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selIrops();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA010BG entity = new IroA010BG();
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				entity.setTitle_x(StringUtil.checkString(rs.getString("Title_X")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("First_Mon")));
				listData.add(entity);
			}
			
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selIropsData:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selIropsData:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	/** 
	  * Area Code ȸ SQLԼ.
	  * @return List ȸ Area Code
	  * @exception Exception
	  * @author Copyright (c) 2005/07/05 HIST 
	  */
	public List selAreaList(String mode) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;

		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    List listData = new LinkedList();
	    
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Area Code  ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selAreaList(mode);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				listData.add(StringUtil.checkString(rs.getString("AREA_CD")));
			}
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:selAreaList:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:selAreaList:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return listData;
	}//end of function	
	
	/** 
	  * FFS  CODE_T ȸ
	  * @return String
	  * @exception Exception
	  * @author Copyright (c) 2008/12/01 
	  */
	public String getNaiRange() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	    
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//NAI RANGE ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().getNaiRange();
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				returnValue = StringUtil.checkString(rs.getString("OTHRS_E"));
			}
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception e) {}
			Logger.debug.println("[BASE:ComAllSLBean:getNaiRange:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ce) {}
			Logger.debug.println("[BASE:ComAllSLBean:getNaiRange:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function	
	
	/** 
	  * <b>Java Mail Sending Լ</b>. 
	  * @param host String SMTP HOST Server IP
	  * @param from String  
	  * @param to String[] ޴»
	  * @param subject String 
	  * @param contents String 
	  * @return  String Mail ۽  
	  * @exception Exception
	  * @author Copyright (c) 2004/07/20 HIST 
	  */	
	public String sendMail (String host, String from, String[] to, String subject, String contents) throws BusinessException {
		String flagMail = "N";
		try {
			/*
			Context initial = new InitialContext();
			Session session = (Session)initial.lookup("java:comp/env/MailSession");
			MimeMessage msg = new MimeMessage(session);
			msg.setFrom(new InternetAddress("juping@hist.co.kr","","KSC5601"));
			msg.setRecipients(javax.mail.Message.RecipientType.TO, InternetAddress.parse(to,false));
			msg.setSubject(contents);
			msg.setSentDate(StringUtil.getGMTDate());
			Transport.send(msg);
			*/
				
			System.out.println("[ComAllSLBean:sendMail] HOST : "+host+", TO : "+to[0]+", SUBJECT : "+subject);
			
			//ѱۺȯ
			//subject = StringUtil.to8859_1(subject);
			//subject = StringUtil.toKSC5601(subject);
			//contents = StringUtil.replaceBR(contents);
			//contents = StringUtil.toKSC5601(contents);
			
			//Logger.debug.println("[ComAllSLBean:sendMail] subject : "+subject);
				
			//Mail Property 
			Properties mailProps = null;
			mailProps = System.getProperties();
			mailProps.put("mail.smtp.host", host);
			//mailProps.put("mail.smtp.RemoteHost", host);
			//mailProps.put("mail.smtp.RemotePort","25");
			Session mailSession = Session.getInstance(mailProps, null);
			
			// ּ 
			InternetAddress toAddrs[] = new InternetAddress[to.length];
			for (int i=0; i<to.length; i++) {
				toAddrs[i] = new InternetAddress(to[i]);
			}
						
			//۽ ּ 
			InternetAddress fromAddr = new InternetAddress(from);
			MimeMessage message = new MimeMessage(mailSession);
			
			message.setFrom(fromAddr);
			message.setRecipients(javax.mail.Message.RecipientType.TO, toAddrs);
			message.setSubject(subject,"EUC-KR");
			
			//Mail  
			MimeBodyPart mbp = new MimeBodyPart();
			mbp.setContent(contents, "text/html;charset=EUC-KR");
			//mbp.setContent(contents, "text/html;charset=KSC5601");
			
			Multipart mp = new MimeMultipart();
			mp.addBodyPart(mbp);
			message.setContent(mp);
			
			//Mail ۽
			Transport.send(message);
			
			flagMail = "Y";	
				
		} catch(Exception e) {
			System.out.println(((Exception)e).getMessage());
			//throw new BusinessException(((Exception)e).getMessage());
		}			
		return flagMail;	
	}//end function	
	
	/** 
	  * NOTAM  Mail 
	  * @param host String SMTP HOST Server ּ
	  * @param from String  
	  * @param to String[] ޴»
	  * @param subject String 
	  * @param contents String 
	  * @return  String Mail ۽  
	  * @exception Exception
	  * @author Copyright (c) 2009/01/21 
	  */	
	public String sendMailNOTAM(String host, String from, String[] to, String subject, String contents, String pdfTitle) throws BusinessException {
		
		String flagMail = "N";
		
		try {
			System.out.println("[ComAllSLBean:sendMailNOTAM] HOST : "+host+", TO : "+to[0]+", SUBJECT : "+subject);
				
			//Mail Property 
			Properties mailProps = null;
			mailProps = System.getProperties();
			mailProps.put("mail.smtp.host", host);
			Session mailSession = Session.getInstance(mailProps, null);
			MimeMessage message = new MimeMessage(mailSession);
			
			// ּ 
			InternetAddress toAddrs[] = new InternetAddress[to.length];
			for (int i=0; i<to.length; i++) {
				toAddrs[i] = new InternetAddress(to[i]);
			}
			message.setRecipients(javax.mail.Message.RecipientType.TO, toAddrs);
			
			//۽ ּ 
			InternetAddress fromAddr = new InternetAddress(from);
			message.setFrom(fromAddr);
			
			//Mail  
			message.setSubject(subject,"EUC-KR");
			
			//Mail  
			Multipart mp = new MimeMultipart();
			
			//1. 
			MimeBodyPart mbp = new MimeBodyPart();
			//mbp.setContent(contents, "text/html;charset=EUC-KR");
			mbp.setContent(" ", "text/html;charset=EUC-KR");
			mp.addBodyPart(mbp);
			
			//****************************************************************************
			/*
			String rdName = ""; //ӽ  ̸
			Random rd = new Random();
			rdName = String.valueOf(rd.nextInt(99999999)).toString();
			
			String notamFilePath = "/opt/apps/attach/notam_pdf/"; // ġ
			
			String tmpHtmlPath = notamFilePath + rdName + ".html"; //ȯų HTML 
			String tmpPdfPath = notamFilePath + rdName + ".pdf"; //ȯŲ PDF 
			
	        FileOutputStream hfos = new FileOutputStream(tmpHtmlPath); //HTML  
	        hfos.write(contents.getBytes());
	        hfos.flush();
	        hfos.close();
			
	        //**** HTML -> PDF ȯ ****
			File pFile = new File(tmpPdfPath);
			FileOutputStream pfos = new FileOutputStream(pFile);
			
			PD4ML pd4ml = new PD4ML();
			
			PD4PageMark footer = new PD4PageMark(); //2009.04.20 ߰ :  ǥ
			footer.setAreaHeight(40);
			footer.setHtmlTemplate("<center><br><font face='Arial' size='2'>PAGE ${page} OF ${total}, "+pdfTitle+"</font></center>");
			pd4ml.setPageFooter(footer);
			
			//pd4ml.generateOutlines(false); //å  false : <a name="destination">Label</a>
			pd4ml.generateOutlines(true); //å  true : <H1>-<H6>
			pd4ml.useTTF("/opt/IBM/WebSphere/AppServer/java/jre/lib/fonts", true); //Embedding fonts to PDF 
			pd4ml.render("file:" + tmpHtmlPath, pfos);
			pfos.close();
	        
	        File htmlFile = new File(tmpHtmlPath); //HTML  
	        htmlFile.delete();
	        
	        String pdfPath = notamFilePath + "KOREAN_AIR_NOTAM.pdf"; //÷νų PDF (̸ ٲ㼭)
	        
			File oldFile = new File(tmpPdfPath); //PDF  ̸ 
		  	File newFile = new File(pdfPath);
		  	oldFile.renameTo(newFile); 
		  	*/
			//****************************************************************************	//@2017-11-20
		  	String filePath	=	"/opt/apps/attach/notam_pdf/";
		  	String fileId	=	"KOREAN_AIR_NOTAM";
			boolean isCreatePdf	=	createPdf(filePath,fileId,contents,pdfTitle);
			if(isCreatePdf==false){
				//throw new BusinessException("Exception from create pdf");
			}
			String pdfPath	=	filePath+fileId+".pdf";
			//****************************************************************************
			//2.  ÷
			MimeBodyPart mbpFile = new MimeBodyPart();
			File pdfFile = new File(pdfPath);
			FileDataSource ds = new FileDataSource(pdfFile);
			DataHandler dh = new DataHandler(ds); 
			mbpFile.setDataHandler(dh); 
			mbpFile.setFileName(ds.getName());
			mp.addBodyPart(mbpFile);
			
			message.setContent(mp);
			
			//Mail ۽
			Transport.send(message);
			
			pdfFile.delete(); //PDF  
			
			flagMail = "Y";	
				
		} catch(Exception e) {
			System.out.println(((Exception)e).getMessage());
		}			
		return flagMail;	
	}//end function	
	
	/** 
	  * CREW SELF BRIEFING - Flight Plan ȸԼ.
	  * @param String flt_num
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/05/12 
	  */
	public Hashtable selFlightPlan(String flt_num) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			sql = ComQ02Query.getInstance().selFltPlan(flt_num);
			rs = stmt.executeQuery(sql);
			
			String plan_msg = "";
			String route = "";
			
			if (rs.next()) {
				plan_msg = StringUtil.convertClobToString(rs.getClob("PLAN_MSG"));
				route = StringUtil.checkString(rs.getString("ROUTE"));
			}
			
			hashData.put("PLAN_MSG", plan_msg);
			hashData.put("ROUTE", route);
			
			//üȯ
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			if (stmt != null) stmt.close();
				   	
	   	} catch(SQLException se) {
			Logger.debug.println("[BASE:ComAllSLBean:selFlightPlan:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:ComAllSLBean:selFlightPlan:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * CREW SELF BRIEFING - Confirm Flight Plan
	  * @param String emp_n
	  * @param String flt_num
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/05/13 
	  */
	public String confirmFlightPlan(String name_n, String flt_num) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    PreparedStatement pstmt = null;
	    
	    //Return ü
	    String returnValue = "";
	    
	    try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			stmt = conn.createStatement();
			sql = ComQ02Query.getInstance().selFltPlan(flt_num);
			rs = stmt.executeQuery(sql);
			
			//2009.07.08 ߰ : PLAN_MSG  CAPTAIN, TIMESTAMP κ update ٰ.
			String syskey = "";
			String plan_msg = "";
			
			if (rs.next()) {
				syskey = StringUtil.checkString(rs.getString("SYSKEY"));
				plan_msg = StringUtil.convertClobToString(rs.getClob("PLAN_MSG"));
			}
			
			//üȯ
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			if (stmt != null) stmt.close();
			
			System.out.println("***** SYSKEY : "+syskey+" *****");
			
			// PLAN_MSG CAPTAIN    ٹٲ ãƳ    ٲٰ ٽ msg .
			if (!syskey.equals("") && !plan_msg.equals("")) {
				
				stmt = conn.createStatement();
				sql = ComQ02Query.getInstance().selNowTime();
				rs = stmt.executeQuery(sql);
				
				String now_time1 = "";
				String now_time2 = "";
				
				if (rs.next()) {
					now_time1 = StringUtil.checkString(rs.getString("NOW_TIME1"));
					now_time2 = StringUtil.checkString(rs.getString("NOW_TIME2"));
				}
				
				//üȯ
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				if (stmt != null) stmt.close();
				
				StringBuffer msgBf = new StringBuffer();
				
				int pos1 = plan_msg.indexOf("CAPTAIN :");
				int pos2 = plan_msg.indexOf(StringUtil.unescape("/uD/uA"), pos1); //CAPTAIN   ù° <cr><lf> ġ
				
				if (pos1 > -1 && pos2 > -1) {
					msgBf.append(plan_msg.substring(0, pos1));
					msgBf.append("CAPTAIN : " + name_n + " AT " + now_time1 + "KST");
					msgBf.append(plan_msg.substring(pos2));
				}
				
				if (msgBf.toString().equals("")) msgBf.append(plan_msg);
				
				//System.out.println(msgBf.toString());
				
				sql = ComQ02Query.getInstance().confirmFltPlan();
				pstmt = conn.prepareStatement(sql);
				pstmt.setString(1, name_n);
				pstmt.setString(2, now_time2);
				pstmt.setString(3, msgBf.toString());
				pstmt.setString(4, syskey);
				int updFlg = pstmt.executeUpdate();
				
				//üȯ
				if (pstmt != null) pstmt.close();
				if (sql != null) sql = null;
				
				if (updFlg == 1) returnValue = "1";
			}
			
			//Connection Commit
			conn.commit();
			
	   	} catch(SQLException se) {
			Logger.debug.println("[BASE:ComAllSLBean:confirmFlightPlan:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:ComAllSLBean:confirmFlightPlan:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}
	
	/** 
	  * Irops Image Titles
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2012/01/15 
	  */
	public Hashtable selIropsImgTitles() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
		
		//Return ü 
		Hashtable hashData = new Hashtable();
		String strTitles = "";
		
		try{
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selIropsImgTitles();
			rs = stmt.executeQuery(sql);
			
			StringBuffer titleBuffer = new StringBuffer();
			
			while(rs.next()){
				titleBuffer.append("{code_c:'"+rs.getString(1)+"',desc_e:'"+rs.getString(2).replaceAll("'","&#39;")+"'},");
			}
			
			strTitles = titleBuffer.toString();
	        if(strTitles.length()>0) {
	            strTitles = "["+strTitles.substring(0,strTitles.length()-1)+"]";
	        }
	        
			hashData.put("arrTitle", strTitles);
		}catch(SQLException se){
			Logger.err.println("[BASE:ComAllSLBean:selIropsImgTitles:SQLException] "+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e){
			Logger.err.println("[BASE:ComAllSLBean:selIropsImgTitles:Exception] "+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		}finally{
			if(rs!=null) try{ rs.close(); }catch(Exception e){}
			if(stmt!=null) try{ stmt.close(); }catch(Exception e){}
		}
		return hashData;
	}
	//==============================================================	@2017-11-20
	private void debug(Throwable tr){
		if(tr!=null){
			StackTraceElement[] stacks	=	tr.getStackTrace();
			StringBuffer sb	=	new StringBuffer();
			sb.append("=========================	BASE debug : "+stacks[0].getClassName()+"."+stacks[0].getMethodName()+"[line "+stacks[0].getLineNumber()+"]");
			sb.append("\nkind : "+tr.getClass().getName());
			sb.append("\nmessage : "+tr.getMessage());	
			sb.append("\ndetail : ------------------");	
			for(int i=0; i<stacks.length; i++){
				sb.append("\n : "+stacks[i].toString());
			}
			System.out.println(sb.toString());
			//Logger.debug.println(sb.toString());
		}
	}
	//==============================================================	@2017-11-20 html tag to pdf file
	public boolean createPdf(
		String filePath
	,	String fileID
	,	String htmlBody
	,	String pageTitle
	){
		boolean result	=	false;
		File 				createFile = null;
		FileOutputStream	fout = null;
		try{
			createFile = new File(filePath , fileID + ".pdf");
			//createFile.getParentFile().mkdirs();
			if(createFile != null && createFile.exists()){
				createFile.delete();
			}
			//---------------------------------------	
			fout = new FileOutputStream(createFile);
			//---------------------------------------	set PD4ML
			PD4ML pd4ml = new PD4ML();
			//-------------------	default
			pd4ml.setHtmlWidth(1200);		
			pd4ml.setPageInsets(new Insets(20, 20, 20, 20));
			//pd4ml.useHttpRequest(request, response);
			//pd4ml.useServletContext(getServletContext());
			pd4ml.useTTF("java:fonts", true);
			pd4ml.setDefaultTTFs("malgun", "Arial", "Courier New");
			
			//-------------------	footer
			if(pageTitle!=null){
				PD4PageMark		footer					=	new PD4PageMark();
				footer.setAreaHeight(20);
				footer.setHtmlTemplate("<CENTER><font face='malgun' size='2' color='#999999'>PAGE ${page} OF ${total},"+pageTitle+"</font></CENTER>");
				pd4ml.setPageFooter(footer);
			}
			java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();  
	      	pd4ml.render(new java.io.StringReader("<HTML><HEAD><META http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><STYLE type=\"text/css\">BODY,.bodyPre{margin:0px;font-family:\"malgun\",\"Arial\",\"Courier New\";}.bodyPre{font-size:1em;line-height:1.4em;}</STYLE></HEAD><BODY>"+htmlBody+"</BODY></HTML>"), baos);   
	      	baos.close();  
	      	fout.write( baos.toByteArray());  

			result=true;
		}catch(Exception e){
			debug(e);
		}finally{
			try{
				if(fout!=null){
					fout.close(); 
				}
			}catch(Exception e){
				debug(e);
			}
		} 
		return result;
	}
}//end of class
