package kal.base.skd.ejb;

//ڹ 
import java.io.*;
import java.sql.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

//Project 
import kal.base.ffs.query.FfsA250Query;
import kal.base.iro.dbbean.IroA310BG;
import kal.base.iro.dbbean.IroQ460BG;
import kal.base.iro.query.IroA310Query;
import kal.base.iro.query.IroQ460Query;
import kal.base.jdf.com.*;
import kal.base.jdf.db.*;
import kal.base.pbf.db.*;
import kal.base.jdf.jtx.*;
import kal.base.com.util.*;
import kal.base.jdf.ejb.*;

//SKD
import kal.base.com.query.*;
import kal.base.skd.query.*;
import kal.base.skd.dbbean.*;

import kal.base.sys.dbbean.*;

/**
 * Bean implementation class for Enterprise Bean: SkdAllSL
 */
public class SkdAllSLBean extends BeanAdapter {
	/** 
	  * <b>Daily SKD Display ȸԼ</b>. 
	  * @param params SkdQ010BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/18 HIST 
	  */
	public Hashtable selSkdQ010Main(SkdQ010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		Statement stmt2 = null;
		ResultSet rs = null;
		ResultSet rs2 = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			Hashtable hashCrewNum = new Hashtable();//2007.11.05 ߰
			stmt = conn.createStatement();
			sql = SkdQ010Query.getInstance().selDailyCrew(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				hashCrew.put(StringUtil.checkString(rs.getString("name_key")),StringUtil.checkString(rs.getString("Surname")));
				hashCrewNum.put(StringUtil.checkString(rs.getString("name_key")),StringUtil.checkString(rs.getString("Staff_Num")));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Daily SKD ȸ
			stmt = conn.createStatement();
			sql = SkdQ010Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			System.out.println("\n\n"+sql+"\n\n");//@2017-10-26
			
			while (rs.next()) {
				SkdQ010BG entity = new SkdQ010BG();
				//ȭ
				entity.setTime_x(params.getTime_x());
				entity.setSch_dep_dt_kst(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Kst")));
				entity.setAct_dep_dt_kst(StringUtil.checkString(rs.getString("Act_Dep_Dt_Kst")));
				
				//20150603 ߰
				entity.setSch_dep_dt_loc(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc")));
				
				//Data
				entity.setHideInfo(StringUtil.checkString(rs.getString("HIDEINFO"))); // 2006.09.15 ==> ߰
				
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				
				//2008.02.21 ߰ : ADMRAD 'A' or 'R' 츸 REGNO Display
				//entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				String admrad = StringUtil.checkString(rs.getString("ADMRAD"));
				//2011.01.27 ߰ : Regno  ǥ  if 
				//if (admrad.equals("A") || admrad.equals("R")) entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				//else entity.setRegno("");
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));				
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSpot_in(StringUtil.checkString(rs.getString("Spot_In")));
				entity.setSpot_out(StringUtil.checkString(rs.getString("Spot_Out")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setSch_dep_tm(StringUtil.checkString(rs.getString("Sch_Dep_tm")));
				entity.setSch_arv_tm(StringUtil.checkString(rs.getString("Sch_Arv_tm")));
				
				//2016.12.26 ߰
				entity.setEst_dep_tm(StringUtil.checkString(rs.getString("Est_Dep_tm")));
				
				//2017.01.11 ߰
				entity.setTkof_t(StringUtil.checkString(rs.getString("Tkof_t")));
				
				String actDepTm = StringUtil.checkString(rs.getString("Act_Dep_tm"));
				String actArvTm = StringUtil.checkString(rs.getString("Act_Arv_tm"));
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),"",actDepTm,"");
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),"",actArvTm,"");
				entity.setAct_dep_tm(arrDep[1]);
				entity.setAct_arv_tm(arrArv[1]);
				
				//2017.01.11 TKOF_T NULL ƴϰ ARV_STS ACT ƴҶ ETA ǥ
				String tkof_t = StringUtil.checkString(rs.getString("Tkof_t"));
				String Land_t = StringUtil.checkString(rs.getString("Land_t"));
				String arv_sts = StringUtil.checkString(rs.getString("Arv_Sts"));
				
				//System.out.println("-----------selSkdQ010Main tkof_t:"+tkof_t);
				//System.out.println("-----------selSkdQ010Main Land_t:"+Land_t);
				//System.out.println("-----------selSkdQ010Main    ATA:"+arrArv[1]);
				
				/*
				if(!"".equals(tkof_t) && !"ACT".equals(arv_sts)){
					entity.setEst_arv_tm(StringUtil.checkString(rs.getString("Est_Arv_tm")));
				}else{
					entity.setEst_arv_tm("");
				}
				*/

				entity.setEst_arv_tm(StringUtil.checkString(rs.getString("Est_Arv_tm")));
				
				if(!"".equals(tkof_t)){ // 2017.01.17 TOFF  ǥ
					entity.setEst_arv_tm(StringUtil.checkString(rs.getString("Est_Arv_tm")));
				}else{
					entity.setEst_arv_tm("");
				}
				
				/*
				if(!"".equals(Land_t)){	//2017.01.17 TDWN  ǥ
					entity.setEst_arv_tm("");
				}
				*/
				
				if(!"".equals(tkof_t) && "".equals(arrArv[1])){	//2017.01.17 TDWN ϰ ATA  (arv_sts = ACT) ǥ
					entity.setEst_arv_tm(StringUtil.checkString(rs.getString("Est_Arv_tm")));
					
				}else{ // ATA  Ⱥ̰
					entity.setEst_arv_tm("");
				}
				
				//2019-01-22
				entity.setEst_dep_dt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
				entity.setEst_arv_dt(StringUtil.checkString(rs.getString("EST_ARV_DT")));
				
				/***** ¼//ž¼/L/F  *****/
				double f_cfg = rs.getDouble("F_Cfg");
				double c_cfg = rs.getDouble("C_Cfg");
				double y_cfg = rs.getDouble("Y_Cfg");
				double f_book = rs.getDouble("F_Book");
				double c_book = rs.getDouble("C_Book");
				double y_book = rs.getDouble("Y_Book");
				double f_chkin = rs.getDouble("F_Chkin");
				double c_chkin = rs.getDouble("C_Chkin");
				double y_chkin = rs.getDouble("Y_Chkin");
				//¼ 0̸ ȭ̹Ƿ ¼//ž¼ ǥ ʿ䰡 .
				//if ((f_cfg+c_cfg+y_cfg) == 0) {
				//2007.01.04  => ¼ 0~40 ̸ ¼//ž¼ ǥþ. (40 ϴ )
				if ((f_cfg+c_cfg+y_cfg) >= 0 && (f_cfg+c_cfg+y_cfg) <= 40) {
					entity.setSupply("");
					entity.setRsvn("");
					entity.setL_f("");
				} else {
					DecimalFormat df = new DecimalFormat("##0");
					entity.setSupply(df.format(f_cfg)+"/"+df.format(c_cfg)+"/"+df.format(y_cfg));
					//2006.10.26  => ATD  book  chkin ش.
					//entity.setRsvn(df.format(f_book)+"/"+df.format(c_book)+"/"+df.format(y_book));
					if (StringUtil.checkString(arrDep[1]).equals("")) {
						entity.setRsvn(df.format(f_book)+"/"+df.format(c_book)+"/"+df.format(y_book));
					} else {
						entity.setRsvn(df.format(f_chkin)+"/"+df.format(c_chkin)+"/"+df.format(y_chkin));
					}
					// ž¼ 0 ũ L/F = ž¼/¼ 0̸ L/F = /¼
					/*if ((f_chkin+c_chkin+y_chkin) > 0) 
						entity.setL_f(df.format(((f_chkin+c_chkin+y_chkin)/(f_cfg+c_cfg+y_cfg))*100));
					else 
						entity.setL_f(df.format(((f_book+c_book+y_book)/(f_cfg+c_cfg+y_cfg))*100));*/
					//2005.07.06  =>  L/F /¼ ̴.
					/*if ((f_book+c_book+y_book) > 0 && (f_cfg+c_cfg+y_cfg) > 0) 
						entity.setL_f(df.format(((f_book+c_book+y_book)/(f_cfg+c_cfg+y_cfg))*100));
					else 
						entity.setL_f("0");*/
					//2007.01.04  => ATD  book/¼  chkin/¼ ش.
					if (StringUtil.checkString(arrDep[1]).equals("")) {
						if ((f_book+c_book+y_book) > 0 && (f_cfg+c_cfg+y_cfg) > 0) 
							entity.setL_f(df.format(((f_book+c_book+y_book)/(f_cfg+c_cfg+y_cfg))*100));
						else 
							entity.setL_f("0");
					} else {
						//2007.01.04  => ATD ־ chkin 0ϰ book/¼ ش.
						if ((f_chkin+c_chkin+y_chkin) == 0) { 
							if ((f_book+c_book+y_book) > 0 && (f_cfg+c_cfg+y_cfg) > 0) 
								entity.setL_f(df.format(((f_book+c_book+y_book)/(f_cfg+c_cfg+y_cfg))*100));
							else 
								entity.setL_f("0");
						} else {
							if ((f_chkin+c_chkin+y_chkin) > 0 && (f_cfg+c_cfg+y_cfg) > 0) 
								entity.setL_f(df.format(((f_chkin+c_chkin+y_chkin)/(f_cfg+c_cfg+y_cfg))*100));
							else 
								entity.setL_f("0");
						}
					}
				}
				/***** Actnid == Cancel ó  *****/
				entity.setActnid(StringUtil.checkString(rs.getString("Actnid")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				double timeStamp = rs.getDouble("TimeStamp");
				double schDepDt = rs.getDouble("Key_Sch_Dep_Dt");
				
				if (entity.getActnid().equals("CNL")) {
					if (timeStamp >= schDepDt) {
						entity.setSurname("---Cancel---");
						entity.setStaffNum("");//2007.11.05 ߰
						
						listData.add(entity);
					}
				} else {
					//Crew ȸ
					String surName = (String)hashCrew.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto()+"P1");
					String staffNum = (String)hashCrewNum.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto()+"P1");//2007.11.05 ߰
					//entity.setSurname(surName);
					if (surName != null) {
						entity.setSurname(surName);
						entity.setStaffNum(staffNum);//2007.11.05 ߰
					} else {
						surName = (String)hashCrew.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto()+"PZ");
						staffNum = (String)hashCrewNum.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto()+"PZ");//2007.11.05 ߰
						if (surName != null) {
							entity.setSurname(surName);
							entity.setStaffNum(staffNum);//2007.11.05 ߰
						} else {
							if ((entity.getRegno().length() >= 3) && (entity.getRegno().substring(2,3)).equals("7")) {
								stmt2 = conn.createStatement();
								sql = SkdQ010Query.getInstance().selCrew(entity);
								rs2 = stmt2.executeQuery(sql);
								if (rs2.next()) {
									entity.setSurname(StringUtil.checkString(rs2.getString("Surname")));
									entity.setStaffNum(StringUtil.checkString(rs2.getString("Staff_Num")));//2007.11.05 ߰
								}
								if (stmt2 != null) stmt2.close();
								if (rs2 != null) rs2.close();
								if (sql != null) sql = null;
							} else {
								entity.setSurname("");
								entity.setStaffNum("");//2007.11.05 ߰
							} 
						}
					}
					listData.add(entity);
				}
			}//end if while
			//Collections.sort(listData);
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (rs2 != null) try {rs2.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
			if (stmt2 != null) try {stmt2.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	//@2017-07-07
	public Hashtable selSkdQ010Kactyp() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//KACTYP ȸ
			stmt = conn.createStatement();
			sql = SkdQ010Query.getInstance().selKactyp();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SkdQ010BG entity = new SkdQ010BG();
				
				entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
				
				listData.add(entity);
			}
			
			hashData.put("KACTYP_LIST", listData);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	//@2017-07-07
	public Hashtable selSkdQ070Kactyp() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//KACTYP ȸ
			stmt = conn.createStatement();
			sql = SkdQ070Query.getInstance().selKactyp();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SkdQ070BG entity = new SkdQ070BG();
				
				entity.setTyp(StringUtil.checkString(rs.getString("KACTYP")));
				
				listData.add(entity);
			}
			
			hashData.put("KACTYP_LIST", listData);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ010Kactyp:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	/** 
	  * Flight Progress Information main ȸԼ.
	  * @param entity SkdQ020BG Flight Progress Information
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/20 
	  */
	public Hashtable selSkdQ020Main(SkdQ020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    
	    //UTC/KST/LOC
	   	String timeX = params.getTime_x();
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Flight Progress Information ȸ
			stmt = conn.createStatement();
			sql = SkdQ020Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				SkdQ020BG entity = new SkdQ020BG();
				
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setSch_dep_date(StringUtil.checkString(rs.getString("Sch_Dep_Date")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				
				//20150605 ߰
				entity.setSch_dep_dt_loc(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Loc")));
				
				//2008.02.21 ߰ : ADMRAD 'A' or 'R' 츸 REGNO Display, 
				//2016.08.17 ADMRAD Ʒ IF  ּóϰ Regnoκ ּ 
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				
				String admrad = StringUtil.checkString(rs.getString("ADMRAD"));
				//if (admrad.equals("A") || admrad.equals("R")) entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				//else entity.setRegno("");
				
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSpt_out(StringUtil.checkString(rs.getString("Spot_Out")));
				entity.setSpt_in(StringUtil.checkString(rs.getString("Spot_In")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt")));
				
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String estDepDt = StringUtil.checkString(rs.getString("Est_Dep_Dt"));
				String actDepDt = StringUtil.checkString(rs.getString("Act_Dep_Dt"));
				String tkofT = StringUtil.checkString(rs.getString("Tkof_T"));
				String estArvDt = StringUtil.checkString(rs.getString("Est_Arv_Dt"));
				String actArvDt = StringUtil.checkString(rs.getString("Act_Arv_Dt"));
				String landT = StringUtil.checkString(rs.getString("Land_T"));
					
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estDepDt,actDepDt,tkofT);
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estArvDt,actArvDt,landT);
					
				entity.setEst_dep_dt(StringUtil.checkString(arrDep[0]));
				entity.setAct_dep_dt(StringUtil.checkString(arrDep[1]));
				entity.setTkof_t(StringUtil.checkString(arrDep[2]));
				entity.setEst_arv_dt(StringUtil.checkString(arrArv[0]));
				entity.setAct_arv_dt(StringUtil.checkString(arrArv[1]));
				entity.setLand_t(StringUtil.checkString(arrArv[2]));
				
				if((StringUtil.checkString(rs.getString("Del_Rc1"))).equals("")) {
					entity.setDel_rc1("");
					entity.setDel_dur1("");
				}
				else {
					entity.setDel_rc1(StringUtil.checkString(rs.getString("Del_Rc1")));
					entity.setDel_dur1("/"+StringUtil.checkString(rs.getString("Del_Dur1")));
				}
				if((StringUtil.checkString(rs.getString("Del_Rc2"))).equals("")) {
					entity.setDel_rc2("");
					entity.setDel_dur2("");
				}
				else {
					entity.setDel_rc2(StringUtil.checkString(rs.getString("Del_Rc2")));
					entity.setDel_dur2("/"+StringUtil.checkString(rs.getString("Del_Dur2")));
				}
				entity.setSch_dep_dt_full(StringUtil.checkString(rs.getString("Sch_Dep_Dt_Full")));
				entity.setAct_dep_dt_kst(StringUtil.checkString(rs.getString("Act_Dep_Dt_Kst")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setTime_x(StringUtil.checkString(timeX.toUpperCase()));
				
				entity.setHideInfo(StringUtil.checkString(rs.getString("HIDEINFO"))); // 2006.09.15 ==> ߰
				
				
				
				listData.add(entity);

			} 
			hashData.put("FLTINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ020Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * Planning SKD INFO main ȸԼ.
	  * @param entity SkdQ030BG Planning SKD INFO
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/01/17 
	  */
	public Hashtable selSkdQ030Main(SkdQ030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		Statement stmt2 = null;
		ResultSet rs = null;
		ResultSet rs2 = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Crew ȸ
			Hashtable hashCrew = new Hashtable();
			stmt = conn.createStatement();
			sql = SkdQ030Query.getInstance().selDailyCrew(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				hashCrew.put(StringUtil.checkString(rs.getString("name_key")),StringUtil.checkString(rs.getString("Surname")));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Planning SKD INFO ȸ
			stmt = conn.createStatement();
			sql = SkdQ030Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			// Regno
			String preReg = "";
			
			String regNo = "";
			String stnFr = "";
			String fltNum = "";
			String kactyp = "";
			String reg = "";
			String onward = "";
			String fltCrew = "";
			String regCrew = "";
			boolean skipFlg = true;
			
			//2010.09.08 ߰
			int dep_cnt = 0;
			int arv_cnt = 0;
			boolean skipFlg2 = true;
			
			while (rs.next()) {
				
				SkdQ030BG entity = new SkdQ030BG();	
				
				/**** Regno ٲ鼭  ߰ STN ƴϸ SKIPѴ. ****/	
				regNo = StringUtil.checkString(rs.getString("Regno"));
				stnFr = StringUtil.checkString(rs.getString("Stnfr"));
				/****  Regno ONWARD ó ****/
				fltNum = StringUtil.checkString(rs.getString("Flt_Num"));
				kactyp = StringUtil.checkString(rs.getString("Kactyp"));
				reg = StringUtil.checkString(rs.getString("Regno"));
				onward = StringUtil.checkString(rs.getString("Flt_Num"));
				/**** Crew ȸ  ****/
				fltCrew = StringUtil.checkString(rs.getString("Flt_Num"));
				regCrew = StringUtil.checkString(rs.getString("Regno"));
				
				boolean chkFlg = false;
				if (!preReg.equals(regNo)) { //Regno ٲ
					skipFlg = false;
					if (params.getStnfr().equals(stnFr)) { 
						skipFlg = true;
						chkFlg = true;
					}
				} else {
					if (params.getStnfr().equals(stnFr) && !skipFlg) {
						skipFlg = true;
						chkFlg = true;
					}
				}

				if (chkFlg) {
					onward = "";
					
				} else {
					fltNum = "";
					kactyp = "";
					reg = "";
				}
				
				if (!preReg.equals(regNo)) {
					//Regno ٲ ʱȭ
					dep_cnt = 0;
					arv_cnt = 0;
					skipFlg2 = true;
				}
				
				if (skipFlg) {
					
					//2010.09.08 ߰ : س¥ ȿ ذ    Ĵ ŵ, 
					//س¥ Ѿ ذ  Ǵ  ְ  Ĵ ŵ. (ִ 3ġ)
					
					if (skipFlg2) {
						
						boolean skipFlg3 = true;
						
						if (StringUtil.checkString(rs.getString("SCH_DATE")).equals(params.getSch_dep_dt())) {
							
							if (StringUtil.checkString(rs.getString("Stnfr")).equals(params.getStnfr())) dep_cnt = dep_cnt + 1;
							if (StringUtil.checkString(rs.getString("Stnto")).equals(params.getStnfr()) && dep_cnt >= 1) arv_cnt = arv_cnt + 1;
						
						} else { //<- س¥ Ѿ ذ  Ǵ  ְ  Ĵ ŵ
							
							if (dep_cnt == arv_cnt) {
								skipFlg2 = false;
								skipFlg3 = false;
								
							} else if (StringUtil.checkString(rs.getString("Stnto")).equals(params.getStnfr())) {
								skipFlg2 = false;
							}
						}
						
						if (skipFlg3) {

							entity.setFlt_num(fltNum);
							entity.setKactyp(kactyp);
							
							/*
							//2008.02.21 ߰ : ADMRAD 'A' or 'R' 츸 REGNO Display - 2010.09.10 .
							String admrad = StringUtil.checkString(rs.getString("ADMRAD"));
							if (admrad.equals("A") || admrad.equals("R")) entity.setRegno(reg);
							else entity.setRegno("");
							*/
							entity.setRegno(reg);
							
							entity.setNextflt_num(onward);
							entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
							entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
								
							/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
							String estDepDt = StringUtil.checkString(rs.getString("Est_Dep_Dt"));
							String actDepDt = StringUtil.checkString(rs.getString("Act_Dep_Dt"));
							String tkofT = StringUtil.checkString(rs.getString("Tkof_T"));
							String estArvDt = StringUtil.checkString(rs.getString("Est_Arv_Dt"));
							String actArvDt = StringUtil.checkString(rs.getString("Act_Arv_Dt"));
							String landT = StringUtil.checkString(rs.getString("Land_T"));
							
							String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estDepDt,actDepDt,tkofT);
							String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estArvDt,actArvDt,landT);
							
							entity.setEst_dep_dt(StringUtil.checkString(arrDep[0]));
							entity.setAct_dep_dt(StringUtil.checkString(arrDep[1]));
							entity.setTkof_t(StringUtil.checkString(arrDep[2]));
							entity.setEst_arv_dt(StringUtil.checkString(arrArv[0]));
						    entity.setAct_arv_dt(StringUtil.checkString(arrArv[1]));
						    entity.setLand_t(StringUtil.checkString(arrArv[2]));
							
							entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
							entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt")));
						    entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
						    
						    //0 : س¥, 1 : س¥ + 1, 2 : س¥ + 2
						    int date_color = StringUtil.daysBetween(params.getSch_dep_dt(), StringUtil.checkString(rs.getString("SCH_DATE")));
						    entity.setDate_color(String.valueOf(date_color).toString());
						    
							//Crew ȸ
							
						    //String surName = (String)hashCrew.get(entity.getFlt_num()+entity.getStnfr()+entity.getStnto());
							String surName = (String)hashCrew.get(entity.getFirst_leg_flt_dt()+fltCrew+entity.getStnfr()+entity.getStnto()); //2010.09.07  : name_key FIRST_LEG_FLT_DT ߰
							if (surName != null) entity.setName(surName);
							else {
								
								if(!"".equals(regCrew)){
								
									if ((regCrew.substring(2,3)).equals("7")) {
										stmt2 = conn.createStatement();
										sql = SkdQ030Query.getInstance().selCrew(entity, fltCrew, params.getSch_dep_dt());
										rs2 = stmt2.executeQuery(sql);
										if (rs2.next()) entity.setName(StringUtil.checkString(rs2.getString("Surname")));
			
										if (stmt2 != null) stmt2.close();
										if (rs2 != null) rs2.close();
										if (sql != null) sql = null;
										
									} else{ 
										entity.setName("");
									}
									
								}	
							
							
							}			   
							
							listData.add(entity);
						}
					}
				}
				preReg = regNo;
			} 
			hashData.put("SKDINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ030Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ030Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	

	/** 
	  * <b>Detail FLT Status ȸԼ</b>. 
	  * @param params SkdQ040BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public Hashtable selSkdQ040Main(SkdQ040BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
		Statement stmt2 = null;
		ResultSet rs2 = null;
	    String sql2 = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = null;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//⺻ ȸ
			stmt = conn.createStatement();
			sql = SkdQ040Query.getInstance().selBasicInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				SkdQ040BG entity = new SkdQ040BG();
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setAcver(StringUtil.checkString(rs.getString("Acver")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				hashData.put("BASICINFO",entity);	
				//Reg Number ߰
				params.setRegno(entity.getRegno());
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// ȸ
			stmt = conn.createStatement();
			sql = SkdQ040Query.getInstance().selFltInfo(params);
			rs = stmt.executeQuery(sql);
			listData = new LinkedList();
			
			while (rs.next()) {
				SkdQ040BG entity = new SkdQ040BG();
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSpt_in(StringUtil.checkString(rs.getString("Spot_In")));
				entity.setSpt_out(StringUtil.checkString(rs.getString("Spot_Out")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setSch_dep_tm(StringUtil.checkString(rs.getString("Sch_Dep_Tm")));
				entity.setSch_arv_tm(StringUtil.checkString(rs.getString("Sch_Arv_Tm")));
				entity.setDel_rc1(StringUtil.checkString(rs.getString("Del_Rc1")));
				entity.setDel_dur1(StringUtil.checkString(rs.getString("Del_Dur1")));
				entity.setDel_rc2(StringUtil.checkString(rs.getString("Del_Rc2")));
				entity.setDel_dur2(StringUtil.checkString(rs.getString("Del_Dur2")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_leg_Flt_Dt")));
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String actDepTm = StringUtil.checkString(rs.getString("Act_Dep_Tm"));
				String actArvTm = StringUtil.checkString(rs.getString("Act_Arv_Tm"));
				String estDepTm = StringUtil.checkString(rs.getString("Est_Dep_Tm"));
				String estArvTm = StringUtil.checkString(rs.getString("Est_Arv_Tm"));
				String tkofT = StringUtil.checkString(rs.getString("Tkof_t"));
				String landT = StringUtil.checkString(rs.getString("Land_t"));
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estDepTm,actDepTm,tkofT);
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estArvTm,actArvTm,landT);
				entity.setEst_dep_tm(arrDep[0]);
				entity.setAct_dep_tm(arrDep[1]);
				entity.setTkof_t(arrDep[2]);

				//2017.01.17
				entity.setEst_arv_tm(arrArv[0]);
				
				System.out.println("-----------selSkdQ040Main tkofT:"+tkofT);
				System.out.println("-----------selSkdQ040Main landT:"+landT);
				
				if(!"".equals(tkofT)){ // 2017.01.17 TOFF  ǥ
					entity.setEst_arv_tm(arrArv[0]);
				}else{
					entity.setEst_arv_tm("");
				}
					
				if(!"".equals(landT)){	// 2017.01.17 TDWN  ǥ
					entity.setEst_arv_tm("");
				}	
								
				
				entity.setAct_arv_tm(arrArv[1]);
				entity.setLand_t(arrArv[2]);
				
				//@2017-10-26 ߰
				entity.setDel_rc3(StringUtil.checkString(rs.getString("Del_Rc3")));
				entity.setDel_dur3(StringUtil.checkString(rs.getString("Del_Dur3")));
				
				listData.add(entity);
			}
			hashData.put("FLTINFO",listData);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			if (listData != null) listData = null;
			
			//Category ȸ
			stmt = conn.createStatement();
			sql = SkdQ040Query.getInstance().selCategoryInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				SkdQ040BG entity = new SkdQ040BG();
				entity.setCat3_date(StringUtil.checkString(rs.getString("Cat3_Date")));
				entity.setCat2_date(StringUtil.checkString(rs.getString("Cat2_Exp_Date")));
				entity.setCat_date(StringUtil.checkString(rs.getString("Cat_Date")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				hashData.put("CATEGORYINFO",entity);	
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//¹ ȸ
			stmt = conn.createStatement();
			//sql = SkdQ040Query.getInstance().selCrewInfo(params);
			sql = SkdQ040Query.getInstance().selCrewInfoNew(params); //2009.10.12 
			rs = stmt.executeQuery(sql);
			
			listData = new LinkedList();
			
			while (rs.next()) {
				
				String sqlCrew = null;
				PreparedStatement pstmt = null;
				ResultSet rsCrew = null;
				
				SkdQ040BG entity = new SkdQ040BG();
				
				//2009.10.12 
				entity.setStaff_num(StringUtil.checkString(rs.getString("STAFF_NUM")));
				entity.setSurname(StringUtil.checkString(rs.getString("ENG_NAME")));
				entity.setActing_rank(StringUtil.checkString(rs.getString("RANK")));
				entity.setDuty_cd(StringUtil.checkString(rs.getString("DUTY")));
				//entity.setStnto(params.getStnto());
				entity.setPrev_flt(StringUtil.checkString(rs.getString("PREV_INFO")));
				entity.setNext_flt(StringUtil.checkString(rs.getString("NEXT_INFO")));
				
				/*
				entity.setStaff_num(StringUtil.checkString(rs.getString("Staff_Num")));
				entity.setSurname(StringUtil.checkString(rs.getString("Surname")));
				entity.setActing_rank(StringUtil.checkString(rs.getString("Acting_Rank")));
				entity.setDuty_cd(StringUtil.checkString(rs.getString("Duty_Cd")));
				entity.setStnto(params.getStnto());
				
				//¹ / FLT ȸ
				//Statement stmtCrew = conn.createStatement();
				//String sqlCrew = SkdQ040Query.getInstance().selCrewFLTInfo(entity.getStaff_num(),params.getAct_dep_dt_kst());
				//ResultSet rsCrew = stmtCrew.executeQuery(sqlCrew);
				
				//¹ / FLT ȸ --. Prepared Statement ȯ 2005.03.14
				String sqlCrew = SkdQ040Query.getInstance().selCrewFLTInfoPre();
				PreparedStatement pstmt = conn.prepareStatement(sqlCrew);
				pstmt.setString(1, entity.getStaff_num());
				pstmt.setString(2, params.getAct_dep_dt_kst());
				pstmt.setString(3, params.getAct_dep_dt_kst());
				pstmt.setString(4, params.getAct_dep_dt_kst());
				pstmt.setString(5, params.getAct_dep_dt_kst());
				pstmt.setString(6, entity.getStaff_num());
				ResultSet rsCrew = pstmt.executeQuery();
				
				//Crew : 9306172
				//CAP    C   KIM JU PIL			NRT
				//Rank Duty   Surname			StnTo
				//PREV : KE0001/23JAN04 - ICN(FLY)                   NEXT : KE0003/24JAN04 - LAX(FLY)
				//      Flt_num(7)  Date(7)    STN Duty(ִ9ڸ)
				while (rsCrew.next()) {
					String mode = StringUtil.checkString(rsCrew.getString("Flt_Seq"));
					String fltNum = StringUtil.checkString(rsCrew.getString("Flt_Num"));
					String fltDate = StringUtil.checkString(rsCrew.getString("Flt_Date"));
					String portA = StringUtil.checkString(rsCrew.getString("Port_a"));
					String portB = StringUtil.checkString(rsCrew.getString("Port_b"));
					String duty = StringUtil.checkString(rsCrew.getString("Duty_Cd"));
					String regNo = StringUtil.checkString(rsCrew.getString("Regno"));
					if (mode.equals("PREV")) {
						entity.setPrev_flt(fltNum+"/"+fltDate+" - "+portA+"/"+portB+"("+duty+")");
					} else {
						entity.setNext_flt(fltNum+"/"+fltDate+" - "+portA+"/"+portB+"("+duty+")");
					}
				}
				
				//ڿȯ
				if (pstmt != null) pstmt.close();
				if (rsCrew != null) rsCrew.close();
				if (sqlCrew != null) sqlCrew = null;
				*/
				
				//¹ LAST FLT ȸ
				//Statement stmtLast = conn.createStatement();
				//String sqlLast = SkdQ040Query.getInstance().selCrewLastInfo(entity.getStaff_num());
				//ResultSet rsLast = stmtLast.executeQuery(sqlLast);
				
				sqlCrew = SkdQ040Query.getInstance().selCrewLastInfoPre();
				pstmt = conn.prepareStatement(sqlCrew);
				pstmt.setString(1, entity.getStaff_num());
				rsCrew = pstmt.executeQuery();
				
				//LAST 
				//KE0783/10MAR05 - HL7574
				while (rsCrew.next()) {
					String mode = StringUtil.checkString(rsCrew.getString("Flt_Seq"));
					String fltNum = StringUtil.checkString(rsCrew.getString("Flt_Num"));
					String fltDate = StringUtil.checkString(rsCrew.getString("Flt_Date"));
					String portA = StringUtil.checkString(rsCrew.getString("Port_a"));
					String portB = StringUtil.checkString(rsCrew.getString("Port_b"));
					String duty = StringUtil.checkString(rsCrew.getString("Duty_Cd"));
					String regNo = StringUtil.checkString(rsCrew.getString("Regno"));
					entity.setLast_flt(fltNum+"/"+fltDate+" - "+regNo);
				}
				
				//ڿȯ
				if (pstmt != null) pstmt.close();
				if (rsCrew != null) rsCrew.close();
				if (sqlCrew != null) sqlCrew = null;
				
				//2010.12.17 ߰ : ¹ CAT  ر/ڰ ð  ߰
				entity.setCrew_cat2("");
				entity.setCrew_cat2("");
				entity.setCrew_cat2("");
				entity.setCrew_rank_tm("");
				
				stmt2 = conn.createStatement();
				sql2 = SkdQ040Query.getInstance().selCatRankTm(entity.getStaff_num());
				rs2 = stmt2.executeQuery(sql2);
				
				while (rs2.next()) {
					if (StringUtil.checkString(rs2.getString("CATEGORY")).equals("CATII")) {
						entity.setCrew_cat2(StringUtil.checkString(rs2.getString("ISSUE_DT")));
						entity.setCrew_rank_tm(StringUtil.checkString(rs2.getString("FLEETRANKTM")));
					
					} else if (StringUtil.checkString(rs2.getString("CATEGORY")).equals("CATIII")) {
						entity.setCrew_cat3(StringUtil.checkString(rs2.getString("ISSUE_DT")));
						entity.setCrew_rank_tm(StringUtil.checkString(rs2.getString("FLEETRANKTM")));
					
					} else if (StringUtil.checkString(rs2.getString("CATEGORY")).equals("CATII/III")) {
						entity.setCrew_cat23(StringUtil.checkString(rs2.getString("ISSUE_DT")));
						entity.setCrew_rank_tm(StringUtil.checkString(rs2.getString("FLEETRANKTM")));
					}
				}
				
				if (stmt2 != null) stmt2.close();
				if (rs2 != null) rs2.close();
				if (sql2 != null) sql2 = null;
				
				listData.add(entity);
			}
			hashData.put("CREWINFO",listData);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			if (listData != null) listData = null;
			
			// ȸ
			stmt = conn.createStatement();
			sql = SkdQ040Query.getInstance().selDcsInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				SkdQ040BG entity = new SkdQ040BG();
				entity.setCfg(StringUtil.checkString(rs.getString("Cfg")));
				entity.setRsvn(StringUtil.checkString(rs.getString("Rsvn")));
				entity.setChk_in(StringUtil.checkString(rs.getString("Chk_In")));
				entity.setCrew(StringUtil.checkString(rs.getString("Crew")));
				double payLoad = rs.getDouble("Act_Payload_q") * 2.20459;
				double aclQ = rs.getDouble("Max_PayLoad_q") * 2.20459;
				double bewQ = rs.getDouble("Act_Bew_q") * 2.20459;
				double sowQ = rs.getDouble("Act_Sow_q") * 2.20459;
				double zfwQ = rs.getDouble("Act_Zfw_q") * 2.20459;
				double towQ = rs.getDouble("Act_Tow_q") * 2.20459;
				double ldwQ = rs.getDouble("Est_Ldw_q") * 2.20459;
				double tofQ = rs.getDouble("Tof_q") * 2.20459;
				double tifQ = rs.getDouble("Tif_q") * 2.20459;
				double cgoWt = rs.getDouble("Cgo_Wt_q") * 2.20459;
				double mailWt = rs.getDouble("Mail_Wt_q") * 2.20459;
				double bagWt = rs.getDouble("Bag_Wt_q") * 2.20459;
				
				DecimalFormat df = new DecimalFormat("#,##0");
				entity.setMax_payload_q(df.format(payLoad));
				entity.setAct_payload_q(df.format(aclQ));
				entity.setAct_bew_q(df.format(bewQ));
				entity.setAct_sow_q(df.format(sowQ));
				entity.setAct_zfw_q(df.format(zfwQ));
				entity.setAct_tow_q(df.format(towQ));
				entity.setEst_ldw_q(df.format(ldwQ));
				entity.setTof_q(df.format(tofQ));
				entity.setTif_q(df.format(tifQ));
				entity.setCgo_wt_q(df.format(cgoWt));
				entity.setMail_wt_q(df.format(mailWt));
				entity.setBag_wt_q(df.format(bagWt));
				hashData.put("DCSINFO",entity);	
			}
			
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Aircraft Connnection  ȸ
			stmt = conn.createStatement();
			sql = SkdQ040Query.getInstance().selAircraftInfo(params);
			rs = stmt.executeQuery(sql);
			listData = new LinkedList();
			
			while (rs.next()) {
				SkdQ040BG entity = new SkdQ040BG();
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSch_dep_tm(StringUtil.checkString(rs.getString("Sch_Dep_Tm")));
				entity.setSch_arv_tm(StringUtil.checkString(rs.getString("Sch_Arv_Tm")));
				entity.setSpt_in(StringUtil.checkString(rs.getString("Spot_In")));
				entity.setSpt_out(StringUtil.checkString(rs.getString("Spot_Out")));
				/***** Daily_Sch_T DB Dep/Arv Status Time  *****/
				String actDepTm = StringUtil.checkString(rs.getString("Act_Dep_Tm"));
				String actArvTm = StringUtil.checkString(rs.getString("Act_Arv_Tm"));
				String estDepTm = StringUtil.checkString(rs.getString("Est_Dep_Tm"));
				String estArvTm = StringUtil.checkString(rs.getString("Est_Arv_Tm"));
				String tkofT = StringUtil.checkString(rs.getString("Tkof_t"));
				String landT = StringUtil.checkString(rs.getString("Land_t"));
				String[] arrDep = StringUtil.StatusTime("D",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estDepTm,actDepTm,tkofT);
				String[] arrArv = StringUtil.StatusTime("A",StringUtil.checkString(rs.getString("Dep_Sts")),StringUtil.checkString(rs.getString("Arv_Sts")),estArvTm,actArvTm,landT);
				entity.setEst_dep_tm(arrDep[0]);
				entity.setAct_dep_tm(arrDep[1]);
				entity.setTkof_t(arrDep[2]);
				
				//2017.01.17
				
				
				entity.setEst_arv_tm(arrArv[0]);
				
				entity.setAct_arv_tm(arrArv[1]);
				entity.setLand_t(arrArv[2]);
				listData.add(entity);
			}
			hashData.put("AIRCRAFTINFO",listData);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			if (listData != null) listData = null;

	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ040Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ040Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * HUB Station Information main ȸԼ.
	  * @param entity SkdQ050BG HUB Station Information
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2005/02/02 
	  */
	public Hashtable selSkdQ050Main(SkdQ050BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		//Statement stmt2 = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		ResultSet rs2 = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    
	    //Station
	   	String station = params.getStn();
	   	//˻ ¥
	   	String allDate = params.getSch_dt_loc();
	   	
	    try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			if (station.equals("ICN")) {
			
				//HUB Station Information ICN ȸ
				stmt = conn.createStatement();
				sql = SkdQ050Query.getInstance().selMainICN(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					SkdQ050BG entity = new SkdQ050BG();
					
					entity.setArlnCd_fltNum(StringUtil.checkString(rs.getString("Arln_Cd"))+StringUtil.checkString(rs.getString("Flt_Num")));
					entity.setDeparv_x(StringUtil.checkString(rs.getString("DepArv_x")));
					entity.setSactyp(StringUtil.checkString(rs.getString("Sactyp")));
					entity.setSpot(StringUtil.checkString(rs.getString("Spot")));
					entity.setGate(StringUtil.checkString(rs.getString("Gate")));
					entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
					entity.setSch_dt_loc(StringUtil.checkString(rs.getString("Sch_Dt_Loc")));
					entity.setEst_dt_loc(StringUtil.checkString(rs.getString("Est_Dt_Loc")));
					entity.setAct_dt_loc(StringUtil.checkString(rs.getString("Act_Dt_Loc")));
					entity.setTkofland_t(StringUtil.checkString(rs.getString("TkofLand_t")));
					entity.setCdsflt(StringUtil.checkString(rs.getString("CdSflt")));
					
					String first = StringUtil.checkString(rs.getString("FIRSTARPTSTOP"));
					String second = StringUtil.checkString(rs.getString("SCDARPTSTOP"));
					String third = StringUtil.checkString(rs.getString("THIRDARPTSTOP"));
					String fst = "";
					if (first.equals("")) { fst = ""; }
					else if (second.equals("")) { fst = first+"-"; }
					else if (third.equals("")) { fst = first+"-"+second+"-"; }
					else { fst = first+"-"+second+"-"+third+"-"; }
					String itnary = "";
					if (StringUtil.checkString(rs.getString("DepArv_x")).equals("D")) {
						//entity.setItnary(station+"-"+fst+StringUtil.checkString(rs.getString("ConxStn")));
						itnary = station+"-"+fst+StringUtil.checkString(rs.getString("ConxStn"));
					} else if (StringUtil.checkString(rs.getString("DepArv_x")).equals("A")) {
						//entity.setItnary(StringUtil.checkString(rs.getString("ConxStn"))+"-"+fst+station);
						itnary = StringUtil.checkString(rs.getString("ConxStn"))+"-"+fst+station;
					}
					entity.setItnary(itnary);
					
					//2007.10.09 ߰ : ˾ ﶧ ʿ.
					entity.setSch_dt_loc_2(StringUtil.checkString(rs.getString("Sch_Dt_Loc_Full")));
					entity.setStn(StringUtil.checkString(rs.getString("Stn")));
					entity.setArln_cd(StringUtil.checkString(rs.getString("Arln_Cd")));
					entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
					
					//entity.setAll_date(allDate);
					
					//REG No ÿ Conx Flt ȸ
					if (!entity.getRegno().equals("")) {
						
						sql = SkdQ050Query.getInstance().selSub(entity);
						pstmt = conn.prepareStatement(sql.toString());
						if (entity.getDeparv_x().equals("D")) {
							pstmt.setString(1, allDate+" 0000");
							pstmt.setString(2, StringUtil.checkString(rs.getString("Sch_Dt_Loc_Full")));
							pstmt.setString(3, StringUtil.checkString(rs.getString("Arln_Cd")));
							pstmt.setString(4, StringUtil.checkString(rs.getString("Regno")));
							pstmt.setString(5, station);
						} else if(entity.getDeparv_x().equals("A")) {
							pstmt.setString(1, StringUtil.checkString(rs.getString("Sch_Dt_Loc_Full")));
							pstmt.setString(2, allDate+" 2359");
							pstmt.setString(3, StringUtil.checkString(rs.getString("Arln_Cd")));
							pstmt.setString(4, StringUtil.checkString(rs.getString("Regno")));
							pstmt.setString(5, station);
						}
						rs2 = pstmt.executeQuery();
	
						if (rs2.next()) {					
							entity.setConx_flt(StringUtil.checkString(rs.getString("Arln_Cd"))+StringUtil.checkString(rs2.getString("Flt_Num")));
							entity.setSub_sch(StringUtil.checkString(rs2.getString("Sch_Dt_Loc")));
							entity.setSub_est(StringUtil.checkString(rs2.getString("Est_Dt_Loc")));
							entity.setSub_act(StringUtil.checkString(rs2.getString("Act_Dt_Loc")));
							entity.setSub_spot(StringUtil.checkString(rs2.getString("Spot")));
						} else {
							entity.setConx_flt("");
							entity.setSub_sch("");
							entity.setSub_est("");
							entity.setSub_act("");
							entity.setSub_spot("");
						}
						if (pstmt != null) pstmt.close();
						if (rs2 != null) rs2.close();
						if (sql != null) sql = null;
					
					} else {
						entity.setConx_flt("");
						entity.setSub_sch("");
						entity.setSub_est("");
						entity.setSub_act("");
						entity.setSub_spot("");
					}
					listData.add(entity);
				} 
			
			} else {
				//2007.10.18 ߰ : GMP  ٸ  ȸ
				//HUB Station Information GMP ȸ
				stmt = conn.createStatement();
				sql = SkdQ050Query.getInstance().selMainGMP(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					SkdQ050BG entity = new SkdQ050BG();
					
					entity.setArlnCd_fltNum(StringUtil.checkString(rs.getString("ARLN_CD"))+StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setDeparv_x(StringUtil.checkString(rs.getString("DA")));
					entity.setSactyp(StringUtil.checkString(rs.getString("SACTYP")));
					entity.setSpot(StringUtil.checkString(rs.getString("SPOT")));
					entity.setGate(StringUtil.checkString(rs.getString("GATE")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setSch_dt_loc(StringUtil.checkString(rs.getString("SCH")));
					/*
					if (StringUtil.checkString(rs.getString("STS")).equals("EST")) entity.setEst_dt_loc(StringUtil.checkString(rs.getString("EST")));
					else entity.setEst_dt_loc("");
					if (StringUtil.checkString(rs.getString("STS")).equals("ACT")) entity.setAct_dt_loc(StringUtil.checkString(rs.getString("ACT")));
					else entity.setAct_dt_loc("");
					entity.setTkofland_t(StringUtil.checkString(rs.getString("OFFON")));
					*/
					//2008.10.14 ߰ : STS ACT ƴҶ ACARS ACT, OFFON   '*'   ǥ. 					
					if (StringUtil.checkString(rs.getString("STS")).equals("ACT")) {
						entity.setEst_dt_loc("");
						entity.setAct_dt_loc(StringUtil.checkString(rs.getString("ACT")));
						entity.setTkofland_t(StringUtil.checkString(rs.getString("OFFON")));
					} else {
						if (!StringUtil.checkString(rs.getString("ACT_ACARS")).equals("") || !StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) {
							entity.setEst_dt_loc("");
							if (StringUtil.checkString(rs.getString("ACT_ACARS")).equals("")) entity.setAct_dt_loc("");
							else entity.setAct_dt_loc(StringUtil.checkString(rs.getString("ACT_ACARS"))+"*");
							if (StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) entity.setTkofland_t("");
							else entity.setTkofland_t(StringUtil.checkString(rs.getString("OFFON_ACAR"))+"*");
						} else {
							if (StringUtil.checkString(rs.getString("STS")).equals("EST")) entity.setEst_dt_loc(StringUtil.checkString(rs.getString("EST")));
							else entity.setEst_dt_loc("");
							entity.setAct_dt_loc("");
							entity.setTkofland_t(StringUtil.checkString(rs.getString("OFFON")));
						}
					}
					
					entity.setCdsflt("");
					entity.setItnary(StringUtil.checkString(rs.getString("ITN")));
					entity.setConx_flt("");
					entity.setSub_sch("");
					entity.setSub_est("");
					entity.setSub_act("");
					entity.setSub_spot("");
					
					//2007.10.09 ߰ : ˾ ﶧ ʿ.
					entity.setSch_dt_loc_2(StringUtil.checkString(rs.getString("SCH_DT_LOC_FULL")));
					entity.setStn("GMP");
					entity.setArln_cd(StringUtil.checkString(rs.getString("ARLN_CD")));
					entity.setFlt_num(StringUtil.checkString(rs.getString("FLT_NUM")));
				
					listData.add(entity);
				}
			}
			
			hashData.put("HUBINFO", listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ050Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ050Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * Gantt Chart main ȸԼ.
	  * @param entity SkdQ110BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2006/04/24 
	  */
	public Hashtable selSkdQ110Main(SkdQ110BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List hlList = new LinkedList();
	    List barList = new LinkedList();
	    List kacList = new LinkedList();
		
	    try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//SKD ȸ
			stmt = conn.createStatement();
			sql = SkdQ110Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			String preRegNo = "";
			int divTop = 5;
			while (rs.next()) {
				String regNo = StringUtil.checkString(rs.getString("REGNO"));
				
				// REGNO Ͽ ٸ LIST ִ´. (REGNO پ  )
				if (!regNo.equals(preRegNo)) {
					SkdQ110BG hEntity = new SkdQ110BG();
					hEntity.setRegNo(regNo);				
					hlList.add(hEntity);
					
					divTop = divTop + 35; // ٲ𶧸 ̸ 35 ش.
				}
				
				//     ⼭  .
				// ġ, β,   ȭ ̺  ǹǷ, ο   ٸ ؾߵ.
				SkdQ110BG bEntity = new SkdQ110BG();
				
				String depSts = StringUtil.checkString(rs.getString("DEP_STS"));
				String arvSts = StringUtil.checkString(rs.getString("ARV_STS"));
				String depHHMI = "";
				if (depSts.equals("SCH")) {
					depHHMI = StringUtil.checkString(rs.getString("SCH_DEP"));
				} else if (depSts.equals("EST")) {
					depHHMI = StringUtil.checkString(rs.getString("EST_DEP"));
				} else if (depSts.equals("ACT")) {
					depHHMI = StringUtil.checkString(rs.getString("ACT_DEP"));
				}
				int fltMinutes = 0;
				String utcDepArv = "";
				String locDepArv = "";
				if (arvSts.equals("ACT")) {
					fltMinutes = rs.getInt("ACTACT_MIN"); //
					utcDepArv = StringUtil.checkString(rs.getString("ACTACT_UTC"));
					locDepArv = StringUtil.checkString(rs.getString("ACTACT_LOC"));
				} else {
					if (depSts.equals("SCH")) { 
						fltMinutes = rs.getInt("SCHSCH_MIN"); //
						utcDepArv = StringUtil.checkString(rs.getString("SCHSCH_UTC"));
						locDepArv = StringUtil.checkString(rs.getString("SCHSCH_LOC"));
					} else if (depSts.equals("EST")) { 
						fltMinutes = rs.getInt("ESTEST_MIN"); //
						utcDepArv = StringUtil.checkString(rs.getString("ESTEST_UTC"));
						locDepArv = StringUtil.checkString(rs.getString("ESTEST_LOC"));
					} else if (depSts.equals("ACT")) { 
						if (arvSts.equals("SCH")) {
							fltMinutes = rs.getInt("ACTSCH_MIN"); // ( )
							utcDepArv = StringUtil.checkString(rs.getString("ACTSCH_UTC"));
							locDepArv = StringUtil.checkString(rs.getString("ACTSCH_LOC"));
						} else if (arvSts.equals("EST")) {
							fltMinutes = rs.getInt("ACTEST_MIN"); // ( )
							utcDepArv = StringUtil.checkString(rs.getString("ACTEST_UTC"));
							locDepArv = StringUtil.checkString(rs.getString("ACTEST_LOC"));
						}
					}
				}
				
				int divLeft = 0;
				int depHH = 0;
				int depMI = 0;
				if (depHHMI.length() == 4) {
					depHH = Integer.parseInt(depHHMI.substring(0,2));
					depMI = Integer.parseInt(depHHMI.substring(2,4));
				}
				divLeft = 48 + (depHH * 36) + ((depMI / 5) * 3);//@  div ϴ
				
				int barWidth = 0;
				barWidth = ((fltMinutes / 60) * 36) + (((fltMinutes % 60) / 5) * 3);
				
				int divWidth = 0; //barWidth 3 
				if (barWidth < 42) divWidth = 47;
				else divWidth = barWidth + 5;
				
				String barColor = ""; //:£ȸ, :£û, :Ķ, :λ
				if (arvSts.equals("ACT")) {
					barColor = "color_1"; //
				} else {
					if (depSts.equals("SCH")) { 
						barColor = "color_3"; //
					} else if (depSts.equals("EST")) { 
						barColor = "color_4"; //
					} else if (depSts.equals("ACT")) { 
						barColor = "color_2"; //
					}
				}	//1,2,3 ߿ .
				
				bEntity.setDivLeft(String.valueOf(divLeft).toString());
				bEntity.setDivTop(String.valueOf(divTop).toString());
				bEntity.setDivWidth(String.valueOf(divWidth).toString()); 
				bEntity.setBarWidth(String.valueOf(barWidth).toString());
				bEntity.setBarColor(barColor);
				
				bEntity.setRegNo(StringUtil.checkString(rs.getString("REGNO")));
				bEntity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				bEntity.setStnFr(StringUtil.checkString(rs.getString("STNFR")));
				bEntity.setStnTo(StringUtil.checkString(rs.getString("STNTO")));
				bEntity.setFirstLegFltDt(StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")));
				
				String fClass = "F:"+StringUtil.checkString(rs.getString("F_CFG"))+"/<font color=#228B22><b>"+StringUtil.checkString(rs.getString("F_BOOK"))+"</b></font>(<font color=#0000CD><b>"+StringUtil.checkString(rs.getString("F_CHKIN"))+"</b></font>)";
				String cClass = "C:"+StringUtil.checkString(rs.getString("C_CFG"))+"/<font color=#228B22><b>"+StringUtil.checkString(rs.getString("C_BOOK"))+"</b></font>(<font color=#0000CD><b>"+StringUtil.checkString(rs.getString("C_CHKIN"))+"</b></font>)";
				String yClass = "Y:"+StringUtil.checkString(rs.getString("Y_CFG"))+"/<font color=#228B22><b>"+StringUtil.checkString(rs.getString("Y_BOOK"))+"</b></font>(<font color=#0000CD><b>"+StringUtil.checkString(rs.getString("Y_CHKIN"))+"</b></font>)";
				bEntity.setHelpBox(fClass+" "+cClass+" "+yClass);
				
				bEntity.setStatusInfo(StringUtil.checkString(rs.getString("KACTYP"))+" / "+StringUtil.checkString(rs.getString("REGNO"))+"          UTC : "+utcDepArv+"          LOC : "+locDepArv);
				
				barList.add(bEntity);
				
				preRegNo = regNo;
			} 
			
			hashData.put("REGNOLIST",hlList);
			hashData.put("BARLIST",barList);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//KACTYP ȸ
			stmt = conn.createStatement();
			sql = SkdQ110Query.getInstance().selKactyp(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SkdQ110BG kEntity = new SkdQ110BG();
				kEntity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
				kacList.add(kEntity);
			}
			
			hashData.put("KACTYPLIST",kacList);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ110Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ110Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
		
	/** 
	  * Gantt Chart main ȸԼ.
	  * @param entity SkdQ110BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2006/05/09 
	  */
	public Hashtable selSkdQ110Crew(SkdQ110BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    
	    try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//SKD ȸ
			stmt = conn.createStatement();
			sql = SkdQ110Query.getInstance().selCrew(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SkdQ110BG entity = new SkdQ110BG();
				
				entity.setStaffNum(StringUtil.checkString(rs.getString("STAFF_NUM")));
				entity.setEngName(StringUtil.checkString(rs.getString("ENG_NAME")));
				entity.setRankCd(StringUtil.checkString(rs.getString("RANK_CD")));
				entity.setGisuNr(StringUtil.checkString(rs.getString("GISU_NR")));
				
				listData.add(entity);
			}
	    
	   		hashData.put("CREWINFO", listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ110Crew:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ110Crew:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * HUB Station Info Detail ȸ Լ
	  * @param entity SkdQ060BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2007/10/11 
	  */
	public Hashtable selSkdQ060Main(SkdQ060BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
		
		//2008.04.16 ߰
		Statement stmtGc = null;
		ResultSet rsGc = null;
		String sqlGc = null;
		
		Statement stmtCs = null;
		ResultSet rsCs = null;
		String sqlCs = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		
		List fltList = new LinkedList();
		List crewList = new LinkedList();
		List aircraftList = new LinkedList();
		List boardingList = new LinkedList();
		List paxList = new LinkedList();
	    
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			if (params.getPArlnCd().equals("KE")) {
				//******************** KE   ********************
				
				String firstLegFltDt = "";
				String stnfr = "";
				String stnto = "";
				String actDepDtLoc = "";
				
				//1. FLT INFO ȸ
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selFltInfoKE(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setFltActyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setFltAcver(StringUtil.checkString(rs.getString("ACVER")));
					entity.setFltAcreg(StringUtil.checkString(rs.getString("REGNO")));
					entity.setFltStd(StringUtil.checkString(rs.getString("SCH")));
					
					String fltSts = StringUtil.checkString(rs.getString("STS"));
					/*
					if (fltSts.equals("EST") || fltSts.equals("ACT")) entity.setFltEtd(StringUtil.checkString(rs.getString("EST")));
					else entity.setFltEtd("");
					if (fltSts.equals("ACT")) entity.setFltAtd(StringUtil.checkString(rs.getString("ACT")));
					else entity.setFltAtd("");
					entity.setFltToff(StringUtil.checkString(rs.getString("ONOFF")));
					*/
					//2008.10.14 ߰ : STS ACT ƴҶ ACARS ACT, OFFON   '*'   ǥ. 					
					if (fltSts.equals("ACT")) {
						entity.setFltEtd(StringUtil.checkString(rs.getString("EST")));
						entity.setFltAtd(StringUtil.checkString(rs.getString("ACT")));
						entity.setFltToff(StringUtil.checkString(rs.getString("ONOFF")));
					} else {
						if (!StringUtil.checkString(rs.getString("ACT_ACARS")).equals("") || !StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) {
							if (fltSts.equals("EST")) entity.setFltEtd(StringUtil.checkString(rs.getString("EST")));
							else entity.setFltEtd("");
							if (StringUtil.checkString(rs.getString("ACT_ACARS")).equals("")) entity.setFltAtd("");
							else entity.setFltAtd(StringUtil.checkString(rs.getString("ACT_ACARS"))+"*");
							if (StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) entity.setFltToff("");
							else entity.setFltToff(StringUtil.checkString(rs.getString("OFFON_ACAR"))+"*");
						} else {
							if (fltSts.equals("EST")) entity.setFltEtd(StringUtil.checkString(rs.getString("EST")));
							else entity.setFltEtd("");
							entity.setFltAtd("");
							entity.setFltToff(StringUtil.checkString(rs.getString("ONOFF")));
						}
					}
					
					entity.setFltSpot(StringUtil.checkString(rs.getString("SPOT")));
					entity.setFltGate(StringUtil.checkString(rs.getString("GATE")));
					
					/* 2008.04.17 
					//2008.04.16 ߰ : ARR     G/C  ȸ GATE -> CRSL
					if (params.getPDepArvX().equals("A")) {
						stmtGc = conn.createStatement();
						sqlGc = SkdQ060Query.getInstance().selArrGc(StringUtil.checkString(rs.getString("SCH_DT_2")), StringUtil.checkString(rs.getString("FLT_NUM_2")));
						rsGc = stmtGc.executeQuery(sqlGc);
						
						if (rsGc.next()) entity.setFltGate(StringUtil.checkString(rsGc.getString("GC")));
						
						if (stmtGc != null) stmtGc.close();
						if (rsGc != null) rsGc.close();
						if (sqlGc != null) sqlGc = null;
					}
					*/
					
					firstLegFltDt = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
					stnfr = StringUtil.checkString(rs.getString("STNFR"));
					stnto = StringUtil.checkString(rs.getString("STNTO"));
					actDepDtLoc = StringUtil.checkString(rs.getString("ACT_DEP_DT_LOC"));
					
					fltList.add(entity);
				}
				hashData.put("FLTLIST", fltList);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				params.setPFirstLegFltDt(firstLegFltDt);
				params.setPStnfr(stnfr);
				params.setPStnto(stnto);
				
				//2. CATEGORY INFO ȸ
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selCategoryInfoKE(params);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setCatCat3(StringUtil.checkString(rs.getString("CAT3_DATE")));
					entity.setCatCat2(StringUtil.checkString(rs.getString("CAT2_DATE")));
					entity.setCatLastFlt(StringUtil.checkString(rs.getString("FLT_NUM"))+" / "+StringUtil.checkString(rs.getString("CAT_DATE"))+" / "+StringUtil.checkString(rs.getString("STNFR"))+" - "+StringUtil.checkString(rs.getString("STNTO")));
					
					hashData.put("CATEGORYINFO", entity);
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//3. CREW INFO ȸ				
				stmt = conn.createStatement();
				//sql = SkdQ060Query.getInstance().selCrewInfoKE(params);
				sql = SkdQ060Query.getInstance().selCrewInfo_PrevNextKE(params);
				rs = stmt.executeQuery(sql);
			
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setCrewStaffNum(StringUtil.checkString(rs.getString("STAFF_NUM")));
					entity.setCrewSurname(StringUtil.checkString(rs.getString("ENG_NAME")));
					entity.setCrewActingRank(StringUtil.checkString(rs.getString("RANK")));
					entity.setCrewDutyCd(StringUtil.checkString(rs.getString("DUTY")));
					entity.setCrewPrevFltInfo(StringUtil.checkString(rs.getString("PRV_FLT")));
					entity.setCrewNextFltInfo(StringUtil.checkString(rs.getString("NXT_FLT")));
					
					/*entity.setCrewStaffNum(StringUtil.checkString(rs.getString("STAFF_NUM")));
					entity.setCrewSurname(StringUtil.checkString(rs.getString("SURNAME")));
					entity.setCrewActingRank(StringUtil.checkString(rs.getString("ACTING_RANK")));
					entity.setCrewDutyCd(StringUtil.checkString(rs.getString("DUTY_CD")));
					
					//CREW PREV,NEXT FLT INFO ȸ
					String sqlCrew1 = SkdQ060Query.getInstance().selCrewPrevNextKE();
					PreparedStatement pstmt1 = conn.prepareStatement(sqlCrew1);
					pstmt1.setString(1, StringUtil.checkString(rs.getString("STAFF_NUM")));
					pstmt1.setString(2, actDepDtLoc);
					pstmt1.setString(3, actDepDtLoc);
					pstmt1.setString(4, StringUtil.checkString(rs.getString("STAFF_NUM")));
					pstmt1.setString(5, actDepDtLoc);
					pstmt1.setString(6, actDepDtLoc);
					ResultSet rsCrew1 = pstmt1.executeQuery();
					
					entity.setCrewPrevFltInfo("");
					entity.setCrewNextFltInfo("");
					
					while (rsCrew1.next()) {
						String mode = StringUtil.checkString(rsCrew1.getString("FLT_SEQ"));
						String fltNum = StringUtil.checkString(rsCrew1.getString("FLT_NUM"));
						String fltDate = StringUtil.checkString(rsCrew1.getString("FLT_DATE"));
						String portA = StringUtil.checkString(rsCrew1.getString("PORT_A"));
						String portB = StringUtil.checkString(rsCrew1.getString("PORT_B"));
						String duty = StringUtil.checkString(rsCrew1.getString("DUTY_CD"));
						String regNo = StringUtil.checkString(rsCrew1.getString("REGNO"));
						
						if (mode.equals("PREV")) {
							entity.setCrewPrevFltInfo(fltNum+"/"+fltDate+" - "+portA+"/"+portB+"("+duty+")"); 
						} else {
							entity.setCrewNextFltInfo(fltNum+"/"+fltDate+" - "+portA+"/"+portB+"("+duty+")"); 
						}
					}
				
					//ڿȯ
					if (pstmt1 != null) pstmt1.close();
					if (rsCrew1 != null) rsCrew1.close();
					if (sqlCrew1 != null) sqlCrew1 = null;*/
					
					//CREW LAST FLT INFO ȸ
					String sqlCrew2 = SkdQ060Query.getInstance().selCrewLastKE();
					PreparedStatement pstmt2 = conn.prepareStatement(sqlCrew2);
					pstmt2.setString(1, StringUtil.checkString(rs.getString("STAFF_NUM")));
					ResultSet rsCrew2 = pstmt2.executeQuery();
					
					entity.setCrewLastFltInfo("");
					
					while (rsCrew2.next()) {
						String mode = StringUtil.checkString(rsCrew2.getString("FLT_SEQ"));
						String fltNum = StringUtil.checkString(rsCrew2.getString("FLT_NUM"));
						String fltDate = StringUtil.checkString(rsCrew2.getString("FLT_DATE"));
						String portA = StringUtil.checkString(rsCrew2.getString("PORT_A"));
						String portB = StringUtil.checkString(rsCrew2.getString("PORT_B"));
						String duty = StringUtil.checkString(rsCrew2.getString("DUTY_CD"));
						String regNo = StringUtil.checkString(rsCrew2.getString("REGNO"));
						
						entity.setCrewLastFltInfo(fltNum+"/"+fltDate+" - "+regNo);
					}
				
					//ڿȯ
					if (pstmt2 != null) pstmt2.close();
					if (rsCrew2 != null) rsCrew2.close();
					if (sqlCrew2 != null) sqlCrew2 = null;
				
					crewList.add(entity);
				}
				hashData.put("CREWLIST", crewList);
				
				//4. Aircraft Connection INFO ȸ				
				/*
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selAircraftInfoKE(params);
				rs = stmt.executeQuery(sql);
			
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setAircFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setAircDep(StringUtil.checkString(rs.getString("STNFR")));
					entity.setAircArr(StringUtil.checkString(rs.getString("STNTO")));
					entity.setAircStd(StringUtil.checkString(rs.getString("SCH_DEP_TM")));
					entity.setAircSta(StringUtil.checkString(rs.getString("SCH_ARV_TM")));
					// Daily_Sch_T DB Dep/Arv Status Time 
					String estDepTm = StringUtil.checkString(rs.getString("EST_DEP_TM"));
					String actDepTm = StringUtil.checkString(rs.getString("ACT_DEP_TM"));
					String estArvTm = StringUtil.checkString(rs.getString("EST_ARV_TM"));
					String actArvTm = StringUtil.checkString(rs.getString("ACT_ARV_TM"));
					String tkofT = StringUtil.checkString(rs.getString("TKOF_T"));
					String landT = StringUtil.checkString(rs.getString("LAND_T"));
					String[] arrDep = StringUtil.StatusTime("D", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estDepTm, actDepTm, tkofT);
					String[] arrArv = StringUtil.StatusTime("A", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estArvTm, actArvTm, landT);
					entity.setAircEtd(arrDep[0]);
					entity.setAircAtd(arrDep[1]);
					entity.setAircToff(arrDep[2]);
					entity.setAircEta(arrArv[0]);
					entity.setAircAta(arrArv[1]);
					entity.setAircTdwn(arrArv[2]);
					entity.setAircDepSpot(StringUtil.checkString(rs.getString("SPOT_OUT")));
					entity.setAircArrSpot(StringUtil.checkString(rs.getString("SPOT_IN")));
					
					aircraftList.add(entity);
				}
				*/
				//DEP ϶
				if (params.getPDepArvX().equals("D")) {
					stmt = conn.createStatement();
					sql = SkdQ060Query.getInstance().selAircraftInfoKEDep(params);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						SkdQ060BG entity = new SkdQ060BG();
						
						entity.setAircFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
						entity.setAircDep(StringUtil.checkString(rs.getString("STNFR")));
						entity.setAircArr(StringUtil.checkString(rs.getString("STNTO")));
						
						entity.setAircSch(StringUtil.checkString(rs.getString("SCH")));
						//***** Daily_Sch_T DB Dep/Arv Status Time  *****
						String estDepTm = StringUtil.checkString(rs.getString("EST"));
						String actDepTm = StringUtil.checkString(rs.getString("ACT"));
						String tkofT = StringUtil.checkString(rs.getString("ONOFF"));
						String[] arrDep = StringUtil.StatusTime("D", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estDepTm, actDepTm, tkofT);
						/*
						entity.setAircEst(arrDep[0]);
						entity.setAircAct(arrDep[1]);
						entity.setAircOffdn(arrDep[2]);
						*/
						//2008.10.14 ߰ : STS ACT ƴҶ ACARS ACT, OFFON   '*'   ǥ.
						if (StringUtil.checkString(rs.getString("DEP_STS")).equals("ACT")) {
							entity.setAircEst(arrDep[0]);
							entity.setAircAct(arrDep[1]);
							entity.setAircOffdn(arrDep[2]);
						} else {
							if (!StringUtil.checkString(rs.getString("ACT_ACARS")).equals("") || !StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) {
								entity.setAircEst(arrDep[0]);
								if (StringUtil.checkString(rs.getString("ACT_ACARS")).equals("")) entity.setAircAct("");
								else entity.setAircAct(StringUtil.checkString(rs.getString("ACT_ACARS"))+"*");
								if (StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) entity.setAircOffdn("");
								else entity.setAircOffdn(StringUtil.checkString(rs.getString("OFFON_ACAR"))+"*");
							} else {
								entity.setAircEst(arrDep[0]);
								entity.setAircAct(arrDep[1]);
								entity.setAircOffdn(arrDep[2]);
							}
						}
						entity.setAircSpot(StringUtil.checkString(rs.getString("SPOT")));
						entity.setAircGcrsl(StringUtil.checkString(rs.getString("GC")));
						
						//CSFLT **************************************************
						String cdsFlt = "";
						
						stmtCs = conn.createStatement();
						sqlCs = SkdQ060Query.getInstance().selCsFlt(params.getPArlnCd(), StringUtil.checkString(rs.getString("SCH_DT_2")), StringUtil.checkString(rs.getString("FLT_NUM_2")));
						rsCs = stmtCs.executeQuery(sqlCs);
						
						if (rsCs.next()) cdsFlt = StringUtil.checkString(rsCs.getString("CDSFLT"));
						
						if (stmtCs != null) stmtCs.close();
						if (rsCs != null) rsCs.close();
						if (sqlCs != null) sqlCs = null;
						
						entity.setAircCsfltid(cdsFlt);
						//******************************************************************
						
						aircraftList.add(entity);
					}
				
				//ARR ϶
				} else {
					stmt = conn.createStatement();
					sql = SkdQ060Query.getInstance().selAircraftInfoKEArr(params);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						SkdQ060BG entity = new SkdQ060BG();
						
						entity.setAircFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
						entity.setAircDep(StringUtil.checkString(rs.getString("STNFR")));
						entity.setAircArr(StringUtil.checkString(rs.getString("STNTO")));
						
						entity.setAircSch(StringUtil.checkString(rs.getString("SCH")));
						//***** Daily_Sch_T DB Dep/Arv Status Time  *****
						String estArvTm = StringUtil.checkString(rs.getString("EST"));
						String actArvTm = StringUtil.checkString(rs.getString("ACT"));
						String landT = StringUtil.checkString(rs.getString("ONOFF"));
						String[] arrArv = StringUtil.StatusTime("A", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estArvTm, actArvTm, landT);
						/*
						entity.setAircEst(arrArv[0]);
						entity.setAircAct(arrArv[1]);
						entity.setAircOffdn(arrArv[2]);
						*/
						//2008.10.14 ߰ : STS ACT ƴҶ ACARS ACT, OFFON   '*'   ǥ.
						if (StringUtil.checkString(rs.getString("ARV_STS")).equals("ACT")) {
							entity.setAircEst(arrArv[0]);
							entity.setAircAct(arrArv[1]);
							entity.setAircOffdn(arrArv[2]);
						} else {
							if (!StringUtil.checkString(rs.getString("ACT_ACARS")).equals("") || !StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) {
								entity.setAircEst(arrArv[0]);
								if (StringUtil.checkString(rs.getString("ACT_ACARS")).equals("")) entity.setAircAct("");
								else entity.setAircAct(StringUtil.checkString(rs.getString("ACT_ACARS"))+"*");
								if (StringUtil.checkString(rs.getString("OFFON_ACAR")).equals("")) entity.setAircOffdn("");
								else entity.setAircOffdn(StringUtil.checkString(rs.getString("OFFON_ACAR"))+"*");
							} else {
								entity.setAircEst(arrArv[0]);
								entity.setAircAct(arrArv[1]);
								entity.setAircOffdn(arrArv[2]);
							}
						}
						entity.setAircSpot(StringUtil.checkString(rs.getString("SPOT")));
						
						//G/C (KE & ARR ϶) **********************************
						String gc = "";
						
						stmtGc = conn.createStatement();
						sqlGc = SkdQ060Query.getInstance().selArrGc(StringUtil.checkString(rs.getString("SCH_DT_2")), StringUtil.checkString(rs.getString("FLT_NUM_2")));
						rsGc = stmtGc.executeQuery(sqlGc);
						
						if (rsGc.next()) gc = StringUtil.checkString(rsGc.getString("GC"));
						
						if (stmtGc != null) stmtGc.close();
						if (rsGc != null) rsGc.close();
						if (sqlGc != null) sqlGc = null;
						
						entity.setAircGcrsl(gc);
						//******************************************************************
						
						//CSFLT **************************************************
						String cdsFlt = "";
						
						stmtCs = conn.createStatement();
						sqlCs = SkdQ060Query.getInstance().selCsFlt(params.getPArlnCd(), StringUtil.checkString(rs.getString("SCH_DT_2")), StringUtil.checkString(rs.getString("FLT_NUM_2")));
						rsCs = stmtCs.executeQuery(sqlCs);
						
						if (rsCs.next()) cdsFlt = StringUtil.checkString(rsCs.getString("CDSFLT"));
						
						if (stmtCs != null) stmtCs.close();
						if (rsCs != null) rsCs.close();
						if (sqlCs != null) sqlCs = null;
						
						entity.setAircCsfltid(cdsFlt);
						//******************************************************************
						
						aircraftList.add(entity);
					}
				}
				
				hashData.put("AIRCRAFTLIST", aircraftList);
			
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//5. BOARDING INFO ȸ
				DecimalFormat df = new DecimalFormat("#,###");
				double totTrans = 0;
				
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selBoardingInfoKE_2(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setBrdObdStn(StringUtil.checkString(rs.getString("OBD_STN_C")));
					entity.setBrdObdRev(df.format(rs.getDouble("REV_Q")));
					entity.setBrdObdReb(df.format(rs.getDouble("REB_Q")));
					entity.setBrdObdTrans(df.format(rs.getDouble("TRANS_Q")));
					entity.setBrdObdCgoWt(df.format(rs.getDouble("CGO_WT_Q")));
					entity.setBrdObdMailWt(df.format(rs.getDouble("MAIL_WT_Q")));
					entity.setBrdObdBagWt(df.format(rs.getDouble("BAG_WT_Q")));
					entity.setBrdObdBagCnt(df.format(rs.getDouble("BAG_CNT_Q")));
					entity.setBrdObdTransWt(df.format(rs.getDouble("TRANS_WT_Q")));
					totTrans = totTrans + rs.getDouble("TRANS_WT_Q");
					
					boardingList.add(entity);
				}
				hashData.put("BOARDINGLIST", boardingList);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selBoardingInfoKE_1(params);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setBrdCfg(StringUtil.checkString(rs.getString("CFG")));
					entity.setBrdRsvn(StringUtil.checkString(rs.getString("RSVN")));
					entity.setBrdChkin(StringUtil.checkString(rs.getString("CHKIN")));
					entity.setBrdAdltChldEnf(StringUtil.checkString(rs.getString("ADLT_CHLD_ENF")));
					entity.setBrdCrew(StringUtil.checkString(rs.getString("CREW")));
					entity.setBrdTrans(df.format(totTrans));
					entity.setBrdPayload(df.format(rs.getDouble("ACT_PAYLOAD_Q")));
					entity.setBrdAcl(df.format(rs.getDouble("MAX_PAYLOAD_Q")));
					entity.setBrdBew(df.format(rs.getDouble("ACT_BEW_Q")));
					entity.setBrdSow(df.format(rs.getDouble("ACT_SOW_Q")));
					entity.setBrdZfw(df.format(rs.getDouble("ACT_ZFW_Q")));
					entity.setBrdTow(df.format(rs.getDouble("ACT_TOW_Q")));
					entity.setBrdLdw(df.format(rs.getDouble("EST_LDW_Q")));
					entity.setBrdTof(df.format(rs.getDouble("TOF_Q")));
					entity.setBrdTif(df.format(rs.getDouble("TIF_Q")));
					entity.setBrdCgoWt(df.format(rs.getDouble("CGO_WT_Q")));
					entity.setBrdMailWt(df.format(rs.getDouble("MAIL_WT_Q")));
					entity.setBrdBagWt(df.format(rs.getDouble("BAG_WT_Q")));
					entity.setBrdDead("");
					
					hashData.put("BOARDINGINFO", entity);
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//6. PAX Connection INFO ȸ
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selPaxInfoKE(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setPaxFlt(StringUtil.checkString(rs.getString("TRANS_ARLN_CD")) + StringUtil.checkString(rs.getString("TRANS_FLT_NUM")));
					entity.setPaxDep(StringUtil.checkString(rs.getString("DEP")));
					entity.setPaxArr(StringUtil.checkString(rs.getString("ARR")));
					entity.setPaxBook(StringUtil.checkString(rs.getString("BOOK")));
					entity.setPaxChkin(StringUtil.checkString(rs.getString("CHKIN")));
					entity.setPaxBagCnt(StringUtil.checkString(rs.getString("BAG_Q")));
					
					String transFltNum = StringUtil.checkString(rs.getString("TRANS_FLT_NUM"));
					String transDate = StringUtil.checkString(rs.getString("TRANS_DATE"));
					String transTime = StringUtil.checkString(rs.getString("TRANS_TIME"));
					String transArlnCd = StringUtil.checkString(rs.getString("TRANS_ARLN_CD"));
					
					params.setPTransFltNum(transFltNum);
					params.setPTransDate(transDate);
					params.setPTransTime(transTime);
					params.setPTransArlnCd(transArlnCd);
					
					entity.setPaxDate("");
					entity.setPaxStdAta("");
					entity.setPaxSts("");
					
					if (params.getPDepArvX().equals("D")) { //D
						
						if (transArlnCd.equals("KE")) {
							Statement stmt1 = conn.createStatement();
							String sql1 = SkdQ060Query.getInstance().selPaxInfoKE_1(params);
							ResultSet rs1 = stmt1.executeQuery(sql1);
							
							if (rs1.next()) {
								entity.setPaxDate(StringUtil.checkString(rs1.getString("ACT_ARV_DATE_LOC")));
								entity.setPaxStdAta(StringUtil.checkString(rs1.getString("ACT_ARV_TIME_LOC")));
								entity.setPaxSts(StringUtil.checkString(rs1.getString("STS")));
							}
							
							if (stmt1 != null) stmt1.close();
							if (rs1 != null) rs1.close();
							if (sql1 != null) sql1 = null;
							
						} else {
							Statement stmt1 = conn.createStatement();
							String sql1 = SkdQ060Query.getInstance().selPaxInfoKE_2(params);
							ResultSet rs1 = stmt1.executeQuery(sql1);
							
							if (rs1.next()) {
								entity.setPaxDate(transDate);
								entity.setPaxStdAta(transTime);
								entity.setPaxSts(StringUtil.checkString(rs1.getString("STS")));
							}
							
							if (stmt1 != null) stmt1.close();
							if (rs1 != null) rs1.close();
							if (sql1 != null) sql1 = null;
						}
						
					} else { //A
												
						if (transArlnCd.equals("KE")) {
							Statement stmt1 = conn.createStatement();
							String sql1 = SkdQ060Query.getInstance().selPaxInfoKE_1(params);
							ResultSet rs1 = stmt1.executeQuery(sql1);
							
							if (rs1.next()) {
								entity.setPaxDate(StringUtil.checkString(rs1.getString("ACT_DEP_DATE_LOC")));
								entity.setPaxStdAta(StringUtil.checkString(rs1.getString("ACT_DEP_TIME_LOC")));
								entity.setPaxSts(StringUtil.checkString(rs1.getString("STS")));
							}
							
							if (stmt1 != null) stmt1.close();
							if (rs1 != null) rs1.close();
							if (sql1 != null) sql1 = null;
							
						} else {
							Statement stmt1 = conn.createStatement();
							String sql1 = SkdQ060Query.getInstance().selPaxInfoKE_2(params);
							ResultSet rs1 = stmt1.executeQuery(sql1);
							
							if (rs1.next()) {
								entity.setPaxDate(transDate);
								entity.setPaxStdAta(transTime);
								entity.setPaxSts(StringUtil.checkString(rs1.getString("STS")));
							}
							
							if (stmt1 != null) stmt1.close();
							if (rs1 != null) rs1.close();
							if (sql1 != null) sql1 = null;
						}
					}
					
					paxList.add(entity);
				}
				hashData.put("PAXLIST", paxList);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
			} else {
				//******************** KE  ƴ  ********************
				
				//1. FLT INFO ȸ
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selFltInfoOther(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setFltActyp(StringUtil.checkString(rs.getString("SACTYP")));
					entity.setFltAcver("");
					entity.setFltAcreg(StringUtil.checkString(rs.getString("REGNO")));
					entity.setFltStd(StringUtil.checkString(rs.getString("SCH")));
					entity.setFltEtd(StringUtil.checkString(rs.getString("EST")));
					entity.setFltAtd(StringUtil.checkString(rs.getString("ACT")));
					entity.setFltToff(StringUtil.checkString(rs.getString("ONOFF")));
					entity.setFltSpot(StringUtil.checkString(rs.getString("SPOT")));
					entity.setFltGate(StringUtil.checkString(rs.getString("GATE")));
					
					fltList.add(entity);
				}
				hashData.put("FLTLIST", fltList);
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
				
				//4. Aircraft Connection INFO ȸ				
				/*
				stmt = conn.createStatement();
				sql = SkdQ060Query.getInstance().selAircraftInfoOther(params);
				rs = stmt.executeQuery(sql);
			
				while (rs.next()) {
					SkdQ060BG entity = new SkdQ060BG();
					
					entity.setAircFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setAircDep(StringUtil.checkString(rs.getString("STNFR")));
					entity.setAircArr(StringUtil.checkString(rs.getString("STNTO")));
					entity.setAircStd(StringUtil.checkString(rs.getString("STD")));
					entity.setAircSta(StringUtil.checkString(rs.getString("STA")));
					//***** Daily_Sch_T DB Dep/Arv Status Time  *****
					String estDepTm = StringUtil.checkString(rs.getString("ETD"));
					String actDepTm = StringUtil.checkString(rs.getString("ATD"));
					String estArvTm = StringUtil.checkString(rs.getString("ETA"));
					String actArvTm = StringUtil.checkString(rs.getString("ATA"));
					String tkofT = StringUtil.checkString(rs.getString("TOFF"));
					String landT = StringUtil.checkString(rs.getString("TDWN"));
					String[] arrDep = StringUtil.StatusTime("D", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estDepTm, actDepTm, tkofT);
					String[] arrArv = StringUtil.StatusTime("A", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estArvTm, actArvTm, landT);
					entity.setAircEtd(arrDep[0]);
					entity.setAircAtd(arrDep[1]);
					entity.setAircToff(arrDep[2]);
					entity.setAircEta(arrArv[0]);
					entity.setAircAta(arrArv[1]);
					entity.setAircTdwn(arrArv[2]);
					entity.setAircDepSpot(StringUtil.checkString(rs.getString("DEP_SPOT")));
					entity.setAircArrSpot(StringUtil.checkString(rs.getString("ARR_SPOT")));
					
					aircraftList.add(entity);
				}
				*/
				//DEP ϶
				if (params.getPDepArvX().equals("D")) {
					stmt = conn.createStatement();
					sql = SkdQ060Query.getInstance().selAircraftInfoOtherDep(params);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						SkdQ060BG entity = new SkdQ060BG();
						
						entity.setAircFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
						entity.setAircDep(StringUtil.checkString(rs.getString("STNFR")));
						entity.setAircArr(StringUtil.checkString(rs.getString("STNTO")));
						
						entity.setAircSch(StringUtil.checkString(rs.getString("SCH")));
						//***** Daily_Sch_T DB Dep/Arv Status Time  *****
						String estDepTm = StringUtil.checkString(rs.getString("EST"));
						String actDepTm = StringUtil.checkString(rs.getString("ACT"));
						String tkofT = StringUtil.checkString(rs.getString("ONOFF"));
						String[] arrDep = StringUtil.StatusTime("D", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estDepTm, actDepTm, tkofT);
						entity.setAircEst(arrDep[0]);
						entity.setAircAct(arrDep[1]);
						entity.setAircOffdn(arrDep[2]);
						
						entity.setAircSpot(StringUtil.checkString(rs.getString("SPOT")));
						entity.setAircGcrsl(StringUtil.checkString(rs.getString("GC")));
						
						//CSFLT **************************************************
						String cdsFlt = "";
						
						stmtCs = conn.createStatement();
						sqlCs = SkdQ060Query.getInstance().selCsFlt(params.getPArlnCd(), StringUtil.checkString(rs.getString("SCH_DT_2")), StringUtil.checkString(rs.getString("FLT_NUM_2")));
						rsCs = stmtCs.executeQuery(sqlCs);
						
						if (rsCs.next()) cdsFlt = StringUtil.checkString(rsCs.getString("CDSFLT"));
						
						if (stmtCs != null) stmtCs.close();
						if (rsCs != null) rsCs.close();
						if (sqlCs != null) sqlCs = null;
						
						entity.setAircCsfltid(cdsFlt);
						//******************************************************************
						
						aircraftList.add(entity);
					}
				
				//ARR ϶
				} else {
					stmt = conn.createStatement();
					sql = SkdQ060Query.getInstance().selAircraftInfoOtherArr(params);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						SkdQ060BG entity = new SkdQ060BG();
						
						entity.setAircFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
						entity.setAircDep(StringUtil.checkString(rs.getString("STNFR")));
						entity.setAircArr(StringUtil.checkString(rs.getString("STNTO")));
						
						entity.setAircSch(StringUtil.checkString(rs.getString("SCH")));
						//***** Daily_Sch_T DB Dep/Arv Status Time  *****
						String estArvTm = StringUtil.checkString(rs.getString("EST"));
						String actArvTm = StringUtil.checkString(rs.getString("ACT"));
						String landT = StringUtil.checkString(rs.getString("ONOFF"));
						String[] arrArv = StringUtil.StatusTime("A", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), estArvTm, actArvTm, landT);
						entity.setAircEst(arrArv[0]);
						entity.setAircAct(arrArv[1]);
						entity.setAircOffdn(arrArv[2]);
						
						entity.setAircSpot(StringUtil.checkString(rs.getString("SPOT")));
						entity.setAircGcrsl(StringUtil.checkString(rs.getString("GC")));
						
						//CSFLT **************************************************
						String cdsFlt = "";
						
						stmtCs = conn.createStatement();
						sqlCs = SkdQ060Query.getInstance().selCsFlt(params.getPArlnCd(), StringUtil.checkString(rs.getString("SCH_DT_2")), StringUtil.checkString(rs.getString("FLT_NUM_2")));
						rsCs = stmtCs.executeQuery(sqlCs);
						
						if (rsCs.next()) cdsFlt = StringUtil.checkString(rsCs.getString("CDSFLT"));
						
						if (stmtCs != null) stmtCs.close();
						if (rsCs != null) rsCs.close();
						if (sqlCs != null) sqlCs = null;
						
						entity.setAircCsfltid(cdsFlt);
						//******************************************************************
						
						aircraftList.add(entity);
					}
				}
				
				hashData.put("AIRCRAFTLIST", aircraftList);
			
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
			}
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ060Main:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ060Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ060Main:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ060Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * Weekly SKD Display - SEASON ȸ Լ
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/10/14 
	  */
	public Hashtable selSkdQ070Season() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			int today = 0;
			
			// ȸ
			stmt = conn.createStatement();
			sql = ComQ01Query.getInstance().selDbTime("YYYYMMDD", "0");
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) today = Integer.parseInt(rs.getString("DB_TIME"));
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//SEASON ȸ
			stmt = conn.createStatement();
			sql = SkdQ070Query.getInstance().selSeason();
			rs = stmt.executeQuery(sql);
			
			String thisSeason = "";
			
			while (rs.next()) {
				SkdQ070BG entity = new SkdQ070BG();
				
				entity.setSeason(StringUtil.checkString(rs.getString("CODE_C")));
				entity.setPeriodFr(StringUtil.checkString(rs.getString("PERIOD_FR")));
				entity.setPeriodTo(StringUtil.checkString(rs.getString("PERIOD_TO")));
				
				if (today >= Integer.parseInt(rs.getString("DATE_FR")) && today <= Integer.parseInt(rs.getString("DATE_TO"))) {
					thisSeason = StringUtil.checkString(rs.getString("CODE_C"))+StringUtil.checkString(rs.getString("PERIOD_FR"))+StringUtil.checkString(rs.getString("PERIOD_TO"));
				}
				
				listData.add(entity);
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			hashData.put("SEASON_LIST", listData);
			hashData.put("THIS_SEASON", thisSeason);
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ070Season:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ070Season:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ070Season:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ070Season:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * Weekly SKD Display ȸ Լ
	  * @param entity SkdQ070BG 
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/10/14 
	  */
	public Hashtable selSkdQ070Main(SkdQ070BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String fltId = "";
			
			//FLT ִ 8
			if (!params.getPFltId().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getPFltId()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) fltId = fltId + ",";
					fltId = fltId + "'" + token + "'";
					chk++;
				}
			}
			
			//SEASON ȸ
			stmt = conn.createStatement();
			sql = SkdQ070Query.getInstance().selMain(params, fltId);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SkdQ070BG entity = new SkdQ070BG();
				
				entity.setFlt(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setPeriod(StringUtil.checkString(rs.getString("PERIOD")));
				entity.setDay(StringUtil.checkString(rs.getString("FRQ")));
				entity.setOnward(StringUtil.checkString(rs.getString("NEXT_FLT_NUM")));
				entity.setSvc(StringUtil.checkString(rs.getString("SVC")));
				entity.setTyp(StringUtil.checkString(rs.getString("KACTYP")));
				entity.setLeg(StringUtil.checkString(rs.getString("LEG_NUM")));
				entity.setDep(StringUtil.checkString(rs.getString("STNFR")));
				entity.setArr(StringUtil.checkString(rs.getString("STNTO")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setSta(StringUtil.checkString(rs.getString("STA")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
				
				listData.add(entity);
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			hashData.put("WEEKLY_LIST", listData);
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ070Main:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ070Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ070Main:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ070Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * RAD - KACTYP ȸ Լ
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/10/15 
	  */
	public Hashtable selSkdA080Kactyp() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//KACTYP ȸ
			stmt = conn.createStatement();
			sql = SkdA080Query.getInstance().selKactyp();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SkdA080BG entity = new SkdA080BG();
				
				entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
				
				listData.add(entity);
			}
			
			hashData.put("KACTYP_LIST", listData);
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdA080Kactyp:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdA080Kactyp:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdA080Kactyp:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdA080Kactyp:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * RAD ȸ Լ
	  * @param entity SkdA080BG
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/10/16 
	  */
	public Hashtable selSkdA080Main(SkdA080BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String kactyp = "";
			
			// : 77A,332 739... => '77A','332','739'...  ȯϱ
			if (!params.getKactyp().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getKactyp()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					if (chk != 0) kactyp = kactyp + ",";
					kactyp = kactyp + "'" + token + "'";
					chk++;
				}
			}
			
			//ȸ
			stmt = conn.createStatement();
			sql = SkdA080Query.getInstance().selMain(params, kactyp);
			rs = stmt.executeQuery(sql);
			
			//REGNO  FLT_NUM   ROW ĭ Ͽ ִ´.
			String prevKactyp = "";
			String prevRegno = "";
			String fltNumList = "";
			
			while (rs.next()) {
				
				String tmpKactyp = StringUtil.checkString(rs.getString("KACTYP"));
				String tmpRegno = StringUtil.checkString(rs.getString("REGNO"));
				String tmpFltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				
				if (tmpRegno.equals(prevRegno)) {
					
					fltNumList = fltNumList + " " + tmpFltNum;
					
				} else {
					
					if (!prevKactyp.equals("") && !prevRegno.equals("")) {
						
						SkdA080BG entity = new SkdA080BG();
						
						entity.setKactyp(prevKactyp);
						entity.setRegno(prevRegno);
						entity.setFltNum(fltNumList);
						
						listData.add(entity);
					}
					
					prevKactyp = tmpKactyp;
					prevRegno = tmpRegno;
					fltNumList = tmpFltNum;
				}
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// Row ߰
			if (!prevKactyp.equals("") && !prevRegno.equals("")) {
				
				SkdA080BG entity = new SkdA080BG();
				
				entity.setKactyp(prevKactyp);
				entity.setRegno(prevRegno);
				entity.setFltNum(fltNumList);
				
				listData.add(entity);
			}
			
			String ddMon = "";
			String timestamp = "";
			String utcTime = "";
			
			// TIME ȸ
			stmt = conn.createStatement();
			sql = SkdA080Query.getInstance().selTime(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				ddMon = StringUtil.checkString(rs.getString("DDMON"));
				timestamp = StringUtil.checkString(rs.getString("TIMESTAMP"));
				utcTime = StringUtil.checkString(rs.getString("UTCTIME"));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			hashData.put("RAD_LIST", listData);
			
			hashData.put("DDMON", ddMon);
			hashData.put("TIMESTAMP", timestamp);
			hashData.put("UTCTIME", utcTime);
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdA080Main:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdA080Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdA080Main:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdA080Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/**
	  * RAD SEND Լ
	  * @param SkdA080BG timeData, Hashtable hashParam
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/10/20 
	  */
	public String insSkdA080Send(SkdA080BG timeData, Hashtable hashParam) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//---------------------------------------------------------------------------------------------------
			//KACTYP, REGNO 
			String kactyp = "";
			
			if (hashParam != null) {
				List listParam = (List)hashParam.get("listParam");
				for (int i=0; i<listParam.size(); i++) {
					
					//'77A','332','739'...   (ߺǴ° )
					if (kactyp.indexOf(StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSKactyp())) == -1) {
						if (i != 0) kactyp = kactyp + ",";
						kactyp = kactyp + "'" + StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSKactyp()) + "'";
					}	
				}
			}
			
			if (kactyp.equals("")) throw new BusinessException("ȸ A/C TYPE    ϴ.");
			
			//System.out.println("kactyp====>"+kactyp);
			
			//---------------------------------------------------------------------------------------------------
			//AIRPORT ȸ
			stmt = conn.createStatement();
			sql = SkdA080Query.getInstance().selAirport(timeData, kactyp);
			rs = stmt.executeQuery(sql);
			
			String airport = "";
			
			while (rs.next()) {
				//'ICN','GMP',...  
				if (airport.equals("")) airport = "'" + StringUtil.checkString(rs.getString("STNFR")) + "'";
				else airport = airport + ",'" + StringUtil.checkString(rs.getString("STNFR")) + "'";
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (airport.equals("")) throw new BusinessException("ȸ     ϴ.");
			
			//System.out.println("airport====>"+airport);
			
			//---------------------------------------------------------------------------------------------------
			//2009.11.16 ߰
			//SVC ȸؼ SERVICE_TYPE_CATEGORY ϱ
			stmt = conn.createStatement();
			sql = SkdA080Query.getInstance().selSvc(timeData, kactyp);
			rs = stmt.executeQuery(sql);
			
			String serviceType = "";
			
			while (rs.next()) {
				String tmpSvc = StringUtil.checkString(rs.getString("SVC"));
				String tmpService = "";
				
				if (tmpSvc.equals("F") || tmpSvc.equals("M") || tmpSvc.equals("A") || tmpSvc.equals("H")) {
					tmpService = "Cargo";
					
				} else if (tmpSvc.equals("J")) {
					tmpService = "Regular";
					
				} else if (tmpSvc.equals("C")) {
					tmpService = "Charter";
					
				} else if (tmpSvc.equals("G")) {
					tmpService = "Extra";
					
				} else if (tmpSvc.equals("P") || tmpSvc.equals("T") || tmpSvc.equals("K") || tmpSvc.equals("W")) {
					tmpService = "Others";
				}
				
				//'Regular','Cargo',...  
				if (serviceType.equals("")) serviceType = "'" + tmpService + "'";
				else serviceType = serviceType + ",'" + tmpService + "'";
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (serviceType.equals("")) throw new BusinessException("ȸ Service Code    ϴ.");
			
			//System.out.println("serviceType====>"+serviceType);
			
			//---------------------------------------------------------------------------------------------------
			//ADDRESS ȸϿ 
			stmt = conn.createStatement();
			sql = SkdA080Query.getInstance().selAddress(airport, serviceType);
			rs = stmt.executeQuery(sql);
			
			List addrList = new LinkedList(); //ٿ address 8 (ĭ , 8° ڿ ĭ ) 4   ׷쿡 ´.
			int x = 1; // ADDRESS 
			String tmpAddr = "";
			
			while (rs.next()) {
				if ((x-1) % 8 == 0) {//ٹٲٰ ĭ ȳֱ (1, 9, 17, 25... )
					if (x % 32 != 1) tmpAddr = tmpAddr + StringUtil.unescape("/uD/uA");//1, 33, 65,...   
					tmpAddr = tmpAddr + StringUtil.checkString(rs.getString("MESSAGE_ADDRESS_BODY"));
				
				} else {
					tmpAddr = tmpAddr + " " + StringUtil.checkString(rs.getString("MESSAGE_ADDRESS_BODY"));
				}
				
				if (x % 32 == 0) { //x 32, 64, 96,... ϶ ´.
					addrList.add(tmpAddr);
					tmpAddr = "";
				}
				x++;
			}
			
			if (!tmpAddr.equals("")) { //   ´.
				addrList.add(tmpAddr);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (x == 1) throw new BusinessException("ȸ ADDRESS    ϴ.");
			
			//---------------------------------------------------------------------------------------------------
			//RAD MSG 
			StringBuffer msgBf = new StringBuffer();
			String prevKactyp = "";
			
			if (hashParam != null) {
				List listParam = (List)hashParam.get("listParam");
				for (int i=0; i<listParam.size(); i++) {
					
					String tmpKactyp = StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSKactyp());
					String tmpRegno = StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSRegno());
					String tmpFltNum = StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSFltNum());
					
					if (!prevKactyp.equals(tmpKactyp)) {
						msgBf.append("KE " + tmpKactyp);
						msgBf.append(StringUtil.unescape("/uD/uA")); //<cr><lf>
					}
					msgBf.append(tmpRegno + " " + tmpFltNum);
					msgBf.append(StringUtil.unescape("/uD/uA")); //<cr><lf>
					
					prevKactyp = tmpKactyp;
				}
			}
			//System.out.println(StringUtil.unescape("/uD/uA") + msgBf.toString());
			
			//---------------------------------------------------------------------------------------------------
			//ADDRESS   ϱ
			
			for (int a=0; a<addrList.size(); a++) {
				
				StringBuffer radMsg = new StringBuffer();
				
				radMsg.append("Q.QU ");
				radMsg.append((String)addrList.get(a)); //ִ 32¥ ADDRESS ׷
				radMsg.append(StringUtil.unescape("/uD/uA")); //<cr><lf>
				radMsg.append("." + timeData.getDeptC() + "KE " + timeData.getUtcTime());
				radMsg.append(StringUtil.unescape("/uD/uA")); //<cr><lf>
				radMsg.append("RAD " + timeData.getDdMon() + " " + timeData.getTimestamp());
				radMsg.append(StringUtil.unescape("/uD/uA")); //<cr><lf>
				radMsg.append(msgBf.toString());
				
				//MS_TELEX_MSG_T  INSERT
				stmt = conn.createStatement();
				sql = SkdA080Query.getInstance().insMsTelexMsgT(timeData.getDeptC()+"KE", radMsg.toString(), "RAD_20"+timeData.getDt()+"_"+timeData.getTimestamp());
				int insChk = stmt.executeUpdate(sql);
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//---------------------------------------------------------------------------------------------------
			//ADMRAD_JOB_T 
			List regnoList = new LinkedList();
			String tmpList = "";
			String pKactyp = "";
			
			if (hashParam != null) {
				List listParam = (List)hashParam.get("listParam");
				for (int i=0; i<listParam.size(); i++) {
					
					String tmpKactyp = StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSKactyp());
					String tmpRegno = StringUtil.checkString(((SkdA080BG)listParam.get(i)).getSRegno());
					
					if (pKactyp.equals(tmpKactyp)) {
						tmpList = tmpList + " " + tmpRegno;

					} else {
						if (i != 0) regnoList.add(tmpList); //333HL7554 HL7584...  ´.
						tmpList = tmpKactyp + tmpRegno;
					}
					
					pKactyp = tmpKactyp;
				}
			}
			if (!tmpList.equals("")) { //   ´.
				regnoList.add(tmpList);
			}
			
			for (int a=0; a<regnoList.size(); a++) {
				//System.out.println((String)regnoList.get(a));
				
				//(String)regnoList.get(a) = 333HL7554 HL7584... 
				String tmpKactyp = ((String)regnoList.get(a)).substring(0,3);
				String tmpRegno = ((String)regnoList.get(a)).substring(3);
				
				//ADMRAD_JOB_T ȸ
				stmt = conn.createStatement();
				sql = SkdA080Query.getInstance().selAdmradJobT(timeData, tmpKactyp);
				rs = stmt.executeQuery(sql);
				
				String radDt = "";
				
				if (rs.next()) {
					radDt = StringUtil.checkString(rs.getString("RAD_DT"));
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				if (radDt.equals("")) {
					//INSERT
					stmt = conn.createStatement();
					sql = SkdA080Query.getInstance().insAdmradJobT(timeData, tmpKactyp, tmpRegno);
					int insChk = stmt.executeUpdate(sql);
					
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					
				} else {
					if (Long.parseLong(radDt) >= Long.parseLong(timeData.getTimestamp())) {
						throw new BusinessException("̹ ۾  ֽϴ. ȸ ٽ Ͻñ ٶϴ.");
						
					} else {
						//UPDATE
						stmt = conn.createStatement();
						sql = SkdA080Query.getInstance().updAdmradJobT(timeData, tmpKactyp);
						int updChk = stmt.executeUpdate(sql);
						
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
					}
				}
			}
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
	  		Logger.debug.println("[BASE:SkdAllSLBean:insSkdA080Send:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:SkdAllSLBean:insSkdA080Send:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:insSkdA080Send:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try {cr.release();} catch(Exception e) {}
			if (conn != null) try {conn.close();} catch(Exception e) {}
			if (rs != null) try {rs.close();} catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/** 
	  * FODIS  ȸ Լ
	  * @param String returnValue
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/10/21 
	  */
	public String selFodisAuth(String empNo) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		String returnValue = "";
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// TIME ȸ
			stmt = conn.createStatement();
			sql = "SELECT AUTH_PMSN FROM PASSWORD_AUTH_T WHERE PROJECT_C = 'FODIS' AND EMP_NO = '"+empNo+"'";
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				returnValue = StringUtil.checkString(rs.getString("AUTH_PMSN"));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:selFodisAuth:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:selFodisAuth:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}
	
	/** 
	  * FODIS Login Լ
	  * @param String returnValue
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2009/10/21 
	  */
	public Hashtable updFodisLogin(String empNo) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
			//DB   ȸ
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//Random Code ߻
			Random rd = new Random();
	    	String randomC = String.valueOf(rd.nextInt(999999999)).toString();
	    	
	    	SysA010BG entity = new SysA010BG();
	    	
	    	entity.setRandom_c(randomC);
			
			//User Log In Module 
			stmt = conn.createStatement();
			sql = " UPDATE PASSWORD_AUTH_T";
			sql += " SET LOGIN_D = SYSDATE,";
			sql += " LOGIN_Y = 'Y', ";
			sql += " RANDOM_C = '"+randomC+"', ";
			sql += " 	USE_CNT = (SELECT USE_CNT+1 FROM PASSWORD_AUTH_T WHERE EMP_NO = '"+empNo+"' AND PROJECT_C = 'FODIS') ";
			sql += " WHERE EMP_NO = '"+empNo+"' ";
			sql += " AND PROJECT_C = 'FODIS' ";
			int updCnt = stmt.executeUpdate(sql);
			
			if (updCnt != 1) throw new BusinessException("[System Exception] Log In Exception");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			hashData.put("FODIS_LOGIN",entity);
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:SkdAllSLBean:updFodisLogin:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:SkdAllSLBean:updFodisLogin:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SkdAllSLBean:updFodisLogin:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
	/** 
	  * RAD MSG ȸ Լ
	  * @param entity SkdQ090BG
	  * @return Hashtable ȸ 
	  * @author Copyright (c) 2010/01/14 
	  */
	public Hashtable selSkdQ090Main(SkdQ090BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		Hashtable hashData = new Hashtable();
		List listData = new LinkedList();
		
		try {	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//ȸ
			stmt = conn.createStatement();
			sql = SkdQ090Query.getInstance().selMsg(params);
			rs = stmt.executeQuery(sql);
			
			//PROJECT_NO  MESSAGE  ROW '=====' Ͽ ִ´.
			String prevProjectNo = "";
			String prevTimestamp = "";
			String msgList = "";
			
			while (rs.next()) {
				String tmpProjectNo = StringUtil.checkString(rs.getString("PROJECT_NO"));
				String tmpTimestamp = StringUtil.checkString(rs.getString("TIMESTAMP"));
				String tmpMessage = StringUtil.checkString(rs.getString("MESSAGE"));
				
				if (tmpProjectNo.equals(prevProjectNo)) {
					msgList += StringUtil.unescape("/uD/uA");
					msgList += "====================================================================";
					msgList += StringUtil.unescape("/uD/uA");
					msgList += tmpMessage;
				
				} else {
					
					if (!prevProjectNo.equals("")) {
						SkdQ090BG entity = new SkdQ090BG();
						
						entity.setTimestamp(prevTimestamp);
						entity.setMsg(msgList);
						
						listData.add(entity);
					}
					
					prevProjectNo = tmpProjectNo;
					prevTimestamp = tmpTimestamp;
					msgList = tmpMessage;
				}
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			// Row ߰
			if (!prevProjectNo.equals("")) {
				SkdQ090BG entity = new SkdQ090BG();
				
				entity.setTimestamp(prevTimestamp);
				entity.setMsg(msgList);
				
				listData.add(entity);
			}
			
			hashData.put("RAD_MSG", listData);
			
		} catch(SQLException se) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ090Main:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ090Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			//Logger.debug.println("[BASE:SkdAllSLBean:selSkdQ090Main:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:SkdAllSLBean:selSkdQ090Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	
}//end of class
