/*
 *	Frame Header Clock
 */
var timerID,miliSecs;

function clockStart(secs) {
	miliSecs = secs;
	updateClocks();
}

function tzone(tz, os, ds) {
	this.ct = new Date(0) ;
	this.tz = tz ;
	this.os = os ;
	this.ds = ds ;				//̰ Ƹ Summer Time 뵵  0:No  1:Yes
}

function updateClocks() {
	var ct = new Array(
		new tzone('KST: ', +9, 0),
		//new tzone('UTC: ',  0, 1)
		new tzone('UTC: ',  0, 0)
	) ;

	//dt ==> Tue Jan 11 13:57:22 UTC+0900 2005
	var dt = new Date() ;
	//var dt = new Date(2005,5,15);
	
	//dt.getFullYear() ==> YYYY
	var startDST = new Date(dt.getFullYear(), 3, 1) ;
	//new Date(dt.getFullYear(), 3, 1) ;  ==>  new Date(YYYY,Month-1,day);
	//startDST ==> Fri Apr 1 00:00:00 UTC+0900 2005
	
	//startDST.getDay() ==> 5
	while (startDST.getDay() != 0) {							//  Ͽ ƴϸ Ͽ ɶ ¥ +1Ѵ
		//startDST.getDay() ========> 5,6
		//startDST.getDate() ==> 1,2
		startDST.setDate(startDST.getDate() + 1) ;
		//startDST.getDate() ==> 2,3
		//startDST.getDay() ========> 6,0
	}

	var endDST = new Date(dt.getFullYear(), 9, 31) ;
	while (endDST.getDay() != 0)
		endDST.setDate(endDST.getDate() - 1) ;

	var ds_active ;
	if (startDST < dt && dt < endDST)
		ds_active = 1 ;
	else
		ds_active = 0 ;	//
		
	for(n=0 ; n<ct.length ; n++)
		if (ct[n].ds == 1 && ds_active == 1) ct[n].os++ ;
	
	//===============  SUMMER TIME 뵵ÿ  UTC  plusų ð ϴ ̴.

	//ct[0].os ==> 9
	gmdt = new Date() ; 
	//   ٿ Time ü   ִ.
	//ct[0].ct = new Date(gmdt.getTime() + ct[0].os * 3600 * 1000) ;
	
	for (n=0 ; n<ct.length ; n++)
		//ct[n].ct = new Date(gmdt.getTime() + ct[n].os * 3600 * 1000) ;
		ct[n].ct = new Date(gmdt.getTime() + ct[n].os * 3600 * 1000 + miliSecs) ;
		//(GMTð + ð ) * 3600 * 1000
		//3600 : 1ð   1000 : 1/1000
		
	if (document.form.clock_mode.value == "K") {
		document.form.digits.value = clockString(ct[0].ct);
		//document.all.Clock0.innerHTML = '<font color="violet">'+ct[0].tz+clockString(ct[0].ct)+'</font>';	
	} else {
		document.form.digits.value = clockString(ct[1].ct);
		//document.all.Clock0.innerHTML = '<font color="sliver">'+ct[1].tz+clockString(ct[1].ct)+'</font>';	
	}
	timerID = window.setTimeout("updateClocks()", 1001) ;
}

function clockString(dt) {
	var stemp
	var dt_year = dt.getUTCFullYear() ;
	var dt_month = dt.getUTCMonth() + 1 ;
	var dt_day = dt.getUTCDate() ;
	var dt_hour = dt.getUTCHours() ;
	var dt_minute = dt.getUTCMinutes() ;
	var dt_second = dt.getUTCSeconds() ;
	/*
	dt_year = dt_year.toString() ;
	if (0 <= dt_hour && dt_hour < 12) {
		ampm = 'AM' ; // AM
		if (dt_hour == 0) dt_hour = 12 ;		
	} else {
		ampm = 'PM' ; // PM
		dt_hour = dt_hour - 12 ;
		if (dt_hour == 0) dt_hour = 12 ;		
	}
	*/
	
	if (dt_month < 10)
		dt_month = '0' + dt_month;
	dt_month = monthString(dt_month);

	if (dt_minute < 10)
		dt_minute = '0' + dt_minute ;

	if (dt_second < 10)
		dt_second = '0' + dt_second ;

	stemp = dt_day+dt_month; 
	stemp = stemp+' '+dt_hour+":"+dt_minute;
	return stemp ;
}

function monthString(MM) {
	var MMM;
	if (MM == "01") MMM = "JAN";
	else if(MM == "02") MMM = "FEB";
	else if(MM == "03") MMM = "MAR";
	else if(MM == "04") MMM = "APR";
	else if(MM == "05") MMM = "MAY";
	else if(MM == "06") MMM = "JUN";
	else if(MM == "07") MMM = "JUL";
	else if(MM == "08") MMM = "AUG";
	else if(MM == "09") MMM = "SEP";
	else if(MM == "10") MMM = "OCT";
	else if(MM == "11") MMM = "NOV";
	else MMM = "DEC";
	
	return MMM;
}