<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--------------------------------------------------------------------
	20151021
	sunpark
	Past Weather UMS Mail
------------------------------------>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="java.text.*" %>
<%@ page import="kal.base.com.util.*" %>
<%@ page import="kal.base.com.serv.*" %>
<%@ page import="kal.base.sup.dbbean.SupQ220BG" %>
<%@ page import="kal.base.sup.ejb.SupAllSL" %>
<%@ page import="kal.base.jdf.ejb.EJBFinder" %>
<%@ page import="kal.base.jdf.com.Logger" %>
<%
	String metarTyp = StringUtil.checkString((String)request.getParameter("metar_typ"));
	String tafTyp = StringUtil.checkString((String)request.getParameter("taf_typ"));
	String textTyp = StringUtil.checkString((String)request.getParameter("text_typ"));
	String icaoPort = StringUtil.checkString((String)request.getParameter("icao_port"));
	String fromDt = StringUtil.checkString((String)request.getParameter("from_dt"));
	String toDt = StringUtil.checkString((String)request.getParameter("to_dt"));
	String wxCond1 = StringUtil.checkString((String)request.getParameter("wx_cond1"));
	String wxCond2 = StringUtil.checkString((String)request.getParameter("wx_cond2"));
	String title = StringUtil.checkString((String)request.getParameter("title"));
	
	//http://10.100.212.151:9080/BASERoot/jsp/sup/SupQ220UIEMS.jsp?metar_typ=Y&taf_typ=Y&text_typ=Y&icao_port=ICN&from_dt=151001&to_dt=151001&wx_cond1=&wx_cond2=&title=
	
	StringBuffer msgBf = new StringBuffer();
	
	try {
		SupQ220BG mainParams = new SupQ220BG();
		mainParams.setMetar_typ(metarTyp);
		mainParams.setTaf_typ(tafTyp);
		mainParams.setText_typ(textTyp);
		mainParams.setIcao_port(icaoPort);
		mainParams.setFrom_dt(fromDt);
		mainParams.setTo_dt(toDt);
		mainParams.setWx_cond1(wxCond1);
		mainParams.setWx_cond2(wxCond2);
		mainParams.setTitle(StringUtil.toKSC5601(title));
		
		SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
		Hashtable hashData = sl.selSupQ220Main(mainParams);
		
		SupQ220BG header = null;
		SupQ220BG params = null;
		List metarList = null;
		List tafList = null;
		List textList = null;

		if (hashData != null) {
			
			params = (SupQ220BG)hashData.get("PARAMS");
			header = (SupQ220BG)hashData.get("HEADER");
			metarList = (List)hashData.get("METAR");
			tafList = (List)hashData.get("TAF");
			textList = (List)hashData.get("TEXT");
			
			if (params != null) {
				msgBf.append("***************************************************************************");
				msgBf.append(StringUtil.unescape("/uD/uA"));
				msgBf.append("KOREAN AIR WEATHER INFORMATION SUMMARY");
				msgBf.append(StringUtil.unescape("/uD/uA"));

				if (!StringUtil.checkString(params.getTitle()).equals("")) {
					String titleTxt = "MEMO : " + StringUtil.checkString(params.getTitle());
					for (int i=0 ; i<titleTxt.length() ; i++) {
						if (i%65 == 0 && i != 0) {
							msgBf.append(StringUtil.unescape("/uD/uA"));
						}
						msgBf.append(titleTxt.charAt(i));
					}
    	 			msgBf.append(StringUtil.unescape("/uD/uA"));
				}
				if (header != null) {
	    	 		msgBf.append(StringUtil.checkString(header.getIcao_port())+"&nbsp;");
	    	 		msgBf.append("("+StringUtil.checkString(header.getIata_port())+")&nbsp;&nbsp;");
	    	 		msgBf.append(StringUtil.checkString(header.getPort_e()));
	    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
	    	 	}
				msgBf.append("***************************************************************************");
				msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 	}
    	 	
    	 	if (metarList != null && metarList.size() >0) {
    	 		msgBf.append("---------------------------------------------------------------------------");
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		msgBf.append("WX TYPE : METAR");
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("WX CONDITION : "+StringUtil.checkString(params.getWx_cond1())+"");
            	msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("PERIOD : "+StringUtil.checkString(params.getFrom_dt())+" ~ "+StringUtil.checkString(params.getTo_dt()));
            	msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("---------------------------------------------------------------------------");
            	msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		
    	 		for (int i=0; i<metarList.size(); i++) {
    	 			
					SupQ220BG entity = (SupQ220BG)metarList.get(i);
					String metarTxt = StringUtil.checkString(entity.getIcao_port())+" "+StringUtil.checkString(entity.getWx_text());
					StringBuffer finalTxt = new StringBuffer();
					String cutTxt = "";
					
					for (int a=0 ; a<metarTxt.length() ; a++) {
						if (metarTxt.charAt(a) == '\n') {
							finalTxt.append(StringUtil.checkString(cutTxt));
		    				finalTxt.append(StringUtil.unescape("/uD/uA"));
		    				finalTxt.append("                ");
		    				cutTxt = "";
						} else if (metarTxt.charAt(a) == '\r') {
							cutTxt = cutTxt + "";
						} else {
							cutTxt = cutTxt + metarTxt.charAt(a);
							if (cutTxt.length() > 75) {
								boolean swFind = false;
		    					int outInt = 0;
								for (int j=cutTxt.length() ; j>0 && !swFind ; j--) {
									if (cutTxt.charAt(j-1) == ' ') {
		    							swFind = true;
		    							outInt = j;
		    						}
								}
								finalTxt.append(StringUtil.checkString(cutTxt.substring(0,outInt)));
		    					finalTxt.append(StringUtil.unescape("/uD/uA"));
						    	finalTxt.append("                ");
						    	cutTxt = cutTxt.substring(outInt);
		    				}
						}
					}
					if (!cutTxt.equals("")) {
						finalTxt.append(StringUtil.checkString(cutTxt));
					}
		    		
		    		msgBf.append(StringUtil.checkString(entity.getWx_dtg())+" "+finalTxt.toString());
		    		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		}
    	 		
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 	}
    	 	
    	 	if (tafList != null && tafList.size() >0) {
    	 		msgBf.append("---------------------------------------------------------------------------");
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		msgBf.append("WX TYPE : TAF");
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("WX CONDITION : "+StringUtil.checkString(params.getWx_cond1())+"");
            	msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("PERIOD : "+StringUtil.checkString(params.getFrom_dt())+" ~ "+StringUtil.checkString(params.getTo_dt()));
            	msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("---------------------------------------------------------------------------");
            	msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		
    	 		for (int i=0; i<tafList.size(); i++) {
    	 			
					SupQ220BG entity = (SupQ220BG)tafList.get(i);
					String tafTxt = StringUtil.checkString(entity.getIcao_port())+" "+StringUtil.checkString(entity.getWx_text());
					StringBuffer finalTxt = new StringBuffer();
					String cutTxt = "";
					
					for (int a=0 ; a<tafTxt.length() ; a++) {
						if (tafTxt.charAt(a) == '\n') {
							finalTxt.append(StringUtil.checkString(cutTxt));
		    				finalTxt.append(StringUtil.unescape("/uD/uA"));
		    				finalTxt.append("                ");
		    				cutTxt = "";
						} else if (tafTxt.charAt(a) == '\r') {
							cutTxt = cutTxt + "";
						} else {
							cutTxt = cutTxt + tafTxt.charAt(a);
							if (cutTxt.length() > 75) {
								boolean swFind = false;
		    					int outInt = 0;
								for (int j=cutTxt.length() ; j>0 && !swFind ; j--) {
									if (cutTxt.charAt(j-1) == ' ') {
		    							swFind = true;
		    							outInt = j;
		    						}
								}
								finalTxt.append(StringUtil.checkString(cutTxt.substring(0,outInt)));
		    					finalTxt.append(StringUtil.unescape("/uD/uA"));
						    	finalTxt.append("                ");
						    	cutTxt = cutTxt.substring(outInt);
		    				}
						}
					}
					if (!cutTxt.equals("")) {
						finalTxt.append(StringUtil.checkString(cutTxt));
					}
		    		
		    		msgBf.append(StringUtil.checkString(entity.getWx_dtg())+" "+finalTxt.toString());
		    		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		}
    	 		
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 	}
    	 	
    	 	if (textList != null && textList.size() >0) {
    	 		msgBf.append("---------------------------------------------------------------------------");
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		msgBf.append("WX TYPE : TEXT");
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("WX CONDITION : "+StringUtil.checkString(params.getWx_cond1())+"");
            	msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("PERIOD : "+StringUtil.checkString(params.getFrom_dt())+" ~ "+StringUtil.checkString(params.getTo_dt()));
            	msgBf.append(StringUtil.unescape("/uD/uA"));
            	msgBf.append("---------------------------------------------------------------------------");
            	msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		
    	 		for (int i=0; i<textList.size(); i++) {
    	 			
					SupQ220BG entity = (SupQ220BG)textList.get(i);
					String textTxt = StringUtil.checkString(entity.getIcao_port())+" "+StringUtil.checkString(entity.getWx_text());
					StringBuffer finalTxt = new StringBuffer();
					String cutTxt = "";
					
					for (int a=0 ; a<textTxt.length() ; a++) {
						if (textTxt.charAt(a) == '\n') {
							finalTxt.append(StringUtil.checkString(cutTxt));
		    				finalTxt.append(StringUtil.unescape("/uD/uA"));
		    				finalTxt.append("                ");
		    				cutTxt = "";
						} else if (textTxt.charAt(a) == '\r') {
							cutTxt = cutTxt + "";
						} else {
							cutTxt = cutTxt + textTxt.charAt(a);
							if (cutTxt.length() > 75) {
								boolean swFind = false;
		    					int outInt = 0;
								for (int j=cutTxt.length() ; j>0 && !swFind ; j--) {
									if (cutTxt.charAt(j-1) == ' ') {
		    							swFind = true;
		    							outInt = j;
		    						}
								}
								finalTxt.append(StringUtil.checkString(cutTxt.substring(0,outInt)));
		    					finalTxt.append(StringUtil.unescape("/uD/uA"));
						    	finalTxt.append("                ");
						    	cutTxt = cutTxt.substring(outInt);
		    				}
						}
					}
					if (!cutTxt.equals("")) {
						finalTxt.append(StringUtil.checkString(cutTxt));
					}
		    		
		    		msgBf.append(StringUtil.checkString(entity.getWx_dtg())+" "+finalTxt.toString());
		    		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 		}
    	 		
    	 		msgBf.append(StringUtil.unescape("/uD/uA"));
    	 	}
    	 	
		}
	} catch(Exception e) {
		e.printStackTrace();
	}
%>

<html>
<head>
<title></title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<style>
.mail_txt{font-size:13px;font-family:돋움체;}
</style>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<pre>
	<table>
		<tr>
			<td class='mail_txt'>
<%=StringUtil.replaceBR(msgBf.toString())%>	
			</td>
		</tr>
	</table>
</pre>
</body>
</html>
