package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA010BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IRR/DSS MULTI IROPS Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/31 HIST  
 */
public class IroA080Serv extends PublicBaseServlet{
	/** 
	  *  IRR/DSS MULTI IROPS Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String[] arrFirstLegFltDt = req.getParameterValues("h_first_leg_flt_dt");
		String[] arrFltNum = req.getParameterValues("h_flt_num");
		String[] arrRegno = req.getParameterValues("h_regno");
		String[] arrStnFr = req.getParameterValues("h_stnfr");
		String[] arrStnTo = req.getParameterValues("h_stnto");
		String[] arrSchDepDt = req.getParameterValues("h_sch_dep_dt");
		String[] arrSchArvDt = req.getParameterValues("h_sch_arv_dt");
		String[] arrEstDepDt = req.getParameterValues("h_est_dep_dt");
		String[] arrEstArvDt = req.getParameterValues("h_est_arv_dt");
		String[] arrLegNum = req.getParameterValues("h_leg_num");
		String[] arrTitleX = req.getParameterValues("title_x");
		String[] arrTitleE = req.getParameterValues("title_e");
		String[] arrRegionFlt = req.getParameterValues("h_region_flt");
		String[] arrRegionLeg = req.getParameterValues("h_region_leg");
		//String empNo = StringUtil.checkString(box.getString("emp_no"));
		String[] arrTimeStamp = req.getParameterValues("h_timestamp");
		String[] arrDisDt = req.getParameterValues("h_dis_dt");
		//Desk 
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));
		String stnFr = StringUtil.checkString(box.getString("stnfr"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter ü 
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			IroA010BG newData = null;
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//ü insert  ŭ Loop 
			for (int i=0; i<arrFirstLegFltDt.length; i++) {
				//Comment Էµ Line Ѵ
				if ((StringUtil.checkString(arrTitleX[i])).equals("MLT")) {
					IroA010BG params = new IroA010BG();
					params.setFirst_leg_flt_dt(StringUtil.checkString(arrFirstLegFltDt[i]));
					params.setFlt_num(StringUtil.checkString(arrFltNum[i]));
					params.setRegno(StringUtil.checkString(arrRegno[i]));
					params.setStnfr(StringUtil.checkString(arrStnFr[i]));
					params.setStnto(StringUtil.checkString(arrStnTo[i]));
					params.setSch_dep_dt(StringUtil.checkString(arrSchDepDt[i]));
					params.setSch_arv_dt(StringUtil.checkString(arrSchArvDt[i]));
					params.setEst_dep_dt(StringUtil.checkString(arrEstDepDt[i]));
					params.setEst_arv_dt(StringUtil.checkString(arrEstArvDt[i]));
					params.setLeg_num(StringUtil.checkString(arrLegNum[i]));
					params.setTitle_x(StringUtil.checkString(arrTitleX[i]));
					params.setTitle_e(StringUtil.checkString(StringUtil.toKSC5601(arrTitleE[i])));
					params.setRegion_flt(StringUtil.checkString(arrRegionFlt[i]));
					params.setRegion_leg(StringUtil.checkString(arrRegionLeg[i]));
					params.setEmp_no(StringUtil.checkString(UserInfo.getEmp_no()));
					params.setTimestamp(StringUtil.checkString(arrTimeStamp[i]));
					params.setDis_dt(StringUtil.checkString(arrDisDt[i]));
					listParam.add(params);
				}
			}
			//ü Data 0 Ŭ츸  ϰ
			//ƴϸ  Ѵ.
			// ⼭ ɸ ʵȴ. JSP ̹ Checkϰ Ѿ; Ѵ.
			if (listParam.size() > 0) {
				hashParam.put("listParam",listParam);
			} else throw new Exception("Էµ Data ϴ.");
			
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session = req.getSession();
				session.setAttribute("desk_x",deskX);
			} else throw new Exception("Desk  ϴ.");

			req.setAttribute("hashParam",hashParam);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA080Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA080Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask	
	
	/** 
	  *  IRR/DSS MULTI IROPS Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/08 HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		//GRID DATA
		String[] arrFirstLegFltDt = req.getParameterValues("h_first_leg_flt_dt");
		String[] arrFltNum = req.getParameterValues("h_flt_num");
		String[] arrStnFr = req.getParameterValues("h_stnfr");
		String[] arrStnTo = req.getParameterValues("h_stnto");
		String[] arrLegNum = req.getParameterValues("h_leg_num");
		String[] arrRegionFlt = req.getParameterValues("h_region_flt");
		String[] arrRegionLeg = req.getParameterValues("h_region_leg");
		//IROPS  DATA
		String titleX =StringUtil.checkString(box.getString("title_x"));
		String titleE = StringUtil.checkString(box.getString("title_e"));
		String decisionC = StringUtil.checkString(box.getString("decision_c"));
		String decisionE = StringUtil.checkString(box.getString("decision_e"));
		String remarkE = StringUtil.checkString(box.getString("remark_e"));
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter ü 
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			IroA010BG newData = null;
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//ü insert  ŭ Loop 
			for (int i=0; i<arrFirstLegFltDt.length; i++) {
				IroA010BG params = new IroA010BG();
				params.setFirst_leg_flt_dt(StringUtil.checkString(arrFirstLegFltDt[i]));
				params.setFlt_num(StringUtil.checkString(arrFltNum[i]));
				params.setStnfr(StringUtil.checkString(arrStnFr[i]));
				params.setStnto(StringUtil.checkString(arrStnTo[i]));
				params.setLeg_num(StringUtil.checkString(arrLegNum[i]));
				params.setRegion_flt(StringUtil.checkString(arrRegionFlt[i]));
				params.setRegion_leg(StringUtil.checkString(arrRegionLeg[i]));
				params.setTitle_x(StringUtil.checkString(titleX));
				params.setTitle_e(StringUtil.checkString(StringUtil.toKSC5601(titleE)));
				params.setEmp_no(StringUtil.checkString(UserInfo.getEmp_no()));
				params.setDecision_c(StringUtil.checkString(StringUtil.toKSC5601(decisionC)));
				params.setDecision_e(StringUtil.checkString(StringUtil.toKSC5601(decisionE)));
				params.setRemark_e(StringUtil.checkString(StringUtil.toKSC5601(remarkE)));
				params.setDesk_x(StringUtil.checkString(deskX));
				listParam.add(params);
			}
			
			if (listParam.size() > 0) hashParam.put("listParam",listParam);
			else throw new Exception("ó IROPS MULTI Ͱ ϴ. \n ڿ Ͽ ֽʽÿ.");
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			boolean insFlag  = sl.insIroA080Irops(hashParam);
			
			if (insFlag) req.setAttribute("successMessage","IROPS MULTI ó ϷǾϴ.");
			else throw new Exception("IROPS MULTI óԴϴ. \n ڿ Ͽ ֽʽÿ.");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA080Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA080Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask		
}//end of class
