package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ320BG;
import kal.base.sta.ejb.StaAllSL;

/**
 * OPS Statistics/Flying Time Status-REG Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/27 HIST  
 */
public class StaQ320Serv  extends PublicBaseServlet{
	/** 
	  * OPS Statistics/Flying Time Status-REG Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String fromDate = StringUtil.checkString(box.getString("from_date"));			//
		String toDate = StringUtil.checkString(box.getString("to_date"));					//
		String actyp = StringUtil.checkString(box.getString("actyp"));						//actyp
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB Parameter 
			StaQ320BG params = new StaQ320BG();
			params.setFrom_date("20"+fromDate);
			params.setTo_date("20"+toDate);
			params.setActyp(actyp);
			
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			Hashtable hashData  = sl.selStaQ320Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Flying Time Status-REG", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ320Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ320Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask		
}
