package kal.base.sys.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.*;
import kal.base.sys.ejb.SysAllSL;

/**
 * Ȳ
 * @version 	1.0
 * @author Copyright (c) 2006/03/30 
 */
public class SysQ010Serv extends PublicBaseServlet {
	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String stn = StringUtil.checkString(box.getString("stn"));
		String car = StringUtil.checkString(box.getString("car"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SysQ010BG params = new SysQ010BG();
			params.setStn(stn);

			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			Hashtable hashData  = sl.selSysCode(params);
			
			req.setAttribute("codeList",hashData);
			req.setAttribute("returnCode","Y");
			req.setAttribute("stn",stn);
			req.setAttribute("car",car);			
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysQ010Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SysQ010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String stn = StringUtil.checkString(box.getString("stn"));
		String car = StringUtil.checkString(box.getString("car"));
		String Skd_nm = StringUtil.checkString(box.getString("Skd_nm"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		try {
			SysQ010BG params = new SysQ010BG();
			params.setStn(stn);
			params.setCar(car);			
			params.setEff(Skd_nm.substring(0,8));
			params.setExp(Skd_nm.substring(8));
			
			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			Hashtable hashData  = sl.selSysQ010Main1(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SYS Messenger", hashData, "SYSMSGLIST", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SysQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String stn = StringUtil.checkString(box.getString("stn"));
		String Skd_nm = StringUtil.checkString(box.getString("Skd_nm"));
		String Car = StringUtil.checkString(box.getString("carrier"));		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		try {
			SysQ010BG params = new SysQ010BG();
			params.setStn(stn);
			params.setSkd_nm(Skd_nm);
			params.setEff(Skd_nm.substring(0,8));
			params.setExp(Skd_nm.substring(8));
			params.setCar(Car);

			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			Hashtable hashData  = sl.selSysQ010Main2(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SYS Messenger", hashData, "SYSMSGLIST", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SysQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
}